/**
 * @author Samsung
 */

 var BtnImgIndex = { BTN_NORMAL_IMG:0, BTN_NORMAL_FOCUS_IMG:1, BTN_SELECTED_IMG:2, BTN_SELECTED_FOCUS_IMG:3, BTN_DIM_IMG:4 };
 var BtnTextStyleIndex = { BTN_TEXT_NORMAL_STYLE:0, BTN_TEXT_FOCUS_STYLE:1, BTN_TEXT_SELECTED_STYLE:2, BTN_TEXT_SELECTED_FOCUS_STYLE:3, BTN_TEXT_DIM_STYLE:4};

function Button(imageId, textId, flagPwd) {

    this.objType ="BUTTON";

    this.image_layer =null;
    this.text_layer =null;
    
    this.flag_Pwd = false;
    this.flag_block_space = false;
	this.flag_id_type = false;
      
    if(imageId)
    {
       this.SetImageObjId(imageId);
    }
    
    if(textId)
    {
        if(flagPwd)
        {
            this.SetTextObjId(imageId, flagPwd);
        }
        else
        {
            this.SetTextObjId(imageId);
        }
    }
   
    this.BtnImg = new Array(4);
    this.initImg = 0;
    
    this.MaxStringLength = 50;
    this.MinStringLength = 1;
    
    this.TextString = "";
    this.HelpTextString = "";
    this.HelpTextStyle = "";
    this.HelpTextShowState = false;
    
    this.BtnTextStyle = new Array(5);
    this.initTextStyle=0;
    this.SetText(this.TextString);
    
     this.onTextChangeFunc =null;
    
    this.flag_highlight = false;
    this.flag_dim = false;
    
    this.textEditorTitle="";
    this.textEditorMsg="";
    
    this.helpBar = null;
	this.flag_visible_helpbar = false;
	
	this.onClickCallbackFunc = null;
	this.flagClickEnable = false;
	
	this.onRightClickCallbackFunc = null;
    	
}

Button.prototype.GetBGLayer = function(id)
{
    return this.image_layer;
}

Button.prototype.SetImageObjId= function(id){

    if(id)
    {
        this.image_layer = new ImageLayer(id);
    }
    else
    {
        this.image_layer= null;
    }

}

Button.prototype.SetTextObjId= function(id, flagPwd){

    if(id)
    {
        this.text_layer = new TextLayer(id);
    }
    else
    {
        this.text_layer= null;
    }
    
    if(flagPwd)
    {
         this.flag_Pwd = flagPwd;
    }
}

Button.prototype.SetBgImage = function(imgIndex, bgImage){
    
    this.BtnImg[imgIndex] = bgImage;
    
    if(this.initImg ==0 && imgIndex==0)
    {
        this.initImg=1;
        this.image_layer.SetBgImage(bgImage);
    }
}

Button.prototype.SetTextStyle = function(styleIndex, textStyle){
    
    this.BtnTextStyle[styleIndex] = textStyle;
    
    if(this.initTextStyle==0 && styleIndex==0)
    {
    	this.initTextStyle=1;
    	this.text_layer.SetTextStyle(textStyle);
    }
}

Button.prototype.SetText = function(string){
   // alert("Button.prototype.SetText()");
    this.TextString = string;
    var PwdString ="";
    
    this.HelpStringShowState = false;
    
    if(this.TextString.length == 0 && this.HelpTextString.length >0  )
    {
         if(this.text_layer !=null)
        {
        	this.SetReverseDisable(false);
        	
            this.text_layer.SetText(this.HelpTextString);
            this.HelpStringShowState = true;
            if( this.HelpTextStyle.length >0)
            {
                this.text_layer.SetTextStyle( this.HelpTextStyle );
            }
        } 
    }
    else
    { 
        if( this.HelpTextString.length >0)
        {
        	this.SetReverseDisable(true); 
        }
               
        if(this.flag_Pwd == true)
        {
            var a=0;
            for(a=0; a< this.TextString.length; a++)
            {
               PwdString =  PwdString+"*";
            }
            
             if(this.text_layer !=null)
            {
                this.text_layer.SetText(PwdString);
            }   
        }
        else
        {
            if(this.text_layer !=null)
            {
                this.text_layer.SetText( this.TextString);
            }
         }
         
       if(  this.flag_highlight == true)
       {
            if(this.BtnTextStyle[BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE])
            {
                this.text_layer.SetTextStyle( this.BtnTextStyle[BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE] );
            }
            else if(this.BtnTextStyle[BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE])
            {
                this.text_layer.SetTextStyle( this.BtnTextStyle[BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE] );
            }
       
       }
       else
       {
              if(this.flag_dim == true)
            {
                 if(this.BtnTextStyle[BtnTextStyleIndex.BTN_TEXT_DIM_STYLE])
                {
                    this.text_layer.SetTextStyle( this.BtnTextStyle[BtnTextStyleIndex.BTN_TEXT_DIM_STYLE] );
                }
                else if(this.BtnTextStyle[BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE])
                {
                    this.text_layer.SetTextStyle( this.BtnTextStyle[BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE] );
                }
            }
            else
            {
                 if(this.BtnTextStyle[BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE])
                {
                    this.text_layer.SetTextStyle( this.BtnTextStyle[BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE] );
                }
            }
       }
         
     }
     
     if( this.onTextChangeFunc)
     {
        this.onTextChangeFunc();
     }
}

Button.prototype.GetText = function(){
    return this.TextString;
}

Button.prototype.SetFlagPwd = function(flagPWD)
{
     if(flagPwd)
    {
         this.flag_Pwd = flagPwd;
         
         this.SetText(this.TextString);
    }
}

Button.prototype.GetFlagPwd = function() {
    return  this.flag_Pwd;
}

Button.prototype.SetFlagBlockSpace= function(flagBlockSpace)
{
     if(flagBlockSpace)
    {
         this.flag_block_space = flagBlockSpace;
    }
}

Button.prototype.GetFlagBlockSpace = function() {
    return  this.flag_block_space;
}

Button.prototype.SetFlagIdType= function(flagIdType)
{
     if(flagIdType)
    {
         this.flag_id_type = flagIdType;
    }
}

Button.prototype.GetFlagIdType= function(flagIdType)
{
  	return  this.flag_id_type;
}

Button.prototype.SetMaxStringLength = function(max_Length){
         this.MaxStringLength = max_Length;
}

Button.prototype.GetMaxStringLength = function(){
    return this.MaxStringLength; 
}

Button.prototype.SetMinStringLength = function(min_Length){
         this.MinStringLength = min_Length;
}

Button.prototype.GetMinStringLength = function(){
    return this.MinStringLength; 
}

Button.prototype.SetHelpText = function(helpString, helpStyle)
{
    this.HelpTextString = helpString;
    
    if(helpStyle)
    {
        this.HelpTextStyle = helpStyle;
    }
    
    this.SetText(this.TextString);
} 

Button.prototype.SetOnTextChangeFunc = function(func){

    if(func)
    {
        this.onTextChangeFunc=func;
    }
}

Button.prototype.SetTextEditorInfo = function(s_titie, s_msg){
     if(s_titie)
     {
        this.textEditorTitle=s_titie;
     }
     if(s_msg)
     {
        this.textEditorMsg=s_msg;
     }
}

Button.prototype.GetTextEditorTitle = function(){
    return this.textEditorTitle; 
}

Button.prototype.GetTextEditorMsg = function(){
    return this.textEditorMsg; 
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////

Button.prototype.highlight = function(){

    this.flag_highlight = true;
    
        this.image_layer.SetBgImage( this.BtnImg[BtnImgIndex.BTN_NORMAL_FOCUS_IMG] );
        
      
        if(this.HelpStringShowState == true && this.HelpTextStyle.length >0)
        {
            this.text_layer.SetTextStyle( this.HelpTextStyle );
        }
        else
        {
            if(this.BtnTextStyle[BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE])
            {
                this.text_layer.SetTextStyle( this.BtnTextStyle[BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE] );
            }
            else if(this.BtnTextStyle[BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE])
            {
                this.text_layer.SetTextStyle( this.BtnTextStyle[BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE] );
            }
        }

    
    /*if( this.helpBar)
    {
         this.helpBar.visibleObj();
    }*/
	this.visibleHelpBar();

}

Button.prototype.blur = function(){

    this.flag_highlight = false;
    
      if(this.flag_dim == false)
    {
        this.image_layer.SetBgImage( this.BtnImg[BtnImgIndex.BTN_NORMAL_IMG] );
        
        if(this.HelpStringShowState == true && this.HelpTextStyle.length >0)
        {
            this.text_layer.SetTextStyle( this.HelpTextStyle );
        }
        else
        {
            if(this.BtnTextStyle[BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE])
            {
                this.text_layer.SetTextStyle( this.BtnTextStyle[BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE] );
            }
        }
    }
    
    /*if( this.helpBar)
    {
         this.helpBar.hiddenObj();
    }*/
	this.hiddenHelpBar();
}

Button.prototype.select = function(){
    
    if(this.BtnImg[BtnImgIndex.BTN_SELECTED_IMG])
    {
        this.image_layer.SetBgImage( this.BtnImg[BtnImgIndex.BTN_SELECTED_IMG] );
    }
    
    if(this.BtnTextStyle[BtnTextStyleIndex.BTN_TEXT_SELECTED_STYLE])
    {
        this.text_layer.SetTextStyle( this.BtnTextStyle[BtnTextStyleIndex.BTN_TEXT_SELECTED_STYLE] );
    }
    
    /*if( this.helpBar)
    {
         this.helpBar.hiddenObj();
    }*/
	this.hiddenHelpBar();
}

Button.prototype.flagHighlight = function(){

    return this.flag_highlight;
}


Button.prototype.AppendFgImage = function(id,h_space, v_space, w, h, img_src)
{
    this.image_layer.AppendFgImage(id,h_space, v_space, w, h, img_src);
}

Button.prototype.SetFgImage = function(img_src){

    this.image_layer.SetFgImage(img_src);
    
}

Button.prototype.registHelpBar= function(obj){
    if(obj)
    {
       this.helpBar = obj;
    }
}

Button.prototype.changeHelpBar= function(obj){
	//alert("Button.prototype.hiddenObj()");
    if(this.helpBar == obj)
    {
        return;
    }
    
    if(this.helpBar != null)
    {
       	this.helpBar.hiddenObj();
    }
    
     if(obj)
    {
       this.helpBar = obj;
       //if(this.flag_highlight ==true)
	   if(this.flag_visible_helpbar== true)
       {
            this.helpBar.visibleObj();
       }
    } 
}

//TEMPCODE:
Button.prototype.changeHelpBarForHiddenObj= function(obj){
	//alert("Button.prototype.hiddenObj()");
    if(this.helpBar == obj)
    {
        return;
    }
    
    if(this.helpBar != null)
    {
       	this.helpBar.hiddenObj();
    }
	      
    if(obj)
	{
           this.helpBar = obj;
    }
	 
}

Button.prototype.visibleHelpBar= function(){
	
	if(this.flag_visible_helpbar == true)
	{
		return;
	}
	else
	{
		this.flag_visible_helpbar = true;
		if( this.helpBar)
	    {
	         this.helpBar.visibleObj();
	    }
	}
}

Button.prototype.hiddenHelpBar= function(){
	
	if(this.flag_visible_helpbar == false)
	{
		return;
	}
	else
	{
		this.flag_visible_helpbar = false;
		if( this.helpBar)
	    {
	         this.helpBar.hiddenObj();
	    }
	}
}


Button.prototype.SetFlagDim = function(b_dim){

    if(this.flag_dim==b_dim  ||  this.flag_highlight ==true)
    {
        return;
    }
    
    this.flag_dim = b_dim;
    
    if(this.flag_dim == true)
    {
        if(this.BtnImg[BtnImgIndex.BTN_DIM_IMG])
        {
            this.image_layer.SetBgImage( this.BtnImg[BtnImgIndex.BTN_DIM_IMG] );
        }
        
        if(this.BtnTextStyle[BtnTextStyleIndex.BTN_TEXT_DIM_STYLE])
        {
            this.text_layer.SetTextStyle( this.BtnTextStyle[BtnTextStyleIndex.BTN_TEXT_DIM_STYLE] );
        }
        
        this.DisableOnClick();	
    }
    else
    {
        this.blur();
        
        this.EnableOnClick();	
    }
}

Button.prototype.GetFlagDim= function(){
    return this.flag_dim;
}

Button.prototype.visibleObj=function()
{
   // alert("Button.prototype.visibleObj()");
    if(this.image_layer)
    {
        this.image_layer.visibleObj();
    }

    if(this.text_layer)
    {
        this.text_layer.visibleObj();
    }
}

Button.prototype.hiddenObj=function(){
    //alert("Button.prototype.hiddenObj()");
    if(this.image_layer)
    {
        this.image_layer.hiddenObj();
    }

    if(this.text_layer)
    {
        this.text_layer.hiddenObj();
    }
}

Button.prototype.SetIsTextInTable = function(flagInTable){

    this.text_layer.SetIsTextInTable(flagInTable) ;
    
}


Button.prototype.setLeft = function(left_value)
{
	var image_id = this.image_layer.GetObjectId();
	$("#"+image_id).css('left', left_value );
}

Button.prototype.SetOnClickCallbackFunc = function(func)
{
	if(WndMgr.MouseClickEnable==false)
	{
		return;	
	}
	
	if(this.image_layer != null)
	{
		alert("Button.SetOnClickCallbackFunc() set on image_layer");
		
		this.onClickCallbackFunc = func;
		this.EnableOnClick();			
	}
}

Button.prototype.SetOnRightClickCallbackFunc = function(func)
{
	if(WndMgr.MouseClickEnable==false)
	{
		return;	
	}
	
	if(this.image_layer != null)
	{
		alert("Button.SetOnRightClickCallbackFunc() set on image_layer");
		
		this.onRightClickCallbackFunc = func;
		if(this.flagClickEnable == true)	
		{
			this.EnableOnRightClick();
		}		
	}
}

Button.prototype.EnableOnClick = function()
{
	if(WndMgr.MouseClickEnable==false)
	{
		return;	
	}
	
	if(this.flagClickEnable == false && this.flag_dim== false)
	{
		var object = this.image_layer.GetObjectId();
		var this_ = this;
		document.getElementById(object).onclick = function(){this_.onClickCallbackFunc(this_);};
		if(this.onRightClickCallbackFunc!=null)
		{
			this.EnableOnRightClick();
		}
		this.flagClickEnable = true;
		$("#"+this.image_layer.GetObjectId()).css({'cursor' : 'pointer'});	
	}
}

Button.prototype.DisableOnClick = function()
{
	if(WndMgr.MouseClickEnable==false)
	{
		return;	
	}
	
	if(this.flagClickEnable == true)
	{
		var object = this.image_layer.GetObjectId();
		document.getElementById(object).onclick = null;		
		if(this.onRightClickCallbackFunc!=null)
		{
			this.DisableRightOnClick();
		}
		this.flagClickEnable = false;
		$("#"+this.image_layer.GetObjectId()).css({'cursor' : ''});	 
	}
}

Button.prototype.EnableOnRightClick = function()
{
	var object = this.image_layer.GetObjectId();
	var this_ = this;
	
	document.getElementById(object).onmousedown = function(){if(event.button==2){this_.onRightClickCallbackFunc(this_);} };

}

Button.prototype.DisableRightOnClick = function()
{
	if(this.flagClickEnable == true)
	{
		var object = this.image_layer.GetObjectId();
		document.getElementById(object).onmousedown = null;
	}
}

Button.prototype.SetReverseDisable = function(flag)
{
	this.text_layer.SetReverseDisable(flag);
}

Button.prototype.SetIsPlainText= function(flag)
{
    this.text_layer.SetIsPlainText(flag);   
}



