

function CompBase () {
   
	this.Showstate  = false;
	
	this.BGLayerIndex	= -1;			//배경 Layer index
   
	this.BGLayerObj	= null;
   
    this.LayerArray = [];
    
    this.clickCallbackFunc			= null;
	this.rightClickCallbackFunc	= null;    
    this.onMouseOverCallbackFunc	= null;
    this.onMouseOutCallbackFunc		= null;
        
    //availity...
    this.flag_ClickEvent		= false;
    this.flag_RightClickEvent	= false;
    this.flag_MouseMoveEvent	= false;    
    //prevent duplication
    this.flag_ClickinProgress		= false;
    this.flag_RightClickinProgress	= false; 
    this.flag_MouseOverProgress		= false;
    this.flag_MouseOutProgress		= false;
}

CompBase.prototype.GetShowState = function() {
		 
	 //alert("CompBase.GetShowState = " + this.ShowState);	 
     return this.Showstate; 

}


CompBase.prototype.GetLastLayerIndex = function() {
	  
	return this.LayerArray.length - 1;

} 

CompBase.prototype.InsertLayer = function(Layer) {
	
    this.LayerArray.push(Layer);    

} 

   
CompBase.prototype.AddTextLayer = function(eID) {

    //alert("CompBase.AddTextLayer(" + tID + ")");
    var textLayer = new TextLayer(eID);

    this.InsertLayer(textLayer); 
    
}

CompBase.prototype.AddImageLayer = function(eID) {

    var imageLayer = new ImageLayer(eID);
    this.InsertLayer(imageLayer); 
    
} 

CompBase.prototype.AddJPGImageLayer = function(eID) {

    var imageLayer = new JPGImageLayer(eID);
    this.InsertLayer(imageLayer); 
    
} 



CompBase.prototype.CreateBG = function(eID) {

    alert("CompBase.CreateBG(" + eID + ")");
    if(eID == null) {
        alert("CCompBase.CreateBG()  >>>   Param is null !!  ");
        return false;
    }
    
    var imageLayer = new ImageLayer(eID);
    
	this.BGLayerIndex = this.LayerArray.length;
	this.BGLayerObj = eID;
	
    this.InsertLayer(imageLayer);
	
	//this.Showstate  = false;
        
}

CompBase.prototype.SetBGImage = function(ImageUrl) {

    alert("CompBase.SetBGImage()");

	this.LayerArray[this.BGLayerIndex].SetImage(ImageUrl);
}


CompBase.prototype.Update = function() {

    //
    
} 

CompBase.prototype.SetTextLayer = function(ArrayIndex,Text) {

    if(ArrayIndex == null || Text == null) {
        alert("[CompBase.SetTextLayer()] Param is null !!");
        return false;
    }
    	
    this.LayerArray[ArrayIndex].SetText(Text);
        
} 

CompBase.prototype.SetImageLayer = function(ArrayIndex,ImageUrl) {

    if(ArrayIndex == null || ImageUrl == null) {
        alert("[CompBase.SetImageLayer()] Param is null !!");
        return false;
    }
	
    this.LayerArray[ArrayIndex].SetImage(ImageUrl);
    
    
} 

CompBase.prototype.SetStyle = function(ArrayIndex,style) {

	alert("CompBase.SetStyle ()" );
    this.LayerArray[ArrayIndex].SetStyle(style);

}

CompBase.prototype.Show = function() {
	
	this.Showstate = true;
	
	if(this.flag_ClickEvent == true)
	{
		this.SetClickEvent();	
	}
	if(this.flag_RightClickEvent == true)
	{
		this.SetRightClickEvent();	
	}
	
	if(this.flag_MouseMoveEvent == true)
	{
		this.SetMouseOverEvent();		
		this.SetMouseOutEvent();	
	}	
		
	$("#"+ this.LayerArray[this.BGLayerIndex].Obj).css('display', 'block');	
}

CompBase.prototype.Hide = function() {
	
	this.Showstate = false;	
	if(this.flag_ClickEvent == true)
	{
		this.ResetClickEvent();	
	}
	if(this.flag_RightClickEvent == true)
	{
		this.ResetRightClickEvent();	
	}	
	
	if(this.flag_MouseMoveEvent == true)
	{
		this.ResetMouseOverEvent();		
		this.ResetMouseOutEvent();	
	}		
			
	$("#"+ this.LayerArray[this.BGLayerIndex].Obj).css('display', 'none');
}

CompBase.prototype.GetBGLayer = function() {
	
	return this.LayerArray[this.BGLayerIndex];
}

//Public
CompBase.prototype.SetOnClickCallbackFunc = function(func) {

	if(WndMgr.MouseClickEnable==false)
	{
		return;	
	}
	
	if(func != null)
	{
		alert("CompBase.SetOnClickCallbackFunc()");		
		this.clickCallbackFunc = func;
		this.SetClickEvent();
		this.flag_ClickEvent = true;
	}
	
}

CompBase.prototype.ResetOnClickCallbackFunc = function() {

	if(WndMgr.MouseClickEnable==false)
	{
		return;	
	}

	alert("CompBase.ResetOnClickCallbackFunc()");	
	this.clickCallbackFunc = null;
	this.ResetClickEvent();
	this.flag_ClickEvent = false;
}

CompBase.prototype.SetOnRightClickCallbackFunc = function(func) {

	if(WndMgr.MouseClickEnable==false)
	{
		return;	
	}
	
	if(func != null)
	{
		alert("CompBase.SetOnRightClickCallbackFunc()");		
		this.rightClickCallbackFunc = func;
		this.SetRightClickEvent();
		this.flag_RightClickEvent = true;
	}
}

CompBase.prototype.ResetOnRightClickCallbackFunc = function() {

	if(WndMgr.MouseClickEnable==false)
	{
		return;	
	}

	alert("CompBase.ResetOnRightClickCallbackFunc()");	
	this.rightClickCallbackFunc = null;
	this.ResetRightClickEvent();
	this.flag_RightClickEvent = false;
}

CompBase.prototype.SetOnMouseOverCallbackFunc = function(func)
{
	if(WndMgr.MouseClickEnable == false)
	{
		return;	
	}	

	if(func != null)
	{
		alert("CompBase.SetOnMouseOverCallbackFunc()");		
		this.onMouseOverCallbackFunc = func;
		this.SetMouseOverEvent();
		this.flag_MouseMoveEvent = true;
	}
}

CompBase.prototype.SetOnMouseOutCallbackFunc = function(func)
{
	if(WndMgr.MouseClickEnable == false)
	{
		return;	
	}
		
	if(func != null)
	{
		alert("CompBase.SetOnMouseOutCallbackFunc()");		
		this.onMouseOutCallbackFunc = func;
		this.SetMouseOutEvent();
		this.flag_MouseMoveEvent = true;
	}
}

CompBase.prototype.ResetOnMouseOverCallbackFunc = function()
{
	if(WndMgr.MouseClickEnable == false)
	{
		return;	
	}

	alert("CompBase.ResetOnMouseOverCallbackFunc()");	
	this.onMouseOverCallbackFunc = null;
	this.ResetMouseOverEvent();
	this.flag_MouseMoveEvent = false;
	
}

CompBase.prototype.ResetOnMouseOutCallbackFunc = function()
{
	if(WndMgr.MouseClickEnable == false)
	{
		return;	
	}

	alert("CompBase.ResetOnMouseOutCallbackFunc()");	
	this.onMouseOutCallbackFunc = null;
	this.ReetMouseOutEvent();
	this.flag_MouseMoveEvent = false;	
	
}

//Private
CompBase.prototype.SetClickEvent = function() {

	if(WndMgr.MouseClickEnable==false)
	{
		return;	
	}

	if(this.flag_ClickinProgress == false)
	{
		alert("CompBase.SetClickEvent()");
		document.getElementById(this.BGLayerObj).onclick = this.clickCallbackFunc;
		$("#"+this.BGLayerObj).css({'cursor' : 'pointer'});
		this.flag_ClickinProgress = true;
	}
	else{
		alert("CompBase.SetClickEvent()  ===> flag_ClickEvent is true");
	}
}

CompBase.prototype.ResetClickEvent = function() {

	if(WndMgr.MouseClickEnable==false)
	{
		return;	
	}

	if(this.flag_ClickinProgress == true)
	{
		alert("CompBase.ResetClickEvent()");
		document.getElementById(this.BGLayerObj).onclick = null;
		$("#"+this.BGLayerObj).css({'cursor' : ''});
		this.flag_ClickinProgress = false;
	}
} 

CompBase.prototype.SetRightClickEvent = function() {

	if(WndMgr.MouseClickEnable==false)
	{
		return;	
	}

	if(this.flag_RightClickinProgress == false)
	{
		alert("CompBase.SetRightClickEvent()");
		var this_ = this;
		document.getElementById(this.BGLayerObj).onmousedown = function(){if(event.button==2){this_.rightClickCallbackFunc();} };
		this.flag_RightClickinProgress = true;
	}
	else{
		alert("CompBase.SetRightClickEvent()  ===> flag_ClickEvent is true");
	}
}

CompBase.prototype.ResetRightClickEvent = function() {

	if(WndMgr.MouseClickEnable==false)
	{
		return;	
	}

	if(this.flag_RightClickinProgress == true)
	{
		alert("CompBase.ResetRightClickEvent()");
		document.getElementById(this.BGLayerObj).onmousedown = null;
		this.flag_RightClickinProgress = false;
	}
} 

//mouse move...
CompBase.prototype.SetMouseOverEvent = function() {

	if(WndMgr.MouseClickEnable==false)
	{
		return;	
	}

	if(this.flag_MouseOverProgress == false)
	{
		alert("CompBase.SetMouseOverEvent()");
		document.getElementById(this.BGLayerObj).onmouseover = this.onMouseOverCallbackFunc;
		this.flag_MouseOverProgress = true;
	}
	else{
		alert("CompBase.SetMouseOverEvent()  ===> flag_MouseOverProgress is true");
	}

}

CompBase.prototype.ResetMouseOverEvent = function() {

	if(WndMgr.MouseClickEnable==false)
	{
		return;	
	}

	if(this.flag_MouseOverProgress == true)
	{
		alert("CompBase.ResetMouseOverEvent()");
		document.getElementById(this.BGLayerObj).onmouseover = null;

		this.flag_MouseOverProgress = false;
	}
} 

CompBase.prototype.SetMouseOutEvent = function() {

	if(WndMgr.MouseClickEnable==false)
	{
		return;	
	}

	if(this.flag_MouseOutProgress == false)
	{
		alert("CompBase.SetMouseOutEvent()");
		document.getElementById(this.BGLayerObj).onmouseout = this.onMouseOutCallbackFunc;
		this.flag_MouseOutProgress = true;
	}
	else{
		alert("CompBase.SetMouseOutEvent()  ===> flag_MouseOutProgress is true");
	}
}

CompBase.prototype.ResetMouseOutEvent = function() {

	if(WndMgr.MouseClickEnable==false)
	{
		return;	
	}

	if(this.flag_MouseOutProgress == true)
	{
		alert("CompBase.ResetMouseOutEvent()");
		document.getElementById(this.BGLayerObj).onmouseout = null;
		this.flag_MouseOutProgress = false;
	}
} 

