
var BUTTON_BASE_TYPE = { 
 
 	ONLY_BG		: 0,
 	BG_TEXT		: 1,
	BG_FG		: 2, 	
	BG_FG_TEXT	: 3,
}

var BUTTON_BASE_STATE = { 
 
 	NORMAL		: 0,
 	HIGHLIGHT	: 1,
	SELECT		: 2, 	
	DIM			: 3,
	MAX			: 4
}


function ButtonBase() {

    this.FgImgLayerIndex	= -1;		//Fg Image 
    this.TextLayerIndex		= -1;
    
	this.BgImgPath = new Array(BUTTON_BASE_STATE.MAX);
	this.FgImgPath = new Array(BUTTON_BASE_STATE.MAX);
	  
	this.TextStyle = new Array(BUTTON_BASE_STATE.MAX);
	this.BgImgStyle = new Array(BUTTON_BASE_STATE.MAX);
	this.FgImgStyle = new Array(BUTTON_BASE_STATE.MAX);
   
	this.buttonType = BUTTON_BASE_TYPE.ONLY_BG;
	this.state = BUTTON_BASE_STATE.NORMAL;
   	
	this.Id	= null;
	
	CompBase.call(this);
}


ButtonBase.prototype = new CompBase(); 

ButtonBase.prototype.Create = function(eID,nType){
	
    alert("ButtonBase.Create(" + eID + ")");
    if(eID == null) {
        alert("ButtonBase.Create()  >>>   Param is null !!  ");
        return false;
    }
    	
	this.CreateBG(eID);	
	
	if(nType > 1) {
		this.CreateFG(eID + "Fg");	
	}
	if((nType % 2) > 0) {
		this.CreateText(eID + "Text");
	}
		
}

ButtonBase.prototype.CreateFG = function(eID){
	
    var imageLayer = new ImageLayer(eID);
    
	this.FgImgLayerIndex = this.LayerArray.length;
	
    this.InsertLayer(imageLayer);
	
}

ButtonBase.prototype.CreateText = function(eID){
	
    var textLayer = new TextLayer(eID);
    
	this.TextLayerIndex = this.LayerArray.length;
	
    this.InsertLayer(textLayer);
	
}


ButtonBase.prototype.SetBgImage = function(stateIndex,ImagePath){
    	
    this.BgImgPath[stateIndex] = ImagePath;
    
    if(stateIndex == BUTTON_BASE_STATE.NORMAL)
    {
		this.LayerArray[this.BGLayerIndex].SetImage(ImagePath);
    }
}

ButtonBase.prototype.SetFgImage = function(stateIndex,ImagePath){
    	
    this.FgImgPath[stateIndex] = ImagePath;
    
    if(stateIndex == BUTTON_BASE_STATE.NORMAL)
    {
		this.LayerArray[this.FgImgLayerIndex].SetImage(ImagePath);
    }
}

ButtonBase.prototype.SetBgStyle = function(stateIndex,Style){
    
    this.BgImgStyle[stateIndex] = Style;
    
    if(stateIndex == BUTTON_BASE_STATE.NORMAL)
    {
		this.LayerArray[this.BGLayerIndex].SetStyle(Style);		
    }
}

ButtonBase.prototype.SetFgStyle = function(stateIndex,Style){
    
    this.FgImgStyle[stateIndex] = Style;
    
    if(stateIndex == BUTTON_BASE_STATE.NORMAL)
    {
		this.LayerArray[this.FgImgLayerIndex].SetStyle(Style);		
    }
}

ButtonBase.prototype.SetTextStyle = function(stateIndex,Style){
    
    this.TextStyle[stateIndex] = Style;
    
    if(stateIndex == BUTTON_BASE_STATE.NORMAL)
    {
		this.LayerArray[this.TextLayerIndex].SetStyle(Style);		
    }
}

ButtonBase.prototype.SetText = function(string){
	
	if(this.TextLayerIndex > 0)  
	{
		this.LayerArray[this.TextLayerIndex].SetText(string);
	}

}



ButtonBase.prototype.ChangeMode = function() {
	
	var curState = this.state;
	
	if(this.BgImgPath[curState]) {
		this.LayerArray[this.BGLayerIndex].SetImage(this.BgImgPath[curState]);		
	}
	
	if(this.FgImgPath[curState]){
		this.LayerArray[this.FgImgLayerIndex].SetImage(this.FgImgPath[curState]);	
	}
	
	if(this.TextStyle[curState]){
		this.LayerArray[this.TextLayerIndex].SetStyle(this.TextStyle[curState]);
	}

	if(this.BgImgStyle[curState]){
		this.LayerArray[this.BGLayerIndex].SetStyle(this.BgImgStyle[curState]);
	}
	
	if(this.FgImgStyle[curState]){
		this.LayerArray[this.FgImgLayerIndex].SetStyle(this.FgImgStyle[curState]);
	}	
}

ButtonBase.prototype.Show = function() {
	
	this.Showstate = true;
	
	if(this.flag_ClickEvent == true)
	{
		if(this.state == BUTTON_BASE_STATE.NORMAL)
		{
			this.SetClickEvent();	
		}
	}	
	$("#"+ this.LayerArray[this.BGLayerIndex].Obj).css('display', 'block');	
}

ButtonBase.prototype.Hide = function() {
	
	this.Showstate = false;
	
	if(this.flag_ClickEvent == true)
	{
		this.ResetClickEvent();	
	}		
	$("#"+ this.LayerArray[this.BGLayerIndex].Obj).css('display', 'none');
}

ButtonBase.prototype.highlight = function(){

    this.state    = BUTTON_BASE_STATE.HIGHLIGHT;
	this.ChangeMode();

	if(this.flag_ClickEvent == true)
	{
		this.SetClickEvent();	
	}	
}

ButtonBase.prototype.blur = function(){

    this.state    = BUTTON_BASE_STATE.NORMAL;
	this.ChangeMode();
	
	if(this.flag_ClickEvent == true)
	{
		this.SetClickEvent();	
	}		
}

ButtonBase.prototype.select = function(){
    
    this.state    = BUTTON_BASE_STATE.SELECT;
	this.ChangeMode();
	
	if(this.flag_ClickEvent == true)
	{
		this.ResetClickEvent();	
	}	
}

ButtonBase.prototype.dim = function(){
    
    this.state    = BUTTON_BASE_STATE.DIM;
	this.ChangeMode();
	
	if(this.flag_ClickEvent == true)
	{
		this.ResetClickEvent();	
	}	
}

ButtonBase.prototype.SetID = function(nID){
    this.ID = nID;
}

ButtonBase.prototype.GetID = function(){
    return this.ID;
}

ButtonBase.prototype.GetState = function(){
    return this.state;
}


