function SceneAccountConnection(options) {
	this.options = options;
    
    this.MainView=null;
	this.MainViewDim=null;
    
    this.TitleBar = null;    
    this.MsgLabel = null;
    
    this.SkypeNameLabel = null;
    this.SkypeNameInputBox = null;
    
    this.PasswordLabel = null;
    this.PasswordInputBox = null;
    
    this.SigninBtn = null;
    this.CancelBtn = null;
    
    this.DefaultHelpBar =null;
    this.InputHelpBar =null;
	
	this.InitFlag = true;
	this.CloseTimer = false;
}

SceneAccountConnection.prototype.initialize = function () {
	alert("SceneAccountConnection.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
    
   this.create();
}

SceneAccountConnection.prototype.handleShow = function () {
	alert("SceneAccountConnection.handleShow()");
	// this function will be called when the scene manager show this scene 
    
    this.MainViewDim.show();
     if(this.InitFlag == true)
    {
        this.initAccountConnection();
    }
	
	this.startTimer();
}

SceneAccountConnection.prototype.handleHide = function () {
	alert("SceneAccountConnection.handleHide()");
	// this function will be called when the scene manager hide this scene  

    this.MainViewDim.hide();

	if(this.CloseTimer==true)
	{
		this.stopTimer();
	}
}

SceneAccountConnection.prototype.handleFocus = function () {
	alert("SceneAccountConnection.handleFocus()");
	// this function will be called when the scene manager focus this scene
	
	if(this.CloseTimer==false)
	{
		this.startTimer();
	}
    
    var currentHighlight =  this.MainView.getCurrentHighlight();
    
    if(currentHighlight ==null)
    {
        this.highlight(this.SkypeNameBtn);
    }
    else
    {
         this.highlight(currentHighlight);
    }
    if(this.MainViewDim.flag_ShowState==false){
    	this.MainViewDim.show();
    }
}

SceneAccountConnection.prototype.handleBlur = function () {
	alert("SceneAccountConnection.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
    
    var currentHighlight =  this.MainView.getCurrentHighlight();
    currentHighlight.blur();
}

SceneAccountConnection.prototype.handleKeyDown = function (keyCode) {
	alert("SceneAccountConnection.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	switch (keyCode) {
		case $.sfKey.LEFT:
		case $.sfKey.RIGHT:
			this.resetTimer();
		 	this.processLeftRightKey();
			break;
		case $.sfKey.UP:
			this.resetTimer();
        	this.processUpKey();
        	break;
		case $.sfKey.DOWN:
			this.resetTimer();
            this.processDownKey();
			break;

		case $.sfKey.ENTER:
             this.processEnterKey();
			break;
            
        case $.sfKey.RETURN:
        case $.sfKey.EXIT:
            this.processReturnKey();
            $.sfKey.block(event);
			break;

          case 147:  //infolink
          case 261:  //contents
          case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneAccountConnection.prototype.create = function(){
    alert("SceneAccountConnection.create()");
    this.MainView = new View("AccountConnection");
    this.MainView.SetBgImage(g_Image.IMAGE_ACCOUNT_CONNECTION_BG);
	
	this.MainViewDim = new DimBg("AccountConnectionDim", "AccountConnection");  
    
    this.TitleBar = new Label(null,"account_connection_title");
    this.TitleBar.SetTextStyle("account_connection_title_style");
    this.TitleBar.SetText(TV_LINK_SKYPE_ACCOUNT);
    
    this.MsgLabel = new Label(null,"account_connection_msg");
	this.MsgLabel.SetTextStyle("account_connection_msg_style");
    this.MsgLabel.SetText(TV_PLEASE_ENTER_YOUR_SKYPE_ID_AND_PASSWORD);
    
    var CurLangID = ResMgr.GetCurLanguage();  
   
    this.SkypeNameLabel = new Label(null,"account_connection_skype_name_text");
    this.SkypeNameLabel.SetTextStyle("account_connection_text_style");
    this.SkypeNameLabel.SetText(IDWS_MOIP_SKYPE_NAME);

    this.PasswordLabel = new Label(null,"account_connection_password_text");
    this.PasswordLabel.SetTextStyle("account_connection_text_style");
    this.PasswordLabel.SetText(SID_PASSWORD);
    
    if(CurLangID == ENUM_TV_LANGUAGE.GRE)
    {
    	$("#account_connection_password_text").css('width', "126px");
    }

	var this_ = $.sfScene.get("AccountConnection");
	var clickCF =  function(obj){this_.processClickEvent(obj);};
	
    this.SkypeNameBtn= new Button();
    this.SkypeNameBtn.SetImageObjId("account_connection_skype_name_input_box");
    this.SkypeNameBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_ACCOUNT_CONNECTION_INPUT_BTN_NORMAL);
    this.SkypeNameBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_ACCOUNT_CONNECTION_INPUT_BTN_NORMALFOCUS);
    this.SkypeNameBtn.SetTextObjId("account_connection_skype_name_input_box_text");
    this.SkypeNameBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"account_connection_input_btn_style");
    this.SkypeNameBtn.SetMaxStringLength(32);
    this.SkypeNameBtn.SetMinStringLength(6);
    this.SkypeNameBtn.SetIsPlainText(true);
    this.SkypeNameBtn.SetFlagBlockSpace(true);
	this.SkypeNameBtn.SetFlagIdType(true);
    this.SkypeNameBtn.SetOnTextChangeFunc(function(){ this_.invalidSkypeName();});
        	  
 	if(CurLangID == ENUM_TV_LANGUAGE.HEB)
	{
		this.SkypeNameBtn.SetHelpText(IDWS_MOIP_PRESS_ENTER, "account_connection_input_btn_help_large_style");
	}
	else
	{
		this.SkypeNameBtn.SetHelpText(IDWS_MOIP_PRESS_ENTER, "account_connection_input_btn_help_style");
	}      
    this.SkypeNameBtn.SetTextEditorInfo(IDWS_MOIP_SKYPE_NAME, SIGN_IN_KEYPAD_HELP_ENTER_SKYPE_NAME);
    this.SkypeNameBtn.SetOnClickCallbackFunc(clickCF);

    this.PasswordBtn= new Button();
    this.PasswordBtn.SetImageObjId("account_connection_password_input_box");
    this.PasswordBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_ACCOUNT_CONNECTION_INPUT_BTN_NORMAL);
    this.PasswordBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_ACCOUNT_CONNECTION_INPUT_BTN_NORMALFOCUS);
    this.PasswordBtn.SetTextObjId("account_connection_password_input_box_text", true);
    this.PasswordBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"account_connection_input_btn_style");
    this.PasswordBtn.SetMaxStringLength(20);
    this.PasswordBtn.SetMinStringLength(6);
    this.PasswordBtn.SetIsPlainText(true);
    this.PasswordBtn.SetOnTextChangeFunc(function(){ this_.invalidPassword();});    
 	if(CurLangID == ENUM_TV_LANGUAGE.HEB)
	{
		this.PasswordBtn.SetHelpText(IDWS_MOIP_PRESS_ENTER, "account_connection_input_btn_help_large_style");
	}
	else
	{
		this.PasswordBtn.SetHelpText(IDWS_MOIP_PRESS_ENTER, "account_connection_input_btn_help_style");
	}     
    this.PasswordBtn.SetTextEditorInfo(SID_PASSWORD, SIGN_IN_KEYPAD_HELP_ENTER_PASSWORD);
    this.PasswordBtn.SetOnClickCallbackFunc(clickCF);
  
    this.SigninBtn= new Button();
    this.SigninBtn.SetImageObjId("account_connection_ok_btn");
    this.SigninBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_ACCOUNT_CONNECTION_BTN_NORMAL);
    this.SigninBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_ACCOUNT_CONNECTION_BTN_NORMALFOCUS);
    this.SigninBtn.SetBgImage(BtnImgIndex.BTN_DIM_IMG, g_Image.IMAGE_ACCOUNT_CONNECTION_BTN_DIM);
    this.SigninBtn.SetTextObjId("account_connection_ok_btn_text");
    this.SigninBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"account_connection_btn_text_style");
	this.SigninBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"account_connection_btn_text_style");
    this.SigninBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE,"account_connection_btn_text_dim_style");
    this.SigninBtn.SetText(SID_OK);
    this.SigninBtn.SetOnClickCallbackFunc(clickCF);
    
    this.CancelBtn= new Button();
    this.CancelBtn.SetImageObjId("account_connection_cancel_btn");
    this.CancelBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_ACCOUNT_CONNECTION_BTN_NORMAL);
    this.CancelBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_ACCOUNT_CONNECTION_BTN_NORMALFOCUS);
    this.CancelBtn.SetBgImage(BtnImgIndex.BTN_DIM_IMG, g_Image.IMAGE_ACCOUNT_CONNECTION_BTN_DIM);
    this.CancelBtn.SetTextObjId("account_connection_cancel_btn_text");
    this.CancelBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"account_connection_btn_text_style");
	this.CancelBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"account_connection_btn_text_style");
    this.CancelBtn.SetText(SID_CANCEL);
    this.CancelBtn.SetOnClickCallbackFunc(clickCF);
    
    this.DefaultHelpBar = new HelpBar(HelpBarIndex.ACCOUNT_CONNECTION,"AccountConnection");
    this.DefaultHelpBar.SetOnClickCallbackFunc(1, function(){this_.processReturnKey();});
    
    this.InputHelpBar = new HelpBar(HelpBarIndex.ACCOUNT_CONNECTION_INPUT,"AccountConnection");
    this.InputHelpBar.SetOnClickCallbackFunc(1, function(){this_.startTextInput();});
    this.InputHelpBar.SetOnClickCallbackFunc(2, function(){this_.processReturnKey();});

    this.SigninBtn.registHelpBar( this.DefaultHelpBar);
    this.CancelBtn.registHelpBar( this.DefaultHelpBar);
    this.SkypeNameBtn.registHelpBar( this.InputHelpBar);
    this.PasswordBtn.registHelpBar( this.InputHelpBar);
    
}

SceneAccountConnection.prototype.setInitFlag= function(init_flag){
     this.InitFlag = init_flag;
}

SceneAccountConnection.prototype.initAccountConnection= function()
{
    alert("SceneAccountConnection.initAccountConnection() ");
    
    this.SkypeNameBtn.SetText("");
    this.PasswordBtn.SetText("");

	this.highlight(null);
    this.InitFlag = false;

    this.SigninBtn.SetFlagDim(true);
}

SceneAccountConnection.prototype.highlight=function(obj)
{
    this.MainView.setCurrenHighlight(obj);
 
}

SceneAccountConnection.prototype.startTextInput = function(){
    alert("SceneAccountConnection.startTextInput() ");
    
    var currentHighlight =  this.MainView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.SkypeNameBtn:
        case this.PasswordBtn:
        
			if(this.CloseTimer==true)
			{
				this.stopTimer();
			}
		    WndMgr.StartTextEditor(currentHighlight, "AccountConnection",this.MainViewDim);
            break;            
    }    
}

SceneAccountConnection.prototype.processLeftRightKey = function(){
    alert("SceneAccountConnection.processLeftRightKey() ");
    var currentHighlight =  this.MainView.getCurrentHighlight();
    
    switch(currentHighlight)
    {              
        case this.SigninBtn:
        	this.highlight(this.CancelBtn);
            break;  
            
        case this.CancelBtn:	
	         if( this.SigninBtn.GetFlagDim() == false)
	         {
	         	this.highlight(this.SigninBtn);
	         }	    
		    
            break;  
    }
}

SceneAccountConnection.prototype.processUpKey = function(){
    alert("SceneAccountConnection.processUpKey() ");
    
    var currentHighlight =  this.MainView.getCurrentHighlight();

    switch(currentHighlight)
    {
        case this.SkypeNameBtn:
               if( this.SigninBtn.GetFlagDim() == false)
               {
                    this.highlight(this.SigninBtn);
               }
               else
               {
                    this.highlight(this.CancelBtn);
               }           
            break;
            
        case this.PasswordBtn:
            this.highlight(this.SkypeNameBtn);
            break;
            
        case this.SigninBtn:
            this.highlight(this.PasswordBtn);          
            break;
      	
        case this.CancelBtn:
            this.highlight(this.PasswordBtn);          
            break;
    }
}

SceneAccountConnection.prototype.processDownKey = function(){
    alert("SceneAccountConnection.processDownKey() ");
    
    var currentHighlight =  this.MainView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.SkypeNameBtn:
                this.highlight(this.PasswordBtn);          
            break;
            
        case this.PasswordBtn:       
               if( this.SigninBtn.GetFlagDim() == false)
               {
                    this.highlight(this.SigninBtn);
               }
               else
               {
                    this.highlight(this.CancelBtn);
               } 
            break;
            
        case this.SigninBtn:
            this.highlight(this.SkypeNameBtn);          
            break;
      	
        case this.CancelBtn:
            this.highlight(this.SkypeNameBtn);          
            break;
    }
}

SceneAccountConnection.prototype.processEnterKey = function(){
    alert("SceneAccountConnection.processEnterKey() ");
    
    var currentHighlight =  this.MainView.getCurrentHighlight();
    
    switch(currentHighlight)
    {     
        case this.SkypeNameBtn:
        case this.PasswordBtn:       
			this.startTextInput();
            break;
            
        case this.SigninBtn:
         	this.requestSignin();
            break;
      	
        case this.CancelBtn:
        	this.setInitFlag(true);
         	WndMgr.BackStepFaceRecogSignin();
            break;
    }
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneAccountConnection.prototype.requestSignin = function(){
    alert("SceneAccountConnection.requestSignin() ");
    if(PluginAPIMgr.IsValidEmail(this.SkypeNameBtn.GetText())==false){
    	ProcMgr.RequestFaceRegistrationAfterSignin(this.SkypeNameBtn.GetText(), this.PasswordBtn.GetText());
    }else{
    	WndMgr.FaceRecogSigninStep="EmailAccount";
    	WndMgr.NextStepFaceRecogSignin();
    }
}

SceneAccountConnection.prototype.InputPWDAgain = function()
{
    alert("SceneSignin.InputPWDAgain() ");
   
    this.highlight(this.PasswordBtn);
    this.PasswordBtn.SetText("");
   	$.sfScene.focus('Signin');
}

SceneAccountConnection.prototype.invalidSkypeName = function(){
    alert("SceneAccountConnection.invalidSkypeName() ");
    if(this.InitFlag ==true)
    {
        return;
    }

    this.checkSigninBtnEnable();
    
    var inputText = this.SkypeNameBtn.GetText();
    
    if(inputText.length > 0)
    {
        this.highlight(this.PasswordBtn);
    } 

}

SceneAccountConnection.prototype.invalidPassword = function(){
    alert("SceneAccountConnection.invalidPassword() ");
     if(this.InitFlag ==true)
    {
        return;
    }
    
     this.checkSigninBtnEnable();
    
    var PWDInputText = this.PasswordBtn.GetText();
    
     if(PWDInputText.length > 0)
    {
        var inputText = this.SkypeNameBtn.GetText();
        if( inputText.length > 0)
        {
            this.highlight(this.SigninBtn);
        }
        else
        {
            this.highlight(this.SkypeNameBtn);
        }
    }
}

SceneAccountConnection.prototype.checkSigninBtnEnable = function(){
    var SkypeNameInputText = this.SkypeNameBtn.GetText();
    var PWDInputText = this.PasswordBtn.GetText();
    
    if(SkypeNameInputText.length > 0 && PWDInputText.length >0)
    {
         alert("SceneAccountConnection.checkSigninBtnEnable()  : false");
        this.SigninBtn.SetFlagDim(false);
    }
    else
    {
        alert("SceneAccountConnection.checkSigninBtnEnable()  : true");
        this.SigninBtn.SetFlagDim(true);
        
    }
}

SceneAccountConnection.prototype.processReturnKey = function(){
    alert("SceneAccountConnection.processReturnKey() ");
	this.setInitFlag(true);
 	WndMgr.BackStepFaceRecogSignin();
}

SceneAccountConnection.prototype.startTimer = function()
{
    alert("SceneAccountConnection.startTimer() ");
	
	this.CloseTimer = true;
	PluginAPIMgr.StartOSDTimer("60000" , function() { $.sfScene.get('AccountConnection').popupTimerCallback();}, ENUM_TIMER_TYPE.POPUP_WND);
}

SceneAccountConnection.prototype.resetTimer = function()
{
    alert("SceneAccountConnection.resetTimer() ");

	if(this.CloseTimer == true)
	{
		PluginAPIMgr.RestartOSDTimer("60000" ,ENUM_TIMER_TYPE.POPUP_WND);
	}
}

SceneAccountConnection.prototype.stopTimer = function()
{
    alert("SceneAccountConnection.stopTimer() ");
	
	this.CloseTimer = false;
	PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.POPUP_WND);
}

SceneAccountConnection.prototype.popupTimerCallback = function()
{
	alert("SceneAccountConnection.popupTimerCallback() ");
	if(this.CloseTimer==false)
   {
   	return
   }
   this.CloseTimer = false;
   
	this.setInitFlag(true);
 	WndMgr.BackStepFaceRecogSignin();
}

SceneAccountConnection.prototype.processClickEvent = function(obj){
	alert("SceneAccountConnection.processClickEvent() ");
	
	var currentHighlight =  this.MainView.getCurrentHighlight();
    if(currentHighlight != obj)
    {
    	this.highlight(obj);
    }
	
	this.processEnterKey();
}




