function SceneAddContact(options) {
	this.options = options;

    this.AddContactView=null;
	this.AddContactDim=null;
    
    this.TitleBar = null;    
    this.MsgLabel = null;

    this.SkypeNameBtn = null;
    this.PhoneNumberBtn = null;
    
    this.AddContactHelpBar = null;
	
	this.flagResetData = false;
	this.CloseTimer = false;

}

SceneAddContact.prototype.initialize = function () {
	alert("SceneAddContact.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
    
   this.create();
}

SceneAddContact.prototype.handleShow = function () {
	alert("SceneAddContact.handleShow()");
	// this function will be called when the scene manager show this scene 
	
	this.AddContactDim.show();
	
	if(this.flagResetData== true)
	{
		this.resetData();
	}   
	
	this.startTimer();
}

SceneAddContact.prototype.handleHide = function () {
	alert("SceneAddContact.handleHide()");
	// this function will be called when the scene manager hide this scene  
	
	this.AddContactDim.hide();
	
	if(this.CloseTimer==true)
	{
		this.stopTimer();
	}

}

SceneAddContact.prototype.handleFocus = function () {
	alert("SceneAddContact.handleFocus()");
	// this function will be called when the scene manager focus this scene
	
	var currentHighlight =  this.AddContactView.getCurrentHighlight();
    if(currentHighlight ==null)
    {
        this.highlight(this.SkypeNameBtn);
    }
    else
    {
         this.highlight(currentHighlight);
    }
}

SceneAddContact.prototype.handleBlur = function () {
	alert("SceneAddContact.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
	
	
}

SceneAddContact.prototype.handleKeyDown = function (keyCode) {
	alert("SceneAddContact.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	PluginAPIMgr.PlayAudio(keyCode);
	
	switch (keyCode) {
		case $.sfKey.LEFT:
		case $.sfKey.RIGHT:

			break;
		case $.sfKey.UP:
		case $.sfKey.DOWN:
			this.resetTimer();
            this.processUpDownKey();
			break;

		case $.sfKey.ENTER:
             this.processEnterKey();
			break;
            
        case $.sfKey.RETURN:
            this.processReturnKey();
            $.sfKey.block(event);
			break;
            
        case $.sfKey.EXIT:
        	this.processExitKey();
            $.sfKey.block(event);
			break;
            
         case 147:  //infolink
         case 261:  //contents
         case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneAddContact.prototype.create = function(){
    alert("SceneAddContact.create()");
	
    this.AddContactView = new View("AddContact");
    this.AddContactView.SetBgImage(g_Image.IMAGE_ADD_CONTACT_BG);
	
	this.AddContactDim = new DimBg("AddContactDim", "AddContact");
    
    this.TitleBar = new Label(null,"add_contact_title");
    this.TitleBar.SetTextStyle("add_contact_title_style");
    this.TitleBar.SetText(IDWS_MOIP_SKYPE_ADD_A_CONTACT);
   
    this.MsgLabel = new Label(null,"add_contact_msg");
    this.MsgLabel.SetTextStyle("add_contact_msg_style");
    this.MsgLabel.SetText(IDWS_MOIP_SKYPE_SELECT_A_CONTACT_TYPE);
    
    var this_ = $.sfScene.get("AddContact");
	var clickCF =  function(obj){this_.processClickEvent(obj);};
        
    this.SkypeNameBtn = new Button();
    this.SkypeNameBtn.SetImageObjId("add_contact_skype_name_btn");
    this.SkypeNameBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_ADD_CONTACT_BTN_NORMAL);
    this.SkypeNameBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_ADD_CONTACT_BTN_NORMALFOCUS);	
    this.SkypeNameBtn.SetTextObjId("add_contact_skype_name_btn_text");
    this.SkypeNameBtn.SetText(IDWS_MOIP_SKYPE_ADD_A_SKYPE_CONTACT);
	this.SkypeNameBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"common_btn_text_f19_normal_style");
   	this.SkypeNameBtn.SetOnClickCallbackFunc(clickCF);
   
    this.PhoneNumberBtn = new Button();
    this.PhoneNumberBtn.SetImageObjId("add_contact_phone_number_btn");
    this.PhoneNumberBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_ADD_CONTACT_BTN_NORMAL);
    this.PhoneNumberBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_ADD_CONTACT_BTN_NORMALFOCUS);	
    this.PhoneNumberBtn.SetTextObjId("add_contact_phone_number_btn_text");
    this.PhoneNumberBtn.SetText(IDWS_MOIP_SKYPE_ADD_A_PHONE_NUMBER);
	this.PhoneNumberBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"common_btn_text_f19_normal_style");
	this.PhoneNumberBtn.SetOnClickCallbackFunc(clickCF);
	
    this.AddContactHelpBar = new HelpBar(HelpBarIndex.ADD_CONTACT, "AddContact");
    this.AddContactHelpBar.SetOnClickCallbackFunc(1, function(){this_.processReturnKey();});
    
    this.AddContactView.registHelpBar( this.AddContactHelpBar);

}

SceneAddContact.prototype.setResetFlag= function(reset_flag){
     this.flagResetData = reset_flag;
}

SceneAddContact.prototype.resetData = function()
{  
	this.highlight(null);
    this.flagResetData= false;	
}

SceneAddContact.prototype.highlight=function(obj)
{
    this.AddContactView.setCurrenHighlight(obj);

}

SceneAddContact.prototype.processUpDownKey = function(){
    alert("SceneAddContact.processUpDownKey() ");
    
    var currentHighlight =  this.AddContactView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.SkypeNameBtn:
            this.highlight(this.PhoneNumberBtn);
            break;
            
        case this.PhoneNumberBtn:
            this.highlight(this.SkypeNameBtn);
            break;
    }
}


SceneAddContact.prototype.processEnterKey = function(){
    alert("SceneAddContact.processEnterKey() ");
    
    var currentHighlight =  this.AddContactView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.SkypeNameBtn:
            WndMgr.StartAddContactSkypeNameStep();
            break;
            
        case this.PhoneNumberBtn:
        	WndMgr.StartAddContactPhoneNumberStep();            
            break;
    }
}

SceneAddContact.prototype.processReturnKey = function(){
    alert("SceneAddContact.processReturnKey() ");
    StateMgr.Stop_Add_Contact_State(true);

}

SceneAddContact.prototype.processExitKey = function(){
    alert("SceneAddContact.processExitKey() ");
    StateMgr.Stop_Add_Contact_State(true);

}

SceneAddContact.prototype.startTimer = function()
{
    alert("SceneAddContact.startTimer() ");
	
	this.CloseTimer = true;
	PluginAPIMgr.StartOSDTimer("60000" , function() { $.sfScene.get('AddContact').popupTimerCallback();}, ENUM_TIMER_TYPE.POPUP_WND);
}

SceneAddContact.prototype.resetTimer = function()
{
    alert("SceneAddContact.resetTimer() ");

	if(this.CloseTimer == true)
	{
		PluginAPIMgr.RestartOSDTimer("60000" ,ENUM_TIMER_TYPE.POPUP_WND);
	}
}

SceneAddContact.prototype.stopTimer = function()
{
    alert("SceneAddContact.stopTimer() ");
	
	this.CloseTimer = false;
	PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.POPUP_WND);
}

SceneAddContact.prototype.popupTimerCallback = function()
{
   alert("SceneAddContact.popupTimerCallback() ");
   if(this.CloseTimer==false)
   {
   	return
   }
   this.CloseTimer = false;
	StateMgr.Stop_Add_Contact_State(true);
}

SceneAddContact.prototype.processClickEvent = function(obj){
	alert("SceneVoiceCall.processClickEvent() ");
	
	var currentHighlight =  this.AddContactView.getCurrentHighlight();
    if(currentHighlight != obj)
    {
    	this.highlight(obj);
    }
	
	this.processEnterKey();
}




