function SceneAddContactSearchResult(options) {

	this.options	= options;
    
	this.SearchList		= null;

	this.UpArrow		= null;
	this.DownArrow		= null;

    this.AddContactSearchResult	= null;
	this.AddContactSearchResultDim = null;
    
    this.TitleBar 		= null;

	this.FullNameLabel	= null;
	this.SkypeNameLabel	= null;
	this.CountryLabel	= null;
	
     this.SearchResultHelpBar =null;
	 this.CloseTimer = false;

	this.WheelOperation = false;	 

}

SceneAddContactSearchResult.prototype.initialize = function () {
	alert("SceneAddContactSearchResult.initialize()");
	this.create();
}

SceneAddContactSearchResult.prototype.handleShow = function () {
	alert("SceneAddContactSearchResult.handleShow()");
    this.AddContactSearchResultDim.show();
    //this.SearchList.Show();
    this.resetData();
	
	this.startTimer();

}

SceneAddContactSearchResult.prototype.handleHide = function () {
	alert("SceneAddContactSearchResult.handleHide()");
	this.AddContactSearchResultDim.hide();
	
	if(this.CloseTimer==true)
	{
		this.stopTimer();
	}
}

SceneAddContactSearchResult.prototype.handleFocus = function () {
	alert("SceneAddContactSearchResult.handleFocus()");
    
	//check exception
	this.SearchList.highlight();
}

SceneAddContactSearchResult.prototype.handleBlur = function () {
	alert("SceneAddContactSearchResult.handleBlur()");
	
	this.SearchList.blur();
}

SceneAddContactSearchResult.prototype.handleKeyDown = function (keyCode) {	
	alert("SceneAddContactSearchResult.handleKeyDown(" + keyCode + ")");
	PluginAPIMgr.PlayAudio(keyCode);
	
		switch (keyCode) {
			case $.sfKey.UP:
				this.resetTimer();
				break;
			case $.sfKey.DOWN:
				this.resetTimer();
				break;
		}
		
		this.SearchList.KeyProcess(keyCode);	
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneAddContactSearchResult.prototype.create = function(){
    alert("SceneAddContactSearchResult.create() ");

    this.AddContactSearchResult = new View("AddContactSearchResult");
    this.AddContactSearchResult.SetBgImage(g_Image.IMAGE_ADD_CONTACT_SEARCH_BG);
	
	this.AddContactSearchResultDim = new DimBg("AddContactSearchResultDim", "AddContactSearchResult");

    this.TitleBar = new Label(null,"add_contact_search_result_title");    
    this.TitleBar.SetText(IDWS_MOIP_SKYPE_ADD_A_SKYPE_CONTACT);
	
    this.FullNameLabel = new Label(null,"add_contact_search_result_full_name");    
    this.FullNameLabel.SetText(IDWS_MOIP_FULL_NAME);

    this.SkypeNameLabel = new Label(null,"add_contact_search_result_skype_name");    
    this.SkypeNameLabel.SetText(IDWS_MOIP_SKYPE_NAME);

    this.CountryLabel = new Label(null,"add_contact_search_result_country");    
    this.CountryLabel.SetText(IDWS_MOIP_SETTING_COUNTRY);
	
	this.SearchList = new SearchList();	
    this.SearchList.Create();


    var this_ = $.sfScene.get("AddContactSearchResult");
    var list_ = this_.SearchList;

	this.UpArrow = new CompBase(); 
	this.UpArrow.CreateBG("searchListUpArrow");
	this.UpArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_UP_NOR);
	this.UpArrow.SetOnClickCallbackFunc(function(){list_.PreviousPage();});	
	this.UpArrow.SetOnMouseOverCallbackFunc(function(){this_.ChangeArrow(ARROW_TYPE.UP_SEL);});
	this.UpArrow.SetOnMouseOutCallbackFunc(function(){this_.ChangeArrow(ARROW_TYPE.UP_NOR);});
    
	this.DownArrow = new CompBase(); 
	this.DownArrow.CreateBG("searchListDownArrow");
	this.DownArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_DOWN_NOR);
	this.DownArrow.SetOnClickCallbackFunc(function(){list_.NextPage();});	
	this.DownArrow.SetOnMouseOverCallbackFunc(function(){this_.ChangeArrow(ARROW_TYPE.DOWN_SEL);});
	this.DownArrow.SetOnMouseOutCallbackFunc(function(){this_.ChangeArrow(ARROW_TYPE.DOWN_NOR);});		    
        
    this.SearchResultHelpBar = new HelpBar(HelpBarIndex.ADD_CONTACT_SEARCH_RESULT, "AddContactSearchResult");
    this.SearchResultHelpBar.SetOnClickCallbackFunc(1, function(){this_.processReturnKey();});
    
    this.AddContactSearchResult.registHelpBar( this.SearchResultHelpBar);

    this.TempDiv = document.getElementById("AddContactSearchResult");
   	this.TempDiv.onmousewheel = function()
   	{
   		if(this_.WheelOperation == false)
   		{
   			alert("SceneListMainContact.onmousewheel");
	   		this_.WheelOperation = true;
	   		PluginAPIMgr.StartOSDTimer("700" , function() { this_.wheelTimerCallback();}, ENUM_TIMER_TYPE.NO_BUTTON);
	   		
			if(event.wheelDelta > 0)
			{
				//alert("Up Up");
				list_.PreviousPage();
			}
			else
			{
				//alert("Down Down");
				list_.NextPage();
			}
	    }		
    };
    
}


SceneAddContactSearchResult.prototype.resetData= function(){
	
	this.SearchList.Reset();
	
	if(this.SearchList.TotalPage > 1)
	{
		this.UpArrow.Show();		
		this.DownArrow.Show();
	}
	else
	{
		this.UpArrow.Hide();		
		this.DownArrow.Hide();;
	}	
}

SceneAddContactSearchResult.prototype.startTimer = function()
{
    alert("SceneAddContactSearchResult.startTimer() ");
	
	this.CloseTimer = true;
	PluginAPIMgr.StartOSDTimer("60000" , function() { $.sfScene.get('AddContactSearchResult').popupTimerCallback();}, ENUM_TIMER_TYPE.POPUP_WND);
}

SceneAddContactSearchResult.prototype.resetTimer = function()
{
    alert("SceneAddContactSearchResult.resetTimer() ");

	if(this.CloseTimer == true)
	{
		PluginAPIMgr.RestartOSDTimer("60000" ,ENUM_TIMER_TYPE.POPUP_WND);
	}
}

SceneAddContactSearchResult.prototype.stopTimer = function()
{
    alert("SceneAddContactSearchResult.stopTimer() ");
	
	this.CloseTimer = false;
	PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.POPUP_WND);
}

SceneAddContactSearchResult.prototype.popupTimerCallback = function()
{
   alert("SceneAddContactSearchResult.popupTimerCallback() ");
   if(this.CloseTimer==false)
   {
   	return
   }
   this.CloseTimer = false;
   
	WndMgr.BackStepAddContact();
}

SceneAddContactSearchResult.prototype.processReturnKey = function(){
    alert("SceneAddContactSearchResult.processReturnKey() ");
    
    WndMgr.BackStepAddContact();
}

SceneAddContactSearchResult.prototype.ProcessClick = function(ItemIndex)
{
	alert("SceneAddContactSearchResult.ProcessClick() -- " + ItemIndex);		

	this.SearchList.MoveItem(ItemIndex);

	var Name = this.SearchList.GetCurSkypeName();
	ProcMgr.SearchContactProfile(Name);			
}

SceneAddContactSearchResult.prototype.ChangeArrow = function(Type)
{
	alert("SceneAddContactSearchResult.ChangeArrow");

	switch(Type)
	{
		case ARROW_TYPE.UP_NOR:
			this.UpArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_UP_NOR);
			break;
			
		case ARROW_TYPE.UP_SEL:
			this.UpArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_UP_SEL);
			break;

		case ARROW_TYPE.DOWN_NOR:
			this.DownArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_DOWN_NOR);
			break;
			
		case ARROW_TYPE.DOWN_SEL:
			this.DownArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_DOWN_SEL);
			break;		
	}
}

SceneAddContactSearchResult.prototype.wheelTimerCallback=function()
{
	this.WheelOperation = false;
}
