
function SceneCameraCheckConnected(options) {
	this.options = options;
    
    this.MainView=null;
    
    this.TitleLabel = null;     	
	this.MsgLabel = null;
    this.AgainCheckBox=null;
    this.StartSkypeBtn = null;

    this.DefaultHelpBar =null;

	//flag	
	this.flagWaiting = false;
	this.flagCameraStarting = false;
}

SceneCameraCheckConnected.prototype.initialize = function () {
	alert("SceneCameraCheckConnected.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
   
    this.create();
    
}

SceneCameraCheckConnected.prototype.handleShow = function () {
	alert("SceneCameraCheckConnected.handleShow()");
	// this function will be called when the scene manager show this scene 
	this.enableButton();
	this.AgainCheckBox.SetFlagSelect(true);

	if(WndMgr.Is1366x768Panel())
	{
		PluginAPIMgr.StartPreview(427,264,512,288);
	}
	else
	{
		PluginAPIMgr.StartPreview(600,378,716,402);		
	}

}

SceneCameraCheckConnected.prototype.handleHide = function () {
	alert("SceneCameraCheckConnected.handleHide()");
	// this function will be called when the scene manager hide this scene      
	PluginAPIMgr.StopPreview();
	
	this.highlight(null);
}

SceneCameraCheckConnected.prototype.handleFocus = function () {
	alert("SceneCameraCheckConnected.handleFocus()");
	// this function will be called when the scene manager focus this scene

    var currentHighlight =  this.MainView.getCurrentHighlight();
    if(currentHighlight ==null)
    {
        this.highlight(this.StartSkypeBtn);
    }
    else
    {
         this.highlight(currentHighlight);
    }
}

SceneCameraCheckConnected.prototype.handleBlur = function () {
	alert("SceneCameraCheckConnected.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
    
    var currentHighlight =  this.MainView.getCurrentHighlight();
	if(currentHighlight !=null)
    {
    	currentHighlight.blur();
	}

}
 
SceneCameraCheckConnected.prototype.handleKeyDown = function (keyCode) {
	alert("SceneCameraCheckConnected.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	PluginAPIMgr.PlayAudio(keyCode);
	if(this.flagWaiting==true)
	{
		return;	
	}
	
	switch (keyCode) {
		case $.sfKey.LEFT:
		case $.sfKey.RIGHT:

			break;
		case $.sfKey.UP:          
		case $.sfKey.DOWN:
           this.processUpDownKey();
			break;

		case $.sfKey.ENTER:
            this.processEnterKey();
			break;
        
		case $.sfKey.TOOLS:
            
			break; 
            
        case $.sfKey.RETURN:
            this.processReturnKey();
            $.sfKey.block(event);
			break;
            
        case $.sfKey.EXIT:
            this.processExitKey();
            $.sfKey.block(event);
			break;
		
        case 147:  //infolink
        case 261:  //contents
        case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
			
		default:
            ProcMgr.processBlockKey(keyCode);
            break;

	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneCameraCheckConnected.prototype.create = function(){
    alert("SceneCameraCheckConnected.create()");
    this.MainView = new View("CameraCheckConnected");
    this.MainView.SetBgImage(g_Image.IMAGE_CAMERA_CHECK_CONNECTED_BG);
    
    this.TitleLabel = new Label(null,"camera_check_connected_title");
    this.TitleLabel.SetTextStyle("camera_check_connected_title_style");
    this.TitleLabel.SetText(TV_DEVICE_CHECK_CHECK_MY_VIDEO );    
	
    this.MsgLabel = new Label(null,"camera_check_connected_msg");
    this.MsgLabel.SetTextStyle("camera_check_connected_msg_style");
    this.MsgLabel.SetText(TV_THIS_IS_YOUR_CAMERAS_VIDEO+"</br>"+TV_WHAT_FRIENDS_VIDEO_CALL_MSG);  
	
	var this_ = $.sfScene.get("CameraCheckConnected");
	var clickCF =  function(obj){this_.processClickEvent(obj);};
	
	this.AgainCheckBox=new CheckBox();
    this.AgainCheckBox.SetImageObjId("camera_check_connected_check_box");
    this.AgainCheckBox.SetBgImage(CBoxImgIndex.CB_NORMAL_IMG,  g_Image.IMAGE_CAMERA_CHECK_CHECK_BOX_NORMAL);
    this.AgainCheckBox.SetBgImage(CBoxImgIndex.CB_NORMAL_FOCUS_IMG,  g_Image.IMAGE_CAMERA_CHECK_CHECK_BOX_NORMALFOCUS);
    this.AgainCheckBox.SetTextObjId("camera_check_connected_check_box_text");
    this.AgainCheckBox.SetText(TV_DONT_SHOW_THIS_MESSAGE_AGAIN);
    this.AgainCheckBox.SetTextStyle("camera_check_connected_check_box_style");
    this.AgainCheckBox.AppendFgImage("camera_check_connected_check_box_selected_icon","0px","0px","29px","29px");
    this.AgainCheckBox.SetFgImage(g_Image.IMAGE_CAMERA_CHECK_CHECK_BOX_SELECTED);
	this.AgainCheckBox.SetFlagSelect(true);
	this.AgainCheckBox.SetOnClickCallbackFunc(clickCF); 
  
    this.StartSkypeBtn= new Button();
    this.StartSkypeBtn.SetImageObjId("camera_check_connected_start_skype_btn");
    this.StartSkypeBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_CAMERA_CHECK_BTN_NORMAL);
    this.StartSkypeBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_CAMERA_CHECK_BTN_NORMALFOCUS);
    this.StartSkypeBtn.SetBgImage(BtnImgIndex.BTN_DIM_IMG, g_Image.IMAGE_CAMERA_CHECK_BTN_DIM);
	this.StartSkypeBtn.SetTextObjId("camera_check_connected_start_skype_btn_text");
    this.StartSkypeBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"camera_check_connected_btn_normal_style");
	this.StartSkypeBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"camera_check_connected_btn_select_style");
    this.StartSkypeBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE,"camera_check_connected_btn_dim_style");
	this.StartSkypeBtn.SetText(TV_SID_CONTINUE_VOICE_KR_CONTINUE);
	this.StartSkypeBtn.SetOnClickCallbackFunc(clickCF);

    this.DefaultHelpBar = new HelpBar(HelpBarIndex.CAMERA_CHECK_CONNECTED,"CameraCheckConnected");
    this.DefaultHelpBar.SetOnClickCallbackFunc(1, function(){this_.processReturnKey();});
    
	this.MainView.registHelpBar(this.DefaultHelpBar);
}

SceneCameraCheckConnected.prototype.highlight=function(obj)
{
	alert("SceneCameraCheckConnected.highlight()");
	
    this.MainView.setCurrenHighlight(obj);
	
}

SceneCameraCheckConnected.prototype.select=function(obj)
{
     this.MainView.setCurrentSelect(obj);
}

SceneCameraCheckConnected.prototype.processUpDownKey = function(){
    alert("SceneCameraCheckConnected.processUpDownKey() ");
    
    var currentHighlight =  this.MainView.getCurrentHighlight();
	
    switch(currentHighlight)
    {
        case this.AgainCheckBox:
			this.highlight(this.StartSkypeBtn);
            break;
            
        case this.StartSkypeBtn:
			this.highlight(this.AgainCheckBox);
            break;
    }
}


SceneCameraCheckConnected.prototype.processEnterKey = function(){
    alert("SceneCameraCheckConnected.processEnterKey() ");
    
    var currentHighlight =  this.MainView.getCurrentHighlight();
	
	this.select(currentHighlight);

    switch(currentHighlight)
    {
        case this.AgainCheckBox:

            break;
            
        case this.StartSkypeBtn:
			this.requestStartMain();
            break;
    }
}


SceneCameraCheckConnected.prototype.processReturnKey = function(){
    alert("SceneCameraCheckConnected.processReturnKey() ");
	
   StateMgr.Start_Exit_State(true);
}

SceneCameraCheckConnected.prototype.processExitKey = function(){
    alert("SceneCameraCheckConnected.processExitKey() ");
	  
   StateMgr.Start_Exit_State(false);
}

SceneCameraCheckConnected.prototype.enableButton = function(){
    alert("SceneCameraCheckConnected.enableButton() ");
    
    this.StartSkypeBtn.SetFlagDim(false);
    
    this.flagWaiting = false;
}

SceneCameraCheckConnected.prototype.disableButton = function(){
    alert("SceneCameraCheckConnected.disableButton() ");
	
    this.flagWaiting = true;
     
    this.StartSkypeBtn.blur();    
    this.StartSkypeBtn.SetFlagDim(true);
}

SceneCameraCheckConnected.prototype.refreshCheckWnd = function(){
    alert("SceneCameraCheckConnected.refreshCheckWnd() ");

	var camState = PluginAPIMgr.GetCameraState();

	if(camState ==  ENUM_CAM_STATE.CAM_STATE_DISCONNECTED);
	{
		StateMgr.Start_Camera_Check_Disconnected_State();
	}	
}

SceneCameraCheckConnected.prototype.requestStartMain = function(){
    alert("SceneCameraCheckConnected.requestStartMain() ");
	
	PluginAPIMgr.SetCameraCheckDisable(this.AgainCheckBox.GetFlagSelect());
	this.disableButton();
	StateMgr.Start_Main_State();
}
/*
SceneCameraCheckConnected.prototype.processAgainCheckBoxClick = function(){
    alert("SceneCameraCheckConnected.processAutoLoginCheckBoxClick() ");
    var currentHighlight =  this.MainView.getCurrentHighlight();
    if(currentHighlight != this.AgainCheckBox)
    {
    	this.highlight(this.AgainCheckBox);
    }
    
    this.select(this.AgainCheckBox);
}

SceneCameraCheckConnected.prototype.processStartSkypeBtnClick = function(){
    alert("SceneCameraCheckConnected.processStartSkypeBtnClick() ");
    var currentHighlight =  this.MainView.getCurrentHighlight();
    if(currentHighlight != this.StartSkypeBtn)
    {
    	this.highlight(this.StartSkypeBtn);
    }
    
    this.requestStartMain();
}*/

SceneCameraCheckConnected.prototype.processClickEvent = function(obj){
	alert("SceneCameraCheckConnected.processClickEvent() ");
	
	if(this.flagWaiting==true)
	{
		return;	
	}
	
	var currentHighlight =  this.MainView.getCurrentHighlight();
    if(currentHighlight != obj)
    {
    	this.highlight(obj);
    }
	
	this.processEnterKey();
}

