
var NUM_OF_DEFAULT_AVATAR = 12;
var TOTAL_NUM_OF_SNAPSHOT = 99;

function SceneChangePicture(options) {

	this.options	= options;
    
    this.ChangePictureView	=	null;
	this.ChangePictureDim = null;
    
    this.Title = null;	
	

	this.PictureList	= null;
	this.ScrollBar		= null;
	this.SnapshotBtn	= null;
    this.PopupHelpBar1	= null;
    this.PopupHelpBar2	= null;	   
	this.PageLabel		= null;	
	this.LeftArrow		= null; 
	this.RightArrow		= null;	
	
	
	this.CurPage		= 0;	
	this.PrevItemIndex	= -1;
	this.NumOfSnapShot	= 0;
	
	this.SavedAvatarImage		= null;
	this.SavedAvatarPathArray	= null;	
	this.DefaultAvatarPathArray	= null;
		
	this.IsNormalHelpBar = true;
	
	this.DeletePhotoIndex	= -1;
	this.LastIndex			= -1;
		
	this.flag_InitData	= null;
		
	//timer
    this.CloseTimer = false;	
	
}

SceneChangePicture.prototype.initialize = function () {
	alert("SceneChangePicture.initialize()");
	this.create();
}

SceneChangePicture.prototype.handleShow = function () {
	alert("SceneChangePicture.handleShow()");
	this.ChangePictureDim.show();
 	
	if(this.flag_InitData){
		this.update();
		this.highlight(null);
		this.flag_InitData = false;
		//this.PictureList.SetPrevItemIndex(0);
	}
			
	var CamState = PluginAPIMgr.GetCameraState();
    if(!(CamState == ENUM_CAM_STATE.CAM_STATE_DISCONNECTED || CamState == ENUM_CAM_STATE.CAM_STATE_CONNECTING))
    {		
		this.SnapshotBtn.blur();
	}
	else{
		
		this.SnapshotBtn.dim();		
	}	
	
	this.startTimer();
		
}

SceneChangePicture.prototype.handleHide = function () {
	alert("SceneChangePicture.handleHide()");
	this.ChangePictureDim.hide();
	
	this.flag_InitData = true;
	
    if (this.CloseTimer ==true)
    {
        this.stopTimer();
    }

}

SceneChangePicture.prototype.handleFocus = function () {
	alert("SceneChangePicture.handleFocus()");

	var currentHighlight =  this.ChangePictureView.getCurrentHighlight();
	
	if(currentHighlight == null){
    
		if(this.LastIndex >= 0){
			this.PictureList.SetHighlightForDataIndex(this.LastIndex);			
			this.ChangeHelpbar();
		}
		else{
			this.PictureList.SetHighlightForDataIndex(0);

			if(this.NumOfSnapShot > 0){
				this.ChangePictureView.registHelpBar( this.PopupHelpBar2);
				this.IsNormalHelpBar = false;				
			}
			else{
				this.ChangePictureView.registHelpBar( this.PopupHelpBar1);
				this.IsNormalHelpBar = true;			
			}						
		}
				
		this.ChangePictureView.setCurrenHighlightObj(this.PictureList);
		

		
	}
	else{
		
		this.highlight(currentHighlight);
		
		if(currentHighlight == this.PictureList){			
			this.ChangeHelpbar();
		}		
	}
	
	this.updatePage();
  	this.LastIndex = -1;
}

SceneChangePicture.prototype.handleBlur = function () {
	alert("SceneChangePicture.handleBlur()");
		
	var currentHighlight =  this.ChangePictureView.getCurrentHighlight();
			
	if(currentHighlight != null)
	{
		currentHighlight.blur();
	}	
}

SceneChangePicture.prototype.handleKeyDown = function (keyCode) {
	
	alert("SceneChangePicture.handleKeyDown(" + keyCode + ")");
PluginAPIMgr.PlayAudio(keyCode);

    switch (keyCode) {
        case $.sfKey.LEFT:
			this.resetTimer();
			this.processLeftKey();
			break;
			
        case $.sfKey.RIGHT:
			this.resetTimer();
			this.processRightKey();
            break;

        case $.sfKey.UP:
        case $.sfKey.DOWN:
			this.resetTimer();
            this.processUpDownKey();
            break;
			
		case $.sfKey.BLUE:
			this.processToolBlueKey();
			break;

        case $.sfKey.RETURN:
        case $.sfKey.EXIT:
            this.processReturnKey();
            $.sfKey.block(event);
			break;

		case $.sfKey.ENTER:
			this.processEnterKey();
			break;
            
        case 147:  //infolink
        case 261:  //contents
        case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;			
    }
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneChangePicture.prototype.create = function(){
    alert("SceneChangePicture.create() ");

    this.ChangePictureView = new View("ChangePicture");
    this.ChangePictureView.SetBgImage(g_Image.IMAGE_LIST_MAIN_SETTING_CHANGE_PICTURE_BG_L);
	
	this.ChangePictureDim = new DimBg("ChangePictureDim", "ChangePicture");  

    this.Title = new Label(null,"pictureListTitle");
    this.Title.SetText(TV_SID_CHANGE_PICTURE);
	
	this.PageLabel = new CompBase(); 
	this.PageLabel.CreateBG("pictureListPage");
	this.PageLabel.SetBGImage("");
	this.PageLabel.AddTextLayer("pictureListPageText");	
	this.PageLabel.Show();
	
	this.PictureList = new ScrollList();
	this.PictureList.CreateBG("pictureList");
	this.PictureList.CreateScrBar("PictureScrollBar");		
	this.PictureList.SetNumOfVisibleItem(5);
	this.PictureList.SetStartDataIndex(0);
	this.PictureList.SetItemClass(PictureItem);
	this.PictureList.SetDataType(ITEM_DATA_TYPE.IMAGE_ONLY);
	this.PictureList.SetScrBarShapeStyle(LIST_SHAPE_STYLE.HORIZONTAL);	
	this.PictureList.SetScrBarImage(g_Image.IMAGE_LIST_MAIN_SETTING_CHANGE_PICTURE_SCROLLBAR_BG,
		g_Image.IMAGE_LIST_MAIN_SETTING_CHANGE_PICTURE_SCROLLBAR_LEFT,
		g_Image.IMAGE_LIST_MAIN_SETTING_CHANGE_PICTURE_SCROLLBAR_MIDDLE,
		g_Image.IMAGE_LIST_MAIN_SETTING_CHANGE_PICTURE_SCROLLBAR_RIGHT);

	this.PreLoadingDafaultImage();			
	this.ResetData();

	this.PictureList.SetOnClickCallbackFunc(0,this.onClickEventFunc1);
	this.PictureList.SetOnClickCallbackFunc(1,this.onClickEventFunc2);
	this.PictureList.SetOnClickCallbackFunc(2,this.onClickEventFunc3);
	this.PictureList.SetOnClickCallbackFunc(3,this.onClickEventFunc4);
	this.PictureList.SetOnClickCallbackFunc(4,this.onClickEventFunc5);
	this.PictureList.SetClickEventAvailable(WndMgr.MouseClickEnable);
	
	
	this.PictureList.ShowItem();
	this.PictureList.SetScrBarPosition(458,0,5);
	this.PictureList.Show();

    this.SnapshotBtn = new ButtonBase();
	this.SnapshotBtn.Create("snapShotButton",BUTTON_BASE_TYPE.BG_TEXT);
    this.SnapshotBtn.SetBgImage(BUTTON_BASE_STATE.NORMAL,g_Image.IMAGE_LIST_MAIN_SETTING_SNAPSHOT_BTN_NORMAL_BG);
    this.SnapshotBtn.SetBgImage(BUTTON_BASE_STATE.HIGHLIGHT,g_Image.IMAGE_LIST_MAIN_SETTING_SNAPSHOT_BTN_HIGHLIGHT_BG);	
	this.SnapshotBtn.SetBgImage(BUTTON_BASE_STATE.DIM,g_Image.IMAGE_LIST_MAIN_SETTING_SNAPSHOT_BTN_DIM_BG);		
	this.SnapshotBtn.SetText(IDWS_MOIP_SKYPE_TAKE_VIDEO_SNAPSHOT);	
	this.SnapshotBtn.SetTextStyle(BUTTON_BASE_STATE.NORMAL,"cButton_Text_Blur_Style");
	//this.SnapshotBtn.SetTextStyle(BUTTON_BASE_STATE.HIGHLIGHT,"cButton_Text_Highlight_Style");		
	this.SnapshotBtn.SetTextStyle(BUTTON_BASE_STATE.DIM,"cButton_Text_Dim_Style");	
	this.SnapshotBtn.SetOnClickCallbackFunc(this.ClickSnapshotBtn);	

	//Imae Lable
	this.LeftArrow = new CompBase(); 
	this.LeftArrow.CreateBG("pictureListLeftArrow");
	this.LeftArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_SETTING_CHANGE_PICTURE_LEFT_ARROW_NOR);
	this.LeftArrow.SetOnClickCallbackFunc(this.PrevScroll);

	this.RightArrow = new CompBase(); 
	this.RightArrow.CreateBG("pictureListRightArrow");
	this.RightArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_SETTING_CHANGE_PICTURE_RIGHT_ARROW_NOR);
	this.RightArrow.SetOnClickCallbackFunc(this.NextScroll);

    this.PopupHelpBar1 = new HelpBar(HelpBarIndex.CHANGE_PICTURE, "ChangePicture");
	this.PopupHelpBar2 = new HelpBar(HelpBarIndex.CHANGE_PICTURE_DELETE, "ChangePicture");    	
		
	var scene = $.sfScene.get("ChangePicture");	
	this.PopupHelpBar1.SetOnClickCallbackFunc(1, function(){scene.processReturnKey();	});
	
    this.PopupHelpBar2.SetOnClickCallbackFunc(1, function(){scene.processToolBlueKey();	}); 
    this.PopupHelpBar2.SetOnClickCallbackFunc(2, function(){scene.processReturnKey();	});  

	this.ChangePictureView.registHelpBar( this.PopupHelpBar1);
		
	this.IsNormalHelpBar = true;

	this.flag_InitData = false;
 
}

SceneChangePicture.prototype.highlight = function(obj)
{
   this.ChangePictureView.setCurrenHighlight(obj);
}

SceneChangePicture.prototype.PreLoadingDafaultImage = function(){

	var prePath = "file:///mtd_down/widgets/normal/" + curWidget.id + "/avatar/"; 
		
	alert("prePath = " + prePath);
	
	this.defaultAvatarImage = new Array(NUM_OF_DEFAULT_AVATAR);
	this.DefaultAvatarPathArray = new Array(NUM_OF_DEFAULT_AVATAR);
	
	for (var i=0; i < NUM_OF_DEFAULT_AVATAR; i++) {
		
		this.defaultAvatarImage[i] = new Image();
	}	
	
	this.defaultAvatarImage[0].src = prePath + "default_avatar_Angel.jpg";
	this.defaultAvatarImage[1].src = prePath + "default_avatar_Architect.jpg";	
	this.defaultAvatarImage[2].src = prePath + "default_avatar_Behind.jpg";
	this.defaultAvatarImage[3].src = prePath + "default_avatar_CallMe.jpg";
	this.defaultAvatarImage[4].src = prePath + "default_avatar_Chic.jpg";
	this.defaultAvatarImage[5].src = prePath + "default_avatar_Earbud.jpg";	
	this.defaultAvatarImage[6].src = prePath + "default_avatar_Behind.jpg";
	this.defaultAvatarImage[7].src = prePath + "default_avatar_Headset.jpg";
	this.defaultAvatarImage[8].src = prePath + "default_avatar_Party.jpg";
	this.defaultAvatarImage[9].src = prePath + "default_avatar_Skypeness.jpg";	
	this.defaultAvatarImage[10].src = prePath + "default_avatar_Star.jpg";
	this.defaultAvatarImage[11].src = prePath + "default_avatar_Travel.jpg";

	this.DefaultAvatarPathArray[0] = prePath + "default_avatar_Angel.jpg";
	this.DefaultAvatarPathArray[1] = prePath + "default_avatar_Architect.jpg";	
	this.DefaultAvatarPathArray[2] = prePath + "default_avatar_Behind.jpg";
	this.DefaultAvatarPathArray[3] = prePath + "default_avatar_CallMe.jpg";
	this.DefaultAvatarPathArray[4] = prePath + "default_avatar_Chic.jpg";
	this.DefaultAvatarPathArray[5] = prePath + "default_avatar_Earbud.jpg";	
	this.DefaultAvatarPathArray[6] = prePath + "default_avatar_Behind.jpg";
	this.DefaultAvatarPathArray[7] = prePath + "default_avatar_Headset.jpg";
	this.DefaultAvatarPathArray[8] = prePath + "default_avatar_Party.jpg";
	this.DefaultAvatarPathArray[9] = prePath + "default_avatar_Skypeness.jpg";	
	this.DefaultAvatarPathArray[10] = prePath + "default_avatar_Star.jpg";
	this.DefaultAvatarPathArray[11] = prePath + "default_avatar_Travel.jpg";
	
	this.SavedAvatarImage 		= new Array(TOTAL_NUM_OF_SNAPSHOT);	
	this.SavedAvatarPathArray 	= new Array(TOTAL_NUM_OF_SNAPSHOT);
}


SceneChangePicture.prototype.ResetData = function(){

	alert("SceneChangePicture.ResetData ");

	this.PictureList.DeleteDataAll();
		
	var strSnapShotPathList = PluginAPIMgr.GetSnapShotPathList();
	// alert("strSnapShotPathList = " + strSnapShotPathList );	
							
	this.NumOfSnapShot = PluginAPIMgr.GetNumOfSnapShot();
	alert("NumOfSnapShot = " + this.NumOfSnapShot );							
							
	if(this.NumOfSnapShot > 0)
	{
						
		var STX = String.fromCharCode(2);
		var ETX = String.fromCharCode(3);
		var splitter = ETX + STX;
	
		//var tempData = new Array(this.NumOfSnapShot);	 		
		var tempData = strSnapShotPathList.split(splitter);	
		var TempPARAM;
		var TempImagePath;
				
		//Set Data "file:///mtd_moip/moip/snapshot/"									
		for (var i=0; i < this.NumOfSnapShot; i++) {
			
			if(this.SavedAvatarImage[i] == null){
				
				alert("Create Image Object");
				this.SavedAvatarImage[i] = new Image();	
			}
			
			TempImagePath = this.PreLoadingSavedAvatar(i,tempData[(this.NumOfSnapShot-1)-i]);		
			TempPARAM = [null, TempImagePath];
			
			//alert("tempData["+ i + "]" + tempData[i]);
					
			this.PictureList.AddData(TempPARAM);
					
		}

		//to set confirm popup
		for (var j=0; j < this.NumOfSnapShot; j++) {
		
			this.SavedAvatarPathArray[j] = tempData[(this.NumOfSnapShot-1)-j];
		}				
	}
	
	var tempDefault;
	for (var j=0; j < NUM_OF_DEFAULT_AVATAR; j++) {

		tempDefault = [null, this.defaultAvatarImage[j].src];	
		//alert("defaultAvatarImage["+ j + "]" + this.defaultAvatarImage[j].src );	
		this.PictureList.AddData(tempDefault);
	}		
		
	//Set Page Info		
	this.PictureList.ResetTotalPage();
}

SceneChangePicture.prototype.PreLoadingSavedAvatar = function(Index,ImagePath) {
		
	this.SavedAvatarImage[Index].src = ImagePath + g_Data.GetImgSuffixPath();	
	return this.SavedAvatarImage[Index].src;

}

SceneChangePicture.prototype.update = function() {
	alert("SceneOptionsBlockedUsers.update ");	

	if(this.PictureList){
		
		this.ResetData();
		this.PictureList.RefreshPage();		
	}
	
}


SceneChangePicture.prototype.updatePage = function(){

	if(this.PictureList){		
		this.PageLabel.SetTextLayer(1,this.PictureList.CurPage + "/" + this.PictureList.TotalPage + " " + TV_SID_PAGES);	
	}	
}

SceneChangePicture.prototype.processReturnKey = function(){
    alert("SceneChangePicture.processReturnKey() ");

	StateMgr.Stop_Change_Picture_State(true);

}

SceneChangePicture.prototype.processEnterKey = function(){
	
    var currentHighlight = this.ChangePictureView.getCurrentHighlight();
	
	if(currentHighlight == this.PictureList){
		
		var confirmScene = $.sfScene.get("ChangePictureConfirm");		
		var curIndex = this.PictureList.GetCurrentDataIndex();
		var curImgPath;
		
		if (curIndex < this.NumOfSnapShot) {
		
			//check
			curImgPath = this.SavedAvatarPathArray[curIndex];
		}
		else{
			
			curImgPath = this.DefaultAvatarPathArray[curIndex - this.NumOfSnapShot];			
		}
		
		this.SaveLastIndex();
		WndMgr.StartPictureConfirmStep(curImgPath);
		
	}
	else if(currentHighlight == this.SnapshotBtn){
		
		if(this.NumOfSnapShot < TOTAL_NUM_OF_SNAPSHOT){
			this.SaveLastIndex();
			StateMgr.Start_Vidoe_Snapshot_State();			
		}
		else{			
			WndMgr.StartWarningWndStep();
		}		
	}	

}	

SceneChangePicture.prototype.processUpDownKey = function(){
    alert("SceneChangePicture.processUpDownKey() ");
	
    var currentHighlight = this.ChangePictureView.getCurrentHighlight();
	
	if(currentHighlight == this.PictureList){
	
	    if(this.SnapshotBtn.GetState() != BUTTON_BASE_STATE.DIM){
			
			this.highlight(this.SnapshotBtn);
			
			if(this.IsNormalHelpBar == false){
				
				this.ChangePictureView.changeHelpBar( this.PopupHelpBar1);
				this.IsNormalHelpBar = true;
			}			
		}				
	}
	else if(currentHighlight == this.SnapshotBtn){
		
		this.highlight(this.PictureList);
		
		if(this.PictureList.GetCurrentDataIndex() < this.NumOfSnapShot){
			
			this.ChangePictureView.changeHelpBar(this.PopupHelpBar2);
			this.IsNormalHelpBar = false;
		}		
		
	}

}


SceneChangePicture.prototype.processLeftKey = function(){
    alert("SceneChangePicture.processLeftRightKey() ");

    var currentHighlight = this.ChangePictureView.getCurrentHighlight();
	
	if(currentHighlight == this.PictureList){
		
		this.PictureList.KeyProcess($.sfKey.LEFT);
		this.updatePage();
		this.ChangeHelpbar();		
	}
	
}

SceneChangePicture.prototype.processRightKey = function(){
    alert("SceneChangePicture.processLeftRightKey() ");

    var currentHighlight = this.ChangePictureView.getCurrentHighlight();
	
	if(currentHighlight == this.PictureList){
		
		this.PictureList.KeyProcess($.sfKey.RIGHT);
		this.updatePage();
		this.ChangeHelpbar();
	}	
}
SceneChangePicture.prototype.ChangeHelpbar = function(){
		
	var curIndex = this.PictureList.GetCurrentDataIndex();
	
	alert("ChangeHelpbar() IsNormalHelpBar = " + this.IsNormalHelpBar + " >> Index = " + curIndex);
	
	if(this.IsNormalHelpBar == true && curIndex < this.NumOfSnapShot){
		
		this.ChangePictureView.changeHelpBar( this.PopupHelpBar2);
		this.IsNormalHelpBar = false;
		alert("Normal  >>>>>  Delete");
	}	
	else if(this.IsNormalHelpBar == false && curIndex >= this.NumOfSnapShot){
		
		this.ChangePictureView.changeHelpBar( this.PopupHelpBar1);
		this.IsNormalHelpBar = true;
		alert("Delete  >>>>>  Normal");	
	}	

}
SceneChangePicture.prototype.processToolBlueKey = function(){
    alert("SceneChangePicture.processToolBlueKey() ");

    var currentHighlight = this.ChangePictureView.getCurrentHighlight();
	this.DeletePhotoIndex = this.PictureList.GetCurrentDataIndex();
	
	
	alert("Seleted photo index =  " + this.DeletePhotoIndex);
	
	if(currentHighlight == this.PictureList && (this.DeletePhotoIndex < this.NumOfSnapShot)){
		
		this.SaveLastIndex();
		WndMgr.StartDeletePictureStep();
	}
	
}

SceneChangePicture.prototype.SaveLastIndex = function(){
		
	this.LastIndex = this.PictureList.GetCurrentDataIndex();
}

SceneChangePicture.prototype.ResetLastIndex = function(){

	this.LastIndex = -1;
}	

/*
SceneChangePicture.prototype.DeleteCurPhoto = function(){

    alert("SceneChangePicture.DeleteCurPhoto(" + this.DeletePhotoIndex + ")");
		
	PluginAPIMgr.DeleteSnapShot(this.DeletePhotoIndex);
	this.update();
}
*/

SceneChangePicture.prototype.GetDeletePhotoIndex = function(){
	
    alert("DeletePhotoIndex = " + this.DeletePhotoIndex);	
    
    var Index = (this.NumOfSnapShot - 1) - this.DeletePhotoIndex;
    
    alert("retrun changed  original Index = " + Index);
    
	return Index;
}

SceneChangePicture.prototype.UpdateVideoSnapshotBtn = function(){
	
	
	var CamState = PluginAPIMgr.GetCameraState();
    if(!(CamState == ENUM_CAM_STATE.CAM_STATE_DISCONNECTED || CamState == ENUM_CAM_STATE.CAM_STATE_CONNECTING)){
		
		this.SnapshotBtn.blur();
	}
	else{
		
		this.SnapshotBtn.dim();
	}	

}

SceneChangePicture.prototype.startTimer = function()
{
    alert("SceneChangePicture.startTimer() ");
	
	this.CloseTimer = true;
	PluginAPIMgr.StartOSDTimer("60000" , function() { $.sfScene.get('ChangePicture').popupTimerCallback();}, ENUM_TIMER_TYPE.POPUP_WND);
}

SceneChangePicture.prototype.resetTimer = function()
{
    alert("SceneChangePicture.resetTimer() ");

	if(this.CloseTimer == true)
	{
		PluginAPIMgr.RestartOSDTimer("60000" ,ENUM_TIMER_TYPE.POPUP_WND);
	}
}

SceneChangePicture.prototype.stopTimer = function()
{
    alert("SceneChangePicture.stopTimer() ");
	
	this.CloseTimer = false;
	PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.POPUP_WND);
}

SceneChangePicture.prototype.popupTimerCallback = function()
{
	alert("SceneChangePicture.popupTimerCallback() ");
	if(this.CloseTimer==false)
   {
   	return
   }
   this.CloseTimer = false;
   
	StateMgr.Stop_Change_Picture_State(true);
}

SceneChangePicture.prototype.PrevScroll = function()
{
	alert("SceneChangePicture.PrevScroll() ");	
	// var This_ = $.sfScene.get(ChangePicture);
	// This_.PictureList.KeyProcess($.sfKey.RIGHT);
		
}

SceneChangePicture.prototype.NextScroll = function()
{
	alert("SceneChangePicture.NextScroll() ");		
	// var scene = $.sfScene.get(WndMgr.GetMainSubSceneID());
	// scene.PageScroll(false);			
}

//check....
SceneChangePicture.prototype.ProcessClick = function(ItemIndex)
{
	alert("SceneChangePicture.onClickEventFunc() -- " + ItemIndex);		

	// var This_ = $.sfScene.get("ChangePicture");			
	var curIndex = ((this.PictureList.CurPage - 1) * 5) + ItemIndex;
	var curImgPath;
	
	if (curIndex < this.NumOfSnapShot) {	
		//check
		curImgPath = this.SavedAvatarPathArray[curIndex];
	}
	else{
		
		curImgPath = this.DefaultAvatarPathArray[curIndex - this.NumOfSnapShot];			
	}
	
	this.SaveLastIndex();
	WndMgr.StartPictureConfirmStep(curImgPath);		
}

SceneChangePicture.prototype.onClickEventFunc1 = function()
{
	var This_ = $.sfScene.get("ChangePicture");	
	This_.ProcessClick(0);
}

SceneChangePicture.prototype.onClickEventFunc2 = function()
{
	var This_ = $.sfScene.get("ChangePicture");	
	This_.ProcessClick(1);
}

SceneChangePicture.prototype.onClickEventFunc3 = function()
{
	var This_ = $.sfScene.get("ChangePicture");	
	This_.ProcessClick(2);
}

SceneChangePicture.prototype.onClickEventFunc4 = function()
{
	var This_ = $.sfScene.get("ChangePicture");	
	This_.ProcessClick(3);
}

SceneChangePicture.prototype.onClickEventFunc5 = function()
{
	var This_ = $.sfScene.get("ChangePicture");	
	This_.ProcessClick(4);
}


SceneChangePicture.prototype.PrevScroll = function()
{
	var This_ = $.sfScene.get("ChangePicture");	
	This_.PictureList.PreviousPage();
	This_.updatePage();
	This_.ChangeHelpbar();
}

SceneChangePicture.prototype.NextScroll = function()
{
	var This_ = $.sfScene.get("ChangePicture");	
	This_.PictureList.NextPage();
	This_.updatePage();
	This_.ChangeHelpbar();	
}

SceneChangePicture.prototype.ClickSnapshotBtn = function()
{

	var This_ = $.sfScene.get('ChangePicture');
		
	if(This_.NumOfSnapShot < TOTAL_NUM_OF_SNAPSHOT){
		This_.SaveLastIndex();
		StateMgr.Start_Vidoe_Snapshot_State();			
	}
	else{			
		WndMgr.StartWarningWndStep();
	}
}