function SceneChangePictureConfirm(options) {

	this.options	= options;
    
    this.PictureConfirmView	=	null;
	this.ChangePictureConfirmDim =null;
    
    this.Title			= null;	
	this.ThumbnailBox	= null;
	this.BodyMsg		= null;
	this.OkBtn			= null;	
	this.CancelBtn		= null;
    this.HelpBar		= null;
	
	this.AvatarImg	= null;
	
	//this.IsChangePictureType	= true;

	//timer
   this.CloseTimer = false;	
	
}

SceneChangePictureConfirm.prototype.initialize = function () {
	alert("SceneChangePictureConfirm.initialize()");
	this.create();
}

SceneChangePictureConfirm.prototype.handleShow = function () {
	alert("SceneChangePictureConfirm.handleShow()");
	this.ChangePictureConfirmDim.show();
    this.SetData();
	
	this.startTimer();

}

SceneChangePictureConfirm.prototype.handleHide = function () {
	alert("SceneChangePictureConfirm.handleHide()");
	this.ChangePictureConfirmDim.hide();

    if (this.CloseTimer == true)
    {
        this.stopTimer();
    }

}

SceneChangePictureConfirm.prototype.handleFocus = function () {
	alert("SceneChangePictureConfirm.handleFocus()");
	
    var currentHighlight =  this.PictureConfirmView.getCurrentHighlight();

    if(currentHighlight ==null)
    {
        this.highlight(this.OkBtn);
    }
    else
    {
         this.highlight(currentHighlight);
    }    
}

SceneChangePictureConfirm.prototype.handleBlur = function () {
	alert("SceneChangePictureConfirm.handleBlur()");
}

SceneChangePictureConfirm.prototype.handleKeyDown = function (keyCode) {
	
	alert("SceneChangePictureConfirm.handleKeyDown(" + keyCode + ")");
	PluginAPIMgr.PlayAudio(keyCode);
	switch (keyCode) {
		case $.sfKey.LEFT:
		case $.sfKey.RIGHT:
			this.resetTimer();
			this.processLEFTKey();
			break;
					
		case $.sfKey.ENTER:
			this.processEnterKey();
			break;
		
		case $.sfKey.RETURN:
		case $.sfKey.EXIT:
			this.processReturnKey();
			$.sfKey.block(event);
			break;
  
         case 147:  //infolink
         case 261:  //contents
         case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
	}

}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneChangePictureConfirm.prototype.create = function(){
    alert("SceneChangePictureConfirm.create() ");

    this.PictureConfirmView = new View("ChangePictureConfirm");
    this.PictureConfirmView.SetBgImage(g_Image.IMAGE_LIST_MAIN_SETTING_CHANGE_PICTURE_BG);
	
	this.ChangePictureConfirmDim = new DimBg("ChangePictureConfirmDim", "ChangePictureConfirm");  

    this.Title = new Label(null,"pictureConfirm_Title");
    this.Title.SetText(TV_SID_CHANGE_PICTURE);
	
	this.ThumbnailBox = new CompBase(); 
	this.ThumbnailBox.CreateBG("pictureConfirm_Box");
	this.ThumbnailBox.SetBGImage(g_Image.IMAGE_LIST_MAIN_SETTING_CHANGE_PICTURE_CONFIRM_THUMBNAIL_BOX);
	this.ThumbnailBox.AddJPGImageLayer("pictureConfirm_Avatar");
		
    this.BodyMsg = new Label(null,"pictureConfirm_Msg");	
	//this.BodyMsg.SetText(TV_SID_CHANGE_PICTURE_QUESTION);
	this.BodyMsg.SetText(TV_SID_SET_THIS_PICTURE_AS_YOUR_CONTACTS_WILL_SEE);

	var CurLangID = ResMgr.GetCurLanguage();

 	if(CurLangID == ENUM_TV_LANGUAGE.THA)
 	{
		$("#pictureConfirm_Msg").css('word-break', "break-all" );
	}

	var scene = $.sfScene.get("ChangePictureConfirm");	
	
    this.OkBtn = new ButtonBase();
    this.OkBtn.Create("pictureConfirm_OkButton",BUTTON_BASE_TYPE.BG_TEXT);
    this.OkBtn.SetBgImage(BUTTON_BASE_STATE.NORMAL, g_Image.IMAGE_LIST_MAIN_BLOCK_CONTACT_BTN_NORMAL_BG);
    this.OkBtn.SetBgImage(BUTTON_BASE_STATE.HIGHLIGHT, g_Image.IMAGE_LIST_MAIN_BLOCK_CONTACT_BTN_HIGHLIGHT_BG);	
	this.OkBtn.SetTextStyle(BUTTON_BASE_STATE.NORMAL,"cButton_Text_Blur_Style");
	//this.OkBtn.SetTextStyle(BUTTON_BASE_STATE.HIGHLIGHT,"cButton_Text_Highlight_Style");	
    this.OkBtn.SetText(SID_OK_KR_YES);
	this.OkBtn.SetOnClickCallbackFunc(function(){scene.ClickOkBtn();});
 	
	this.CancelBtn = new ButtonBase();
    this.CancelBtn.Create("pictureConfirm_CancelButton",BUTTON_BASE_TYPE.BG_TEXT);
    this.CancelBtn.SetBgImage(BUTTON_BASE_STATE.NORMAL, g_Image.IMAGE_LIST_MAIN_BLOCK_CONTACT_BTN_NORMAL_BG);
    this.CancelBtn.SetBgImage(BUTTON_BASE_STATE.HIGHLIGHT, g_Image.IMAGE_LIST_MAIN_BLOCK_CONTACT_BTN_HIGHLIGHT_BG);	
	this.CancelBtn.SetTextStyle(BUTTON_BASE_STATE.NORMAL,"cButton_Text_Blur_Style");
	//this.CancelBtn.SetTextStyle(BUTTON_BASE_STATE.HIGHLIGHT,"cButton_Text_Highlight_Style");	
    this.CancelBtn.SetText(SID_CANCEL);
	this.CancelBtn.SetOnClickCallbackFunc(function(){scene.processReturnKey();}); 
	
    this.HelpBar = new HelpBar(HelpBarIndex.CHANGE_PICTURE_CONFIRM, "ChangePictureConfirm");
	this.HelpBar.SetOnClickCallbackFunc(1, function(){scene.processReturnKey();	});    


    
    this.PictureConfirmView.registHelpBar( this.HelpBar);

}

SceneChangePictureConfirm.prototype.SetData = function(){

	this.ThumbnailBox.SetImageLayer(1,this.AvatarImg + g_Data.GetImgSuffixPath());
}

SceneChangePictureConfirm.prototype.SetAvatarPath = function(ImgPath){

	this.AvatarImg = ImgPath;
}

SceneChangePictureConfirm.prototype.highlight=function(obj){

	//alert("SceneChangePictureConfirm.highlight()");	
    this.PictureConfirmView.setCurrenHighlight(obj);
	
}

SceneChangePictureConfirm.prototype.processEnterKey = function(){
    //alert("SceneChangePictureConfirm.processEnterKey() ");

	alert("processEnterKey >>> AvatarImg =" + this.AvatarImg);
	
    var currentHighlight =  this.PictureConfirmView.getCurrentHighlight();
    
	if(currentHighlight == this.OkBtn){
		
		this.ClickOkBtn();
	}
	else if(currentHighlight == this.CancelBtn){
		this.processReturnKey();
	}

	
}

SceneChangePictureConfirm.prototype.processReturnKey = function(){
    alert("SceneChangePictureConfirm.processReturnKey() ");
  
	this.highlight(null);
	$.sfScene.hide('ChangePictureConfirm');
	StateMgr.Start_Change_Picture_State();
	
//	$.sfScene.show('ChangePicture');
//	$.sfScene.focus('ChangePicture');

  
}

SceneChangePictureConfirm.prototype.processLEFTKey = function(){
    alert("SceneChangePictureConfirm.processLEFTKey() ");

    var currentHighlight =  this.PictureConfirmView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.OkBtn:
            this.highlight(this.CancelBtn);
            break;
            
        case this.CancelBtn:
            this.highlight(this.OkBtn);
            break;
    }
    
}

SceneChangePictureConfirm.prototype.startTimer = function()
{
    alert("SceneChangePictureConfirm.startTimer() ");
	
	this.CloseTimer = true;
	PluginAPIMgr.StartOSDTimer("30000" , function() { $.sfScene.get('ChangePictureConfirm').popupTimerCallback();}, ENUM_TIMER_TYPE.TWO_BUTTON);
}

SceneChangePictureConfirm.prototype.resetTimer = function()
{
    alert("SceneChangePictureConfirm.resetTimer() ");
	
	if(this.CloseTimer == true)
	{
		PluginAPIMgr.RestartOSDTimer("30000" ,ENUM_TIMER_TYPE.TWO_BUTTON);
	}
}

SceneChangePictureConfirm.prototype.stopTimer = function()
{
    alert("SceneChangePictureConfirm.stopTimer() ");

	this.CloseTimer = false;
	PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.TWO_BUTTON); 
}

SceneChangePictureConfirm.prototype.popupTimerCallback = function()
{
    alert("SceneChangePictureConfirm.popupTimerCallback() ");
	
	if (this.CloseTimer == false)
	{
		return;
	}
	this.CloseTimer = false;	
		
	this.processReturnKey();
}

SceneChangePictureConfirm.prototype.ClickOkBtn = function()
{
	$.sfScene.get("ChangePicture").ResetLastIndex();
	
	ProcMgr.SetAvatar(this.AvatarImg);
	$.sfScene.hide('ChangePictureConfirm');
	WndMgr.ReturnMain();
}





