function SceneConferenceCall(options) {
	this.options = options;
    
    this.ConferenceCallView =null;

    this.CallDurationTextLabel =null;
    this.CallDurationTimeLabel =null; 
    
    this.CallEndBtn=null;
    this.MicVolumeBtn=null;
    this.HoldBtn=null;
    
    this.MainThumbnailLabel=null;
    this.MainOnlineStatusLabel=null;
    this.MainNameLabel=null;
    
    this.CallMember = new Array(9);
    this.MaxCallMemberId = 9;
    this.LastCallMemberId =0;
    this.CallMemberListOffset = 0;
    this.NumOfCallMember =0;
    
     this.ScrollTop=null;
     this.ScrollCenter=null;
     this.ScrollUnder=null;

    this.ConfCallHelpBar =null;
	
    this.HoldIconLabel = null;
	this.HoldAniLabel = null;
	
	this.isActive = false;
	
	this.TopArrow = null;
	this.BottomArrow = null;
}

SceneConferenceCall.prototype.initialize = function () {
	alert("SceneConferenceCall.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
    
   this.create();
}

SceneConferenceCall.prototype.handleShow = function () {
	alert("SceneConferenceCall.handleShow()");
	// this function will be called when the scene manager show this scene 

    this.update();
}

SceneConferenceCall.prototype.handleHide = function () {
	alert("SceneConferenceCall.handleHide()");
	// this function will be called when the scene manager hide this scene  
    
     this.highlight(null);
}

SceneConferenceCall.prototype.handleFocus = function () {
	alert("SceneConferenceCall.handleFocus()");
	// this function will be called when the scene manager focus this scene

    var currentHighlight =  this.ConferenceCallView.getCurrentHighlight();
    if(currentHighlight ==null)
    {
        this.highlight(this.CallEndBtn);
    }
    else
    {
        this.highlight(currentHighlight);
    }
    
     this.updateCallMemberInfo();
}

SceneConferenceCall.prototype.handleBlur = function () {
	alert("SceneConferenceCall.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
    
    var currentHighlight =  this.ConferenceCallView.getCurrentHighlight();
     if(currentHighlight !=null)
    {
        currentHighlight.blur();
    }
}

SceneConferenceCall.prototype.handleKeyDown = function (keyCode) {
	alert("SceneConferenceCall.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	PluginAPIMgr.PlayAudio(keyCode);
	switch (keyCode) {
		case $.sfKey.LEFT:
        this.processLeftKey();
			break;
		case $.sfKey.RIGHT:
        this.processRightKey();
			break;
		case $.sfKey.UP:
             this.processUpKey();
			break;
		case $.sfKey.DOWN:
            this.processDownKey();
			break;

		case $.sfKey.ENTER:
         this.processEnterKey();
			break;
            
        case $.sfKey.VOL_DOWN:
        case $.sfKey.PANEL_VOL_DOWN:
		case $.sfKey.VOL_UP:
        case $.sfKey.PANEL_VOL_UP:
             this.processVolumeKey();
			break;
            
        case $.sfKey.N1:
        case $.sfKey.N2:
        case $.sfKey.N3:
        case $.sfKey.N4:
        case $.sfKey.N5:
        case $.sfKey.N6:
        case $.sfKey.N7:
        case $.sfKey.N8:
        case $.sfKey.N9:
        case 35:
		case 650: 
        case $.sfKey.N0:
        case 259:
            ProcMgr.SendDTMF(keyCode);
            break;
            
        case $.sfKey.RED:

			break;

		case $.sfKey.BLUE:
			//this.processBlueKey();
			break;	 
			
		case $.sfKey.YELLOW:
		case $.sfKey.GREEN:
            break;
            
		case $.sfKey.TOOLS:
			alert("KEY_TOOLS");
			//this.processToolKey();
            break;
			
       case $.sfKey.RETURN:
           this.processReturnKey();
            $.sfKey.block(event);
            break;
            
        case $.sfKey.EXIT:
            this.processExitKey();
            $.sfKey.block(event);
			break;
            
          case 147:  //infolink
          case 261:  //contents
          case 115:  //wiselink
            ProcMgr.processInfolinkKey();
			break;
            
         default:
            ProcMgr.processBlockKey(keyCode);
            break;  
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneConferenceCall.prototype.create = function(){
    alert("SceneConferenceCall.create() ");
    this.ConferenceCallView = new View("ConferenceCall");
    this.ConferenceCallView.SetBgImage(WndMgr.Bg_ConfCall.src);
    
    this.CallDurationTextLabel = new Label(null,"conf_call_duration_text");
    this.CallDurationTextLabel.SetTextStyle("conf_call_duration_text_style");
    this.CallDurationTextLabel.SetText(IDWS_MOIP_SKYPE_CALL_DURATION);

    this.CallDurationTimeLabel = new Label(null,"conf_call_duration_time");
    this.CallDurationTimeLabel.SetTextStyle("conf_call_duration_time_style");
    this.CallDurationTimeLabel.SetText("00:00:00");
    
    var this_ = $.sfScene.get('ConferenceCall');
    var clickCF =  function(obj){this_.processClickEvent(obj);};
    
    this.CallEndBtn = new Button();
    this.CallEndBtn.SetImageObjId("conf_call_end_btn");
    this.CallEndBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_CONFERENCE_CALL_END_BTN_NORMAL);
    this.CallEndBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_CONFERENCE_CALL_END_BTN_NORMALFOCUS);	
    this.CallEndBtn.SetTextObjId("conf_call_end_btn_text");
    this.CallEndBtn.SetText(TV_SID_END_CALL); 
    this.CallEndBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"common_btn_text_f17_normal_style");
	this.CallEndBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"common_btn_text_f17_highlight_style");
    this.CallEndBtn.SetOnClickCallbackFunc(clickCF);
    
    this.MicVolumeBtn = new Button();
    this.MicVolumeBtn.SetImageObjId("conf_call_mic_volume_btn");
    this.MicVolumeBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_CONFERENCE_CALL_BTN_NORMAL);
    this.MicVolumeBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_CONFERENCE_CALL_BTN_NORMALFOCUS);
	this.MicVolumeBtn.SetBgImage(BtnImgIndex.BTN_DIM_IMG, g_Image.IMAGE_CONFERENCE_CALL_BTN_DIM);	
    this.MicVolumeBtn.SetTextObjId("conf_call_mic_volume_btn_text");
    this.MicVolumeBtn.SetText(TV_SID_MIC_VOL);
    this.MicVolumeBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"common_btn_text_f17_normal_style");
    this.MicVolumeBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE,"common_btn_text_f17_dim_style");
    this.MicVolumeBtn.SetOnClickCallbackFunc(clickCF);
    
    this.HoldBtn = new Button();
    this.HoldBtn.SetImageObjId("conf_call_hold_btn");
    this.HoldBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_CONFERENCE_CALL_BTN_NORMAL);
    this.HoldBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_CONFERENCE_CALL_BTN_NORMALFOCUS);	
    this.HoldBtn.SetTextObjId("conf_call_hold_btn_text");
    this.HoldBtn.SetText(IDWS_MOIP_SKYPE_HOLD);
    this.HoldBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"common_btn_text_f17_normal_style");
    this.HoldBtn.SetOnClickCallbackFunc(clickCF);
    
    this.MainThumbnailLabel= new Label("conf_main_thumbnail", null);
    this.MainThumbnailLabel.SetBgImage(g_Image.IMAGE_CONFERENCE_CALL_MAIN_THUMBNAIL);
    this.MainThumbnailLabel.AppendFgImage("conf_main_thumbnail_avata","3px","3px","143px","140px");
    
    this.MainOnlineStatusLabel= new Label("conf_main_online_status", null);
    this.MainOnlineStatusLabel.SetBgImage(g_Image.IMAGE_ONLINE_STATUS_PRESENCE_OFFLINE);
    
    this.MainNameLabel = new Label(null,"conf_main_name");
    this.MainNameLabel.SetTextStyle("conf_main_name_style");
    this.MainNameLabel.SetReverseDisable(true);
    this.MainNameLabel.SetIsPlainText(true);
    this.MainNameLabel.SetText(g_Data.GetMyAccountName());

    var a=0;
   for( a=0; a< this.CallMember.length; a++)
  {
        this.CallMember[a] = new Object();
        this.CallMember[a].thumbnail = new Label("conf_call_member_"+a+"_thumbnail", null);
        this.CallMember[a].thumbnail.AppendFgImage("conf_call_member_"+a+"_thumbnail_image", "8px","9px","139px","102px");
        
        this.CallMember[a].OnlineStatus = new Label("conf_call_member_"+a+"_online_status", null);
        
        this.CallMember[a].name = new Label(null,"conf_call_member_"+a+"_name");
        this.CallMember[a].name.SetTextStyle("conf_call_member_name_style");
        this.CallMember[a].name.SetReverseDisable(true); 
        this.CallMember[a].name.SetIsPlainText(true);
		
		this.CallMember[a].endIcon = new Label("conf_call_member_"+a+"_end_icon", null);
		this.CallMember[a].endIcon.AppendFgImage("conf_call_member_"+a+"_end_fg_icon","0px","0px","22px","22px");
		this.CallMember[a].isShow= false;
		this.CallMember[a].isActivate = false;     
    }
    
    this.HoldIconLabel= new Label("conf_call_hold_icon", null);
    this.HoldIconLabel.SetBgImage(g_Image.IMAGE_VIDEO_CALL_HOLD_ICON);
	
	this.HoldAniLabel= new Label("conf_call_hold_animation", null);
	this.HoldAniLabel.AppendFgImage("conf_call_hold_animation_icon","0px","0px","108px","108px");
    this.HoldAniLabel.SetFgImage(WndMgr.Bg_LoadingGIF.src);
    
    this.ScrollTop= new Label("conf_call_scroll_top", null);
    this.ScrollTop.SetBgImage(g_Image.IMAGE_CHAT_SCROLL_TOP);
    
    this.ScrollUnder= new Label("conf_call_scroll_under", null);
    this.ScrollUnder.SetBgImage(g_Image.IMAGE_CHAT_SCROLL_UNDER);
    
    this.ScrollCenter= new Label("conf_call_scroll_center", null);
    this.ScrollCenter.SetBgImage(g_Image.IMAGE_CHAT_SCROLL_CENTER);

    this.ConfCallHelpBar = new HelpBar(HelpBarIndex.CONF_CALL, "SceneConferenceCall");

    //this.ConfCallHelpBar.SetOnClickCallbackFunc(1, function(){this_.processBlueKey();});    
    //this.ConfCallHelpBar.SetOnClickCallbackFunc(2, function(){this_.processToolKey();});
    this.ConfCallHelpBar.SetOnClickCallbackFunc(1, function(){this_.processReturnKey();});
    
    this.CallEndBtn.registHelpBar( this.ConfCallHelpBar);
	this.MicVolumeBtn.registHelpBar( this.ConfCallHelpBar);
	this.HoldBtn.registHelpBar( this.ConfCallHelpBar);
	
	this.TopArrow= new Label("conf_call_top_arrow", null);
    this.TopArrow.SetBgImage(g_Image.IMAGE_CONFERENCE_CALL_ALLOW_TOP_NOR);
    this.TopArrow.SetOnClickCallbackFunc(clickCF);
    this.TopArrow.SetOnMouseOutOverImage(g_Image.IMAGE_CONFERENCE_CALL_ALLOW_TOP_NOR, g_Image.IMAGE_CONFERENCE_CALL_ALLOW_TOP_OVER);

    this.BottomArrow= new Label("conf_call_bottom_arrow", null);
    this.BottomArrow.SetBgImage(g_Image.IMAGE_CONFERENCE_CALL_ALLOW_BOTTOM_NOR);
    this.BottomArrow.SetOnClickCallbackFunc(clickCF);
    this.BottomArrow.SetOnMouseOutOverImage(g_Image.IMAGE_CONFERENCE_CALL_ALLOW_BOTTOM_NOR, g_Image.IMAGE_CONFERENCE_CALL_ALLOW_BOTTOM_OVER);
    
}

SceneConferenceCall.prototype.update=function()
{
    alert("SceneConferenceCall.update() ");
    this.MainNameLabel.SetText(PluginAPIMgr.GetMyDisplayName() );
    this.MainThumbnailLabel.SetFgImage(PluginAPIMgr.GetMyAvataImageForCall());
    this.MainOnlineStatusLabel.SetBgImage(PluginAPIMgr.GetMyOnlineStateImage());
    
    this.toggleMicVolumeBtnEnable();
    
      if(g_Data.GetCallLocalHold() == true)
     {
        this.LocalHold();
     }
     else if(g_Data.GetCallRemoteHold() == true)
     {
        this.RemoteHold();
     }
     else
     {
	 	if(ProcMgr.callHoldTimer == true)
		{
			this.StartLocalHoldWait();
		}
		else
		{
			this.StopLocalHoldWait();
		}
		
        this.Resume();
     }
    
    this.CallMemberListOffset =0;
    
        var a=0;
      for( a=0; a< this.CallMember.length; a++)
      {
            this.CallMember[a].thumbnail.SetBgImage("");
            this.CallMember[a].thumbnail.SetFgImage("");
            this.CallMember[a].OnlineStatus.SetBgImage("");
            this.CallMember[a].name.SetText("");
			this.CallMember[a].endIcon.SetFgImage(""); 
			this.CallMember[a].isShow= false;
			this.CallMember[a].isActivate = false;
      }
 }
 
 SceneConferenceCall.prototype.updateCallMemberInfo=function()
{
    //alert("SceneConferenceCall.updateCallMemberInfo() ");
    this.NumOfCallMember = PluginAPIMgr.GetNumOfCallMembers(); 
     
     this.LastCallMemberId =0;
     var a=0;
     for(a= this.CallMemberListOffset; a<this.NumOfCallMember; a++)
     {
        this.AddCallMember(a);
     }
     
     this.DeleteCallMember();
     
    this.updateScrollBar();
}

SceneConferenceCall.prototype.AddCallMember=function(index)
{
   // alert("SceneConferenceCall.AddCallMember() ");

    if(this.LastCallMemberId<this.MaxCallMemberId)
    {
        var a = this.LastCallMemberId ;
        this.CallMember[a].thumbnail.SetBgImage(g_Image.IMAGE_CONFERENCE_CALL_MEMBER_THUMBNAIL);
        this.CallMember[a].thumbnail.SetFgImage(PluginAPIMgr.GetConferenceCallMemberAvataImage(index));
        this.CallMember[a].OnlineStatus.SetBgImage(PluginAPIMgr.GetCallMemberOnlineStateImage(index));
        this.CallMember[a].name.SetText(PluginAPIMgr.GetCallMemberDisplayName(index));
		
		if(PluginAPIMgr.isConferenceCallMemberFinised(index)== true)
		{
			this.CallMember[a].endIcon.SetFgImage(g_Image.IMAGE_CONFERENCE_CALL_END_ICON); 
		}
		else if(PluginAPIMgr.isConferenceCallMemberCalling(index)==true)
		{
			var wifi_img = new Image;
			wifi_img.src = g_Image.IMAGE_CONFERENCE_CALLING_ICON;
			this.CallMember[a].endIcon.SetFgImage(wifi_img.src); 
		}
		else
		{
			this.CallMember[a].endIcon.SetFgImage(""); 
		}
		
		this.CallMember[a].isShow= true;
        
        this.LastCallMemberId++;
     }
}

SceneConferenceCall.prototype.DeleteCallMember=function(index)
{
    //alert("SceneConferenceCall.DeleteCallMember() ");

    var a=0;
    for(a=this.LastCallMemberId; a < this.MaxCallMemberId; a++ )
    {
        this.CallMember[a].thumbnail.SetBgImage("");
        this.CallMember[a].thumbnail.SetFgImage("");
        this.CallMember[a].OnlineStatus.SetBgImage("");
        this.CallMember[a].name.SetText("");
		this.CallMember[a].endIcon.SetFgImage(""); 
		this.CallMember[a].isShow= false;
		this.CallMember[a].isActivate = false;
     }
}

 SceneConferenceCall.prototype.updateActiveMemberInfo=function(data)
{
    alert("SceneConferenceCall.updateActiveMemberInfo() : "+ data);
	var dataInfo = String(data);
	var lineInfo = parseInt(dataInfo.substring(1, 3));
	var flagAvtive = new Array(3);
	flagAvtive[0] = dataInfo.substring(3, 4);
	flagAvtive[1] = dataInfo.substring(4, 5);
	flagAvtive[2] = dataInfo.substring(5, 6);
	
	if(lineInfo<this.CallMemberListOffset || lineInfo > this.CallMemberListOffset+2)
	{
		alert("SceneConferenceCall.updateActiveMemberInfo() line : "+ lineInfo +" is not displayed");
		return;
	}
	
	var offset =lineInfo-this.CallMemberListOffset;
	
	
     var a=0;
     for(a= 0; a<3; a++)
     {
	 	if(this.CallMember[(offset * 3) + a].isShow== false)
		{
			break;
		}
		
	 	if (flagAvtive[a] == "1") {
			if (this.CallMember[(offset * 3) + a].isActivate == false) {
				this.CallMember[(offset * 3) + a].thumbnail.SetBgImage(g_Image.IMAGE_CONFERENCE_ACTIVE_MEMBER_THUMBNAIL);
				this.CallMember[(offset * 3) + a].thumbnail.ChangeFgImageRect("8px", "7px", "139px", "102px");
				this.CallMember[(offset * 3) + a].isActivate = true;
			}
		}
		else 
		{
			if (this.CallMember[(offset * 3) + a].isActivate == true) 
			{
				this.CallMember[(offset * 3) + a].thumbnail.SetBgImage(g_Image.IMAGE_CONFERENCE_CALL_MEMBER_THUMBNAIL);
				this.CallMember[(offset * 3) + a].thumbnail.ChangeFgImageRect("8px", "9px", "139px", "102px");
				this.CallMember[(offset * 3) + a].isActivate = false;
			}
		}
     }	 
}
 
 SceneConferenceCall.prototype.updateCallDuration = function(time)
{
     this.CallDurationTimeLabel.SetText(time);
}

SceneConferenceCall.prototype.toggleMicVolumeBtnEnable=function()
{
    alert("SceneConferenceCall.toggleMicVolumeBtnEnable() ");
    
    var camera_state = PluginAPIMgr.GetCameraState();
    
    if(camera_state == ENUM_CAM_STATE.CAM_STATE_DISCONNECTED || camera_state == ENUM_CAM_STATE.CAM_STATE_CONNECTING)
    {
        alert("SceneConferenceCall.toggleMicVolumeBtnEnable() Dim : true ->  camera_state : "+ camera_state );
         var currentHighlight =  this.ConferenceCallView.getCurrentHighlight();
        
        if(currentHighlight ==  this.MicVolumeBtn)
        {
             if(this.MicVolumeBtn.flag_highlight == true)
            {
                this.highlight(this.CallEndBtn);
            }
            else
            {
                this.highlight(null);
            }
        }
        this.MicVolumeBtn.SetFlagDim(true);
    }
    else
    {
        alert("SceneConferenceCall.toggleMicVolumeBtnEnable() Dim :  false ");
        if(PluginAPIMgr.IsInCall()==1)
		{
			PluginAPIMgr.StartRecord();
		} 
        this.MicVolumeBtn.SetFlagDim(false);
    }    
}

SceneConferenceCall.prototype.updateScrollBar = function(){
    
    var item_number_per_line =3;
    var max_displayed_line = 3;
    var total_line = Math.ceil(this.NumOfCallMember / item_number_per_line) ;

    var max_scroll_length = 402;
    var init_scroll_start_position = 33;
    var curr_scroll_start_position = init_scroll_start_position;
    var curr_scroll_length=0;
    
    this.hiddenScrollBar();
    
    if(total_line <=3)  
    {
        this.hiddenScrollBar(); 
    }
    else
    {
            var scroll_rate= Math.floor(max_scroll_length / total_line);
            var upper_hidden_line = this.CallMemberListOffset / item_number_per_line;
            var extra_length =max_scroll_length - (scroll_rate*total_line);
            var displayed_line = total_line - upper_hidden_line;
            if(displayed_line > max_displayed_line)
            {
                displayed_line =max_displayed_line;
            }
            
            curr_scroll_start_position =  init_scroll_start_position +(scroll_rate*upper_hidden_line);
            curr_scroll_length = (scroll_rate*displayed_line) + extra_length;
     
            var center_top = String(curr_scroll_start_position);
            var center_height = String(curr_scroll_length);
            
            var scroll_top = String(curr_scroll_start_position-5);
            var scroll_under = String(curr_scroll_start_position+curr_scroll_length);
            
            $("#conf_call_scroll_center").css("top",  center_top+"px");
            $("#conf_call_scroll_center").height(center_height+"px");
            
            $("#conf_call_scroll_top").css("top",  scroll_top+"px");
            $("#conf_call_scroll_under").css("top",  scroll_under+"px");
           
           //alert("SceneConferenceCall.updateScrollBar() top: "+ scroll_top+" length : "+center_height+" bottom : " + scroll_under);
            
            this.visibleScrollBar();
        
    }

}

SceneConferenceCall.prototype.hiddenScrollBar = function()
{
    this.ScrollTop.hiddenObj();
    this.ScrollUnder.hiddenObj();
    this.ScrollCenter.hiddenObj();
    
    this.TopArrow.hiddenObj();
    this.BottomArrow.hiddenObj();
}

SceneConferenceCall.prototype.visibleScrollBar = function()
{
    this.ScrollTop.visibleObj();
    this.ScrollUnder.visibleObj();
    this.ScrollCenter.visibleObj();
    
    this.toggleArrow();
}

SceneConferenceCall.prototype.toggleArrow = function()
{	
	if(this.CallMemberListOffset <=0)
    {
        this.TopArrow.hiddenObj();
    }
    else
    {
    	this.TopArrow.visibleObj();
    }
    
    if((this.CallMemberListOffset +this.MaxCallMemberId) - this.NumOfCallMember >= 0)
    {
       this.BottomArrow.hiddenObj();
    }
    else
    {
    	this.BottomArrow.visibleObj();
    }	
}

SceneConferenceCall.prototype.highlight=function(obj)
{
    this.ConferenceCallView.setCurrenHighlight(obj);
}

SceneConferenceCall.prototype.processLeftKey = function(){
    alert("SceneConferenceCall.processLeftKey() ");
    
    var currentHighlight =  this.ConferenceCallView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.CallEndBtn:
            this.highlight(this.HoldBtn);
            break;
            
        case this.MicVolumeBtn:
            this.highlight(this.CallEndBtn);
            break;
            
        case this.HoldBtn:
        if(this.MicVolumeBtn.GetFlagDim()==true)
        {
            this.highlight(this.CallEndBtn);
        }
        else
        {
            this.highlight(this.MicVolumeBtn);
        }
            break;
    }
}

SceneConferenceCall.prototype.processRightKey = function(){
    alert("SceneConferenceCall.processRightKey() ");
    
    var currentHighlight =  this.ConferenceCallView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.CallEndBtn:
             if(this.MicVolumeBtn.GetFlagDim()==true)
            {
                this.highlight(this.HoldBtn);
            }
            else
            {
                this.highlight(this.MicVolumeBtn);
            }
            break;
            
        case this.MicVolumeBtn:
            this.highlight(this.HoldBtn);
            break;
            
        case this.HoldBtn:
            this.highlight(this.CallEndBtn);
            break;
    }
}

SceneConferenceCall.prototype.processUpKey = function(){
    alert("SceneConferenceCall.processUpKey() ");
    if(this.CallMemberListOffset <=0)
    {
        return;
    }
    
    this.CallMemberListOffset -= 3;
    this.updateCallMemberInfo();
 }
 
 SceneConferenceCall.prototype.processDownKey = function(){
    alert("SceneConferenceCall.processDownKey() ");
    if((this.CallMemberListOffset +this.MaxCallMemberId) - this.NumOfCallMember >= 0)
    {
        return;
    }
    
    this.CallMemberListOffset +=3;
    this.updateCallMemberInfo();
 }

SceneConferenceCall.prototype.processEnterKey = function(){
    alert("SceneConferenceCall.processEnterKey() ");
    
    var currentHighlight =  this.ConferenceCallView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.CallEndBtn:
            ProcMgr.DisconnectCall();
            break;
            
        case this.MicVolumeBtn:
              StateMgr.Start_Volume_Mic_State();
            break;
            
        case this.HoldBtn:
            ProcMgr.ToggleLocalHold(); 
            break;
    }
}

SceneConferenceCall.prototype.processReturnKey = function(){
    alert("SceneConferenceCall.processReturnKey() ");
    
    /*if(ProcMgr.isGenoaS==false)
	{
		StateMgr.Start_Main_State();
	}
	else
	{
		StateMgr.Start_Call_Switch_State(); 
	}*/    
	
	ProcMgr.DisconnectCall();   
}

SceneConferenceCall.prototype.processExitKey = function(){
    alert("SceneConferenceCall.processExitKey() ");
   
   StateMgr.Start_Exit_State(false);
}


SceneConferenceCall.prototype.processVolumeKey=function()
{
    alert("SceneConferenceCall.processVolumeKey() ");
    StateMgr.Start_Volume_Speaker_State();
}

SceneConferenceCall.prototype.processBlueKey = function(){
    alert("SceneVoiceCall.processBlueKey() ");
    
	if(ProcMgr.isGenoaS==false)
	{
		StateMgr.Start_Live_Contact_List_State();
	}
}

SceneConferenceCall.prototype.StartLocalHoldWait=function()
{
	alert("SceneConferenceCall.StartLocalHoldWait() "); 
	this.HoldAniLabel.visibleObj(); 
}

SceneConferenceCall.prototype.StopLocalHoldWait=function()
{
	alert("SceneConferenceCall.StopLocalHoldWait() "); 
	this.HoldAniLabel.hiddenObj();
}

SceneConferenceCall.prototype.LocalHold=function()
{
    alert("SceneConferenceCall.LocalHold() ");
	this.StopLocalHoldWait();   
    this.HoldIconLabel.visibleObj();
    this.HoldBtn.SetText(SID_RESUME);
    this.CallDurationTextLabel.SetText(IDWS_MOIP_CALL_ON_HOLD);    
}

SceneConferenceCall.prototype.RemoteHold=function()
{
    alert("SceneConferenceCall.RemoteHold() ");
	this.StopLocalHoldWait();    
    this.HoldIconLabel.visibleObj();
    this.HoldBtn.SetText(IDWS_MOIP_SKYPE_HOLD);
    this.CallDurationTextLabel.SetText(TV_SID_YOU_ARE_ON_HOLD); 
}

SceneConferenceCall.prototype.Resume=function()
{
    alert("SceneConferenceCall.Resume() ");  
    this.HoldIconLabel.hiddenObj();
    this.HoldBtn.SetText(IDWS_MOIP_SKYPE_HOLD);
    this.CallDurationTextLabel.SetText(IDWS_MOIP_SKYPE_CALL_DURATION); 
}


SceneConferenceCall.prototype.processClickEvent = function(obj){
	alert("SceneConferenceCall.processClickEvent() ");
	
	if(obj == this.TopArrow || obj == this.BottomArrow)
	{
		if(event.button==2)
		{
			alert("SceneVoiceCall.processClickEvent() -> right button ");
			//this.processToolKey();			
		}
		else
		{
			if(obj == this.TopArrow)
			{
				this.processUpKey();
			}
			else
			{
				this.processDownKey();
			}	
		}
		
		return;
	}
	
	var currentHighlight =  this.ConferenceCallView.getCurrentHighlight();

	if(currentHighlight != obj)
    {
    	this.highlight(obj);
    }
    
	if(event.button==2)
	{
		alert("SceneVoiceCall.processClickEvent() -> right button ");
		//this.processToolKey();
	}
	else
	{
		alert("SceneVoiceCall.processClickEvent() -> left button ");
		this.processEnterKey();
	}
}

SceneConferenceCall.prototype.processToolKey=function()
{
    alert("SceneConferenceCall.processToolKey() ");

	if(ProcMgr.isGenoaS==false)
	{
		StateMgr.Start_List_Tools_State(TOOL_MENU_LIST_TYPE.VOICE_CALL);  
	}
		  
}
