
var FLAG_LIST_TYPE = {      
	    INIT						:   0,
	    LIST_MAIN_CALL				:   1, 
		ADD_CONTACT_PHONENUMBER		:	2,
		EDIT_PROFILE_HOME_PHONE		:	3,
		EDIT_PROFILE_OFFICE_PHONE	:	4,
		EDIT_PROFILE_MOBILE_PHONE	:	5,      
        OPTIONS_CALL_FORWARD_FIRST  :   6,
        OPTIONS_CALL_FORWARD_SECOND :   7,
        OPTIONS_CALL_FORWARD_THIRD  :   8,
        ADD_ASSIGNED_PHONENUMBER	:   9
}

var FlagListStyle = [
		"CountryFlagList_Init_position",
		"CountryFlagList_ListMainCall_position",
		"CountryFlagList_AddPhoneNumber_position",	
		"CountryFlagList_Edit_HomePhone_position",
		"CountryFlagList_Edit_OfficePhone_position",
		"CountryFlagList_Edit_MobilePhone_position",			
		"CountryFlagList_Options_Callforward_First_position",			
		"CountryFlagList_Options_Callforward_Second_position",			
		"CountryFlagList_Options_Callforward_Third_position",
		"CountryFlagList_Add_Assigned_Phonenumber_position"		
	];

var FlagListBGImage = [
		" ",
		"images/flag_list_L_bg.png",
		"images/country_bg_L.png",	
		"images/country_bg_L.png",
		"images/country_bg_L.png",
		"images/country_bg_L.png",			
		"images/country_bg_L.png",			
		"images/country_bg_L.png",			
		"images/country_bg_L.png",
		"images/country_bg_L.png"
	];
	
	
function SceneCountryFlagList(options) {

	this.options			= options;	
	
	this.FlagType	= FLAG_LIST_TYPE.INIT; 
	this.FlagList	= null;
	this.NeedToInit	= false;
	this.CurCountryIndex	= -1;

	this.CallerScene = null;
	this.EnterCallbackFunc = null;
	
	this.testCallback = null;		
	
	this.WheelOperation = false;
	
}

SceneCountryFlagList.prototype.initialize = function () {
	alert("SceneCountryFlagList.initialize()");	
	this.create();
}

SceneCountryFlagList.prototype.handleShow = function () {
	alert("SceneCountryFlagList.handleShow()");

	if(this.NeedToInit){
		alert("FlagList Init.......");
		//this.NeedToInit = false;

		var BgLayer = this.FlagList.GetBGLayer();
		BgLayer.SetImage(FlagListBGImage[this.FlagType]);
		BgLayer.SetStyle(FlagListStyle[this.FlagType]);	

		this.FlagList.SetStyle(this.FlagType);
				
		this.NeedToInit = false;	
	}
		
	//reset highlight position

	this.FlagList.Show();
		
}

SceneCountryFlagList.prototype.handleHide = function () {
	alert("SceneCountryFlagList.handleHide()");
	
	this.FlagList.Hide();

}

SceneCountryFlagList.prototype.handleFocus = function () {
	alert("SceneCountryFlagList.handleFocus()");

	if(this.FlagList.GetCurrentDataIndex() != this.CurCountryIndex){
		this.FlagList.SetHighlightForDataIndex(this.CurCountryIndex);	
	}
	else {		
		this.FlagList.highlight();
	}	
}

SceneCountryFlagList.prototype.handleBlur = function () {
	alert("SceneCountryFlagList.handleBlur()");
	
	this.FlagList.blur();
}

SceneCountryFlagList.prototype.handleKeyDown = function (keyCode) {
	
	alert("SceneCountryFlagList.handleKeyDown(" + keyCode + ")");
PluginAPIMgr.PlayAudio(keyCode);
	switch(keyCode){
    
		case $.sfKey.ENTER:
			this.ResetCallerSceneTimer();
			this.ProcessKeyEnter();			
			break;			
                   
		case $.sfKey.RETURN:
			alert("KEY_RETURN");
			this.ResetCallerSceneTimer();
			this.ProcessKeyReturn();
			$.sfKey.block(event);			
			break;
			
		case $.sfKey.EXIT:
			$.sfKey.block(event);
			break;	
			
        case 147:  //infolink
        case 261:  //contents
        case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
			
		default :
			if(keyCode == $.sfKey.DOWN || keyCode == $.sfKey.UP)
			{
				this.ResetCallerSceneTimer();	
			}
			
			this.FlagList.KeyProcess(keyCode);	
			break;	
		                   
    }
	
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneCountryFlagList.prototype.create = function(){
    alert("SceneCountryFlagList.create() ");

	this.BGObj = new CompBase(); 
	this.BGObj.CreateBG("CountryFlagList");
	this.BGObj.SetOnClickCallbackFunc(this.testCallback);

	this.FlagList = new CountryList();
	this.FlagList.Create();
		
	var this_ = $.sfScene.get('CountryFlagList');
	
    this.TempDiv = document.getElementById("CountryFlagList");
   	this.TempDiv.onmousewheel = function()
   	{
   		if(this_.WheelOperation == false)
   		{
   			alert("SceneListMainContact.onmousewheel");
	   		this_.WheelOperation = true;
	   		PluginAPIMgr.StartOSDTimer("700" , function() { this_.wheelTimerCallback();}, ENUM_TIMER_TYPE.NO_BUTTON);
	   		
			if(event.wheelDelta > 0)
			{
				//alert("Up Up");
				this_.FlagList.PreviousPage();
			}
			else
			{
				//alert("Down Down");
				this_.FlagList.NextPage();
			}
	    }		
    };	
}


SceneCountryFlagList.prototype.Init = function(nType,CallerScene_,EnterCallbackFunc,ReturnCallbackFunc){
	
	this.NeedToInit	= true;
	this.FlagType	= nType; 
	
	this.CallerScene = CallerScene_;
	this.EnterCallbackFunc = EnterCallbackFunc;
	this.ReturnCallbackFunc = ReturnCallbackFunc;
	
}

SceneCountryFlagList.prototype.ProcessKeyReturn = function(){

	alert("SceneCountryFlagList.ProcessKeyReturn() ");

	if(this.ReturnCallbackFunc){
		this.ReturnCallbackFunc();
	}

	$.sfScene.focus(this.CallerScene);
	$.sfScene.hide('CountryFlagList');
}


SceneCountryFlagList.prototype.ProcessKeyEnter = function(){
	alert("SceneCountryFlagList.ProcessKeyEnter() ");
		
	if(this.EnterCallbackFunc){
		this.EnterCallbackFunc();
	}
	
	$.sfScene.focus(this.CallerScene);
	$.sfScene.hide('CountryFlagList');	
}


SceneCountryFlagList.prototype.GetCountryFlag = function(){
	
	var Index = this.FlagList.GetCurrentDataIndex();
	return g_Image.base_flag_image_path + g_Data.DATA_COUNTRY_CODE_ARRAY[Index].toUpperCase() + ".png"
}

SceneCountryFlagList.prototype.GetPrefix = function(){
	
	var Index = this.FlagList.GetCurrentDataIndex();	
	return g_Data.DATA_COUNTRY_PREFIX_ARRAY[Index];

}

SceneCountryFlagList.prototype.GetCountryName = function(){

	var Index = this.FlagList.GetCurrentDataIndex();	
	return g_Data.DATA_COUNTRY_NAME_ARRAY[Index];

}

SceneCountryFlagList.prototype.GetCountryCode= function(){

	var Index = this.FlagList.GetCurrentDataIndex();	
	return g_Data.DATA_COUNTRY_CODE_ARRAY[Index];

}

SceneCountryFlagList.prototype.SetCurIndex= function(Index){
	
	alert("SceneCountryFlagList.SetCurIndex");
	
	if(Index < 0){		
		this.CurCountryIndex = g_Data.GetMyCountryIndex();		
	}
	else{
		this.CurCountryIndex = Index;		
	}
	
	alert("Index = " + this.CurCountryIndex);

}

SceneCountryFlagList.prototype.ResetCallerSceneTimer = function(){
	switch(this.FlagType)
	{
		case FLAG_LIST_TYPE.ADD_CONTACT_PHONENUMBER:
			$.sfScene.get("AddContactPhoneNumber").resetTimer();
		break;
		case FLAG_LIST_TYPE.EDIT_PROFILE_HOME_PHONE:
		case FLAG_LIST_TYPE.EDIT_PROFILE_OFFICE_PHONE:
		case FLAG_LIST_TYPE.EDIT_PROFILE_MOBILE_PHONE:
		 	$.sfScene.get("EditProfile").resetTimer();
		 break;
		 
		case FLAG_LIST_TYPE.OPTIONS_CALL_FORWARD_FIRST  :
        case FLAG_LIST_TYPE.OPTIONS_CALL_FORWARD_SECOND :
        case FLAG_LIST_TYPE.OPTIONS_CALL_FORWARD_THIRD  :
			OptionsMgr.resetTimer();
		 break;
		 
		case FLAG_LIST_TYPE.ADD_ASSIGNED_PHONENUMBER:
			$.sfScene.get("AddAssignedPhoneNumber").resetTimer();
		break;
	}
}


SceneCountryFlagList.prototype.ProcessClick = function(ItemIndex)
{
	alert("SceneCountryFlagList.ProcessClick() -- " + ItemIndex);		

	this.FlagList.MoveItem(ItemIndex);

	if(this.EnterCallbackFunc){
		this.EnterCallbackFunc();		
	}
	
	$.sfScene.focus(this.CallerScene);
	$.sfScene.hide('CountryFlagList');	

}

SceneCountryFlagList.prototype.wheelTimerCallback=function()
{
	this.WheelOperation = false;
}

