
function SceneEditProfileDayList(options) {

	this.options			= options;	
	
	this.list		= null;
	this.UpArrow	= null;
	this.DownArrow	= null;
	
	this.CurDayIndex	= -1;
	this.MaxDay			= 0;
	
	this.Callback = null;
	
	this.WheelOperation = false;	
}

SceneEditProfileDayList.prototype.initialize = function () {
	alert("SceneEditProfileDayList.initialize()");	
	this.create();
}

SceneEditProfileDayList.prototype.handleShow = function () {
	alert("SceneEditProfileDayList.handleShow()");
	
	//Set information of list
	this.list.SetMaxNumOfData(this.MaxDay);
	this.list.ResetTotalPage();
	
	this.list.Show();
}

SceneEditProfileDayList.prototype.handleHide = function () {
	alert("SceneEditProfileDayList.handleHide()");
	
	this.list.Hide();

}

SceneEditProfileDayList.prototype.handleFocus = function () {
	alert("SceneEditProfileDayList.handleFocus()");

	if(this.list.GetCurrentDataIndex() != this.CurDayIndex){
		this.list.SetHighlightForDataIndex(this.CurDayIndex);	
	}
	else {
		this.list.UpdatePage();		
		this.list.highlight();
	}
	
}

SceneEditProfileDayList.prototype.handleBlur = function () {
	alert("EditProfileDayList.handleBlur()");
	
	this.list.blur();
}

SceneEditProfileDayList.prototype.handleKeyDown = function (keyCode) {
	
	alert("EditProfileDayList.handleKeyDown(" + keyCode + ")");
	PluginAPIMgr.PlayAudio(keyCode);

	switch(keyCode){
    
		case $.sfKey.ENTER:
			this.ResetCallerSceneTimer();
			this.ProcessKeyEnter();			
			break;			
                   
		case $.sfKey.RETURN:
			alert("KEY_RETURN");
			this.ResetCallerSceneTimer();
			this.ProcessKeyReturn();
			$.sfKey.block(event);			
			break;
			
		case $.sfKey.EXIT:
			$.sfKey.block(event);
			break;	
			
        case 147:  //infolink
        case 261:  //contents
        case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
			
		default :
			if(keyCode == $.sfKey.DOWN || keyCode == $.sfKey.UP)
			{
				this.ResetCallerSceneTimer();	
			}
			
			this.list.KeyProcess(keyCode);	
			break;	
		                   
    }
	
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneEditProfileDayList.prototype.create = function(){
    alert("SceneEditProfileDayList.create() ");


	this.list = new ScrollList();
	this.list.CreateBG("DayList");
	this.list.SetBGImage(g_Image.IMAGE_EDIT_PROFILE_DAY_LIST_BG);	
	this.list.SetNumOfVisibleItem(5);
	this.list.SetItemBgImage(ITEM_STATE.NORMAL," ");
	this.list.SetItemBgImage(ITEM_STATE.HIGHLIGHT,g_Image.IMAGE_EDIT_PROFILE_DAY_ITEM_HIGHLIGHT_BG);
	this.list.SetItemDefualtTextStyle(ITEM_STATE.NORMAL,"cDayListItem_Text_normal_style");
	this.list.SetItemDefualtTextStyle(ITEM_STATE.HIGHLIGHT,"cDayListItem_Text_Highlight_style");
	this.list.SetDataType(ITEM_DATA_TYPE.TEXT_ONLY);
	this.list.CreateScrBar("DayListScrollBar");
	this.list.SetScrBarImage(g_Image.IMAGE_EDIT_PROFILE_DAY_SCROLLBAR_BG,
		g_Image.IMAGE_BLOCK_SCROLLBAR_TOP,
		g_Image.IMAGE_BLOCK_SCROLLBAR_CENTER,
		g_Image.IMAGE_BLOCK_SCROLLBAR_BOTTOM);		
		
	var tempData = new Array(31);
		
	for (var i=1; i < 32; i++) {
				
		tempData[i] = [ "" + i , null ];				
		this.list.AddData(tempData[i]);					
	}		

    var This_ = $.sfScene.get("EditProfileDayList");
    var list_ = This_.list;

	//Set Click Event

	this.list.SetOnClickCallbackFunc(0,function(){This_.ProcessCallback(0);});					
	this.list.SetOnClickCallbackFunc(1,function(){This_.ProcessCallback(1);});	
	this.list.SetOnClickCallbackFunc(2,function(){This_.ProcessCallback(2);});						
	this.list.SetOnClickCallbackFunc(3,function(){This_.ProcessCallback(3);});	
	this.list.SetOnClickCallbackFunc(4,function(){This_.ProcessCallback(4);});
	this.list.SetClickEventAvailable(WndMgr.MouseClickEnable);		
	this.list.ShowItem();
	
	//modify....
	this.list.SetScrBarPosition(182,0,5);
	
	this.UpArrow = new CompBase(); 
	this.UpArrow.CreateBG("DayListUpArrow");
	this.UpArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_UP_NOR);
	this.UpArrow.SetOnClickCallbackFunc(function(){list_.PreviousPage();});	
	this.UpArrow.SetOnMouseOverCallbackFunc(function(){This_.ChangeArrow(ARROW_TYPE.UP_SEL);});
	this.UpArrow.SetOnMouseOutCallbackFunc(function(){This_.ChangeArrow(ARROW_TYPE.UP_NOR);});

	this.DownArrow = new CompBase(); 
	this.DownArrow.CreateBG("DayListDownArrow");
	this.DownArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_DOWN_NOR);
	this.DownArrow.SetOnClickCallbackFunc(function(){list_.NextPage();});	
	this.DownArrow.SetOnMouseOverCallbackFunc(function(){This_.ChangeArrow(ARROW_TYPE.DOWN_SEL);});
	this.DownArrow.SetOnMouseOutCallbackFunc(function(){This_.ChangeArrow(ARROW_TYPE.DOWN_NOR);});			

    this.TempDiv = document.getElementById("EditProfileDayList");
   	this.TempDiv.onmousewheel = function()
   	{
   		if(This_.WheelOperation == false)
   		{
   			alert("EditProfileDayList.onmousewheel");
	   		This_.WheelOperation = true;
	   		PluginAPIMgr.StartOSDTimer("700" , function() { This_.wheelTimerCallback();}, ENUM_TIMER_TYPE.NO_BUTTON);
	   		
			if(event.wheelDelta > 0)
			{
				//alert("Up Up");
				list_.PreviousPage();
			}
			else
			{
				//alert("Down Down");
				list_.NextPage();
			}
	    }		
    };	

}


SceneEditProfileDayList.prototype.Init = function(MaxDay,CurDay,CallbackFunc){

	if(MaxDay < 28 || MaxDay > 31){
		MaxDay = 31;		
	}
		
	this.MaxDay = MaxDay;
	
	if(CurDay < 1 || CurDay > MaxDay){
				
		CurDay = 1;
	}
	
	this.CurDayIndex = CurDay -1;
	this.Callback = CallbackFunc;
}

SceneEditProfileDayList.prototype.ProcessKeyReturn = function(){

//	alert("EditProfileDayList.ProcessKeyReturn() ");


	$.sfScene.focus('EditProfile');
	$.sfScene.hide('EditProfileDayList');
}


SceneEditProfileDayList.prototype.ProcessKeyEnter = function(){
	alert("EditProfileDayList.ProcessKeyEnter() ");
		
	if(this.Callback){
		this.Callback();
	}
	
	this.ProcessKeyReturn();
}

SceneEditProfileDayList.prototype.GetDay = function(){

	var curday = this.list.GetCurrentDataIndex() + 1;

	if(curday < 10){
		
		return "0" + curday;
	}
	else{
		return "" + curday;
	}	
}

SceneEditProfileDayList.prototype.ResetCallerSceneTimer = function()
{
			$.sfScene.get("EditProfile").resetTimer();
}

SceneEditProfileDayList.prototype.ProcessCallback = function(ItemIndex){

	alert("SceneEditProfileYearList.ProcessCallback() -- " + ItemIndex);		

	this.list.MoveItem(ItemIndex);

	if(this.Callback){
		this.Callback();
	}
	
	this.ProcessKeyReturn();
	
}

SceneEditProfileDayList.prototype.ChangeArrow = function(Type)
{
	alert("SceneEditProfileDayList.ChangeArrow");

	switch(Type)
	{
		case ARROW_TYPE.UP_NOR:
			this.UpArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_UP_NOR);
			break;
			
		case ARROW_TYPE.UP_SEL:
			this.UpArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_UP_SEL);
			break;

		case ARROW_TYPE.DOWN_NOR:
			this.DownArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_DOWN_NOR);
			break;
			
		case ARROW_TYPE.DOWN_SEL:
			this.DownArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_DOWN_SEL);
			break;		
	}
}

SceneEditProfileDayList.prototype.wheelTimerCallback=function()
{
	this.WheelOperation = false;
}
