
function SceneEditProfileYearList(options) {

	this.options			= options;	
	
	this.list		= null;
	this.UpArrow	= null;
	this.DownArrow	= null;
	
	this.CurYearIndex	= -1;

	this.Callback = null;
	
	this.LimitYear = 1997;

	this.WheelOperation = false;	
}

SceneEditProfileYearList.prototype.initialize = function () {
	alert("SceneEditProfileYearList.initialize()");	
	this.create();
}

SceneEditProfileYearList.prototype.handleShow = function () {
	alert("SceneEditProfileYearList.handleShow()");

	this.list.Show();
}

SceneEditProfileYearList.prototype.handleHide = function () {
	alert("SceneEditProfileYearList.handleHide()");
	
	this.list.Hide();

}

SceneEditProfileYearList.prototype.handleFocus = function () {
	alert("SceneEditProfileYearList.handleFocus()");

	if(this.list.GetCurrentDataIndex() != this.CurYearIndex){
		this.list.SetHighlightForDataIndex(this.CurYearIndex);	
	}
	else {		
		this.list.highlight();
	}
	
}

SceneEditProfileYearList.prototype.handleBlur = function () {
	alert("EditProfileDayList.handleBlur()");
	
	this.list.blur();
}

SceneEditProfileYearList.prototype.handleKeyDown = function (keyCode) {
	
	alert("EditProfileDayList.handleKeyDown(" + keyCode + ")");
	PluginAPIMgr.PlayAudio(keyCode);
	switch(keyCode){
    
		case $.sfKey.ENTER:
			this.ResetCallerSceneTimer();
			this.ProcessKeyEnter();			
			break;			
                   
		case $.sfKey.RETURN:
			alert("KEY_RETURN");
			this.ResetCallerSceneTimer();
			this.ProcessKeyReturn();
			$.sfKey.block(event);			
			break;
			
		case $.sfKey.EXIT:
			$.sfKey.block(event);
			break;	
			
        case 147:  //infolink
        case 261:  //contents
        case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
			
		default :
			if(keyCode == $.sfKey.DOWN || keyCode == $.sfKey.UP)
			{
				this.ResetCallerSceneTimer();	
			}
			
			this.list.KeyProcess(keyCode);	
			break;	
		                   
    }
	
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneEditProfileYearList.prototype.create = function(){
    alert("SceneEditProfileYearList.create() ");


	this.list = new ScrollList();
	this.list.CreateBG("YearList");
	this.list.SetBGImage(g_Image.IMAGE_EDIT_PROFILE_YEAR_LIST_BG);	
	this.list.SetNumOfVisibleItem(5);
	this.list.SetItemBgImage(ITEM_STATE.NORMAL," ");
	this.list.SetItemBgImage(ITEM_STATE.HIGHLIGHT,g_Image.IMAGE_EDIT_PROFILE_YEAR_ITEM_HIGHLIGHT_BG);
	this.list.SetItemDefualtTextStyle(ITEM_STATE.NORMAL,"cYearListItem_Text_normal_style");
	this.list.SetItemDefualtTextStyle(ITEM_STATE.HIGHLIGHT,"cYearListItem_Text_Highlight_style");
	this.list.SetDataType(ITEM_DATA_TYPE.TEXT_ONLY);
	this.list.CreateScrBar("YearListScrollBar");
	this.list.SetScrBarImage(g_Image.IMAGE_EDIT_PROFILE_DAY_SCROLLBAR_BG,
		g_Image.IMAGE_BLOCK_SCROLLBAR_TOP,
		g_Image.IMAGE_BLOCK_SCROLLBAR_CENTER,
		g_Image.IMAGE_BLOCK_SCROLLBAR_BOTTOM);		
	
	var tempData = new Array();
		
		
	var loadDt = new Date(); 
	var CurYear = parseInt(loadDt.getFullYear()); 
	this.LimitYear = CurYear - 13;
	
	alert("Year limit = " + this.LimitYear); 	

	//1998		
	for (var i = 1900; i < this.LimitYear; i++) {
				
		tempData[i] = [ "" + i , null ];				
		this.list.AddData(tempData[i]);					
	}		

    var This_ = $.sfScene.get("EditProfileYearList");
    var list_ = This_.list;

	//Set Click Event
	this.list.SetOnClickCallbackFunc(0,function(){This_.ProcessCallback(0);});					
	this.list.SetOnClickCallbackFunc(1,function(){This_.ProcessCallback(1);});	
	this.list.SetOnClickCallbackFunc(2,function(){This_.ProcessCallback(2);});						
	this.list.SetOnClickCallbackFunc(3,function(){This_.ProcessCallback(3);});	
	this.list.SetOnClickCallbackFunc(4,function(){This_.ProcessCallback(4);});	
	this.list.SetClickEventAvailable(WndMgr.MouseClickEnable);	
	
					
	this.list.ShowItem();
	
	//modify....
	this.list.SetScrBarPosition(182,0,5);

	this.UpArrow = new CompBase(); 
	this.UpArrow.CreateBG("YearListUpArrow");
	this.UpArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_UP_NOR);
	this.UpArrow.SetOnClickCallbackFunc(function(){list_.PreviousPage();});	
	this.UpArrow.SetOnMouseOverCallbackFunc(function(){This_.ChangeArrow(ARROW_TYPE.UP_SEL);});
	this.UpArrow.SetOnMouseOutCallbackFunc(function(){This_.ChangeArrow(ARROW_TYPE.UP_NOR);});	

	this.DownArrow = new CompBase(); 
	this.DownArrow.CreateBG("YearListDownArrow");
	this.DownArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_DOWN_NOR);
	this.DownArrow.SetOnClickCallbackFunc(function(){list_.NextPage();});	
	this.DownArrow.SetOnMouseOverCallbackFunc(function(){This_.ChangeArrow(ARROW_TYPE.DOWN_SEL);});
	this.DownArrow.SetOnMouseOutCallbackFunc(function(){This_.ChangeArrow(ARROW_TYPE.DOWN_NOR);});		

    this.TempDiv = document.getElementById("EditProfileYearList");
   	this.TempDiv.onmousewheel = function()
   	{
   		if(This_.WheelOperation == false)
   		{
   			alert("EditProfileYearList.onmousewheel");
	   		This_.WheelOperation = true;
	   		PluginAPIMgr.StartOSDTimer("700" , function() { This_.wheelTimerCallback();}, ENUM_TIMER_TYPE.NO_BUTTON);
	   		
			if(event.wheelDelta > 0)
			{
				//alert("Up Up");
				list_.PreviousPage();
			}
			else
			{
				//alert("Down Down");
				list_.NextPage();
			}
	    }		
    };	

}

SceneEditProfileYearList.prototype.Init = function(CurYear,CallbackFunc){
	
	alert("setting Init >>  CurYear = " + CurYear);
	if(CurYear < 1900 || CurYear > this.LimitYear){
				
		CurYear = this.LimitYear-1;
	}
	
	this.CurYearIndex = CurYear - 1900;
	this.Callback = CallbackFunc;
}

SceneEditProfileYearList.prototype.ProcessKeyReturn = function(){

//	alert("SceneEditProfileYearList.ProcessKeyReturn() ");


	$.sfScene.focus('EditProfile');
	$.sfScene.hide('EditProfileYearList');
}


SceneEditProfileYearList.prototype.ProcessKeyEnter = function(){
	alert("SceneEditProfileYearList.ProcessKeyEnter() ");
		
	if(this.Callback){
		this.Callback();
	}
	
	this.ProcessKeyReturn();
}

SceneEditProfileYearList.prototype.GetYear = function(){

	return this.list.GetCurrentInputData(); 
}

SceneEditProfileYearList.prototype.ResetCallerSceneTimer = function()
{
	$.sfScene.get("EditProfile").resetTimer();
}


SceneEditProfileYearList.prototype.ProcessCallback = function(ItemIndex){

	alert("SceneEditProfileYearList.ProcessCallback() -- " + ItemIndex);		

	this.list.MoveItem(ItemIndex);

	if(this.Callback){
		this.Callback();
	}
	
	this.ProcessKeyReturn();
	
}

SceneEditProfileYearList.prototype.ChangeArrow = function(Type)
{
	alert("SceneEditProfileYearList.ChangeArrow");

	switch(Type)
	{
		case ARROW_TYPE.UP_NOR:
			this.UpArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_UP_NOR);
			break;
			
		case ARROW_TYPE.UP_SEL:
			this.UpArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_UP_SEL);
			break;

		case ARROW_TYPE.DOWN_NOR:
			this.DownArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_DOWN_NOR);
			break;
			
		case ARROW_TYPE.DOWN_SEL:
			this.DownArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_DOWN_SEL);
			break;		
	}
}

SceneEditProfileYearList.prototype.wheelTimerCallback=function()
{
	this.WheelOperation = false;
}
