function SceneExit(options) {
	this.options = options;
    
	this.MainView=null;
	this.MainViewDim=null;
	
	this.TitleLabel = null;
	
	this.HelpMsgLabel = null;
	
	this.SigninBtn = null;
	this.SignoutBtn = null;
	this.CancelBtn = null;
	
	this.DefaultHelpBar = null;
	
	this.flag_FromReturnKey = false;
	this.flagWaiting = false;
	
	this.CloseTimer = false;

}

SceneExit.prototype.initialize = function () {
	alert("SceneExit.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
    
   this.create();
}

SceneExit.prototype.handleShow = function () {
	alert("SceneExit.handleShow()");
	// this function will be called when the scene manager show this scene 
	this.MainViewDim.show();
    this.highlight(this.SigninBtn);

    this.startTimer();
}

SceneExit.prototype.handleHide = function () {
	alert("SceneExit.handleHide()");
	// this function will be called when the scene manager hide this scene  
	this.MainViewDim.hide();
    this.flag_FromReturnKey = false ; //init
    this.enableButton();
    
	if(this.CloseTimer == true)
	{
		this.stopTimer();
	}
}

SceneExit.prototype.handleFocus = function () {
	alert("SceneExit.handleFocus()");
	// this function will be called when the scene manager focus this scene

}

SceneExit.prototype.handleBlur = function () {
	alert("SceneExit.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
}

SceneExit.prototype.handleKeyDown = function (keyCode) {
	alert("SceneExit.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	PluginAPIMgr.PlayAudio(keyCode);
	switch (keyCode) {
		case $.sfKey.LEFT:
			break;
		case $.sfKey.RIGHT:
			break;
		case $.sfKey.UP:
			this.resetTimer();
			this.processUpKey();
			break;
		case $.sfKey.DOWN:
            this.resetTimer();
			this.processDownKey();
			break;

		case $.sfKey.ENTER:
            this.processEnterKey();
			break;
            
        case $.sfKey.RETURN:
        case $.sfKey.EXIT:
            this.processReturnKey();
            $.sfKey.block(event);
			break;

        case 147:  //infolink
        case 261:  //contents
        case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneExit.prototype.create = function(){
    alert("SceneExit.create()");
    this.MainView = new View("Exit");
    this.MainView.SetBgImage(g_Image.IMAGE_EXIT_BG);
	
	this.MainViewDim = new DimBg("ExitDim", "Exit");
    
    this.TitleLabel = new Label(null,"exit_title");
    this.TitleLabel.SetTextStyle("exit_title_style");
    this.TitleLabel.SetText(TV_SID_EXIT_SKYPE);
    
    this.HelpMsgLabel = new Label(null,"exit_help_msg");
    this.HelpMsgLabel.SetTextStyle("exit_help_msg_style");
    this.HelpMsgLabel.SetText(TV_RECEIVE_CALLS_WHILE_WATCHING_TV_MSG);
    
    var this_ = $.sfScene.get("Exit");
    var clickCF =  function(obj){this_.processClickEvent(obj);};
    
    this.SigninBtn = new Button();
    this.SigninBtn.SetImageObjId("exit_signin_btn");
    this.SigninBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_EXIT_BTN_NORMAL);
    this.SigninBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_EXIT_BTN_NORMALFOCUS);	
    this.SigninBtn.SetBgImage(BtnImgIndex.BTN_DIM_IMG, g_Image.IMAGE_EXIT_BTN_NORMAL);	
    this.SigninBtn.SetTextObjId("exit_signin_btn_text");
    this.SigninBtn.SetText(TV_KEEP_ME_SIGNED_IN);
    this.SigninBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"exit_btn_text_normal_style");
    this.SigninBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"exit_btn_text_select_style");
    this.SigninBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE,"exit_btn_text_dim_style");
    this.SigninBtn.SetOnClickCallbackFunc(clickCF);   
    
    this.SignoutBtn = new Button();
    this.SignoutBtn.SetImageObjId("exit_signout_btn");
    this.SignoutBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_EXIT_BTN_NORMAL);
    this.SignoutBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_EXIT_BTN_NORMALFOCUS);
	this.SignoutBtn.SetBgImage(BtnImgIndex.BTN_DIM_IMG, g_Image.IMAGE_EXIT_BTN_NORMAL);	
    this.SignoutBtn.SetTextObjId("exit_signout_btn_text");
    this.SignoutBtn.SetText(IDWS_MOIP_POPUP_EXIT_SIGN_OUT);
    this.SignoutBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"exit_btn_text_normal_style");
    this.SignoutBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"exit_btn_text_select_style");
	this.SignoutBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE,"exit_btn_text_dim_style");
    this.SignoutBtn.SetOnClickCallbackFunc(clickCF);	
    
    this.CancelBtn = new Button();
    this.CancelBtn.SetImageObjId("exit_cancel_btn");
    this.CancelBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_EXIT_BTN_NORMAL);
    this.CancelBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_EXIT_BTN_NORMALFOCUS);
	this.CancelBtn.SetBgImage(BtnImgIndex.BTN_DIM_IMG, g_Image.IMAGE_EXIT_BTN_NORMAL);	
    this.CancelBtn.SetTextObjId("exit_cancel_btn_text");
    this.CancelBtn.SetText(SID_CANCEL);
    this.CancelBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"exit_btn_text_normal_style");
    this.CancelBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"exit_btn_text_select_style");
	this.CancelBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE,"exit_btn_text_dim_style");
    this.CancelBtn.SetOnClickCallbackFunc(clickCF);	
   
    this.DefaultHelpBar = new HelpBar(HelpBarIndex.EXIT, "Exit");
    this.DefaultHelpBar.SetOnClickCallbackFunc(1, function(){this_.processReturnKey();});
    this.MainView.registHelpBar( this.DefaultHelpBar);
}

SceneExit.prototype.SetFromReturnKey=function(fromReturnKey)
{
   this.flag_FromReturnKey  = fromReturnKey;
}


SceneExit.prototype.highlight=function(obj)
{
    this.MainView.setCurrenHighlight(obj);
    
    if(obj == this.SigninBtn)
    {
    	this.HelpMsgLabel.SetText(TV_RECEIVE_CALLS_WHILE_WATCHING_TV_MSG);
    }
    else if(obj == this.SignoutBtn)
    {
    	this.HelpMsgLabel.SetText(TV_NOT_RECEIVE_CALLS_WHILE_WATCHING_TV_MSG);
    }
    else
    {
    	this.HelpMsgLabel.SetText(TV_RETURN_TO_USING_SKYPE);
    }
}


SceneExit.prototype.processUpKey = function(){
    alert("SceneExit.processUpKey() ");
     if(this.flagWaiting ==true)
    {
        return;
    }
    
    var currentHighlight =  this.MainView.getCurrentHighlight();
    
    switch(currentHighlight)
    {  
        case this.SigninBtn:
       	 	this.highlight(this.CancelBtn);
        break;
		
        case this.SignoutBtn:
            this.highlight(this.SigninBtn);
            break;   
            
        case this.CancelBtn:
            this.highlight(this.SignoutBtn);
            break;
    }
}

SceneExit.prototype.processDownKey = function(){
    alert("SceneExit.processDownKey() ");
     if(this.flagWaiting ==true)
    {
        return;
    }
    
    var currentHighlight =  this.MainView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.SigninBtn:
       	 	this.highlight(this.SignoutBtn);
        break;
		
        case this.SignoutBtn:
            this.highlight(this.CancelBtn);
            break;   
            
        case this.CancelBtn:
            this.highlight(this.SigninBtn);
            break;
    }
}

SceneExit.prototype.processEnterKey = function(){
    alert("SceneExit.processEnterKey() ");
    if(this.flagWaiting ==true)
    {
        return;
    }
    
    var currentHighlight =  this.MainView.getCurrentHighlight();
  
    switch(currentHighlight)
    {
        case this.SigninBtn:
        	this.disableButton();
           if(this.flag_FromReturnKey==true)
           {
                ProcMgr.CloseWithSignIn();
            }
            else
            {
                ProcMgr.ExitWithSignIn();
            }
            break;
            
        case this.SignoutBtn:
            this.disableButton();
            if(this.flag_FromReturnKey==true)
            {
                ProcMgr.CloseWithSignOut();
            }
            else
            {
                ProcMgr.ExitWithSignOut();
            }
            break;
            
        case this.CancelBtn:
            StateMgr.Stop_Exit_State(true);
            break;
            
    }
}

SceneExit.prototype.enableButton = function(){
    alert("SceneExit.enableButton() ");
	
    this.SigninBtn.SetFlagDim(false);
    this.SignoutBtn.SetFlagDim(false);
    this.CancelBtn.SetFlagDim(false);

    this.flagWaiting = false;
}

SceneExit.prototype.disableButton = function(){
    alert("SceneExit.disableButton() ");
	if(this.CloseTimer == true)
	{
		this.stopTimer();
	}
	
    this.flagWaiting = true;

    var currentHighlight =  this.MainView.getCurrentHighlight();
    currentHighlight.blur();
    
    this.SigninBtn.SetFlagDim(true);
    this.SignoutBtn.SetFlagDim(true);
    this.CancelBtn.SetFlagDim(true);   
}

SceneExit.prototype.processReturnKey = function(){
    alert("SceneExit.processReturnKey() ");
         if(this.flagWaiting ==true)
    {
        return;
    }
  
    StateMgr.Stop_Exit_State(true);
}

SceneExit.prototype.startTimer = function()
{
    alert("SceneExit.startTimer() ");
	
	this.CloseTimer = true;
	PluginAPIMgr.StartOSDTimer("30000" , function() { $.sfScene.get('Exit').popupTimerCallback();}, ENUM_TIMER_TYPE.TWO_BUTTON);
}

SceneExit.prototype.resetTimer = function()
{
    alert("SceneExit.resetTimer() ");
	
	if(this.CloseTimer == true)
	{
		PluginAPIMgr.RestartOSDTimer("30000" ,ENUM_TIMER_TYPE.TWO_BUTTON);
	}
}

SceneExit.prototype.stopTimer = function()
{
    alert("SceneExit.stopTimer() ");

	this.CloseTimer = false;
	PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.TWO_BUTTON); 
}

SceneExit.prototype.popupTimerCallback = function()
{
    alert("SceneExit.popupTimerCallback() ");
	
	if (this.CloseTimer == false)
	{
		return;
	}
	this.CloseTimer = false;	
		
	StateMgr.Stop_Exit_State(true); 
}
/*
SceneExit.prototype.processSigninBtnClick = function()
{
    alert("SceneExit.processSigninBtnClick() ");
    
    var currentHighlight =  this.MainView.getCurrentHighlight();
    if(currentHighlight!=this.SigninBtn)
    {
    	this.highlight(this.SigninBtn);
    }
    
	this.processEnterKey(); 
}

SceneExit.prototype.processSignoutBtnClick = function()
{
    alert("SceneExit.processSignoutBtnClick() ");

    var currentHighlight =  this.MainView.getCurrentHighlight();
    if(currentHighlight!=this.SignoutBtn)
    {
    	this.highlight(this.SignoutBtn);
    }
    
	this.processEnterKey(); 
}

SceneExit.prototype.processCancelBtnClick = function()
{
    alert("SceneExit.processCancelBtnClick() ");
    
    var currentHighlight =  this.MainView.getCurrentHighlight();
    if(currentHighlight!=this.CancelBtn)
    {
    	this.highlight(this.CancelBtn);
    }
    
	this.processEnterKey(); 
}*/

SceneExit.prototype.processClickEvent = function(obj){
	alert("SceneExit.processClickEvent() ");
	
	var currentHighlight =  this.MainView.getCurrentHighlight();
    if(currentHighlight != obj)
    {
    	this.highlight(obj);
    }
	
	this.processEnterKey();
}

