function SceneFaceRecogDuplicate(options) {
	this.options = options;
    
	this.MainView=null;
	this.MainViewDim=null;
	
	this.MsgLabel = null;
	this.SkypeNameLabel = null;
	
	this.OkBtn = null;

	this.flagWaiting = false;
	
	this.CloseTimer = false;
}

SceneFaceRecogDuplicate.prototype.initialize = function () {
	alert("SceneFaceRecogDuplicate.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
    
   this.create();
}

SceneFaceRecogDuplicate.prototype.handleShow = function () {
	alert("SceneFaceRecogDuplicate.handleShow()");
	// this function will be called when the scene manager show this scene 
	this.MainViewDim.show();
	this.updateData();
    this.highlight(this.OkBtn);

    this.startTimer();
}

SceneFaceRecogDuplicate.prototype.handleHide = function () {
	alert("SceneFaceRecogDuplicate.handleHide()");
	// this function will be called when the scene manager hide this scene  
	this.MainViewDim.hide();

    this.enableButton();
    
	if(this.CloseTimer == true)
	{
		this.stopTimer();
	}
}

SceneFaceRecogDuplicate.prototype.handleFocus = function () {
	alert("SceneFaceRecogDuplicate.handleFocus()");
	// this function will be called when the scene manager focus this scene

}

SceneFaceRecogDuplicate.prototype.handleBlur = function () {
	alert("SceneFaceRecogDuplicate.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
}

SceneFaceRecogDuplicate.prototype.handleKeyDown = function (keyCode) {
	alert("SceneFaceRecogDuplicate.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	PluginAPIMgr.PlayAudio(keyCode);
	switch (keyCode) {
		case $.sfKey.LEFT:
			break;
		case $.sfKey.RIGHT:
			break;
		case $.sfKey.UP:

			break;
		case $.sfKey.DOWN:

			break;

		case $.sfKey.ENTER:
            this.processEnterKey();
			break;
            
        case $.sfKey.RETURN:
        case $.sfKey.EXIT:
            this.processReturnKey();
            $.sfKey.block(event);
			break;

        case 147:  //infolink
        case 261:  //contents
        case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneFaceRecogDuplicate.prototype.create = function(){
    alert("SceneFaceRecogDuplicate.create()");
    this.MainView = new View("FaceRecogDuplicate");
    this.MainView.SetBgImage(g_Image.IMAGE_FACE_RECOG_DUPLICATE_BG);
	
	this.MainViewDim = new DimBg("FaceRecogDuplicateDim", "FaceRecogDuplicate");
    
    this.MsgLabel = new Label(null,"face_recog_duplicate_msg");
    this.MsgLabel.SetTextStyle("face_recog_duplicate_msg_style");
    this.MsgLabel.SetText(TV_THIS_FACE_IS_ALREADY_USED_BY_ANOTHER_ACCOUNT+"</br>"+TV_TRANSFER_YOUR_FACE_TO_THIS_ACCOUNT_AND_RETRY);
    
    var CurLangID = ResMgr.GetCurLanguage();  
    if(CurLangID == ENUM_TV_LANGUAGE.PER)
    {
    	$("#face_recog_duplicate_msg").css('left', "40px");
    	$("#face_recog_duplicate_msg").css('width', "440px");
    }
    
    this.SkypeNameLabel = new Label(null,"face_recog_duplicate_skype_name");
    this.SkypeNameLabel.SetTextStyle("face_recog_duplicate_msg_style");
    //this.SkypeNameLabel.SetReverseDisable(true);
    
    var this_ = $.sfScene.get("FaceRecogDuplicate");
    var clickCF =  function(obj){this_.processClickEvent(obj);};
    
    this.OkBtn = new Button();
    this.OkBtn.SetImageObjId("face_recog_duplicate_ok_btn");
    this.OkBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_FACE_RECOG_DUPLICATE_BTN_NORMAL);
    this.OkBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_FACE_RECOG_DUPLICATE_BTN_NORMALFOCUS);		
    this.OkBtn.SetTextObjId("face_recog_duplicate_ok_btn_text");
    this.OkBtn.SetText(SID_OK);
    this.OkBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"face_recog_duplicate_btn_style");
    this.OkBtn.SetOnClickCallbackFunc(clickCF);     
}

SceneFaceRecogDuplicate.prototype.updateData = function(){
    alert("SceneFaceRecogDuplicate.updateData() ");
    
    this.SkypeNameLabel.SetText(g_Data.CombinateStrings(TV_MIX_REGISTERED_ACCOUNT_COLON , g_Data.GetFaceRecogDupliceteSkypeName()));

}

SceneFaceRecogDuplicate.prototype.highlight=function(obj)
{
    this.MainView.setCurrenHighlight(obj);
    
}

SceneFaceRecogDuplicate.prototype.processEnterKey = function(){
    alert("SceneFaceRecogDuplicate.processEnterKey() ");
    if(this.flagWaiting ==true)
    {
        return;
    }
    
    var currentHighlight =  this.MainView.getCurrentHighlight();
  
    switch(currentHighlight)
    {
        case this.OkBtn:
        	this.disableButton();
			ProcMgr.ReturnToFaceRecogRegistrationCaller();
            break;

    }
}

SceneFaceRecogDuplicate.prototype.enableButton = function(){
    alert("SceneFaceRecogDuplicate.enableButton() ");
	
    this.OkBtn.SetFlagDim(false);

    this.flagWaiting = false;
}

SceneFaceRecogDuplicate.prototype.disableButton = function(){
    alert("SceneFaceRecogDuplicate.disableButton() ");
	if(this.CloseTimer == true)
	{
		this.stopTimer();
	}
	
    this.flagWaiting = true;

    var currentHighlight =  this.MainView.getCurrentHighlight();
    currentHighlight.blur();
    
    this.OkBtn.SetFlagDim(true); 
}

SceneFaceRecogDuplicate.prototype.processReturnKey = function(){
    alert("SceneFaceRecogDuplicate.processReturnKey() ");
 	if(this.flagWaiting ==true)
    {
        return;
    }
  
    ProcMgr.ReturnToFaceRecogRegistrationCaller();
}

SceneFaceRecogDuplicate.prototype.startTimer = function()
{
    alert("SceneFaceRecogDuplicate.startTimer() ");
	
	this.CloseTimer = true;
	PluginAPIMgr.StartOSDTimer("10000" , function() { $.sfScene.get('FaceRecogDuplicate').popupTimerCallback();}, ENUM_TIMER_TYPE.ONE_BUTTON);
}

SceneFaceRecogDuplicate.prototype.resetTimer = function()
{
    alert("SceneFaceRecogDuplicate.resetTimer() ");
	
	if(this.CloseTimer == true)
	{
		PluginAPIMgr.RestartOSDTimer("10000" ,ENUM_TIMER_TYPE.ONE_BUTTON);
	}
}

SceneFaceRecogDuplicate.prototype.stopTimer = function()
{
    alert("SceneFaceRecogDuplicate.stopTimer() ");

	this.CloseTimer = false;
	PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.ONE_BUTTON); 
}

SceneFaceRecogDuplicate.prototype.popupTimerCallback = function()
{
    alert("SceneFaceRecogDuplicate.popupTimerCallback() ");
	
	if (this.CloseTimer == false)
	{
		return;
	}
	this.CloseTimer = false;	
		
	ProcMgr.ReturnToFaceRecogRegistrationCaller();
}

SceneFaceRecogDuplicate.prototype.processClickEvent = function(obj){
	alert("SceneFaceRecogDuplicate.processClickEvent() ");
	
	var currentHighlight =  this.MainView.getCurrentHighlight();
    if(currentHighlight != obj)
    {
    	this.highlight(obj);
    }
	
	this.processEnterKey();
}

