
function SceneFaceRecogRegistration(options) {
	this.options = options;
    
    this.MainView=null;
    
    this.TitleLabel = null;     	
	this.MsgLabel = null;
	
	this.BoxLabel = null;

    this.StopBtn = null;
    this.RetryBtn = null;
    this.CancelBtn = null;

    this.DefaultHelpBar =null;

	//flag	
	this.flagWaiting = false;
	this.flagCameraStarting = false;
	
	this.flagStartRecog = false;
}

SceneFaceRecogRegistration.prototype.initialize = function () {
	alert("SceneFaceRecogRegistration.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
   
    this.create();
    
}

SceneFaceRecogRegistration.prototype.handleShow = function () {
	alert("SceneFaceRecogRegistration.handleShow()");
	// this function will be called when the scene manager show this scene 

	this.initFaceRecogRegistration();
}

SceneFaceRecogRegistration.prototype.handleHide = function () {
	alert("SceneFaceRecogRegistration.handleHide()");
	// this function will be called when the scene manager hide this scene      
	ProcMgr.StopFaceRecogRegistration(); 
	
	this.highlight(null);
}

SceneFaceRecogRegistration.prototype.handleFocus = function () {
	alert("SceneFaceRecogRegistration.handleFocus()");
	// this function will be called when the scene manager focus this scene

    var currentHighlight =  this.MainView.getCurrentHighlight();
    if(currentHighlight ==null)
    {
        this.highlight(this.StopBtn);
    }
    else
    {
         this.highlight(currentHighlight);
    }
}

SceneFaceRecogRegistration.prototype.handleBlur = function () {
	alert("SceneFaceRecogRegistration.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
    
    var currentHighlight =  this.MainView.getCurrentHighlight();
	if(currentHighlight !=null)
    {
    	currentHighlight.blur();
	}

}
 
SceneFaceRecogRegistration.prototype.handleKeyDown = function (keyCode) {
	alert("SceneFaceRecogRegistration.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	PluginAPIMgr.PlayAudio(keyCode);
	if(this.flagWaiting==true)
	{
		return;	
	}
	
	switch (keyCode) {
		case $.sfKey.LEFT:
		case $.sfKey.RIGHT:
			this.processLeftRightKey();
			break;
		case $.sfKey.UP:          
		case $.sfKey.DOWN:

			break;

		case $.sfKey.ENTER:
            this.processEnterKey();
			break;
        
		case $.sfKey.TOOLS:
            
			break; 
            
        case $.sfKey.RETURN:
            this.processReturnKey();
            $.sfKey.block(event);
			break;
            
        case $.sfKey.EXIT:
            this.processExitKey();
            $.sfKey.block(event);
			break;
		
        case 147:  //infolink
        case 261:  //contents
        case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
			
		default:
            ProcMgr.processBlockKey(keyCode);
            break;

	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneFaceRecogRegistration.prototype.create = function(){
    alert("SceneFaceRecogRegistration.create()");
    this.MainView = new View("FaceRecogRegistration");
    this.MainView.SetBgImage(g_Image.IMAGE_FACE_RECOG_REGISTRATION_BG);
    
    this.TitleLabel = new Label(null,"face_recog_registration_title");
    this.TitleLabel.SetTextStyle("face_recog_registration_title_style");
    this.TitleLabel.SetText(TV_REGISTER_FACE_BTTN);   
	
    this.MsgLabel = new Label("face_recog_registration_msg_bg","face_recog_registration_msg_text");    
    this.MsgLabel.SetBgImage(g_Image.IMAGE_FACE_RECOG_REGISTRATION_MSG_BG);
    this.MsgLabel.SetText(TV_FACE_IN_CENTER_SCREEN_MSG+"</br>"+TV_WAIT_RECT_TURNS_GREEN_MSG);
    this.MsgLabel.SetTextStyle("face_recog_registration_msg_style"); 
    
	if(ResMgr.GetCurLanguage() == ENUM_TV_LANGUAGE.GRE)
	{
		$("#face_recog_registration_msg_text").css('top', "5px" );
	} 
    
    this.BoxLabel = new Label("face_recog_registration_box",null);    
    this.BoxLabel.SetBgImage(g_Image.IMAGE_FACE_RECOG_REGISTRATION_BOX_RED);
	
	var this_ = $.sfScene.get("FaceRecogRegistration");
	var clickCF =  function(obj){this_.processClickEvent(obj);};
	
    this.StopBtn= new Button();
    this.StopBtn.SetImageObjId("face_recog_registration_stop_btn");
    this.StopBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_FACE_RECOG_REGISTRATION_BTN_NORMAL);
    this.StopBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_FACE_RECOG_REGISTRATION_BTN_NORMALFOCUS);
	this.StopBtn.SetTextObjId("face_recog_registration_stop_btn_text");
    this.StopBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"face_recog_registration_btn_normal_style");
	this.StopBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"face_recog_registration_btn_select_style");
	this.StopBtn.SetText(SID_STOP);
	this.StopBtn.SetOnClickCallbackFunc(clickCF);
		
    this.RetryBtn= new Button();
    this.RetryBtn.SetImageObjId("face_recog_registration_retry_btn");
    this.RetryBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_FACE_RECOG_REGISTRATION_BTN_NORMAL);
    this.RetryBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_FACE_RECOG_REGISTRATION_BTN_NORMALFOCUS);
	this.RetryBtn.SetTextObjId("face_recog_registration_retry_btn_text");
    this.RetryBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"face_recog_registration_btn_normal_style");
	this.RetryBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"face_recog_registration_btn_select_style");
	this.RetryBtn.SetText(SID_RETRY_KR_RETRY);
	this.RetryBtn.SetOnClickCallbackFunc(clickCF);
	
    this.CancelBtn= new Button();
    this.CancelBtn.SetImageObjId("face_recog_registration_cancel_btn");
    this.CancelBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_FACE_RECOG_REGISTRATION_BTN_NORMAL);
    this.CancelBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_FACE_RECOG_REGISTRATION_BTN_NORMALFOCUS);
	this.CancelBtn.SetTextObjId("face_recog_registration_cancel_btn_text");
    this.CancelBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"face_recog_registration_btn_normal_style");
	this.CancelBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"face_recog_registration_btn_select_style");
	this.CancelBtn.SetText(SID_CANCEL);
	this.CancelBtn.SetOnClickCallbackFunc(clickCF);


    this.DefaultHelpBar = new HelpBar(HelpBarIndex.FACE_RECOG_REGISTRATION,"FaceRecogRegistration");
    this.DefaultHelpBar.SetOnClickCallbackFunc(1, function(){this_.processReturnKey();});
    
	this.MainView.registHelpBar(this.DefaultHelpBar);
}


SceneFaceRecogRegistration.prototype.initFaceRecogRegistration = function(){
    alert("SceneFaceRecogRegistration.initFaceRecogRegistration() ");
    
    this.showStartRecogPage();
    this.BoxLabel.SetBgImage(g_Image.IMAGE_FACE_RECOG_REGISTRATION_BOX_RED);
}

SceneFaceRecogRegistration.prototype.showStartRecogPage = function(){
    alert("SceneFaceRecogRegistration.showStartRecogPage() ");
	this.flagStartRecog = true;
	
    this.StopBtn.visibleObj();

    this.RetryBtn.hiddenObj();
    this.CancelBtn.hiddenObj();
    
    this.highlight(this.StopBtn);
}

SceneFaceRecogRegistration.prototype.showStopRecogPage = function(){
    alert("SceneFaceRecogRegistration.showStopRecogPage() ");
	
	this.flagStartRecog = false;
	
    this.StopBtn.hiddenObj();

    this.RetryBtn.visibleObj();
    this.CancelBtn.visibleObj();
    
    this.highlight(this.RetryBtn);
}

SceneFaceRecogRegistration.prototype.updateBoxColor = function(image){
    alert("SceneFaceRecogRegistration.updateBoxColor() ");
    
    this.BoxLabel.SetBgImage(image);
}

SceneFaceRecogRegistration.prototype.highlight=function(obj)
{
	alert("SceneFaceRecogRegistration.highlight()");
	
    this.MainView.setCurrenHighlight(obj);	
}

SceneFaceRecogRegistration.prototype.processLeftRightKey = function(){
    alert("SceneFaceRecogRegistration.processLeftRightKey() ");
    
    var currentHighlight =  this.MainView.getCurrentHighlight();
	
    switch(currentHighlight)
    {            
        case this.RetryBtn:
			this.highlight(this.CancelBtn);
            break;
            
        case this.CancelBtn:
			this.highlight(this.RetryBtn);
            break;
    }
}

SceneFaceRecogRegistration.prototype.processEnterKey = function(){
    alert("SceneFaceRecogRegistration.processEnterKey() ");
    
    var currentHighlight =  this.MainView.getCurrentHighlight();

    switch(currentHighlight)
    {
        case this.StopBtn:
			ProcMgr.PauseFaceDetect(true);
			this.showStopRecogPage();
            break;
            
        case this.RetryBtn:
			ProcMgr.RetryFaceDetect();
			this.showStartRecogPage();
            break;
            
        case this.CancelBtn:
        	ProcMgr.ReturnToFaceRecogRegistrationCaller();
            break;
    }
}


SceneFaceRecogRegistration.prototype.processReturnKey = function(){
    alert("SceneFaceRecogRegistration.processReturnKey() ");
	
    ProcMgr.ReturnToFaceRecogRegistrationCaller();
}

SceneFaceRecogRegistration.prototype.processExitKey = function(){
    alert("SceneFaceRecogRegistration.processExitKey() ");
	  
   ProcMgr.ExitWithSignIn();
}


SceneFaceRecogRegistration.prototype.processClickEvent = function(obj){
	alert("SceneFaceRecogRegistration.processClickEvent() ");
	
	var currentHighlight =  this.MainView.getCurrentHighlight();
    if(currentHighlight != obj)
    {
    	this.highlight(obj);
    }
	
	this.processEnterKey();
}



