function SceneFaceRecogSecureComplete(options) {
	this.options = options;
    
	this.MainView=null;
	this.MainViewDim=null;
	
	this.MsgLabel = null;
	
	this.ImageBox = null;
	this.SkypeNameLabel = null;

	this.SecureCheckBox = null;
	
	this.RetryBtn = null;
	this.OkBtn = null;

	this.flagWaiting = false;
	
	this.CloseTimer = false;
}

SceneFaceRecogSecureComplete.prototype.initialize = function () {
	alert("SceneFaceRecogSecureComplete.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
    
   this.create();
}

SceneFaceRecogSecureComplete.prototype.handleShow = function () {
	alert("SceneFaceRecogSecureComplete.handleShow()");
	// this function will be called when the scene manager show this scene 
	this.MainViewDim.show();
	this.updateData();
    this.highlight(this.OkBtn);

    this.startTimer();
}

SceneFaceRecogSecureComplete.prototype.handleHide = function () {
	alert("SceneFaceRecogSecureComplete.handleHide()");
	// this function will be called when the scene manager hide this scene  
	this.MainViewDim.hide();

    this.enableButton();
    
	if(this.CloseTimer == true)
	{
		this.stopTimer();
	}
}

SceneFaceRecogSecureComplete.prototype.handleFocus = function () {
	alert("SceneFaceRecogSecureComplete.handleFocus()");
	// this function will be called when the scene manager focus this scene

}

SceneFaceRecogSecureComplete.prototype.handleBlur = function () {
	alert("SceneFaceRecogSecureComplete.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
}

SceneFaceRecogSecureComplete.prototype.handleKeyDown = function (keyCode) {
	alert("SceneFaceRecogSecureComplete.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	if(this.flagWaiting==true)
	{
		return;	
	}
	
	PluginAPIMgr.PlayAudio(keyCode);
	switch (keyCode) {
		case $.sfKey.LEFT:
		case $.sfKey.RIGHT:
			this.processLeftRightKey();
			break;
		case $.sfKey.UP:
		case $.sfKey.DOWN:
			this.processUpDownKey();
			break;

		case $.sfKey.ENTER:
            this.processEnterKey();
			break;
            
        case $.sfKey.RETURN:
        case $.sfKey.EXIT:
            this.processReturnKey();
            $.sfKey.block(event);
			break;

        case 147:  //infolink
        case 261:  //contents
        case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneFaceRecogSecureComplete.prototype.create = function(){
    alert("SceneFaceRecogSecureComplete.create()");
    this.MainView = new View("FaceRecogSecureComplete");
    this.MainView.SetBgImage(g_Image.IMAGE_FACE_RECOG_SECURE_COMPLETE_BG);
	
	this.MainViewDim = new DimBg("FaceRecogSecureCompleteDim", "FaceRecogSecureComplete");
    
    this.MsgLabel = new Label(null,"face_recog_secure_complete_msg");
    this.MsgLabel.SetTextStyle("face_recog_complete_msg_style");
    this.MsgLabel.SetText(TV_YOUR_FACE_HAS_BEEN_REGISTERED_TO_THE_SELECTED_ACCOUNT_MSG);
        
    this.ImageBox= new Label("face_recog_secure_complete_image_box", null);
    this.ImageBox.SetBgImage(g_Image.IMAGE_FACE_RECOG_SECURE_COMPLETE_IMAGE);
    this.ImageBox.AppendFgImage("face_recog_secure_complete_image","7px","7px","60px","60px");
    
    this.SkypeNameLabel = new Label(null,"face_recog_secure_complete_skype_name");
    this.SkypeNameLabel.SetTextStyle("face_recog_secure_complete_skype_name_style");
        
    var this_ = $.sfScene.get("FaceRecogSecureComplete");
    var clickCF =  function(obj){this_.processClickEvent(obj);};
    
    this.SecureCheckBox=new CheckBox();
    this.SecureCheckBox.SetImageObjId("face_recog_secure_complete_check_box");
    this.SecureCheckBox.SetBgImage(CBoxImgIndex.CB_NORMAL_IMG,  g_Image.IMAGE_FACE_RECOG_SECURE_COMPLETE_CHECK_BOX_NORMAL);
    this.SecureCheckBox.SetBgImage(CBoxImgIndex.CB_NORMAL_FOCUS_IMG,  g_Image.IMAGE_FACE_RECOG_SECURE_COMPLETE_CHECK_BOX_NORMALFOCUS);
    this.SecureCheckBox.SetTextObjId("face_recog_secure_complete_check_box_text");
    this.SecureCheckBox.SetText(TV_I_WANT_TO_ENTER_PASSWORD_AS_WELL_FOR_INCREASED_SECURITY_MSG);
    this.SecureCheckBox.SetTextStyle("face_recog_secure_complete_check_box_style");
    this.SecureCheckBox.AppendFgImage("face_recog_secure_complete_check_box_selected_icon","0px","0px","29px","29px");
    this.SecureCheckBox.SetFgImage(g_Image.IMAGE_FACE_RECOG_SECURE_COMPLETE_CHECK_BOX_SELECTED);
    this.SecureCheckBox.SetOnClickCallbackFunc(clickCF); 
    
    this.RetryBtn = new Button();
    this.RetryBtn.SetImageObjId("face_recog_secure_complete_retry_btn");
    this.RetryBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_FACE_RECOG_SECURE_COMPLETE_BTN_NORMAL);
    this.RetryBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_FACE_RECOG_SECURE_COMPLETE_BTN_NORMALFOCUS);		
    this.RetryBtn.SetTextObjId("face_recog_secure_complete_retry_btn_text");
    this.RetryBtn.SetText(SID_RETRY_KR_RETRY);
    this.RetryBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"face_recog_secure_complete_btn_style");
    this.RetryBtn.SetOnClickCallbackFunc(clickCF); 
    
    this.OkBtn = new Button();
    this.OkBtn.SetImageObjId("face_recog_secure_complete_ok_btn");
    this.OkBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_FACE_RECOG_SECURE_COMPLETE_BTN_NORMAL);
    this.OkBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_FACE_RECOG_SECURE_COMPLETE_BTN_NORMALFOCUS);		
    this.OkBtn.SetTextObjId("face_recog_secure_complete_ok_btn_text");
    this.OkBtn.SetText(SID_OK);
    this.OkBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"face_recog_secure_complete_btn_style");
    this.OkBtn.SetOnClickCallbackFunc(clickCF);     
}

SceneFaceRecogSecureComplete.prototype.updateData = function(){
    alert("SceneFaceRecogSecureComplete.updateData() ");
    this.SkypeNameLabel.SetText(PluginAPIMgr.GetMySkyeName());

    this.ImageBox.SetFgImage("");
    this.ImageBox.SetFgImage(ProcMgr.GetMyFaceImagePath()+g_Data.GetImgSuffixPath());
    
    this.SecureCheckBox.SetFlagSelect(false);
}

SceneFaceRecogSecureComplete.prototype.highlight=function(obj)
{
    this.MainView.setCurrenHighlight(obj);
    
}

SceneFaceRecogSecureComplete.prototype.select=function(obj)
{
     this.MainView.setCurrentSelect(obj);
}


SceneFaceRecogSecureComplete.prototype.processLeftRightKey = function(){
    alert("SceneFaceRecogSecureComplete.processLeftRightKey() ");
    var currentHighlight =  this.MainView.getCurrentHighlight();
    switch(currentHighlight)
    {
        case this.RetryBtn:
           this.highlight(this.OkBtn);
           break;
            
        case this.OkBtn:
           this.highlight(this.RetryBtn);
           break;
            
    }
}

SceneFaceRecogSecureComplete.prototype.processUpDownKey = function(){
    alert("SceneFaceRecogSecureComplete.processUpDownKey() ");
    var currentHighlight =  this.MainView.getCurrentHighlight();
    switch(currentHighlight)
    {
    	case this.SecureCheckBox:
    		this.highlight(this.OkBtn);
    		break;
    		
        case this.RetryBtn:
           this.highlight(this.SecureCheckBox);
           break;
            
        case this.OkBtn:
           this.highlight(this.SecureCheckBox);
           break;         
    }
}

SceneFaceRecogSecureComplete.prototype.processEnterKey = function(){
    alert("SceneFaceRecogSecureComplete.processEnterKey() ");

    var currentHighlight =  this.MainView.getCurrentHighlight();
    
    this.select(currentHighlight);
  
    switch(currentHighlight)
    {
    	case this.RetryBtn:
    		this.disableButton();
    		ProcMgr.RetryFaceRecogRegistration();
    		break;
        case this.OkBtn:
        	this.disableButton();
			ProcMgr.CompliteFaceRecogRegistration(this.SecureCheckBox.GetFlagSelect());
            break;

    }
}

SceneFaceRecogSecureComplete.prototype.enableButton = function(){
    alert("SceneFaceRecogSecureComplete.enableButton() ");
	
    this.RetryBtn.SetFlagDim(false);
    this.OkBtn.SetFlagDim(false);

    this.flagWaiting = false;
}

SceneFaceRecogSecureComplete.prototype.disableButton = function(){
    alert("SceneFaceRecogSecureComplete.disableButton() ");
	if(this.CloseTimer == true)
	{
		this.stopTimer();
	}
	
    this.flagWaiting = true;

    var currentHighlight =  this.MainView.getCurrentHighlight();
    currentHighlight.blur();
    
    this.RetryBtn.SetFlagDim(true);
    this.OkBtn.SetFlagDim(true);
}

SceneFaceRecogSecureComplete.prototype.processReturnKey = function(){
    alert("SceneFaceRecogSecureComplete.processReturnKey() ");
 	if(this.flagWaiting ==true)
    {
        return;
    }
  
    //ProcMgr.CompliteFaceRecogRegistration();
    ProcMgr.CompliteFaceRecogRegistration(this.SecureCheckBox.GetFlagSelect());
}

SceneFaceRecogSecureComplete.prototype.startTimer = function()
{
    alert("SceneFaceRecogSecureComplete.startTimer() ");
	
	this.CloseTimer = true;
	PluginAPIMgr.StartOSDTimer("30000" , function() { $.sfScene.get('FaceRecogSecureComplete').popupTimerCallback();}, ENUM_TIMER_TYPE.TWO_BUTTON);
}

SceneFaceRecogSecureComplete.prototype.resetTimer = function()
{
    alert("SceneFaceRecogSecureComplete.resetTimer() ");
	
	if(this.CloseTimer == true)
	{
		PluginAPIMgr.RestartOSDTimer("30000" ,ENUM_TIMER_TYPE.TWO_BUTTON);
	}
}

SceneFaceRecogSecureComplete.prototype.stopTimer = function()
{
    alert("SceneFaceRecogSecureComplete.stopTimer() ");

	this.CloseTimer = false;
	PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.TWO_BUTTON); 
}

SceneFaceRecogSecureComplete.prototype.popupTimerCallback = function()
{
    alert("SceneFaceRecogSecureComplete.popupTimerCallback() ");
	
	if (this.CloseTimer == false)
	{
		return;
	}
	this.CloseTimer = false;	
		
	//ProcMgr.CompliteFaceRecogRegistration();
	ProcMgr.CompliteFaceRecogRegistration(this.SecureCheckBox.GetFlagSelect());
}

SceneFaceRecogSecureComplete.prototype.processClickEvent = function(obj){
	alert("SceneFaceRecogSecureComplete.processClickEvent() ");
	
	if(this.flagWaiting==true)
	{
		return;	
	}
	
	var currentHighlight =  this.MainView.getCurrentHighlight();
    if(currentHighlight != obj)
    {
    	this.highlight(obj);
    }
	
	this.processEnterKey();
}

