

function SceneFaceRecogSecurityPopup(options) {
	this.options = options;
    
    this.MainView=null;
	this.MainViewDim=null;
    
    this.PopupMsg = null;
    this.YesBtn = null;
    this.NoBtn = null;
   
    this.CloseTimer = false;

}

SceneFaceRecogSecurityPopup.prototype.initialize = function () {
	alert("SceneFaceRecogSecurityPopup.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
    
   this.create();
}

SceneFaceRecogSecurityPopup.prototype.handleShow = function () {
	alert("SceneFaceRecogSecurityPopup.handleShow()");
	// this function will be called when the scene manager show this scene 
	this.MainViewDim.show();
	
    this.highlight(this.YesBtn);

    this.startTimer();
    
}

SceneFaceRecogSecurityPopup.prototype.handleHide = function () {
	alert("SceneFaceRecogSecurityPopup.handleHide()");
	// this function will be called when the scene manager hide this scene  

	this.MainViewDim.hide();
	
	if(this.CloseTimer== true)
	{
		this.stopTimer();
	}
}

SceneFaceRecogSecurityPopup.prototype.handleFocus = function () {
	alert("SceneFaceRecogSecurityPopup.handleFocus()");
	// this function will be called when the scene manager focus this scene

}

SceneFaceRecogSecurityPopup.prototype.handleBlur = function () {
	alert("SceneFaceRecogSecurityPopup.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
}

SceneFaceRecogSecurityPopup.prototype.handleKeyDown = function (keyCode) {
	alert("SceneFaceRecogSecurityPopup.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	PluginAPIMgr.PlayAudio(keyCode);
	switch (keyCode) {
		case $.sfKey.LEFT:
		case $.sfKey.RIGHT:
		this.resetTimer();
        this.processLeftRightKey();
			break;
		case $.sfKey.UP:

			break;
		case $.sfKey.DOWN:

			break;

		case $.sfKey.ENTER:
             this.processEnterKey();
			break;
            
        case $.sfKey.RETURN:
        case $.sfKey.EXIT:
            this.processReturnKey();
            $.sfKey.block(event);
			break;
            
         case 147:  //infolink
         case 261:  //contents
         case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneFaceRecogSecurityPopup.prototype.create = function(){
    alert("SceneFaceRecogSecurityPopup.create()");
    this.MainView = new View("FaceRecogSecurityPopup");
    this.MainView.SetBgImage(g_Image.IMAGE_FACE_RECOG_SECURITY_POPUP_BG); 
	 
	this.MainViewDim = new DimBg("FaceRecogSecurityPopupDim", "FaceRecogSecurityPopup");       
    this.PopupMsg = new Label(null,"face_recog_security_popup_msg");
        
    if(ResMgr.GetCurLanguage()== ENUM_TV_LANGUAGE.UKR)
    {
    	this.PopupMsg.SetTextStyle("face_recog_security_popup_msg_style_s");
    }
    else
    {
    	this.PopupMsg.SetTextStyle("face_recog_security_popup_msg_style");
    }    
    this.PopupMsg.SetText(TV_THUMBNAIL_IMAGE_OF_YOUR_FACE_WILL_BE_STORED_MSG+"</br>"+TV_LOGIN_FACE_RECOG_SECURITY_MSG+"</br>"+TV_I_ACCEPT_AND_WISH_TO_CONTINUE_MSG);
    
    var this_ = $.sfScene.get("FaceRecogSecurityPopup");
    var clickCF =  function(obj){this_.processClickEvent(obj);};

    this.YesBtn = new Button();
    this.YesBtn.SetImageObjId("face_recog_security_popup_yes_btn");
    this.YesBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_FACE_RECOG_POPUP_BTN_NORMAL);
    this.YesBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_FACE_RECOG_POPUP_BTN_NORMALFOCUS);	
    this.YesBtn.SetTextObjId("face_recog_security_popup_yes_btn_text");
    this.YesBtn.SetText(SID_YES);
    this.YesBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"face_recog_security_popup_btn_text_style");
	this.YesBtn.SetOnClickCallbackFunc(clickCF);
    
    this.NoBtn = new Button();
    this.NoBtn.SetImageObjId("face_recog_security_popup_no_btn");
    this.NoBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_FACE_RECOG_POPUP_BTN_NORMAL);
    this.NoBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_FACE_RECOG_POPUP_BTN_NORMALFOCUS);	
    this.NoBtn.SetTextObjId("face_recog_security_popup_no_btn_text");
    this.NoBtn.SetText(SID_NO);
    this.NoBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"face_recog_security_popup_btn_text_style");
	this.NoBtn.SetOnClickCallbackFunc(clickCF);
}


SceneFaceRecogSecurityPopup.prototype.highlight=function(obj)
{
    this.MainView.setCurrenHighlight(obj);

}

SceneFaceRecogSecurityPopup.prototype.startTimer = function()
{
    alert("SceneFaceRecogSecurityPopup.startTimer() ");
	
	this.CloseTimer = true;
	PluginAPIMgr.StartOSDTimer("30000" , function() { $.sfScene.get('FaceRecogSecurityPopup').popupTimerCallback();}, ENUM_TIMER_TYPE.TWO_BUTTON);
}

SceneFaceRecogSecurityPopup.prototype.resetTimer = function()
{
    alert("SceneFaceRecogSecurityPopup.resetTimer() ");
	
	if(this.CloseTimer == true)
	{
		PluginAPIMgr.RestartOSDTimer("30000" ,ENUM_TIMER_TYPE.TWO_BUTTON);
	}
}

SceneFaceRecogSecurityPopup.prototype.stopTimer = function()
{
    alert("SceneFaceRecogSecurityPopup.stopTimer() ");

	this.CloseTimer = false;
	PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.TWO_BUTTON); 
}

SceneFaceRecogSecurityPopup.prototype.popupTimerCallback = function()
{
    alert("SceneFaceRecogSecurityPopup.popupTimerCallback() ");
	
	if (this.CloseTimer == false)
	{
		return;
	}
	this.CloseTimer = false;	
		
   ProcMgr.SkipFaceRecogRegistration(); 
}

SceneFaceRecogSecurityPopup.prototype.processLeftRightKey = function(){
    alert("SceneFaceRecogSecurityPopup.processLeftRightKey() ");
    
    var currentHighlight =  this.MainView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.YesBtn:
           this.highlight(this.NoBtn);
            break;
            
        case this.NoBtn:
           this.highlight(this.YesBtn);
            break;
    }
}

SceneFaceRecogSecurityPopup.prototype.processEnterKey = function(){
    alert("SceneFaceRecogSecurityPopup.processEnterKey() ");
    
    var currentHighlight =  this.MainView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.YesBtn:
			ProcMgr.RequestFaceRecogRegistration();

            break;
            
        case this.NoBtn:

		   	ProcMgr.SkipFaceRecogRegistration(); 
            break;
    }
}

SceneFaceRecogSecurityPopup.prototype.processReturnKey = function(){
    alert("SceneFaceRecogSecurityPopup.processReturnKey() ");
	
   	ProcMgr.SkipFaceRecogRegistration(); 
}

SceneFaceRecogSecurityPopup.prototype.processClickEvent = function(obj){
	alert("SceneFaceRecogSecurityPopup.processClickEvent() ");
	
	var currentHighlight =  this.MainView.getCurrentHighlight();
    if(currentHighlight != obj)
    {
    	this.highlight(obj);
    }
	
	this.processEnterKey();
}

