
function SceneFaceRecogSignin(options) {
	this.options = options;
    
    this.MainView=null;
    
    this.RecogAreaView=null;
    
    this.TitleLabel = null;     	
	this.MsgLabel = null;

    this.StopBtn = null;
    this.PwdModeBtn = null;
    this.RetryBtn = null;
    this.CancelBtn = null;

    this.DefaultHelpBar =null;

	//flag	
	this.flagWaiting = false;
	this.flagCameraStarting = false;
	
	this.flagStartRecog = false;
	
	this.flagCreate = false;
}

SceneFaceRecogSignin.prototype.initialize = function () {
	alert("SceneFaceRecogSignin.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
   
    this.create();
    
}

SceneFaceRecogSignin.prototype.handleShow = function () {
	alert("SceneFaceRecogSignin.handleShow()");
	// this function will be called when the scene manager show this scene 

	this.initFaceRecogSignin();
}

SceneFaceRecogSignin.prototype.handleHide = function () {
	alert("SceneFaceRecogSignin.handleHide()");
	// this function will be called when the scene manager hide this scene      
	ProcMgr.StopFaceRecogSignin(); 
	
	this.highlight(null);
}

SceneFaceRecogSignin.prototype.handleFocus = function () {
	alert("SceneFaceRecogSignin.handleFocus()");
	// this function will be called when the scene manager focus this scene

    var currentHighlight =  this.MainView.getCurrentHighlight();
    if(currentHighlight ==null)
    {
        this.highlight(this.StopBtn);
    }
    else
    {
         this.highlight(currentHighlight);
    }
    
    if(this.flagStartRecog==true)
    {
    	ProcMgr.RetryFaceRecog(); 
    }
}

SceneFaceRecogSignin.prototype.handleBlur = function () {
	alert("SceneFaceRecogSignin.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
    
    var currentHighlight =  this.MainView.getCurrentHighlight();
	if(currentHighlight !=null)
    {
    	currentHighlight.blur();
	}

}
 
SceneFaceRecogSignin.prototype.handleKeyDown = function (keyCode) {
	alert("SceneFaceRecogSignin.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	PluginAPIMgr.PlayAudio(keyCode);
	if(this.flagWaiting==true)
	{
		return;	
	}
	
	switch (keyCode) {
		case $.sfKey.LEFT:
			this.processLeftKey();
			break;
		case $.sfKey.RIGHT:
			this.processRightKey();
			break;
		case $.sfKey.UP:          
		case $.sfKey.DOWN:

			break;

		case $.sfKey.ENTER:
            this.processEnterKey();
			break;
        
		case $.sfKey.TOOLS:
            
			break; 
            
        case $.sfKey.RETURN:
            this.processReturnKey();
            $.sfKey.block(event);
			break;
            
        case $.sfKey.EXIT:
            this.processExitKey();
            $.sfKey.block(event);
			break;
		
        case 147:  //infolink
        case 261:  //contents
        case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
			
		default:
            ProcMgr.processBlockKey(keyCode);
            break;

	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneFaceRecogSignin.prototype.create = function(){
    alert("SceneFaceRecogSignin.create()");
    this.MainView = new View("FaceRecogSignin");
    this.MainView.SetBgImage(g_Image.IMAGE_FACE_RECOG_SIGNIN_BG);
    
    this.RecogAreaView = new View("face_recog_signin_recog_area");
    
    this.TitleLabel = new Label(null,"face_recog_signin_title");
    this.TitleLabel.SetTextStyle("face_recog_signin_title_style");
    this.TitleLabel.SetText(IDWS_MOIP_WELCOM_TO_SKYPE );    
	
    this.MsgLabel = new Label("face_recog_signin_msg_bg","face_recog_signin_msg_text");
    this.MsgLabel.SetTextStyle("face_recog_signin_msg_style");
    this.MsgLabel.SetBgImage(g_Image.IMAGE_FACE_RECOG_SIGNIN_MSG_BG);
    this.MsgLabel.SetText(TV_YOU_CAN_LOG_IN_USING_FACE_RECOGNITION+"</br>"+TV_TURN_FACE_TOWARDS_TV_MSG );  
    
	if(ResMgr.GetCurLanguage() == ENUM_TV_LANGUAGE.TAM)
	{
		$("#face_recog_signin_msg_text").css('top', "5px" );
	} 
	
	var this_ = $.sfScene.get("FaceRecogSignin");
	var clickCF =  function(obj){this_.processClickEvent(obj);};
	
    this.StopBtn= new Button();
    this.StopBtn.SetImageObjId("face_recog_signin_stop_btn");
    this.StopBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_FACE_RECOG_SIGNIN_BTN_NORMAL);
    this.StopBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_FACE_RECOG_SIGNIN_BTN_NORMALFOCUS);
	this.StopBtn.SetTextObjId("face_recog_signin_stop_btn_text");
    this.StopBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"face_recog_signin_btn_normal_style");
	this.StopBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"face_recog_signin_btn_select_style");
	this.StopBtn.SetText(SID_STOP);
	this.StopBtn.SetOnClickCallbackFunc(clickCF);
	
    this.PwdModeBtn= new Button();
    this.PwdModeBtn.SetImageObjId("face_recog_signin_pwd_mode_btn");
    this.PwdModeBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_FACE_RECOG_SIGNIN_BTN_NORMAL);
    this.PwdModeBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_FACE_RECOG_SIGNIN_BTN_NORMALFOCUS);
	this.PwdModeBtn.SetTextObjId("face_recog_signin_pwd_mode_btn_text");
    this.PwdModeBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"face_recog_signin_btn_normal_style");
	this.PwdModeBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"face_recog_signin_btn_select_style");
	this.PwdModeBtn.SetText(TV_PASSWORD_MODE);
	this.PwdModeBtn.SetOnClickCallbackFunc(clickCF);
	
    this.RetryBtn= new Button();
    this.RetryBtn.SetImageObjId("face_recog_signin_retry_btn");
    this.RetryBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_FACE_RECOG_SIGNIN_BTN_NORMAL);
    this.RetryBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_FACE_RECOG_SIGNIN_BTN_NORMALFOCUS);
	this.RetryBtn.SetTextObjId("face_recog_signin_retry_btn_text");
    this.RetryBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"face_recog_signin_btn_normal_style");
	this.RetryBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"face_recog_signin_btn_select_style");
	this.RetryBtn.SetText(SID_RETRY_KR_RETRY);
	this.RetryBtn.SetOnClickCallbackFunc(clickCF);
	
    this.CancelBtn= new Button();
    this.CancelBtn.SetImageObjId("face_recog_signin_cancel_btn");
    this.CancelBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_FACE_RECOG_SIGNIN_BTN_NORMAL);
    this.CancelBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_FACE_RECOG_SIGNIN_BTN_NORMALFOCUS);
	this.CancelBtn.SetTextObjId("face_recog_signin_cancel_btn_text");
    this.CancelBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"face_recog_signin_btn_normal_style");
	this.CancelBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"face_recog_signin_btn_select_style");
	this.CancelBtn.SetText(SID_CANCEL);
	this.CancelBtn.SetOnClickCallbackFunc(clickCF);

	this.flagCreate = true;

    this.DefaultHelpBar = new HelpBar(HelpBarIndex.FACE_RECOG_SIGNIN,"FaceRecogSignin");
    this.DefaultHelpBar.SetOnClickCallbackFunc(1, function(){this_.processReturnKey();});
    
	this.MainView.registHelpBar(this.DefaultHelpBar);
}


SceneFaceRecogSignin.prototype.initFaceRecogSignin = function(){
    alert("SceneFaceRecogSignin.initFaceRecogSignin() ");
    
    this.initRecogArea();
    this.showStartRecogPage();  
}

SceneFaceRecogSignin.prototype.initRecogArea= function(){
    alert("SceneFaceRecogSignin.initRecogArea() ");
    
    $("#face_recog_signin_recog_area").empty();
}

SceneFaceRecogSignin.prototype.updateRecogArea = function(){
    alert("SceneFaceRecogSignin.updateRecogArea() ");

    if(this.flagCreate==false)
    {
    	return;	
    }
    
    this.initRecogArea();

    var Area_info = g_Data.GetFaceRecogAreaInfo();

    for(var a=0; a<Area_info.length; a++)
    {

    	var bg_color ='rgb(250,14,2)';
    	if(Area_info[a].registered == true)
    	{
    		bg_color ='rgb(165,255,0)';
    	}

    	for(var b=0; b<Area_info[a].x.length ; b++)
    	{
    		var area_id = "face_recog_signin_recog_area"+"_"+a+"_"+b;
    		
    		$("<div id='"+ area_id +"' />").appendTo("#face_recog_signin_recog_area");
			$("#"+area_id).css(	{
				'position' : 'absolute',
				'left' : Area_info[a].x[b],
				'top' : Area_info[a].y[b],
				'width' : Area_info[a].w[b],
				'height' : Area_info[a].h[b],
				'background-color' : bg_color,
			});
    	}    	
    }
}


SceneFaceRecogSignin.prototype.showStartRecogPage = function(){
    alert("SceneFaceRecogSignin.showStartRecogPage() ");
	this.flagStartRecog = true;
	
    this.StopBtn.visibleObj();
    this.PwdModeBtn.setLeft("258px");
    this.RetryBtn.hiddenObj();
    this.CancelBtn.hiddenObj();
    
    this.RecogAreaView.visibleObj(); 
    
    this.highlight(this.PwdModeBtn);
}

SceneFaceRecogSignin.prototype.showStopRecogPage = function(){
    alert("SceneFaceRecogSignin.showStopRecogPage() ");
	
	this.flagStartRecog = false;
	
    this.StopBtn.hiddenObj();
    this.PwdModeBtn.setLeft("165px");
    this.RetryBtn.visibleObj();
    this.CancelBtn.visibleObj();
    
    this.initRecogArea();
    this.RecogAreaView.hiddenObj(); 
    
    this.highlight(this.RetryBtn);
}

SceneFaceRecogSignin.prototype.highlight=function(obj)
{
	alert("SceneFaceRecogSignin.highlight()");
	
    this.MainView.setCurrenHighlight(obj);	
}

SceneFaceRecogSignin.prototype.processLeftKey = function(){
    alert("SceneFaceRecogSignin.processLeftKey() ");
    
    var currentHighlight =  this.MainView.getCurrentHighlight();
	
    switch(currentHighlight)
    {
           
        case this.PwdModeBtn:
	        if(this.flagStartRecog==true)
	        {
	        	this.highlight(this.StopBtn);
	        }
	        else
	        {
	        	this.highlight(this.CancelBtn);
	        }
			
            break;
            
        case this.StopBtn:
			this.highlight(this.PwdModeBtn);
            break;
            
        case this.RetryBtn:
			this.highlight(this.PwdModeBtn);
            break;
            
        case this.CancelBtn:
			this.highlight(this.RetryBtn);
            break;
    }
}

SceneFaceRecogSignin.prototype.processRightKey = function(){
    alert("SceneFaceRecogSignin.processRightKey() ");
    
    var currentHighlight =  this.MainView.getCurrentHighlight();
	
    switch(currentHighlight)
    {         
        case this.PwdModeBtn:
	        if(this.flagStartRecog==true)
	        {
	        	this.highlight(this.StopBtn);
	        }
	        else
	        {
	        	this.highlight(this.RetryBtn);
	        }
	        break;
	        
          case this.StopBtn:
			this.highlight(this.PwdModeBtn);
            break;
			
        case this.RetryBtn:
			this.highlight(this.CancelBtn);
            break;
            
        case this.CancelBtn:
			this.highlight(this.PwdModeBtn);
            break;
    }
}


SceneFaceRecogSignin.prototype.processEnterKey = function(){
    alert("SceneFaceRecogSignin.processEnterKey() ");
    
    var currentHighlight =  this.MainView.getCurrentHighlight();

    switch(currentHighlight)
    {
        case this.StopBtn:
			ProcMgr.PauseFaceRecog(true);
			this.showStopRecogPage();
            break;
            
        case this.PwdModeBtn:
			StateMgr.Start_Signin_State(); 			
            break;
            
        case this.RetryBtn:
			ProcMgr.RetryFaceRecog();
			this.showStartRecogPage();
            break;
            
        case this.CancelBtn:
			StateMgr.Start_Welcome_State();
            break;
    }
}


SceneFaceRecogSignin.prototype.processReturnKey = function(){
    alert("SceneFaceRecogSignin.processReturnKey() ");
	
   StateMgr.Start_Welcome_State();
}

SceneFaceRecogSignin.prototype.processExitKey = function(){
    alert("SceneFaceRecogSignin.processExitKey() ");
	  
   ProcMgr.ExitWithSignIn();
}


SceneFaceRecogSignin.prototype.processClickEvent = function(obj){
	alert("SceneFaceRecogSignin.processClickEvent() ");
	
	var currentHighlight =  this.MainView.getCurrentHighlight();
    if(currentHighlight != obj)
    {
    	this.highlight(obj);
    }
	
	this.processEnterKey();
}

