var MAX_LAST_LOGIN_ID = 5;

function SceneLastLoginIdList(options) {

	this.options			= options;	
	this.list				= null;
	this.lastLoginIdArray	= new Array(MAX_LAST_LOGIN_ID);
	
	this.showstate			= false;
	
	this.callerScene = "";
	
	this.HelpBar			= null;	
}

SceneLastLoginIdList.prototype.initialize = function () {
	alert("SceneLastLoginIdList.initialize()");	
	this.create();
}

SceneLastLoginIdList.prototype.handleShow = function () {
	alert("SceneLastLoginIdList.handleShow()");
    this.ResetData();
	this.list.Show();
	this.showstate = true;
	
	this.HelpBar.visibleObj();	
}

SceneLastLoginIdList.prototype.handleHide = function () {
	alert("SceneLastLoginIdList.handleHide()");

	if(this.list){
		
		this.list.Hide();	
		this.showstate = false;
	}
	
	this.HelpBar.hiddenObj();	
}

SceneLastLoginIdList.prototype.handleFocus = function () {
	alert("SceneLastLoginIdList.handleFocus()");
	
	if(this.list.GetMaxNumOfData() > 0){
		this.list.SetCurrentItem(0);
	}
	else{
		alert("No Previous Login ID");
	}
	
}

SceneLastLoginIdList.prototype.handleBlur = function () {
	alert("SceneLastLoginIdList.handleBlur()");
}

SceneLastLoginIdList.prototype.handleKeyDown = function (keyCode) {
	
	alert("SceneLastLoginIdList.handleKeyDown(" + keyCode + ")");
	PluginAPIMgr.PlayAudio(keyCode);
	this.list.KeyProcess(keyCode);	

}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneLastLoginIdList.prototype.create = function(){
    alert("SceneLastLoginIdList.create() ");

	this.list = new List();
	this.list.CreateBG("LoginIdList");
	this.list.SetBGImage(g_Image.IMAGE_LOGIN_LAST_LOGIN_ID_LIST_BG);	
	this.list.SetNumOfVisibleItem(5);
	this.list.SetStartDataIndex(0);
	this.list.SetItemBgImage(ITEM_STATE.NORMAL," ");
	this.list.SetItemBgImage(ITEM_STATE.HIGHLIGHT,g_Image.IMAGE_LOGIN_LAST_LOGIN_ID_ITEM_HIGHLIGHT_BG);
	this.list.SetItemDefualtTextStyle(ITEM_STATE.NORMAL,"cLoginIdList_Text_Normal");
	this.list.SetItemDefualtTextStyle(ITEM_STATE.HIGHLIGHT,"cLoginIdList_Text_Highlight");
	this.list.SetDataType(ITEM_DATA_TYPE.TEXT_ONLY);
	this.list.SetEventOnReturnFunc(this.ProcessKeyReturn);
	this.list.SetItemPressedEventCallback(this.ProcessKeyEnter);

	//Set Click Event
	this.list.SetOnClickCallbackFunc(0,this.onClickEventFunc1);
	this.list.SetOnClickCallbackFunc(1,this.onClickEventFunc2);
	this.list.SetOnClickCallbackFunc(2,this.onClickEventFunc3);
	this.list.SetOnClickCallbackFunc(3,this.onClickEventFunc4);
	this.list.SetOnClickCallbackFunc(4,this.onClickEventFunc5);		
	this.list.SetClickEventAvailable(WndMgr.MouseClickEnable);	
	
	this.HelpBar = new HelpBar(HelpBarIndex.SIGNIN_LAST_ID_LIST, "LastLoginIdList");
		
}

SceneLastLoginIdList.prototype.setCallerScene = function(caller){
	this.callerScene = caller;	
	alert("SceneLastLoginIdList.setCallerScene() "+ this.callerScene);
}

SceneLastLoginIdList.prototype.ProcessKeyReturn = function(){

	var scene = $.sfScene.get("LastLoginIdList");
	$.sfScene.focus(scene.callerScene);
	$.sfScene.hide('LastLoginIdList');

}

SceneLastLoginIdList.prototype.ProcessKeyEnter = function(){
	
	var scene = $.sfScene.get("LastLoginIdList");	
	var Index = scene.list.GetCurrentItem();
	
	alert("ProcessKeyEnter >>  Index = " + Index );
	
    $.sfScene.get(scene.callerScene).SetSkypeNameFromLoginIdList(scene.lastLoginIdArray[Index]);	
	$.sfScene.hide('LastLoginIdList');
	
}

SceneLastLoginIdList.prototype.ShowState = function(){

	return this.showstate;

}

SceneLastLoginIdList.prototype.ResetData = function(){

	this.list.DeleteDataAll();
	this.list.SetStartDataIndex(0);

	
	var tempData = new Array(MAX_LAST_LOGIN_ID); 
	var LoginId;
	
	for (var i=0; i < MAX_LAST_LOGIN_ID; i++) {
			
		LoginId = PluginAPIMgr.GetLastLoginID(i);
		
		if(LoginId){
			
			tempData[i] = [ LoginId ,null ];			
			this.list.AddData(tempData[i]);
			this.lastLoginIdArray[i] = LoginId;	
		
		}
		else{
			break;
		}
	}
		
	this.list.ShowItem();	

}

SceneLastLoginIdList.prototype.ProcessCallback = function(Index){

	alert("SceneLastLoginIdList.ProcessCallback >> " + Index );
	
    $.sfScene.get(this.callerScene).SetSkypeNameFromLoginIdList(this.lastLoginIdArray[Index]);	
	$.sfScene.hide('LastLoginIdList');
}

SceneLastLoginIdList.prototype.onClickEventFunc1 = function(){
	
	var This_ = $.sfScene.get("LastLoginIdList");	
	This_.ProcessCallback(0);
}

SceneLastLoginIdList.prototype.onClickEventFunc2 = function(){

	var This_ = $.sfScene.get("LastLoginIdList");	
	This_.ProcessCallback(1);
}

SceneLastLoginIdList.prototype.onClickEventFunc3 = function(){
	
	var This_ = $.sfScene.get("LastLoginIdList");	
	This_.ProcessCallback(2);
}

SceneLastLoginIdList.prototype.onClickEventFunc4 = function(){
	
	var This_ = $.sfScene.get("LastLoginIdList");	
	This_.ProcessCallback(3);
}

SceneLastLoginIdList.prototype.onClickEventFunc5 = function(){
	
	var This_ = $.sfScene.get("LastLoginIdList");	
	This_.ProcessCallback(4);
}

