function SceneListMainSetting(options) {
	this.options = options;
    
    this.ListMainSettingView=null;

    this.SettingBgLabel=null;
    
    this.SettingOnlineStateBtn=null;
    this.SettingEditProfileBtn=null;
    this.SettingChangePictureBtn=null;
    this.SettingChangePasswordBtn=null;
    this.SettingAccountManagerBtn=null;
    this.SettingSkypeOptionsBtn=null;
    
    this.BtnList = new Array(5);
     
    this.HelpBar =null;
    
    this.destroyFlag=true;
    
    this.FlagFocus=false;
}

SceneListMainSetting.prototype.initialize = function () {
	alert("SceneListMainSetting.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called

   this.create();
}

SceneListMainSetting.prototype.handleShow = function () {
	alert("SceneListMainSetting.handleShow()");
	// this function will be called when the scene manager show this scene 
    this.initListMainSetting();
}

SceneListMainSetting.prototype.handleHide = function () {
	alert("SceneListMainSetting.handleHide()");
	// this function will be called when the scene manager hide this scene  
}

SceneListMainSetting.prototype.handleFocus = function () {
	alert("SceneListMainSetting.handleFocus()");
	// this function will be called when the scene manager focus this scene
    
    this.FlagFocus=true;
    
    var currentHighlight =  this.ListMainSettingView.getCurrentHighlight();
    if(currentHighlight ==null)
    {
        this.highlight(this.SettingOnlineStateBtn);
    }
    else
    {
        this.highlight(currentHighlight);
    }
    
}

SceneListMainSetting.prototype.handleBlur = function () {
	alert("SceneListMainSetting.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
    
    this.FlagFocus=false;
    
     var currentHighlight =  this.ListMainSettingView.getCurrentHighlight();
     currentHighlight.blur();
}

SceneListMainSetting.prototype.handleKeyDown = function (keyCode) {
	alert("SceneListMainSetting.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	PluginAPIMgr.PlayAudio(keyCode);
	switch (keyCode) {
		case $.sfKey.LEFT:
        this.processLeftKey();
			break;
		case $.sfKey.RIGHT:
            //this.processRightKey();
			break;
		case $.sfKey.UP:
            this.processUpKey();
			break;
		case $.sfKey.DOWN:
            this.processDownKey();
			break;

		case $.sfKey.ENTER:
        this.processEnterKey();
			break;
         case $.sfKey.RETURN:
            this.processReturnKey();
            $.sfKey.block(event);
            break;
         case $.sfKey.RED:
            this.processRedKey();
			break;
            
         case $.sfKey.EXIT:
            this.processExitKey();
            $.sfKey.block(event);
			break;
            
        case 147:  //infolink
        case 261:  //contents
        case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
            
        default:
            ProcMgr.processBlockKey(keyCode);
            break;  
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneListMainSetting.prototype.create = function(){
    alert("SceneListMainSetting.create()");
    this.ListMainSettingView = new View("ListMainSetting");

    this.SettingBgLabel= new Label("list_main_setting_bg", null);
    this.SettingBgLabel.SetBgImage(g_Image.IMAGE_LIST_MAIN_SETTING_BG);
    
    var this_ = $.sfScene.get('ListMainSetting');
    var clickCF =  function(obj){this_.processClickEvent(obj);};
    
    this.SettingOnlineStateBtn = new Button();
    this.SettingOnlineStateBtn.SetImageObjId("list_main_setting_online_state_btn");
    this.SettingOnlineStateBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, null);
    this.SettingOnlineStateBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_LIST_MAIN_SETTING_BTN_NORMALFOCUS);	
    this.SettingOnlineStateBtn.SetTextObjId("list_main_setting_online_state_btn_text");
    this.SettingOnlineStateBtn.SetText(TV_SID_ONLINE_STATE);
    this.SettingOnlineStateBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"list_main_setting_btn_text_nor_style");
    this.SettingOnlineStateBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"list_main_setting_btn_text_sel_style");
    this.SettingOnlineStateBtn.AppendFgImage("list_main_setting_online_state_btn_icon","10px","4px","56px","53px");
    this.SettingOnlineStateBtn.SetFgImage(g_Image.IMAGE_LIST_MAIN_SETTING_ONLING_STATE_ICON);
    this.SettingOnlineStateBtn.SetOnClickCallbackFunc(clickCF);
    
    this.SettingEditProfileBtn = new Button();
    this.SettingEditProfileBtn.SetImageObjId("list_main_setting_edit_profile_btn");
    this.SettingEditProfileBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, null);
    this.SettingEditProfileBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_LIST_MAIN_SETTING_BTN_NORMALFOCUS);	
    this.SettingEditProfileBtn.SetTextObjId("list_main_setting_edit_profile_btn_text");
    this.SettingEditProfileBtn.SetText(TV_SID_EDIT_PROFILE);
    this.SettingEditProfileBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"list_main_setting_btn_text_nor_style");
    this.SettingEditProfileBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"list_main_setting_btn_text_sel_style");
	this.SettingEditProfileBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE,"list_main_setting_btn_text_dim_style");
	this.SettingEditProfileBtn.AppendFgImage("list_main_setting_edit_profile_btn_icon","10px","4px","56px","53px");
    this.SettingEditProfileBtn.SetFgImage(g_Image.IMAGE_LIST_MAIN_SETTING_EDIT_PROFILE_ICON);
    this.SettingEditProfileBtn.SetOnClickCallbackFunc(clickCF);
    
    this.SettingChangePictureBtn = new Button();
    this.SettingChangePictureBtn.SetImageObjId("list_main_setting_change_picture_btn");
    this.SettingChangePictureBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, null);
    this.SettingChangePictureBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_LIST_MAIN_SETTING_BTN_NORMALFOCUS);	
    this.SettingChangePictureBtn.SetTextObjId("list_main_setting_change_picture_btn_text");
    this.SettingChangePictureBtn.SetText(TV_SID_CHANGE_PICTURE);
    this.SettingChangePictureBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"list_main_setting_btn_text_nor_style");
    this.SettingChangePictureBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"list_main_setting_btn_text_sel_style");
	this.SettingChangePictureBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE,"list_main_setting_btn_text_dim_style");
    this.SettingChangePictureBtn.AppendFgImage("list_main_setting_change_picture_btn_icon","10px","4px","56px","53px");
    this.SettingChangePictureBtn.SetFgImage(g_Image.IMAGE_LIST_MAIN_SETTING_CHANGE_PICTURE_ICON);
    this.SettingChangePictureBtn.SetOnClickCallbackFunc(clickCF);
    
    this.SettingChangePasswordBtn = new Button();
    this.SettingChangePasswordBtn.SetImageObjId("list_main_setting_change_password_btn");
    this.SettingChangePasswordBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, null);
    this.SettingChangePasswordBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_LIST_MAIN_SETTING_BTN_NORMALFOCUS);	
    this.SettingChangePasswordBtn.SetTextObjId("list_main_setting_change_password_btn_text");
    this.SettingChangePasswordBtn.SetText(IDWS_MOIP_CHANGE_PASS);
    this.SettingChangePasswordBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"list_main_setting_btn_text_nor_style");
    this.SettingChangePasswordBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"list_main_setting_btn_text_sel_style");
	this.SettingChangePasswordBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE,"list_main_setting_btn_text_dim_style");
    this.SettingChangePasswordBtn.AppendFgImage("list_main_setting_change_password_btn_icon","10px","4px","56px","53px");
    this.SettingChangePasswordBtn.SetFgImage(g_Image.IMAGE_LIST_MAIN_SETTING_CHANGE_PASSWORD_ICON);
    this.SettingChangePasswordBtn.SetOnClickCallbackFunc(clickCF);
    
    this.SettingAccountManagerBtn = new Button();
    this.SettingAccountManagerBtn.SetImageObjId("list_main_setting_account_manager_btn");
    this.SettingAccountManagerBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, null);
    this.SettingAccountManagerBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_LIST_MAIN_SETTING_BTN_NORMALFOCUS);	
    this.SettingAccountManagerBtn.SetTextObjId("list_main_setting_account_manager_btn_text");
    this.SettingAccountManagerBtn.SetText(TV_ACCOUNT_MANAGER);
    this.SettingAccountManagerBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"list_main_setting_btn_text_nor_style");
    this.SettingAccountManagerBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"list_main_setting_btn_text_sel_style");
	this.SettingAccountManagerBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE,"list_main_setting_btn_text_dim_style");
    this.SettingAccountManagerBtn.AppendFgImage("list_main_setting_account_manager_btn_icon","10px","4px","56px","53px");
    this.SettingAccountManagerBtn.SetFgImage(g_Image.IMAGE_LIST_MAIN_SETTING_CHANGE_PASSWORD_ICON);
    this.SettingAccountManagerBtn.SetOnClickCallbackFunc(clickCF);
    
    this.SettingSkypeOptionsBtn = new Button();
    this.SettingSkypeOptionsBtn.SetImageObjId("list_main_setting_skype_options_btn");
    this.SettingSkypeOptionsBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, null);
    this.SettingSkypeOptionsBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_LIST_MAIN_SETTING_BTN_NORMALFOCUS);	
    this.SettingSkypeOptionsBtn.SetTextObjId("list_main_setting_skype_options_btn_text");
    this.SettingSkypeOptionsBtn.SetText(TV_SID_SKYPE_OPTIONS);
    this.SettingSkypeOptionsBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"list_main_setting_btn_text_nor_style");
    this.SettingSkypeOptionsBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"list_main_setting_btn_text_sel_style");
	this.SettingSkypeOptionsBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE,"list_main_setting_btn_text_dim_style");
    this.SettingSkypeOptionsBtn.AppendFgImage("list_main_setting_skype_options_btn_icon","10px","4px","56px","53px");
    this.SettingSkypeOptionsBtn.SetFgImage(g_Image.IMAGE_LIST_MAIN_SETTING_SKYPE_OPTIONS_ICON);
    this.SettingSkypeOptionsBtn.SetOnClickCallbackFunc(clickCF);
    
     var a=0;
     for(a=0; a<this.BtnList.length; a++)
     {
         this.BtnList[a]=new Object();
     }
     
     this.BtnList[0].obj =  this.SettingOnlineStateBtn;
     this.BtnList[1].obj =  this.SettingEditProfileBtn;
     this.BtnList[2].obj =  this.SettingChangePictureBtn;
     if(PluginAPIMgr.RecognitionPluginAvailable == false)
     {
     	this.BtnList[3].obj =  this.SettingChangePasswordBtn;
     }
     else
     {
     	if(ProcMgr.GetMyPwd().length>0)
     	{
     		this.BtnList[3].obj =  this.SettingAccountManagerBtn;
     	}
     	else
     	{
     		this.BtnList[3].obj =  this.SettingChangePasswordBtn;
     	}
     	
     }
     
     this.BtnList[4].obj =  this.SettingSkypeOptionsBtn;
     
    this.HelpBar = new HelpBar(HelpBarIndex.LIST_MAIN_SETTING_PAGE,"SceneListMain");
    this.HelpBar.SetOnClickCallbackFunc(1, function(){this_.processRedKey();});
    this.HelpBar.SetOnClickCallbackFunc(2, function(){this_.processReturnKey();});

    this.SettingOnlineStateBtn.registHelpBar( this.HelpBar);
    this.SettingEditProfileBtn.registHelpBar( this.HelpBar);
    this.SettingChangePictureBtn.registHelpBar( this.HelpBar);
    this.SettingChangePasswordBtn.registHelpBar( this.HelpBar);
    this.SettingAccountManagerBtn.registHelpBar( this.HelpBar);
    this.SettingSkypeOptionsBtn.registHelpBar( this.HelpBar);

}

SceneListMainSetting.prototype.initListMainSetting=function()
{
    alert("SceneListMainCall.initListMainSetting()"); 
    
    if(PluginAPIMgr.RecognitionPluginAvailable == false)
    {
    	this.BtnList[3].obj =  this.SettingChangePasswordBtn;
    	this.SettingChangePasswordBtn.visibleObj();
    	this.SettingAccountManagerBtn.hiddenObj();
    }
    else
    {
    	if(ProcMgr.GetMyPwd().length>0)
    	{
    		this.BtnList[3].obj =  this.SettingAccountManagerBtn;
	    	this.SettingChangePasswordBtn.hiddenObj();
    		this.SettingAccountManagerBtn.visibleObj();
    	}
    	else
    	{
    		this.BtnList[3].obj =  this.SettingChangePasswordBtn;
	    	this.SettingChangePasswordBtn.visibleObj();
    		this.SettingAccountManagerBtn.hiddenObj();
    	}
    }
       
	this.toggleButtonEnable();
    if(this.destroyFlag==true)
    {
        this.highlight(null);
        this.destroyFlag = false;
    }
}

SceneListMainSetting.prototype.setDestroyFlag= function(destroy_flag){
     this.destroyFlag = destroy_flag;
}

SceneListMainSetting.prototype.toggleButtonEnable = function()
{
	alert("SceneListMainCall.toggleButtonEnable()");
	
	if( $.sfScene.get("ListMain").liveCallFlag==true)
	{
		this.highlight(null);
		this.SettingEditProfileBtn.SetFlagDim(true);
	    this.SettingChangePictureBtn.SetFlagDim(true);
	    this.SettingChangePasswordBtn.SetFlagDim(true);
	    this.SettingAccountManagerBtn.SetFlagDim(true);
	    this.SettingSkypeOptionsBtn.SetFlagDim(true);
		
		this.SettingEditProfileBtn.SetFgImage(g_Image.IMAGE_LIST_MAIN_SETTING_EDIT_PROFILE_DIM_ICON);
		this.SettingChangePictureBtn.SetFgImage(g_Image.IMAGE_LIST_MAIN_SETTING_CHANGE_PICTURE_DIM_ICON);
		this.SettingChangePasswordBtn.SetFgImage(g_Image.IMAGE_LIST_MAIN_SETTING_CHANGE_PASSWORD_DIM_ICON);
		this.SettingAccountManagerBtn.SetFgImage(g_Image.IMAGE_LIST_MAIN_SETTING_CHANGE_PASSWORD_DIM_ICON);
		this.SettingSkypeOptionsBtn.SetFgImage(g_Image.IMAGE_LIST_MAIN_SETTING_SKYPE_OPTIONS_DIM_ICON);	
	}
	else
	{
		this.SettingEditProfileBtn.SetFlagDim(false);
	    this.SettingChangePictureBtn.SetFlagDim(false);
	    this.SettingChangePasswordBtn.SetFlagDim(false);
	    this.SettingAccountManagerBtn.SetFlagDim(false);
	    this.SettingSkypeOptionsBtn.SetFlagDim(false);
		
		this.SettingEditProfileBtn.SetFgImage(g_Image.IMAGE_LIST_MAIN_SETTING_EDIT_PROFILE_ICON);
		this.SettingChangePictureBtn.SetFgImage(g_Image.IMAGE_LIST_MAIN_SETTING_CHANGE_PICTURE_ICON);
		this.SettingChangePasswordBtn.SetFgImage(g_Image.IMAGE_LIST_MAIN_SETTING_CHANGE_PASSWORD_ICON);
		this.SettingAccountManagerBtn.SetFgImage(g_Image.IMAGE_LIST_MAIN_SETTING_CHANGE_PASSWORD_ICON);
		this.SettingSkypeOptionsBtn.SetFgImage(g_Image.IMAGE_LIST_MAIN_SETTING_SKYPE_OPTIONS_ICON);
	}
}

SceneListMainSetting.prototype.highlight=function(obj)
{
    this.ListMainSettingView.setCurrenHighlight(obj);
}

SceneListMainSetting.prototype.processDownKey = function(){
    alert("SceneListMainSetting.processDownKey() ");
    var currentHighlight =  this.ListMainSettingView.getCurrentHighlight();
    
    var a =0;
    for(a=0; a<this.BtnList.length; a++)
    {
        if(this.BtnList[a].obj == currentHighlight )
        {
            var b = a+1;
			if(b==this.BtnList.length) { b=0;}
			if(this.BtnList[b].obj.GetFlagDim()== true)
			{
				return;
			}
            this.highlight(this.BtnList[b].obj);
        }
     }
}

SceneListMainSetting.prototype.processUpKey = function(){
    alert("SceneListMainSetting.processUpKey() ");
    
    var currentHighlight =  this.ListMainSettingView.getCurrentHighlight();
    
    var a =0;
    for(a=0; a<this.BtnList.length; a++)
    {
        if(this.BtnList[a].obj == currentHighlight )
        {
            var b = a-1;
			if(b<0) { b = this.BtnList.length-1;}
			if(this.BtnList[b].obj.GetFlagDim()== true)
			{
				return;
			} 
            this.highlight(this.BtnList[b].obj);
        }
     }
}


SceneListMainSetting.prototype.processEnterKey = function(){
    alert("SceneListMainSetting.processEnterKey() ");
    
    var currentHighlight =  this.ListMainSettingView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.SettingOnlineStateBtn:
            StateMgr.Start_Online_Status_State();
            break;
            
        case this.SettingEditProfileBtn:
           StateMgr.Start_Edit_Profile_State();
            break;
            
       case this.SettingChangePictureBtn:
            StateMgr.Start_Change_Picture_State();
            break;
            
        case this.SettingChangePasswordBtn:
            StateMgr.Start_Change_Password_State();
            break;
        case this.SettingAccountManagerBtn:
         	StateMgr.Start_Account_Manager_State(); 
         break; 

        case this.SettingSkypeOptionsBtn:
            StateMgr.Start_Options_State();
            break;
    }
}

SceneListMainSetting.prototype.processLeftKey = function(){
    alert("SceneListMainSetting.processLeftKey() ");
    WndMgr.ReturnSubToMain();
    this.highlight(null);
}

SceneListMainSetting.prototype.processReturnKey = function(){
    alert("SceneListMainSetting.processReturnKey() ");
    WndMgr.ReturnSubToMain();
    this.highlight(null);
}

SceneListMainSetting.prototype.processRedKey = function(){
    alert("SceneListMainSetting.processRedKey() ");
    
    StateMgr.Start_Signout_State();      
}

SceneListMainSetting.prototype.processExitKey = function(){
    alert("SceneListMainLiveCall.processExitKey() ");
   
   StateMgr.Start_Exit_State(false);
}

///////// Processing Click evnet  //////////////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneListMainSetting.prototype.processClickEvent = function(obj){
	alert("SceneListMainSetting.processClickEvent() ");
	
	var currentHighlight =  this.ListMainSettingView.getCurrentHighlight();

	if(currentHighlight != obj)
    {
    	this.highlight(obj);
    }
    
    if(this.FlagFocus==false)
	{   
		$.sfScene.get('ListMain').selectOnCurrHighlight();
	}

    this.processEnterKey();	
}



