var LoadingTypeIndex ={ 
    SIGNIN_WITH_CANCEL  : 1,
    SIGNIN  : 2,
    SEARCH : 3,
    WAIT : 4,
}

function SceneLoading(options) {
	this.options = options;
    
    this.LoadingView=null;
	this.LoadingDim =null;
    
    this.LoadingAni = null;
    this.LoadingMsg = null;
    this.CancelBtn = null;
    
    this.FlagAnimation = false;
    this.LoadingAniImage = new Array(36);
    this.iCurrAniImage =0;
    
    this.LoadingTimer = null;
    
    this.LoadingType= 1;

}

SceneLoading.prototype.initialize = function () {
	alert("SceneLoading.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
    
   this.create();
}

SceneLoading.prototype.handleShow = function () {
	alert("SceneLoading.handleShow()");
	// this function will be called when the scene manager show this scene 
	
	this.LoadingDim.show();
	this.update();
	
	this.startTimer();
    
}

SceneLoading.prototype.handleHide = function () {
	alert("SceneLoading.handleHide()");
	// this function will be called when the scene manager hide this scene  
	this.LoadingDim.hide();
	
	if(this.LoadingTimer!=null)
	{
		this.stopTimer();
	}
}

SceneLoading.prototype.handleFocus = function () {
	alert("SceneLoading.handleFocus()");
	// this function will be called when the scene manager focus this scene

}

SceneLoading.prototype.handleBlur = function () {
	alert("SceneLoading.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
}

SceneLoading.prototype.handleKeyDown = function (keyCode) {
	alert("SceneLoading.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	PluginAPIMgr.PlayAudio(keyCode);
	switch (keyCode) {
		case $.sfKey.LEFT:
		case $.sfKey.RIGHT:
			break;
		case $.sfKey.UP:

			break;
		case $.sfKey.DOWN:

			break;

		case $.sfKey.ENTER:
             this.processEnterKey();
			break;
            
        case $.sfKey.RETURN:           
            $.sfKey.block(event);
			break;
            
         case $.sfKey.EXIT:            
            $.sfKey.block(event);
			break;

        case 147:  //infolink
         case 261:  //contents
         case 115:  //wiselink
            $.sfKey.block(event);
			break;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneLoading.prototype.create = function(){
    alert("SceneLoading.create()");
    this.LoadingView = new View("Loading");
    this.LoadingView.SetBgImage(g_Image.IMAGE_LOADING_BG);
	
	this.LoadingDim = new DimBg("LoadingDim", "Loading");
    
    var a=0;
    for (a=0; a < this.LoadingAniImage.length; a++)
    {
        var b = (a+1);
        if(b<10)
        {
            this.LoadingAniImage[a] = g_Image.base_loading_image_path +"create_loading"+"0"+b+".png";
        }
        else
        {
            this.LoadingAniImage[a] = g_Image.base_loading_image_path +"create_loading"+b+".png";
        }   
    }
    
    this.LoadingAni= new Label("loading_animation", null);
    this.LoadingAni.SetBgImage(this.LoadingAniImage[this.iCurrAniImage]);
    
    this.LoadingMsg = new Label(null,"loading_message");    
    this.LoadingMsg.SetTextStyle("loading_message_style");

	var CurLangID = ResMgr.GetCurLanguage();
    if(CurLangID == ENUM_TV_LANGUAGE.VIE)
    {
    	$("#loading_message").css('font-size', "18px" );
    }
    
    var this_ = $.sfScene.get("Loading");
    var clickCF =  function(obj){this_.processClickEvent(obj);};

    this.CancelBtn = new Button();
    this.CancelBtn.SetImageObjId("loading_btn");
    this.CancelBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_LOADING_BTN_NORMAL);
    this.CancelBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_LOADING_BTN_NORMALFOCUS);
	this.CancelBtn.SetBgImage(BtnImgIndex.BTN_DIM_IMG, g_Image.IMAGE_LOADING_BTN_DIM);	
    this.CancelBtn.SetTextObjId("loading_btn_text");
    this.CancelBtn.SetText(SID_CANCEL);
    this.CancelBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"common_btn_text_f17_normal_style");
    this.CancelBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE, "common_btn_text_f17_dim_style");
        
    this.CancelBtn.hiddenObj();
    this.CancelBtn.SetOnClickCallbackFunc(clickCF);
}

SceneLoading.prototype.initLoadingType = function(typeIndex)
{
    this.LoadingType =  typeIndex;
}

SceneLoading.prototype.update = function()
{
    if(this.LoadingType==LoadingTypeIndex.SIGNIN_WITH_CANCEL)
    {
        this.LoadingMsg.SetText(IDWS_MOIP_SKYPE_SIGNING_IN);
        if(this.CancelBtn.GetFlagDim() == true)
        {
            this.CancelBtn.SetFlagDim(false);
        }
        
        this.highlight(this.CancelBtn);
        this.CancelBtn.visibleObj();
    }
    else if(this.LoadingType==LoadingTypeIndex.SIGNIN)
    {       
		this.LoadingMsg.SetText(TV_SID_CHECKING_YOUR_SKYPE_NAME_IS_AVAILABLE_DOT);
        this.CancelBtn.hiddenObj();
    }
    else if(this.LoadingType==LoadingTypeIndex.SEARCH)
    {
        this.LoadingMsg.SetText(SID_SEARCHING);
        this.CancelBtn.hiddenObj();
    }
    else if(this.LoadingType==LoadingTypeIndex.WAIT)
    {
        this.LoadingMsg.SetText(TV_SID_WAITING_DOT);
        this.CancelBtn.hiddenObj();
    }
    else
    {
        this.LoadingMsg.SetText(IDWS_MOIP_SKYPE_SIGNING_IN);
        this.CancelBtn.hiddenObj();
    }
}

SceneLoading.prototype.highlight=function(obj)
{
    this.LoadingView.setCurrenHighlight(obj);
}

SceneLoading.prototype.startTimer = function()
{
   // alert("SceneLoading.startTimer() ");

	var scene = $.sfScene.get('Loading');
  	this.LoadingTimer=setInterval("timerCF()", 100);
    timerCF = function() { scene.loadingTimerCallback();}   
}

SceneLoading.prototype.stopTimer = function()
{
    alert("SceneLoading.stopTimer() ");
    
	clearInterval( this.LoadingTimer);
    this.LoadingTimer=null;
    this.iCurrAniImage =0;
}

SceneLoading.prototype.loadingTimerCallback = function()
{
     this.iCurrAniImage++;
     
    if(this.iCurrAniImage >= this.LoadingAniImage.length)
    {
        this.iCurrAniImage = 0;
    }   
    
    this.LoadingAni.SetBgImage(this.LoadingAniImage[this.iCurrAniImage]);
}


SceneLoading.prototype.processEnterKey = function(){
    alert("SceneLoading.processEnterKey() ");
    
    var currentHighlight =  this.LoadingView.getCurrentHighlight();
    
    switch(currentHighlight)
    {           
        case this.CancelBtn:
			this.requestSigninCancel();         
            break;
    }
}

SceneLoading.prototype.requestSigninCancel = function(){
    alert("SceneLoading.requestSigninCancel() ");
    
    if(this.LoadingType==LoadingTypeIndex.SIGNIN_WITH_CANCEL)
    {
         if(this.CancelBtn.GetFlagDim() == false)
        {
            this.CancelBtn.blur();
            this.CancelBtn.SetFlagDim(true); 
            this.LoadingMsg.SetText(TV_SID_WAITING_DOT);
            ProcMgr.CancelSignin(); 
        }                
    } 
}
/*
SceneLoading.prototype.processCancelBtnClick = function(){
    alert("SceneLoading.processCancelBtnClick() ");
    
    this.requestSigninCancel();
}*/


SceneLoading.prototype.processReturnKey = function(){
    alert("SceneLoading.processReturnKey() ");
    
    $.sfScene.hide('Loading');
}

SceneLoading.prototype.disableCancel = function(){
    if(this.CancelBtn.GetFlagDim() == false)
    {
    	this.CancelBtn.blur();
	    this.CancelBtn.SetFlagDim(true); 
	    this.LoadingMsg.SetText(TV_SID_WAITING_DOT);
    }
}

SceneLoading.prototype.processClickEvent = function(obj){
	alert("SceneLoading.processClickEvent() ");
	
	this.processEnterKey();
}




