function SceneOnlineStatus(options) {
	this.options = options;
    
    this.OnlineStatusView=null;
	this.OnlineStatusDim=null;
    
    this.TitleBar = null;
    
    this.OnlineBtn = null;   
    this.AwayBtn = null;  
	this.DoNotDisturbBtn = null;  
	this.InvisibleBtn = null;
	this.OfflineBtn = null;
    
    this.OnlineStatusHelpBar = null;
	this.CloseTimer = false;

}

SceneOnlineStatus.prototype.initialize = function () {
	alert("SceneOnlineStatus.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
    
   this.create();
}

SceneOnlineStatus.prototype.handleShow = function () {
	alert("SceneOnlineStatus.handleShow()");
	// this function will be called when the scene manager show this scene 

    //this.highlight(this.OnlineBtn);
	this.OnlineStatusDim.show();
	
	this.startTimer();    
}

SceneOnlineStatus.prototype.handleHide = function () {
	alert("SceneOnlineStatus.handleHide()");
	// this function will be called when the scene manager hide this scene  
    this.OnlineStatusDim.hide();
	
	if(this.CloseTimer == true)
	{
		this.stopTimer();
	}
}

SceneOnlineStatus.prototype.handleFocus = function () {
	alert("SceneOnlineStatus.handleFocus()");
	// this function will be called when the scene manager focus this scene
    this.initOnlineStatus();
}

SceneOnlineStatus.prototype.handleBlur = function () {
	alert("SceneOnlineStatus.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
}

SceneOnlineStatus.prototype.handleKeyDown = function (keyCode) {
	alert("SceneOnlineStatus.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	PluginAPIMgr.PlayAudio(keyCode);
	switch (keyCode) {
		case $.sfKey.LEFT:
		case $.sfKey.RIGHT:

			break;
		case $.sfKey.UP:
			this.resetTimer();
            this.processUpKey();
			break;
		case $.sfKey.DOWN:
            this.resetTimer();
			this.processDownKey();
			break;

		case $.sfKey.ENTER:
             this.processEnterKey();
			break;
            
        case $.sfKey.RETURN:
        case $.sfKey.EXIT:
            this.processReturnKey();
            $.sfKey.block(event);
			break;
            
        
        case 147:  //infolink
        case 261:  //contents
        case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneOnlineStatus.prototype.create = function(){
    alert("SceneOnlineStatus.create()");
    this.OnlineStatusView = new View("OnlineStatus");
    this.OnlineStatusView.SetBgImage(g_Image.IMAGE_ONLINE_STATUS_BG);
	
	this.OnlineStatusDim = new DimBg("OnlineStatusDim", "OnlineStatus");
    
    this.TitleBar = new Label(null,"online_status_title");
    this.TitleBar.SetTextStyle("online_status_title_style");
    this.TitleBar.SetText(IDWS_MOIP_SETTING_ONLINE_STATUS);
    
    var this_ = $.sfScene.get("OnlineStatus");
	var clickCF =  function(obj){this_.processClickEvent(obj);};

    this.OnlineBtn = new Button();
    this.OnlineBtn.SetImageObjId("online_status_online_btn");
    this.OnlineBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, null);
    this.OnlineBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_ONLINE_STATUS_BTN_NORMALFOCUS);
    this.OnlineBtn.SetTextObjId("online_status_online_btn_text");
    this.OnlineBtn.SetText(IDWS_MOIP_SETTING_ONLINE);
    this.OnlineBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"online_status_btn_style_nor");
    this.OnlineBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"online_status_btn_style_focus");
    this.OnlineBtn.AppendFgImage("online_status_online_btn_icon","13px","10px","18px","19px");
    this.OnlineBtn.SetFgImage(g_Image.IMAGE_ONLINE_STATUS_PRESENCE_ONLINE);
    this.OnlineBtn.SetOnClickCallbackFunc(clickCF);   
    
    this.AwayBtn = new Button();
    this.AwayBtn.SetImageObjId("online_status_away_btn");
    this.AwayBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, null);
    this.AwayBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_ONLINE_STATUS_BTN_NORMALFOCUS);
    this.AwayBtn.SetTextObjId("online_status_away_btn_text");
    this.AwayBtn.SetText(IDWS_MOIP_SETTING_AWAY);
    this.AwayBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"online_status_btn_style_nor");
    this.AwayBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"online_status_btn_style_focus");
    this.AwayBtn.AppendFgImage("online_status_away_btn_icon","13px","10px","18px","19px");
    this.AwayBtn.SetFgImage(g_Image.IMAGE_ONLINE_STATUS_PRESENCE_AWAY);
    this.AwayBtn.SetOnClickCallbackFunc(clickCF);  
    
    this.DoNotDisturbBtn = new Button();
    this.DoNotDisturbBtn.SetImageObjId("online_status_do_not_disturb_btn");
    this.DoNotDisturbBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, null);
    this.DoNotDisturbBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_ONLINE_STATUS_BTN_NORMALFOCUS);
    this.DoNotDisturbBtn.SetTextObjId("online_status_do_not_disturb_btn_text");
    this.DoNotDisturbBtn.SetText(IDWS_MOIP_SETTING_DO_NOT_DISTURB);
	if(ResMgr.GetCurLanguage()== ENUM_TV_LANGUAGE.TAM)
	{
	    this.DoNotDisturbBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"online_status_btn_small_style_nor");
    	this.DoNotDisturbBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"online_status_btn_small_style_focus");
    	
    	//multi line
    	$("#online_status_do_not_disturb_btn_text").css('top', "1px");
	}
	else
	{
		this.DoNotDisturbBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"online_status_btn_style_nor");
    	this.DoNotDisturbBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"online_status_btn_style_focus");
	}
    this.DoNotDisturbBtn.AppendFgImage("online_status_do_not_disturb_btn_icon","13px","10px","18px","19px");
    this.DoNotDisturbBtn.SetFgImage(g_Image.IMAGE_ONLINE_STATUS_PRESENCE_DO_NOT_DISTURB);
    this.DoNotDisturbBtn.SetOnClickCallbackFunc(clickCF);  
    


	
	this.InvisibleBtn = new Button();
    this.InvisibleBtn.SetImageObjId("online_status_invisible_btn");
    this.InvisibleBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, null);
    this.InvisibleBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_ONLINE_STATUS_BTN_NORMALFOCUS);
    this.InvisibleBtn.SetTextObjId("online_status_invisible_btn_text");
    this.InvisibleBtn.SetText(IDWS_MOIP_SETTING_INVISIBLE);
	if(ResMgr.GetCurLanguage()== ENUM_TV_LANGUAGE.GRE)
	{
	    this.InvisibleBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"online_status_btn_small_style_nor");
    	this.InvisibleBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"online_status_btn_small_style_focus");
	}
	else
	{
		this.InvisibleBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"online_status_btn_style_nor");
    	this.InvisibleBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"online_status_btn_style_focus");
	}
    this.InvisibleBtn.AppendFgImage("online_status_invisible_btn_icon","13px","10px","18px","19px");
    this.InvisibleBtn.SetFgImage(g_Image.IMAGE_ONLINE_STATUS_PRESENCE_OFFLINE);
    this.InvisibleBtn.SetOnClickCallbackFunc(clickCF);
		
	this.OfflineBtn = new Button();
    this.OfflineBtn.SetImageObjId("online_status_offline_btn");
    this.OfflineBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, null);
    this.OfflineBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_ONLINE_STATUS_BTN_NORMALFOCUS);
    this.OfflineBtn.SetTextObjId("online_status_offline_btn_text");
    this.OfflineBtn.SetText(TV_SID_OFFLINE);
    this.OfflineBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"online_status_btn_style_nor");
    this.OfflineBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"online_status_btn_style_focus");
    this.OfflineBtn.AppendFgImage("online_status_offline_btn_icon","13px","10px","18px","19px");
    this.OfflineBtn.SetFgImage(g_Image.IMAGE_ONLINE_STATUS_PRESENCE_OFFLINE);
    this.OfflineBtn.SetOnClickCallbackFunc(clickCF);    
    
    this.OnlineStatusHelpBar = new HelpBar(HelpBarIndex.ONLINE_STATUS, "OnlineStatus");
    this.OnlineStatusHelpBar.SetOnClickCallbackFunc(1, function(){this_.processReturnKey();});
    
    this.OnlineStatusView.registHelpBar( this.OnlineStatusHelpBar);
}

SceneOnlineStatus.prototype.initOnlineStatus = function(){
	
   var curr_state = PluginAPIMgr.GetMyOnlineState();
   
   alert("SceneOnlineStatus.initOnlineStatus() ");
   
   if(curr_state == ENUM_ACCOUNT_AVAILABILITY.ONLINE)
   {
        this.highlight(this.OnlineBtn);
   }
   else if(curr_state == ENUM_ACCOUNT_AVAILABILITY.AWAY)
   {
        this.highlight(this.AwayBtn);
   }
   else if(curr_state == ENUM_ACCOUNT_AVAILABILITY.DO_NOT_DISTURB)
   {
        this.highlight(this.DoNotDisturbBtn);
   }
   else if(curr_state == ENUM_ACCOUNT_AVAILABILITY.INVISIBLE)
   {
        this.highlight(this.InvisibleBtn);
   }   
   else if(curr_state == ENUM_ACCOUNT_AVAILABILITY.OFFLINE)
   {
        this.highlight(this.OfflineBtn);
   }
   else
   {
        this.highlight(this.OfflineBtn);
   }
}


SceneOnlineStatus.prototype.highlight=function(obj)
{
    this.OnlineStatusView.setCurrenHighlight(obj);

}

SceneOnlineStatus.prototype.processUpKey = function(){
    alert("SceneOnlineStatus.processUpKey() ");
    
    var currentHighlight =  this.OnlineStatusView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.OnlineBtn:
            this.highlight( this.OfflineBtn);
            break;
			
       case this.AwayBtn:
            this.highlight(this.OnlineBtn);
            break;
            
        case this.DoNotDisturbBtn:
            this.highlight(this.AwayBtn);
            break;
			
		case this.InvisibleBtn:
            this.highlight(this.DoNotDisturbBtn);
            break;
			
		case this.OfflineBtn:
            this.highlight(this.InvisibleBtn);
            break;
            
    }
}

SceneOnlineStatus.prototype.processDownKey = function(){
    alert("SceneOnlineStatus.processDownKey() ");
    
    var currentHighlight =  this.OnlineStatusView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.OnlineBtn:
            this.highlight( this.AwayBtn);
            break;
                        
       case this.AwayBtn:
            this.highlight(this.DoNotDisturbBtn);
            break;
            
        case this.DoNotDisturbBtn:
            this.highlight(this.InvisibleBtn);
            break;
			
		case this.InvisibleBtn:
            this.highlight(this.OfflineBtn);
            break;
			
		case this.OfflineBtn:
            this.highlight(this.OnlineBtn);
            break;
    }
}

SceneOnlineStatus.prototype.processEnterKey = function(){
    alert("SceneOnlineStatus.processEnterKey() ");
    
    var currentHighlight =  this.OnlineStatusView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.OnlineBtn:
            ProcMgr.SetOnlineStatus(ENUM_ACCOUNT_AVAILABILITY.ONLINE);
            break;
            
       case this.AwayBtn:
            ProcMgr.SetOnlineStatus(ENUM_ACCOUNT_AVAILABILITY.AWAY);
            break;
            
        case this.DoNotDisturbBtn:
            ProcMgr.SetOnlineStatus(ENUM_ACCOUNT_AVAILABILITY.DO_NOT_DISTURB);
            break;
		
		case this.InvisibleBtn:
           ProcMgr.SetOnlineStatus(ENUM_ACCOUNT_AVAILABILITY.INVISIBLE);
            break;
			
		case this.OfflineBtn:
           ProcMgr.SetOnlineStatus(ENUM_ACCOUNT_AVAILABILITY.OFFLINE);
            break;
    }
}

SceneOnlineStatus.prototype.processReturnKey = function(){
    alert("SceneOnlineStatus.processReturnKey() ");
    StateMgr.Stop_Online_Status_State(true);

}

SceneOnlineStatus.prototype.startTimer = function()
{
    alert("SceneOnlineStatus.startTimer() ");
	
	this.CloseTimer = true;
	PluginAPIMgr.StartOSDTimer("60000" , function() { $.sfScene.get('OnlineStatus').popupTimerCallback();}, ENUM_TIMER_TYPE.POPUP_WND);
}

SceneOnlineStatus.prototype.resetTimer = function()
{
    alert("SceneOnlineStatus.resetTimer() ");

	if(this.CloseTimer == true)
	{
		PluginAPIMgr.RestartOSDTimer("60000" ,ENUM_TIMER_TYPE.POPUP_WND);
	}
}

SceneOnlineStatus.prototype.stopTimer = function()
{
    alert("SceneOnlineStatus.stopTimer() ");
	
	this.CloseTimer = false;
	PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.POPUP_WND);
}

SceneOnlineStatus.prototype.popupTimerCallback = function()
{
	alert("SceneOnlineStatus.popupTimerCallback() ");
   if(this.CloseTimer==false)
   {
   	return
   }
   this.CloseTimer = false;
   
	StateMgr.Stop_Online_Status_State(true);
}

SceneOnlineStatus.prototype.processClickEvent = function(obj){
	alert("SceneOnlineStatus.processClickEvent() ");
	
	var currentHighlight =  this.OnlineStatusView.getCurrentHighlight();
    if(currentHighlight != obj)
    {
    	this.highlight(obj);
    }
	
	this.processEnterKey();
}






