/**
 * @author Samsung
 */

function SceneOptions(options)
{
    this.options = options;
    this.OptionsView = null;
	this.OptionsDim=null;
	this.OptionsBgLabel = null;
    this.GeneralSettingsBtn = null;
    //this.AudioSettingsBtn = null;
    this.VideoSettingsBtn = null;
    this.PrivacySettingsBtn = null;
    this.BlockedUsersBtn = null;
    this.CallForwardingBtn = null;
    this.VoiceMailBtn = null;
    this.AboutSkypeBtn = null;
    this.iCurrentSubScene = 0;
    this.BtnList = new Array(7);
	this.sceneId = "Options";
	
	//flag
	this.flag_Focus = false;
    
    this.DefaultHelpBar = null;
    this.SaveHelpBar = null;
}

SceneOptions.prototype.initialize = function()
{
	alert("SceneOptions.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
   this.create();
}

SceneOptions.prototype.handleShow = function()
{
	alert("SceneOptions.handleShow()");
	// this function will be called when the scene manager show this scene 
	this.OptionsDim.show();
    if(OptionsMgr.getInitFlag() == true)
    {
        OptionsMgr.init();
        
        var currentHighlight =  this.OptionsView.getCurrentHighlight();
        this.iCurrentSubScene = 0;
        var i = 0;
        for(i = 0; i < this.BtnList.length; i++)
        {
            this.BtnList[i].flagSelect = false;
            if(currentHighlight!=null && currentHighlight==this.BtnList[i].obj)
            {
            	this.BtnList[i].obj.blur();
            }
        }
    }
	
	OptionsMgr.startTimer();
}

SceneOptions.prototype.handleHide = function()
{
	alert("SceneOptions.handleHide()");
	// this function will be called when the scene manager hide this scene  
	this.OptionsDim.hide();
    WndMgr.HideOptionsSubscene(this.iCurrentSubScene);
    
	if(OptionsMgr.CloseTimer==true)
	{
		OptionsMgr.stopTimer();
	}
}

SceneOptions.prototype.handleFocus = function()
{
	alert("SceneOptions.handleFocus()");
	// this function will be called when the scene manager focus this scene

    this.highlight(this.BtnList[this.iCurrentSubScene].obj, this.iCurrentSubScene);
	
	this.flag_Focus = true;
}

SceneOptions.prototype.handleBlur = function()
{
	alert("SceneOptions.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
    //Todo check the below alternative 
     
    if(this.BtnList[this.iCurrentSubScene].flagSelect == false)
    {
        this.BtnList[this.iCurrentSubScene].obj.blur();
    }
	
	this.flag_Focus = false;
}

SceneOptions.prototype.handleKeyDown = function(keyCode)
{
	alert("SceneOptions.handleKeyDown(" + keyCode + ")");
    // TODO : write an key event handler when this scene get focued
    PluginAPIMgr.PlayAudio(keyCode);
    switch (keyCode) {
        case $.sfKey.LEFT:
            // this.processLeftKey();
            break;

        case $.sfKey.RIGHT:
			OptionsMgr.resetTimer();
            this.processRightKey();
            break;

        case $.sfKey.UP:
			OptionsMgr.resetTimer();
            this.processUpKey();
            break;

        case $.sfKey.DOWN:
			OptionsMgr.resetTimer();
            this.processDownKey();
            break;

        case $.sfKey.BLUE:
            this.processBlueKey();
            break;

        case $.sfKey.ENTER:
			OptionsMgr.resetTimer();
            this.processEnterKey();
            break;

        case $.sfKey.RETURN:
            this.processReturnKey();
            $.sfKey.block(event);
            break;
        case $.sfKey.EXIT:
        	this.processExitKey();
			$.sfKey.block(event);
			break;
		
        case 147:  //infolink
        case 261:  //contents
        case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
    }
}

/////////////////////////////////////////////////////////////////////////////
SceneOptions.prototype.create = function()
{
    alert("Options.create()");

    this.OptionsView = new View("Options");
    this.OptionsBgLabel = new Label("list_options_bg", null);
	this.OptionsBgLabel.SetBgImage(g_Image.IMAGE_LIST_OPTIONS_BG);
	
	this.OptionsDim = new DimBg("OptionsDim", "Options");

    this.SkypeOptions = new Label(null, "options_skype_options_label");
    this.SkypeOptions.SetTextStyle("options_skype_options_label_style");
    this.SkypeOptions.SetText(TV_SID_SKYPE_OPTIONS); 
		
	this.GeneralSettingsBtn = new Button();
	this.GeneralSettingsBtn.SetImageObjId("list_general_settings_img");
	this.GeneralSettingsBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, null);
	this.GeneralSettingsBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_LIST_OPTIONS_HIGHLIGHT);
	this.GeneralSettingsBtn.SetBgImage(BtnImgIndex.BTN_SELECTED_IMG, g_Image.IMAGE_LIST_OPTIONS_SELECTED);
	this.GeneralSettingsBtn.SetTextObjId("list_general_settings_txt");
	// this.GeneralSettingsBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "list_options_text_normal");
	// this.GeneralSettingsBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "list_options_text_selected");
	this.GeneralSettingsBtn.SetText(IDWS_MOIP_SKYPE_SETTING_GENERAL_SETTINGS);
	this.GeneralSettingsBtn.AppendFgImage("list_general_settings_icon", "10px", "7px", "31px", "31px");
	this.GeneralSettingsBtn.SetFgImage(g_Image.IMAGE_GENERAL_SETTINGS_ICON);

	this.VideoSettingsBtn = new Button();
	this.VideoSettingsBtn.SetImageObjId("list_video_settings_img");
	this.VideoSettingsBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, null);
	this.VideoSettingsBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_LIST_OPTIONS_HIGHLIGHT);
	this.VideoSettingsBtn.SetBgImage(BtnImgIndex.BTN_SELECTED_IMG, g_Image.IMAGE_LIST_OPTIONS_SELECTED);
	this.VideoSettingsBtn.SetTextObjId("list_video_settings_txt");	
	// this.VideoSettingsBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "list_options_text_normal");
	// this.VideoSettingsBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "list_options_text_selected");
	this.VideoSettingsBtn.SetText(IDWS_MOIP_SKYPE_SETTING_VIDEO_SETTINGS);
	this.VideoSettingsBtn.AppendFgImage("list_video_settings_icon", "10px", "7px", "31px", "31px");
	this.VideoSettingsBtn.SetFgImage(g_Image.IMAGE_VIDEO_SETTINGS_ICON);

	this.PrivacySettingsBtn = new Button();
	this.PrivacySettingsBtn.SetImageObjId("list_privacy_settings_img");
	this.PrivacySettingsBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, null);
	this.PrivacySettingsBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_LIST_OPTIONS_HIGHLIGHT);
	this.PrivacySettingsBtn.SetBgImage(BtnImgIndex.BTN_SELECTED_IMG, g_Image.IMAGE_LIST_OPTIONS_SELECTED);
	this.PrivacySettingsBtn.SetTextObjId("list_privacy_settings_txt");	
	// this.PrivacySettingsBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "list_options_text_normal");
	// this.PrivacySettingsBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "list_options_text_selected");		
	this.PrivacySettingsBtn.SetText(IDWS_MOIP_SKYPE_SETTING_PRIVACY_SETTINGS);
	this.PrivacySettingsBtn.AppendFgImage("list_privacy_settings_icon", "10px", "7px", "31px", "31px");
	this.PrivacySettingsBtn.SetFgImage(g_Image.IMAGE_PRIVACY_SETTINGS_ICON);
	

	
	this.BlockedUsersBtn = new Button();
	this.BlockedUsersBtn.SetImageObjId("list_blocked_users_img");
	this.BlockedUsersBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, null);
	this.BlockedUsersBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_LIST_OPTIONS_HIGHLIGHT);
	this.BlockedUsersBtn.SetBgImage(BtnImgIndex.BTN_SELECTED_IMG, g_Image.IMAGE_LIST_OPTIONS_SELECTED);
	this.BlockedUsersBtn.SetTextObjId("list_blocked_users_txt");	
	// this.BlockedUsersBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "list_options_text_normal");
	// this.BlockedUsersBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "list_options_text_selected");
	this.BlockedUsersBtn.SetText(IDWS_MOIP_SKYPE_SETTING_BLOCKED_USERS);
	this.BlockedUsersBtn.AppendFgImage("list_blocked_users_icon", "10px", "7px", "31px", "31px");
	this.BlockedUsersBtn.SetFgImage(g_Image.IMAGE_BLOCKED_USERS_ICON);

	this.CallForwardingBtn = new Button();
	this.CallForwardingBtn.SetImageObjId("list_call_forwarding_img");
	this.CallForwardingBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, null);
	this.CallForwardingBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_LIST_OPTIONS_HIGHLIGHT);
	this.CallForwardingBtn.SetBgImage(BtnImgIndex.BTN_SELECTED_IMG, g_Image.IMAGE_LIST_OPTIONS_SELECTED);
	this.CallForwardingBtn.SetTextObjId("list_call_forwarding_txt");	
	// this.CallForwardingBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "list_options_text_normal");
	// this.CallForwardingBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "list_options_text_selected");
	this.CallForwardingBtn.SetText(IDWS_MOIP_SKYPE_CALL_FORWARDING);
	this.CallForwardingBtn.AppendFgImage("list_call_forwarding_icon", "10px", "7px", "31px", "31px");
	this.CallForwardingBtn.SetFgImage(g_Image.IMAGE_CALL_FORWARDING_ICON);

	this.VoiceMailBtn = new Button();
	this.VoiceMailBtn.SetImageObjId("list_voice_mail_img");
	this.VoiceMailBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, null);
	this.VoiceMailBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_LIST_OPTIONS_HIGHLIGHT);
	this.VoiceMailBtn.SetBgImage(BtnImgIndex.BTN_SELECTED_IMG, g_Image.IMAGE_LIST_OPTIONS_SELECTED);
	this.VoiceMailBtn.SetTextObjId("list_voice_mail_txt");	
	// this.VoiceMailBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "list_options_text_normal");
	// this.VoiceMailBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "list_options_text_selected");
	this.VoiceMailBtn.SetText(IDWS_MOIP_SKYPE_VOICEMAIL);
	this.VoiceMailBtn.AppendFgImage("list_voice_mail_icon", "10px", "7px", "31px", "31px");
	this.VoiceMailBtn.SetFgImage(g_Image.IMAGE_VOICE_MAIL_ICON);

	this.AboutSkypeBtn = new Button();
	this.AboutSkypeBtn.SetImageObjId("list_about_skype_img");
	this.AboutSkypeBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, null);
	this.AboutSkypeBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_LIST_OPTIONS_HIGHLIGHT);
	this.AboutSkypeBtn.SetBgImage(BtnImgIndex.BTN_SELECTED_IMG, g_Image.IMAGE_LIST_OPTIONS_SELECTED);
	this.AboutSkypeBtn.SetTextObjId("list_about_skype_txt");	
	// this.AboutSkypeBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "list_options_text_normal");
	// this.AboutSkypeBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "list_options_text_selected");
	this.AboutSkypeBtn.SetText(IDWS_MOIP_ABOUT_SKYPE);
	this.AboutSkypeBtn.AppendFgImage("list_about_skype_icon", "10px", "7px", "31px", "31px");
	this.AboutSkypeBtn.SetFgImage(g_Image.IMAGE_ABOUT_SKYPE_ICON);



	var i = 0;
	for(i = 0; i < this.BtnList.length; i++)
	{
		this.BtnList[i] = new Object();
	}

    //Initialized array of buttons
	this.BtnList[0].obj = this.GeneralSettingsBtn;
	this.BtnList[1].obj = this.VideoSettingsBtn;
	this.BtnList[2].obj = this.PrivacySettingsBtn;
	this.BtnList[3].obj = this.BlockedUsersBtn;
	this.BtnList[4].obj = this.CallForwardingBtn;
	this.BtnList[5].obj = this.VoiceMailBtn;
	this.BtnList[6].obj = this.AboutSkypeBtn;
	
	var CurLangID = ResMgr.GetCurLanguage();
	
	var this_ = $.sfScene.get("Options");
	var clickCF =  function(obj){this_.processClickEvent(obj);};
	
	for(i = 0; i < this.BtnList.length; i++)
	{
	 	if(CurLangID == ENUM_TV_LANGUAGE.TAM || CurLangID == ENUM_TV_LANGUAGE.KAZ || CurLangID == ENUM_TV_LANGUAGE.HAU || CurLangID == ENUM_TV_LANGUAGE.MKD || 
	 		CurLangID == ENUM_TV_LANGUAGE.RUS || CurLangID == ENUM_TV_LANGUAGE.SWE || CurLangID == ENUM_TV_LANGUAGE.AFR || CurLangID == ENUM_TV_LANGUAGE.SWA ||
	 		CurLangID == ENUM_TV_LANGUAGE.XHO || CurLangID == ENUM_TV_LANGUAGE.SLV || CurLangID == ENUM_TV_LANGUAGE.PER)
 		{
			this.BtnList[i].obj.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "list_options_text_small_normal");
			this.BtnList[i].obj.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "list_options_text_small_selected");	
 		}
 		else if(CurLangID == ENUM_TV_LANGUAGE.IND)
 		{
			this.BtnList[i].obj.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "list_options_text_small_small_normal");
			this.BtnList[i].obj.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "list_options_text_small_small_selected");	
 			
 			$("#list_general_settings_txt").css('left',"45px");
 			$("#list_video_settings_txt").css('left',"45px");
 			$("#list_privacy_settings_txt").css('left',"45px");
 			$("#list_blocked_users_txt").css('left',"45px");
 			$("#list_call_forwarding_txt").css('left',"45px");
 			$("#list_voice_mail_txt").css('left',"45px");
 			$("#list_about_skype_txt").css('left',"45px");

 		}
 		else
 		{
			this.BtnList[i].obj.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "list_options_text_normal");
			this.BtnList[i].obj.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "list_options_text_selected");
 		}
 		
 		this.BtnList[i].obj.SetOnClickCallbackFunc(clickCF);
	}
	
	this.AdjustLanguage();
	
	//Set helpbar for the buttons
    this.DefaultHelpBar = new HelpBar(HelpBarIndex.OPTIONS,"Options");
    this.DefaultHelpBar.SetOnClickCallbackFunc(1, function(){this_.processReturnKey();});
    
    this.SaveHelpBar = new HelpBar(HelpBarIndex.OPTIONS_SAVE,"Options");
   	this.SaveHelpBar.SetOnClickCallbackFunc(1, function(){this_.processBlueKey();});
    this.SaveHelpBar.SetOnClickCallbackFunc(2, function(){this_.processReturnKey();});

	this.GeneralSettingsBtn.registHelpBar(this.DefaultHelpBar);
    this.VideoSettingsBtn.registHelpBar(this.DefaultHelpBar); 
    this.PrivacySettingsBtn.registHelpBar(this.DefaultHelpBar); 
    this.BlockedUsersBtn.registHelpBar(this.DefaultHelpBar); 
    this.CallForwardingBtn.registHelpBar(this.DefaultHelpBar); 
    this.VoiceMailBtn.registHelpBar(this.DefaultHelpBar); 
    this.AboutSkypeBtn.registHelpBar(this.DefaultHelpBar); 
    
}

SceneOptions.prototype.changeToDefaultHelpBar= function()
{
	/*this.GeneralSettingsBtn.changeHelpBar(this.DefaultHelpBar);
    this.VideoSettingsBtn.changeHelpBar(this.DefaultHelpBar); 
    this.PrivacySettingsBtn.changeHelpBar(this.DefaultHelpBar); 
    this.BlockedUsersBtn.changeHelpBar(this.DefaultHelpBar); 
    this.CallForwardingBtn.changeHelpBar(this.DefaultHelpBar); 
    this.VoiceMailBtn.changeHelpBar(this.DefaultHelpBar); 
    this.AboutSkypeBtn.changeHelpBar(this.DefaultHelpBar); */
	//to avoid duplication of helpar from option-manager
	//Function 'changeHelpBar' make helpbar shown in highlight , so we must check focus.....   
    if(this.flag_Focus)
    {
		this.GeneralSettingsBtn.changeHelpBar(this.DefaultHelpBar);
		this.VideoSettingsBtn.changeHelpBar(this.DefaultHelpBar); 
		this.PrivacySettingsBtn.changeHelpBar(this.DefaultHelpBar); 
		this.BlockedUsersBtn.changeHelpBar(this.DefaultHelpBar); 
		this.CallForwardingBtn.changeHelpBar(this.DefaultHelpBar); 
		this.VoiceMailBtn.changeHelpBar(this.DefaultHelpBar); 
		this.AboutSkypeBtn.changeHelpBar(this.DefaultHelpBar); 
    }
	else{
		
		this.GeneralSettingsBtn.changeHelpBarForHiddenObj(this.DefaultHelpBar);
		this.VideoSettingsBtn.changeHelpBarForHiddenObj(this.DefaultHelpBar);
		this.PrivacySettingsBtn.changeHelpBarForHiddenObj(this.DefaultHelpBar);		
		this.BlockedUsersBtn.changeHelpBarForHiddenObj(this.DefaultHelpBar);
		this.CallForwardingBtn.changeHelpBarForHiddenObj(this.DefaultHelpBar);
		this.VoiceMailBtn.changeHelpBarForHiddenObj(this.DefaultHelpBar); 
		this.AboutSkypeBtn.changeHelpBarForHiddenObj(this.DefaultHelpBar); 		
	}
	/*this.GeneralSettingsBtn.changeHelpBar(this.DefaultHelpBar);
    this.VideoSettingsBtn.changeHelpBar(this.DefaultHelpBar); 
    this.PrivacySettingsBtn.changeHelpBar(this.DefaultHelpBar); 
    this.BlockedUsersBtn.changeHelpBar(this.DefaultHelpBar); 
    this.CallForwardingBtn.changeHelpBar(this.DefaultHelpBar); 
     this.VoiceMailBtn.changeHelpBar(this.DefaultHelpBar); 
    this.AboutSkypeBtn.changeHelpBar(this.DefaultHelpBar);*/

}

SceneOptions.prototype.changeToSaveHelpBar= function()
{
    if(this.flag_Focus)
    {
		this.GeneralSettingsBtn.changeHelpBar(this.SaveHelpBar);
		this.VideoSettingsBtn.changeHelpBar(this.SaveHelpBar); 
		this.PrivacySettingsBtn.changeHelpBar(this.SaveHelpBar); 
		this.BlockedUsersBtn.changeHelpBar(this.SaveHelpBar); 
		this.CallForwardingBtn.changeHelpBar(this.SaveHelpBar); 
		this.VoiceMailBtn.changeHelpBar(this.SaveHelpBar); 
		this.AboutSkypeBtn.changeHelpBar(this.SaveHelpBar); 
    }
	else{
		
		this.GeneralSettingsBtn.changeHelpBarForHiddenObj(this.SaveHelpBar);
		this.VideoSettingsBtn.changeHelpBarForHiddenObj(this.SaveHelpBar);
		this.PrivacySettingsBtn.changeHelpBarForHiddenObj(this.SaveHelpBar);		
		this.BlockedUsersBtn.changeHelpBarForHiddenObj(this.SaveHelpBar);
		this.CallForwardingBtn.changeHelpBarForHiddenObj(this.SaveHelpBar);
		this.VoiceMailBtn.changeHelpBarForHiddenObj(this.SaveHelpBar); 
		this.AboutSkypeBtn.changeHelpBarForHiddenObj(this.SaveHelpBar); 		
	}
}

SceneOptions.prototype.highlight=function(obj, index)
{
    alert("SceneOptions.highlight(), object: " + obj + ", index: " + index);
    
    this.OptionsView.setCurrenHighlight(obj);

    if(index != this.iCurrentSubScene)
    {
       WndMgr.HideOptionsSubscene(this.iCurrentSubScene);
       this.iCurrentSubScene = index;
    }
    WndMgr.ShowOptionsSubscene(this.iCurrentSubScene);
}

SceneOptions.prototype.processDownKey = function()
{
    alert("SceneOptions.processDownKey() ");
    var currentHighlight =  this.OptionsView.getCurrentHighlight();
    
    var a = 0;
    for(a = 0; a < this.BtnList.length; a++)
    {
        if(this.BtnList[a].obj == currentHighlight )
        {
            var b = a + 1;
            if(b == this.BtnList.length) { b = 0;}
            this.highlight(this.BtnList[b].obj, b);
        }
     }
}

SceneOptions.prototype.processUpKey = function()
{
    alert("SceneOptions.processUpKey() ");
    
    var currentHighlight = this.OptionsView.getCurrentHighlight();
    
    var a = 0;
    for(a = 0; a<this.BtnList.length; a++)
    {
        if(this.BtnList[a].obj == currentHighlight )
        {
            var b = a - 1;
            if(b < 0) { b = this.BtnList.length - 1;}
            this.highlight(this.BtnList[b].obj, b);
        }
     }
}

SceneOptions.prototype.moveToSub = function()
{
    alert("SceneOptions.moveToSub()");
    var currentHighlight = this.OptionsView.getCurrentHighlight();

    switch(currentHighlight)
    {
        case this.AboutSkypeBtn:
            //Do nothing
            break;

        case this.VoiceMailBtn:
            if(OptionsMgr.getVoiceMailState())
                this.select(currentHighlight);
            break;

        case this.GeneralSettingsBtn:
		/*if($.sfScene.get("OptionsGeneralSettings").flagEnable== false)
		{
			return;
		}
		else
		{
			this.select(currentHighlight);
		}*/
			this.select(currentHighlight);
			break;
			
        case this.VideoSettingsBtn:
        case this.PrivacySettingsBtn:
        case this.BlockedUsersBtn:
        case this.CallForwardingBtn:
            this.select(currentHighlight);
            break;
    } 
}

SceneOptions.prototype.processEnterKey = function()
{
    alert("SceneOptions.processEnterKey() ");
    this.moveToSub();    
}

SceneOptions.prototype.exitWithoutSave = function()
{
    alert("SceneOptions.exitWithoutSave"); 
    OptionsMgr.init();
    $.sfScene.get("Options").exit();
}

SceneOptions.prototype.exit = function()
{
    alert("SceneOptions.exit()");
    StateMgr.Stop_Options_State(true);
}

SceneOptions.prototype.processReturnKey = function()
{
    alert("SceneOptions.processReturnKey()");
        
     if(OptionsMgr.flagChange == true)
    {
        WndMgr.StartOptionsSaveReturnStep();
     }
     else
     {
        StateMgr.Stop_Options_State(true); 
     }
}

SceneOptions.prototype.processExitKey = function()
{
    alert("SceneOptions.processExitKey()");
        
     if(OptionsMgr.flagChange == true)
    {
        WndMgr.StartOptionsSaveReturnStep();
     }
     else
     {
        StateMgr.Stop_Options_State(true); 
     }
}

SceneOptions.prototype.processRightKey = function()
{
    alert("SceneOptions.processRightKey() ");
    this.moveToSub();
}

SceneOptions.prototype.processBlueKey = function()
{
    alert("SceneOptions.processBlueKey() ");
    OptionsMgr.SaveOptions();
}

SceneOptions.prototype.select = function(obj)
{
     this.OptionsView.setCurrentSelect(obj);
     this.BtnList[this.iCurrentSubScene].flagSelect = true;
     WndMgr.SelectOptionsSubscene(this.iCurrentSubScene);
}

SceneOptions.prototype.exitSave = function()
{
	alert("SceneOptions.exitSave()");
	$.sfScene.get("Options").exit();
	$.sfScene.get("Options").preSave();
}

SceneOptions.prototype.preSave = function()
{
    alert("SceneOptions.preSave()"); 
	var scene = $.sfScene.get("Options");
    if(OptionsMgr.getSkypeOutState() === false)
        if(OptionsMgr.isChangedCallForwardNumbers() || OptionsMgr.isChangedCallForwardTimer())
            WndMgr.StartOptionsSkypeOutDisabledMsg("ListMainSetting", scene.save);
        else
            scene.save();
}

SceneOptions.prototype.save = function()
{
    alert("SceneOptions.save()"); 
    var saveResult = OptionsMgr.save();
    alert("Save result: " + saveResult);
    alert("SAVE_NUMBER_MISFORMAT: " + OptionsMgr.SAVE_NUMBER_MISSFORMAT);
    var destSceneId = "ListMainSetting";
    switch(saveResult)
    {
        case OptionsMgr.SAVE_NUMBER_MISSFORMAT:
            alert("Options forwarding numbers are misformatted");
            WndMgr.StartOptionsCommitNumberMisformatMsg(destSceneId);
            break;

        case OptionsMgr.SAVE_SERVER:
            alert("Wait for event from server");
            WndMgr.StartOptionsCommittingMsg(destSceneId);
            break;

        case OptionsMgr.SAVE_LOCAL:
            alert("Options committed");
            WndMgr.StartOptionsCommitedMsg(destSceneId); 
            break;
        default:
            alert("Not registered save result");
            break;
    }
}

SceneOptions.prototype.saveScene = function()
{
    var currentHighlight = this.OptionsView.getCurrentHighlight();

    switch(currentHighlight)
    {
        case this.AboutSkypeBtn:
            //Do nothing
            break;

        case this.GeneralSettingsBtn:
            if(OptionsMgr.saveGeneralSettings())
                WndMgr.StartOptionsCommitedMsg(this.sceneId);
            break;

        case this.VideoSettingsBtn:
            if(OptionsMgr.saveVideoSettings())
                WndMgr.StartOptionsCommitedMsg(this.sceneId);
            break;

        case this.PrivacySettingsBtn:
            if(OptionsMgr.savePrivacySettings())
                WndMgr.StartOptionsCommittingMsg(this.sceneId);
            break;

        case this.BlockedUsersBtn:
            //todo: should be implemented
            break;

        case this.CallForwardingBtn:
              var saveResult = OptionsMgr.saveCallForwarding(); 
              alert("Save result: " + saveResult);
              switch(saveResult)
              {
                  case OptionsMgr.SAVE_NUMBER_MISSFORMAT:
                      alert("Options forwarding numbers are misformatted");
                      WndMgr.StartOptionsCommitNumberMisformatMsg(this.sceneId);
                      break;

                  case OptionsMgr.SAVE_SERVER:
                      alert("Wait for event from server");
                      WndMgr.StartOptionsCommittingMsg(this.sceneId);
                      break;

                  case OptionsMgr.SAVE_LOCAL:
                      alert("Options committed");
                      WndMgr.StartOptionsCommitedMsg(this.sceneId); 
                      break;

                  default:
                      alert("Not registered save result");
                      break;
              }
              break;

        case this.VoiceMailBtn:
              if(OptionsMgr.getVoiceMailState() === true)
                  if(OptionsMgr.saveVoiceMail())
                      WndMgr.StartOptionsCommitedMsg(this.sceneId);
              break;

    } 
}

SceneOptions.prototype.AdjustLanguage = function()
{
	var CurLangID = ResMgr.GetCurLanguage();

 	if(CurLangID == ENUM_TV_LANGUAGE.HAU || CurLangID == ENUM_TV_LANGUAGE.MKD || CurLangID == ENUM_TV_LANGUAGE.RUS || CurLangID == ENUM_TV_LANGUAGE.KAZ ||
 		CurLangID == ENUM_TV_LANGUAGE.SWA || CurLangID == ENUM_TV_LANGUAGE.XHO)
 	{
		$("#list_general_settings_txt").css('left', "40px" );	 		
		$("#list_video_settings_txt").css('left', "40px");			
		$("#list_privacy_settings_txt").css('left', "40px");				
		$("#list_blocked_users_txt").css('left', "40px" );		
		$("#list_call_forwarding_txt").css('left', "40px" );
		$("#list_voice_mail_txt").css('left', "40px" );				
		$("#list_about_skype_txt").css('left', "40px" );
   	}
}

SceneOptions.prototype.processClickEvent = function(obj){
	alert("SceneOptions.processClickEvent() ");
	OptionsMgr.resetTimer();
	
	var currentHighlight =  this.OptionsView.getCurrentHighlight();
    
    var index =0;
    
    var a = 0;
    for(a = 0; a < this.BtnList.length; a++)
    {
		if(this.BtnList[a].obj==obj)
		{
			index=a;
			break;
		}
    }
    if(this.flag_Focus == true)
    {
    	if(this.BtnList[index].obj == currentHighlight )
        {
        	this.processEnterKey();

        }
        else
        {
        	this.highlight(this.BtnList[index].obj, index);
        }
    }
	else
	{
		if(WndMgr.OptionsSubscene[WndMgr.iCurrentOptionsSubscene].flagSelect == true)
		{
			$.sfScene.get(WndMgr.GetCurrentOptionsSubsceneID()).processReturnKey();			
		}
		
		if(this.BtnList[index].obj != currentHighlight )
		{
			this.highlight(this.BtnList[index].obj, index);
		}		
	}
}
