/**
 * @author Samsung
 */

function SceneOptionsCallForwarding(options)
{
    this.options = options;
    this.OptionsCallForwardingView = null;
    this.CallBtn = null;
    this.TimeBtn = null;
	this.CallForwardingLabel=null;
	this.TimeLabel=null;
	this.SecondsLabel=null;
	
    this.maxPhones = 3;
    this.path = null;
    this.sceneId = "OptionsCallForwarding";
    // Current position
    this.curPos = 0;
    // Positions of buttions withing the traverse path
    this.idxCallBtn = 0;
    this.idxTimeBtn = 1;
    this.idxFlagBtn1 = 2;
    this.idxFlagBtn2 = 4;
    this.idxFlagBtn3 = 6;
    this.idxNumberBtn1 = 3;
    this.idxNumberBtn2 = 5;
    this.idxNumberBtn3 = 7;
    this.idxObj = 2;
    // Horizontal traverse
    this.horizontal = 0;
    // Vertical traverse
    this.vertical = 1;
    // Next item
    this.next = 0;
    // Previous item
    this.prev = 1;
    this.callForwardNumbers = null;
    this.records = null;
    this.splitCharSpace = " ";
    this.splitCharComma = ",";
    this.isNavigatable = false;
    this.TIME_MAX_LENGTH = 3;
    this.NUMBER_MAX_LENGTH = 30;
	
	this.CurCountryCode = null;
    
    this.DefaultHelpBar = null;
    this.SaveHelpBar = null;
    this.PhoneNumberInputHelpBar = null;
    this.PhoneNumberInputSaveHelpBar = null;
    this.PlusPhoneNumberInputHelpBar = null;
    this.PlusPhoneNumberInputSaveHelpBar = null;
    this.NumberInputHelpBar = null;
    this.NumberInputSaveHelpBar = null;
    
    this.flagPlusBtnEnable = false;
    
    this.flagCreate = false;
	this.flagSubList = false;
	this.flagShownPrefixList = false;
    this.isInit= true;
	
	this.btnList = null;
}

SceneOptionsCallForwarding.prototype.initialize = function ()
{
	alert("SceneOptionsCallForwarding.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
    this.create();
}


SceneOptionsCallForwarding.prototype.handleShow = function ()
{
	// this function will be called when the scene manager show this scene 
	alert("SceneOptionsCallForwarding.handleShow()");
	this.curPos = 0;
	
    if(this.isInit== true)
    {
        this.initOptions();
    }
}

SceneOptionsCallForwarding.prototype.setOptions = function ()
{
    alert("SceneOptionsCallForwarding.setOptions()");
    OptionsMgr.setCallForwardState(this.CallBtn.GetText());
    OptionsMgr.setCallForwardTimer(this.TimeBtn.GetText());
    OptionsMgr.setCallForwardNumbers(this.serialize());
}

SceneOptionsCallForwarding.prototype.handleHide = function ()
{
	// this function will be called when the scene manager hide this scene  
	alert("SceneOptionsCallForwarding.handleHide()");

	if(this.flagSubList){
		WndMgr.StopOptionSelector();
		this.flagSubList = false;
	}
	
	
	if(this.flagShownPrefixList){
		
		$.sfScene.hide('CountryFlagList');
		this.flagShownPrefixList = false;
	}

}

SceneOptionsCallForwarding.prototype.handleFocus = function ()
{
	// this function will be called when the scene manager focus this scene
	alert("SceneOptionsCallForwarding.handleFocus()");
    this.highlight(this.path[this.curPos][this.idxObj]);
	
	this.flagSubList = false;
	this.flagShownPrefixList = false;
}

SceneOptionsCallForwarding.prototype.handleBlur = function ()
{
	// this function will be called when the scene manager move focus to another scene from this scene
    alert("SceneOptionsCallForwarding.handleBlur()");
    this.setOptions();
    var currentHighlight =  this.OptionsCallForwardingView.getCurrentHighlight();
	if(currentHighlight != null)
	{
		currentHighlight.blur();
	}    
}

SceneOptionsCallForwarding.prototype.handleKeyDown = function (keyCode)
{
	alert("SceneOptionsCallForwarding.handleKeyDown(" + keyCode + ")");
    // TODO : write an key event handler when this scene get focued
    PluginAPIMgr.PlayAudio(keyCode);
    switch (keyCode) {
        case $.sfKey.LEFT:
			OptionsMgr.resetTimer();
            this.processLeftKey();
            break;

        case $.sfKey.RIGHT:
			OptionsMgr.resetTimer();
            this.processRightKey();
            break;

        case $.sfKey.UP:
			OptionsMgr.resetTimer();
            this.processUpKey();
            break;

        case $.sfKey.BLUE:
            this.processBlueKey();
            break;

        case $.sfKey.DOWN:
			OptionsMgr.resetTimer();
            this.processDownKey();
            break;

        case $.sfKey.ENTER:
			OptionsMgr.resetTimer();
            this.processEnterKey();
            break;

        case $.sfKey.RETURN:
			OptionsMgr.resetTimer();
            this.processReturnKey();
            $.sfKey.block(event);
            break;
            
       case $.sfKey.EXIT:
       		this.processExitKey();
			$.sfKey.block(event);
			break;
		
        case 147:  //infolink
        case 261:  //contents
        case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
    }
}

/////////////////////////////////////////////////////////////////////////////
SceneOptionsCallForwarding.prototype.create = function()
{
    alert("SceneOptionsCallForwarding.create()");
    this.OptionsCallForwardingView = new View("OptionsCallForwarding");

    this.CallForwardingLabel = new Label(null, "options_call_forwarding_label");
    this.CallForwardingLabel.SetTextStyle("options_call_forwarding_label_style");
    //this.CallForwardingLabel.SetReverseDisable(true);
    if(ResMgr.isReverseLanguage())
    {
    	this.CallForwardingLabel.SetText(IDWS_MOIP_SKYPE_CALL_FORWARDING);
    }
    else
    {
    	this.CallForwardingLabel.SetText(IDWS_MOIP_SKYPE_CALL_FORWARDING+" :");
    }
    
    
    this.TimeLabel = new Label(null, "options_time_label");
    this.TimeLabel.SetTextStyle("options_call_forwarding_label_style");
    //this.TimeLabel.SetReverseDisable(true);
    if(ResMgr.isReverseLanguage())
    {
    	this.TimeLabel.SetText(TV_SID_FORWARDING_TIME_SETTING);
    }
    else
    {
    	this.TimeLabel.SetText(TV_SID_FORWARDING_TIME_SETTING+" :");
    }
    

    this.SecondsLabel = new Label(null, "options_seconds_label");
    this.SecondsLabel.SetTextStyle("options_label_style_17");
    this.SecondsLabel.SetText(SID_SEC);
    
	var CurLangID = ResMgr.GetCurLanguage();

 	if(CurLangID == ENUM_TV_LANGUAGE.HAU || CurLangID == ENUM_TV_LANGUAGE.XHO || CurLangID == ENUM_TV_LANGUAGE.IGB || CurLangID == ENUM_TV_LANGUAGE.URD)
 	{
		$("#options_time_input_box").css('left', "315px" );	 		
		$("#options_seconds_label").css('left', "420px");
   	}

    this.SkypeCredit = new Label("options_skype_credit_bg", "options_skype_credit_label");
    this.SkypeCredit.SetTextStyle("options_skype_credit_label_style");
    this.SkypeCredit.SetText(IDWS_MOIP_NEED_TO_PURCHASE);
    this.SkypeCredit.AppendFgImage("options_info_icon", "0px", "0px", "28px", "28px");
    this.SkypeCredit.SetFgImage(g_Image.FORWARDING_INFO_ICON);

    this.CallBtn = new Button();
    this.CallBtn.SetImageObjId("options_call_btn");
    this.CallBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.OPTIONS_AUTO_START);
    this.CallBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.OPTIONS_AUTO_START_HIGHLIGHT);
    this.CallBtn.SetTextObjId("options_call_txt");
    
 	if(CurLangID == ENUM_TV_LANGUAGE.ARA)
 	{
	    this.CallBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "options_label_style_16");
		this.CallBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "options_label_style_16");
   	}
   	else 
   	{
	    this.CallBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "options_label_style_17");
		this.CallBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "options_label_style_17");
   	}    
    
    this.CallBtn.AppendFgImage("options_call_icon", "113px", "20px", "13px", "8px");
    this.CallBtn.SetFgImage(g_Image.OPTIONS_ARROW_DOWN);

    var scene = $.sfScene.get(this.sceneId);

    this.TimeBtn = new NumberInputBox();
    this.TimeBtn.SetButtonObjId("options_time_input_box");
    this.TimeBtn.SetButtonTextObjId("options_time_input_text");
    this.TimeBtn.SetInputBoxObjId("options_time_input_text_editor");
    this.TimeBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "options_label_style_17");
    this.TimeBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "options_label_style_17");
    this.TimeBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE, "options_label_style_dim_17");
    this.TimeBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.RESPOND_INPUTBOX);
    this.TimeBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.RESPOND_INPUTBOX_FOCUS);
    this.TimeBtn.SetBgImage(BtnImgIndex.BTN_DIM_IMG, g_Image.RESPOND_INPUTBOX_DIM);
	this.TimeBtn.setPrevEventOnLeftFunc(function(){scene.processLeftKey(); OptionsMgr.resetTimer();});
    this.TimeBtn.setPrevEventOnDownFunc(function(){scene.moveDown(); OptionsMgr.resetTimer();});
    this.TimeBtn.setPrevEventOnUpFunc(function(){scene.moveUp(); OptionsMgr.resetTimer();});
    this.TimeBtn.setPrevEventOnBlueFunc(function(){scene.processBlueKey()});
    this.TimeBtn.setPrevEventOnReturnFunc(function(){$.sfKey.block(event); scene.processReturnKey(); OptionsMgr.resetTimer();});
	this.TimeBtn.setPrevEventOnExitFunc(function(){$.sfKey.block(event); scene.processExitKey();});
	this.TimeBtn.setPrevEventOnInfolinkFunc(function(){$.sfKey.block(event); });
	this.TimeBtn.setAnyKeyFunc(function(keyCode){scene.callbackNumberInput(); OptionsMgr.resetTimer();});
    this.TimeBtn.setMaxLength(this.TIME_MAX_LENGTH);
    this.TimeBtn.setFlagPhoneNumber(false);

    this.countryCodeBtn = new Array(this.maxPhones);
    this.countryCodeArrowLabel = new Array(this.maxPhones);
    this.phoneNumber = new Array(this.maxPhones);
	this.CurCountryCode = new Array(this.maxPhones);

	this.records = new Array(this.maxPhones);
    this.resetRecords();

    var country_code = "options_country_code_";
    var phone_number = "options_phone_number_";
    for(var i = 0; i < this.maxPhones; i++)
    {
        this.countryCodeBtn[i] = new Button();
        this.countryCodeBtn[i].SetImageObjId(country_code + "btn" + i);
        this.countryCodeBtn[i].SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.OPTIONS_COUNTRY_CODE);
        this.countryCodeBtn[i].SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.OPTIONS_COUNTRY_CODE_HIGHLIGHT);
        this.countryCodeBtn[i].SetBgImage(BtnImgIndex.BTN_DIM_IMG, g_Image.OPTIONS_COUNTRY_CODE_DIM);
        this.countryCodeBtn[i].SetTextObjId(country_code + "txt" + i);
        this.countryCodeBtn[i].SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "options_label_style_17");
        this.countryCodeBtn[i].SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "options_label_style_17");
        this.countryCodeBtn[i].SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE, "options_label_style_dim_17");
        this.countryCodeBtn[i].AppendFgImage(country_code + "icon" + i, "15px", "11px", "37px", "27px"); 

        this.countryCodeArrowLabel[i] = new Label(country_code + "btn_arrow_" + i, null);
        this.countryCodeArrowLabel[i].SetBgImage(g_Image.OPTIONS_ARROW_DOWN);

        this.phoneNumber[i] = new NumberInputBox();
        this.phoneNumber[i].SetButtonObjId(phone_number + "input_box" + i);
        this.phoneNumber[i].SetButtonTextObjId(phone_number + "input_text" + i);
        this.phoneNumber[i].SetInputBoxObjId(phone_number + "input_text_editor" + i);
        this.phoneNumber[i].SetBgImage(BtnImgIndex.BTN_DIM_IMG, g_Image.NUMBER_INPUTBOX_DIM);
        this.phoneNumber[i].SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "options_label_style_17");
        this.phoneNumber[i].SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "options_label_style_17");
        this.phoneNumber[i].SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE, "options_label_style_dim_17");
        this.phoneNumber[i].SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.NUMBER_INPUTBOX_NORMAL);
        this.phoneNumber[i].SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.NUMBER_INPUTBOX_FOCUS);
        this.phoneNumber[i].setPrevEventOnLeftFunc(function(){scene.moveLeft(); OptionsMgr.resetTimer();});
        this.phoneNumber[i].setPrevEventOnRightFunc(function(){scene.moveRight(); OptionsMgr.resetTimer();});
        this.phoneNumber[i].setPrevEventOnDownFunc(function(){scene.moveDown(); OptionsMgr.resetTimer();});
		this.phoneNumber[i].setEnterFunc(function(){scene.moveDown(); OptionsMgr.resetTimer();});
        this.phoneNumber[i].setPrevEventOnUpFunc(function(){scene.moveUp(); OptionsMgr.resetTimer();});
        this.phoneNumber[i].setPrevEventOnBlueFunc(function(){scene.processBlueKey()});
        this.phoneNumber[i].setPrevEventOnReturnFunc(function(){$.sfKey.block(event); scene.processReturnKey(); OptionsMgr.resetTimer();});
        this.phoneNumber[i].setPrevEventOnExitFunc(function(){$.sfKey.block(event); scene.processExitKey(); });
		this.phoneNumber[i].setPrevEventOnInfolinkFunc(function(){$.sfKey.block(event); });
		this.phoneNumber[i].setAnyKeyFunc(function(keyCode){scene.callbackPhoneNumberInput(); OptionsMgr.resetTimer();});
        this.phoneNumber[i].setMaxLength(this.NUMBER_MAX_LENGTH);
        this.phoneNumber[i].SetReverseDisable(true);
    }

    //this.initOptions();
    this.path = new Array(8);
    var i = 0;
    for(i = 0; i < this.path.length; i++)
        this.path[i] = new Object();

    this.initPath();
    
    this.DefaultHelpBar  = new HelpBar(HelpBarIndex.OPTIONS_CALL_FORWARDING,"Options");
    this.DefaultHelpBar.SetOnClickCallbackFunc(1, function(){this_.processReturnKey();});
    
    this.SaveHelpBar = new HelpBar(HelpBarIndex.OPTIONS_CALL_FORWARDING_SAVE,"Options");
    this.SaveHelpBar.SetOnClickCallbackFunc(1, function(){this_.processBlueKey();});
    this.SaveHelpBar.SetOnClickCallbackFunc(2, function(){this_.processReturnKey();});
    
    this.PhoneNumberInputHelpBar = new HelpBar(HelpBarIndex.OPTIONS_CALL_FORWARDING_PHONE_NUMBER_INPUT,"Options");
    this.PhoneNumberInputHelpBar.SetOnClickCallbackFunc(1, function(){this_.startKeypad();});
    this.PhoneNumberInputHelpBar.SetOnClickCallbackFunc(2, function(){this_.inputDelete();});
    this.PhoneNumberInputHelpBar.SetOnClickCallbackFunc(3, function(){this_.processReturnKey();});
    
    this.PhoneNumberInputSaveHelpBar = new HelpBar(HelpBarIndex.OPTIONS_CALL_FORWARDING_PHONE_NUMBER_INPUT_SAVE,"Options");
    this.PhoneNumberInputSaveHelpBar.SetOnClickCallbackFunc(1, function(){this_.startKeypad();});
    this.PhoneNumberInputSaveHelpBar.SetOnClickCallbackFunc(2, function(){this_.inputDelete();});
    this.PhoneNumberInputSaveHelpBar.SetOnClickCallbackFunc(3, function(){this_.processBlueKey();});
    this.PhoneNumberInputSaveHelpBar.SetOnClickCallbackFunc(4, function(){this_.processReturnKey();});
    
    this.PlusPhoneNumberInputHelpBar = new HelpBar(HelpBarIndex.OPTIONS_CALL_FORWARDING_PHONE_NUMBER_INPUT_PLUS,"Options");
    this.PlusPhoneNumberInputHelpBar.SetOnClickCallbackFunc(1, function(){this_.startKeypad();});
	this.PlusPhoneNumberInputHelpBar.SetOnClickCallbackFunc(2, function(){this_.inputPlus();});
    this.PlusPhoneNumberInputHelpBar.SetOnClickCallbackFunc(3, function(){this_.inputDelete();});
    this.PlusPhoneNumberInputHelpBar.SetOnClickCallbackFunc(4, function(){this_.processReturnKey();});
    
    this.PlusPhoneNumberInputSaveHelpBar = new HelpBar(HelpBarIndex.OPTIONS_CALL_FORWARDING_PHONE_NUMBER_INPUT_SAVE_PLUS,"Options");
    this.PlusPhoneNumberInputSaveHelpBar.SetOnClickCallbackFunc(1, function(){this_.startKeypad();});
	this.PlusPhoneNumberInputSaveHelpBar.SetOnClickCallbackFunc(2, function(){this_.inputPlus();});
    this.PlusPhoneNumberInputSaveHelpBar.SetOnClickCallbackFunc(3, function(){this_.inputDelete();});
    this.PlusPhoneNumberInputSaveHelpBar.SetOnClickCallbackFunc(4, function(){this_.processBlueKey();});
    this.PlusPhoneNumberInputSaveHelpBar.SetOnClickCallbackFunc(5, function(){this_.processReturnKey();});
    
    this.NumberInputHelpBar = new HelpBar(HelpBarIndex.OPTIONS_CALL_FORWARDING_NUMBER_INPUT,"Options");
    this.NumberInputHelpBar.SetOnClickCallbackFunc(1, function(){this_.startKeypad();});
    this.NumberInputHelpBar.SetOnClickCallbackFunc(2, function(){this_.inputDelete();});
    this.NumberInputHelpBar.SetOnClickCallbackFunc(3, function(){this_.processReturnKey();});
    
    this.NumberInputSaveHelpBar = new HelpBar(HelpBarIndex.OPTIONS_CALL_FORWARDING_NUMBER_INPUT_SAVE,"Options");
    this.NumberInputSaveHelpBar.SetOnClickCallbackFunc(1, function(){this_.startKeypad();});
    this.NumberInputSaveHelpBar.SetOnClickCallbackFunc(2, function(){this_.inputDelete();});
    this.NumberInputSaveHelpBar.SetOnClickCallbackFunc(3, function(){this_.processBlueKey();});
    this.NumberInputSaveHelpBar.SetOnClickCallbackFunc(4, function(){this_.processReturnKey();});
    
    this.CallBtn.registHelpBar(this.DefaultHelpBar);
    this.countryCodeBtn[0].registHelpBar(this.DefaultHelpBar);
    this.countryCodeBtn[1].registHelpBar(this.DefaultHelpBar);
    this.countryCodeBtn[2].registHelpBar(this.DefaultHelpBar);
    this.phoneNumber[0].registHelpBar(this.PhoneNumberInputHelpBar);
    this.phoneNumber[1].registHelpBar(this.PhoneNumberInputHelpBar);
    this.phoneNumber[2].registHelpBar(this.PhoneNumberInputHelpBar);
    this.TimeBtn.registHelpBar(this.NumberInputHelpBar);
    
    this.btnList= new Array(8);
    for(i = 0; i < this.btnList.length; i++)
    {
    	this.btnList[i] = new Object();
    }
    
    this.btnList[0] = this.CallBtn;
    this.btnList[1] = this.TimeBtn;
    this.btnList[2] = this.countryCodeBtn[0];
    this.btnList[3] = this.phoneNumber[0];
    this.btnList[4] = this.countryCodeBtn[1];
    this.btnList[5] = this.phoneNumber[1];
    this.btnList[6] = this.countryCodeBtn[2];
    this.btnList[7] = this.phoneNumber[2];

    var this_ = $.sfScene.get("OptionsCallForwarding");
	var clickCF =  function(obj){this_.processClickEvent(obj);};
    
    for(i = 0; i < this.btnList.length; i++)
    {
    	this.btnList[i].SetOnClickCallbackFunc(clickCF);
    }
        
    this.flagCreate = true;
}


SceneOptionsCallForwarding.prototype.setInitFlag = function(initFlag)
{
    this.isInit = initFlag;
}

SceneOptionsCallForwarding.prototype.changeToDefaultHelpBar= function()
{ 
     if(this.flagCreate == false)
    {
        return;
    }
    
    this.CallBtn.changeHelpBar(this.DefaultHelpBar);
    this.countryCodeBtn[0].changeHelpBar(this.DefaultHelpBar);
    this.countryCodeBtn[1].changeHelpBar(this.DefaultHelpBar);
    this.countryCodeBtn[2].changeHelpBar(this.DefaultHelpBar);
    this.TimeBtn.changeHelpBar(this.NumberInputHelpBar);
    if(this.phoneNumber[0].GetText().length >0)
    {
        this.phoneNumber[0].changeHelpBar(this.PhoneNumberInputHelpBar);
    }
    else
    {
        this.phoneNumber[0].changeHelpBar(this.PlusPhoneNumberInputHelpBar);
    }
    
    if(this.phoneNumber[1].GetText().length >0)
    { 
        this.phoneNumber[1].changeHelpBar(this.PhoneNumberInputHelpBar);
    }
    else
    {
        this.phoneNumber[1].changeHelpBar(this.PlusPhoneNumberInputHelpBar);
    }
    
     if(this.phoneNumber[2].GetText().length >0)
    { 
        this.phoneNumber[2].changeHelpBar(this.PhoneNumberInputHelpBar);
    }
    else
    {
         this.phoneNumber[2].changeHelpBar(this.PlusPhoneNumberInputHelpBar);
    }
    
    this.checkPlusBtnEnable();
}

SceneOptionsCallForwarding.prototype.changeToSaveHelpBar= function()
{
     if(this.flagCreate == false)
    {
        return;
    }
    
    this.CallBtn.changeHelpBar(this.SaveHelpBar);
    this.countryCodeBtn[0].changeHelpBar(this.SaveHelpBar);
    this.countryCodeBtn[1].changeHelpBar(this.SaveHelpBar);
    this.countryCodeBtn[2].changeHelpBar(this.SaveHelpBar);
    this.TimeBtn.changeHelpBar(this.NumberInputSaveHelpBar);
    
     if(this.phoneNumber[0].GetText().length >0)
    {
        this.phoneNumber[0].changeHelpBar(this.PhoneNumberInputSaveHelpBar);
    }
    else
    {
        this.phoneNumber[0].changeHelpBar(this.PlusPhoneNumberInputSaveHelpBar);
    }
    
     if(this.phoneNumber[1].GetText().length >0)
    {
        this.phoneNumber[1].changeHelpBar(this.PhoneNumberInputSaveHelpBar);
    }
    else
    {
        this.phoneNumber[1].changeHelpBar(this.PlusPhoneNumberInputSaveHelpBar);
    }
    
     if(this.phoneNumber[2].GetText().length >0)
    {
        this.phoneNumber[2].changeHelpBar(this.PhoneNumberInputSaveHelpBar);
    }
    else
    {
        this.phoneNumber[2].changeHelpBar(this.PlusPhoneNumberInputSaveHelpBar);
    }
    
    this.checkPlusBtnEnable();
}

SceneOptionsCallForwarding.prototype.checkPlusBtnEnable = function()
{
    alert("SceneOptionsCallForwarding.checkPlusBtnEnable() ");
    
     if(this.flagCreate == false)
    {
        return;
    }

    var currentHighlight =  this.OptionsCallForwardingView.getCurrentHighlight();
      if(currentHighlight !=this.phoneNumber[0] && currentHighlight !=this.phoneNumber[1]   && currentHighlight !=this.phoneNumber[2]  )
    {
           return;
    }

        var PhoneNumberInputBox = currentHighlight;
        var input_phone_number = PhoneNumberInputBox.GetText();
        var pos_of_caret = PhoneNumberInputBox.GetPosOfCaret();
        
        if(input_phone_number.length ==0)
        {
            this.flagPlusBtnEnable = true;
        }
        else if(input_phone_number.indexOf("+") ==0 || input_phone_number.indexOf("00") ==0 || input_phone_number.indexOf("011") ==0)
        {
            this.flagPlusBtnEnable = false;
        }   
        else if( pos_of_caret ==0)
        {
            this.flagPlusBtnEnable = true;
        }
        else
        {
             this.flagPlusBtnEnable = false;
        }

        this.setPlusBtnEnable();
    
    
}

SceneOptionsCallForwarding.prototype.setPlusBtnEnable = function()
{
    alert("SceneOptionsCallForwarding.setPlusBtnEnable() ");

    var currentHighlight =  this.OptionsCallForwardingView.getCurrentHighlight();
     if(currentHighlight !=this.phoneNumber[0] && currentHighlight !=this.phoneNumber[1]   && currentHighlight !=this.phoneNumber[2]  )
    {
           return;
    }
    
    var PhoneNumberInputBox =  currentHighlight;
    
    if(this.flagPlusBtnEnable == true)
    {
        if(OptionsMgr.flagChange == true)
        {
            PhoneNumberInputBox.changeHelpBar( this.PlusPhoneNumberInputSaveHelpBar);
        }
        else
        {
             PhoneNumberInputBox.changeHelpBar( this.PlusPhoneNumberInputHelpBar);
        }
        
        PhoneNumberInputBox.setFlagPhoneNumber(true);
    }
    else
    {   
         if(OptionsMgr.flagChange == true)
        {
            PhoneNumberInputBox.changeHelpBar( this.PhoneNumberInputSaveHelpBar);
        }
        else
        {
             PhoneNumberInputBox.changeHelpBar( this.PhoneNumberInputHelpBar);
        }
        
        PhoneNumberInputBox.setFlagPhoneNumber(false);
    }    
}


SceneOptionsCallForwarding.prototype.resetRecords = function()
{
    alert("SceneOptionsCallForwarding.resetRecords");
	for(var i = 0; i < this.maxPhones; i++)
	{
	    this.records[i] = new Object();	
        this.records[i].number = ""; 
        this.records[i].countryCodeAlpha = ""; 
        this.records[i].countryCode = ""; 
        this.records[i].localNumber = "";
	}
}

SceneOptionsCallForwarding.prototype.getFlagImageName = function(countryCodeAlpha)
{
    alert("SceneOptionsCallForwarding.getFlagImageName()"); 
    if(countryCodeAlpha !== "" && countryCodeAlpha !== undefined)
        return g_Image.base_flag_image_path + countryCodeAlpha.toUpperCase() + ".png";
    else
        return "";
}

SceneOptionsCallForwarding.prototype.deserialize = function(packet)
{
    alert("SceneOptionsCallForwarding.deserialize()"); 
    alert("Packet :" + packet);
    if(!packet)
        return;
    this.resetRecords();
	var set = packet.split(this.splitCharSpace);
	var period = 3;
    var offset = 2;
    alert("set.length: " + set.length);
	for(var i = 0; i < set.length; i++)
	{
        var item = set[i].split(this.splitCharComma);
        alert("item.length: " + item.length);
        
        alert("item: " + item);
        alert("item[offset]: " + item[offset]);
        if(!item || item[offset] === undefined)
            continue;

        this.records[i].number = item[offset];
        this.records[i].countryCodeAlpha = PluginAPIMgr.FindCountryCodeByNumber(item[offset]);
        this.records[i].localNumber = PluginAPIMgr.GetLocalNumber(item[offset]);
        this.records[i].countryCode = item[offset].replace(this.records[i].localNumber, ""); 

        alert("Index: " + i);
        alert("Number: " + this.records[i].number);
        alert("Country code alpha: " + this.records[i].countryCodeAlpha);
        alert("Country code: " + this.records[i].countryCode);
        alert("Local number: " + this.records[i].localNumber);
	}
}

/**
 *  Checks whether the phone numbers changed.
 *  @return Boolean value which is checking result.
 */
SceneOptionsCallForwarding.prototype.isValidNumber = function(packet)
{
    alert("SceneOptionsCallForwarding.isValidNumber()"); 

    if(!packet)
        return false;

    var offset = 2;
	var set = packet.split(this.splitCharSpace);

	for(var i = 0; i < set.length; i++)
    {
        var item = set[i].split(this.splitCharComma);

        if(!item || item[offset] === undefined)
            continue;

        var number = item[offset];

        if(!this.isNormalizedNumber(number) && !this.isEmergencyNumber(number))
            return false;
    }

    return true;
}

/**
 * Checks whether the number is emergency
 * @param number the full number which have the following format: "+"<country-code><local-number>
 */
SceneOptionsCallForwarding.prototype.isEmergencyNumber = function(number)
{
    alert("SceneOptionsCallForwarding.isEmergencyNumber"); 
    //var normNum = PluginAPIMgr.IsEmergencyCall(number);
    return false;
}

/**
 * Checks whether the number is normalized
 * @param number the full number which have the following format: "+"<country-code><local-number>
 */
SceneOptionsCallForwarding.prototype.isNormalizedNumber = function(number)
{
    alert("SceneOptionsCallForwarding.isNormalizedNumber"); 
    var normNum = PluginAPIMgr.NormalizeIdentity(number);
    if(normNum.length > 0)
        return true;
    else
        return false;
}

/**
 * Serializes provided forwarding phone numbers to one string
 * @return String packed with the provided phone numbers and timeouts
 * @remarks The serialized string is a space-separated list of 
 * "begSecond, endSecond,identity" tokens. So "a0,b0,id0 a1,b1,id1 ... an,bn,idn". Redirect to id1 
 * if id0 is not answering from a0 [sec] to b0 [sec]; redirect to id2 if id1 is not answering 
 * from a1 [sec] to b1 [sec] ... and so on. For example: 0,20,some_user 20,40 some_user2 40,60,+some_number, 
 * if user to whom we are calling is not answering then redirect to some_user, if some_user is not 
 * answering [0,20] sec redirect to some_user2, if some_user2 is not answering during [20,40] sec 
 * then redirect to +some_number and so on.
 */
SceneOptionsCallForwarding.prototype.serialize = function()
{
    alert("SceneOptionsCallForwarding.serialize()"); 
    var timeLimits = ["0", "20", "40", "60"];
    var recordIndex = 0;
    var serializedNumber = "";
    var divider = this.splitCharSpace;
	for(var i = 0; i < this.maxPhones; i++)
	{
        var localNumber = this.phoneNumber[i].GetText();
        var countryCode = this.countryCodeBtn[i].countryCode;
        var number = countryCode + localNumber; 

        alert("Number: " + number);
        alert("Local number: " + localNumber);
        alert("Country code: " + countryCode);

        if(localNumber.length !== 0)
        {
            
            if(recordIndex === 0)
                divider = "";
            else
                divider = this.splitCharSpace;

            serializedNumber = serializedNumber + divider + timeLimits[i] + this.splitCharComma + timeLimits[i+1] + this.splitCharComma + number;
            recordIndex++;
        }
	}
    this.deserialize(serializedNumber);
    return serializedNumber;
}

SceneOptionsCallForwarding.prototype.initPath = function()
{
    alert("SceneOptionsCallForwarding.initPath() "); 
	this.path[this.idxCallBtn] = [[this.idxCallBtn, this.idxTimeBtn], [this.idxNumberBtn1, this.idxTimeBtn], this.CallBtn];   
    this.path[this.idxFlagBtn1] = [[this.idxNumberBtn1, this.idxCallBtn], [this.idxFlagBtn2, this.idxCallBtn], this.countryCodeBtn[0]]; 
    this.path[this.idxFlagBtn2] = [[this.idxNumberBtn2, this.idxNumberBtn1], [this.idxFlagBtn3, this.idxFlagBtn1], this.countryCodeBtn[1]];  
    this.path[this.idxFlagBtn3] = [[this.idxNumberBtn3, this.idxNumberBtn2], [this.idxTimeBtn, this.idxFlagBtn2], this.countryCodeBtn[2]];   
    this.path[this.idxNumberBtn1] = [[this.idxFlagBtn1, this.idxFlagBtn1], [this.idxNumberBtn2, this.idxCallBtn], this.phoneNumber[0]];
	this.path[this.idxNumberBtn2] = [[this.idxFlagBtn2, this.idxFlagBtn2], [this.idxNumberBtn3, this.idxNumberBtn1], this.phoneNumber[1]];  
	this.path[this.idxNumberBtn3] = [[this.idxFlagBtn3, this.idxFlagBtn3], [this.idxTimeBtn, this.idxNumberBtn2], this.phoneNumber[2]];
	this.path[this.idxTimeBtn]  = [[this.idxCallBtn, this.idxNumberBtn3], [this.idxCallBtn, this.idxNumberBtn3], this.TimeBtn]; 
}

SceneOptionsCallForwarding.prototype.highlight = function(obj)
{
    alert("SceneOptionsCallForwarding.highlight() ");
    var preHighlight =  this.OptionsCallForwardingView.getCurrentHighlight();
    
    this.OptionsCallForwardingView.setCurrenHighlight(obj);
    
    if(obj != null && preHighlight!=null)
    {
    	if(preHighlight.objType == "NUMBERINPUTBOX" && obj.objType != "NUMBERINPUTBOX")
    	{
    		this.leaveInputBox();
    	}        
    }
	
	this.checkPlusBtnEnable();
}

SceneOptionsCallForwarding.prototype.callbackPhoneNumberInput = function()
{
    alert("SceneOptionsCallForwarding.callbackPhoneNumberInput() ");
    var currentHighlight = this.OptionsCallForwardingView.getCurrentHighlight();
    var index=0;
    for (index=0; index<3; index++)
    {
        if(currentHighlight == this.phoneNumber[index])
        {
            OptionsMgr.setCallForwardLocalCode(index, this.phoneNumber[index].GetText())
        }
    }
}

SceneOptionsCallForwarding.prototype.callbackNumberInput = function()
{
    alert("SceneOptionsCallForwarding.callbackNumberInput() ");

       OptionsMgr.setCallForwardTimer(this.TimeBtn.GetText());
}


SceneOptionsCallForwarding.prototype.processLeftKey = function()
{
    alert("SceneOptionsCallForwarding.processLeftKey() ");
    this.exit();
}

SceneOptionsCallForwarding.prototype.processRightKey = function()
{
    alert("SceneOptionsCallForwarding.processRightKey() ");
    this.gotoNext(this.horizontal);
}

SceneOptionsCallForwarding.prototype.processDownKey = function()
{
    alert("SceneOptionsCallForwarding.processDownKey() ");
    this.gotoNext(this.vertical);
}

SceneOptionsCallForwarding.prototype.processUpKey = function()
{
    alert("SceneOptionsCallForwarding.processUpKey() ");
    this.gotoPrev(this.vertical);
}

SceneOptionsCallForwarding.prototype.processEnterKey = function(){
    alert("SceneOptionsCallForwarding.processEnterKey() ");
    var currentHighlight = this.OptionsCallForwardingView.getCurrentHighlight();
    switch(currentHighlight)
    {
        case this.CallBtn:
            alert("CallBtn");
            var scene = $.sfScene.get("OptionsCallForwarding");
            WndMgr.StartSelectorOnOff(this.CallBtn, this.sceneId, scene.callBack, this.CallBtn.GetText());
            this.flagSubList = true;
			break;

        case this.countryCodeBtn[0]:
        case this.countryCodeBtn[1]:
        case this.countryCodeBtn[2]:
            this.showCountryList(currentHighlight);
            break;
    }
}

SceneOptionsCallForwarding.prototype.callBack = function(result)
{
    alert("SceneOptionsCallForwarding.callBack"); 
    var scene = $.sfScene.get("OptionsCallForwarding");
    
     OptionsMgr.setCallForwardState(scene.CallBtn.GetText());
    if(result === SID_OFF)
        scene.disable();    
    else 
        scene.enable();
}

SceneOptionsCallForwarding.prototype.moveLeft = function()
{
    alert("SceneOptionsCallForwarding.moveLeft() ");
    var curObj = this.gotoPrev(this.horizontal);
    /*if(curObj.objType != "NUMBERINPUTBOX")
        this.leaveInputBox();*/
}

SceneOptionsCallForwarding.prototype.moveRight = function()
{
    alert("SceneOptionsCallForwarding.moveRight() ");
    var curObj = this.gotoNext(this.horizontal);
    /*if(curObj.objType != "NUMBERINPUTBOX")
        this.leaveInputBox();*/
}

SceneOptionsCallForwarding.prototype.moveUp = function()
{
    alert("SceneOptionsCallForwarding.moveUp()");
    var curObj = this.gotoPrev(this.vertical);
    /*if(curObj.objType != "NUMBERINPUTBOX")
        this.leaveInputBox();*/
}

SceneOptionsCallForwarding.prototype.moveDown = function()
{
    alert("SceneOptionsCallForwarding.moveDown()");
    var curObj = this.gotoNext(this.vertical);
    /*if(curObj.objType != "NUMBERINPUTBOX")
        this.leaveInputBox();*/
}

SceneOptionsCallForwarding.prototype.leaveInputBox = function()
{
    alert("SceneOptionsCallForwarding.leaveInputBox() ");
    $.sfScene.focus("OptionsCallForwarding");
	$.sf.returnFocus();
}

SceneOptionsCallForwarding.prototype.exit = function()
{
    alert("SceneOptionsCallForwarding.exit() ");
	this.highlight(null);
    WndMgr.ReturnOptionsSubToMain();
    
}

SceneOptionsCallForwarding.prototype.processReturnKey = function()
{
    alert("SceneOptionsCallForwarding.processReturnKey() ");
    this.exit();
}

SceneOptionsCallForwarding.prototype.processExitKey = function()
{
    alert("SceneOptionsCallForwarding.processExitKey()");
        
     if(OptionsMgr.flagChange == true)
    {
        WndMgr.StartOptionsSaveReturnStep();
     }
     else
     {
        StateMgr.Stop_Options_State(true); 
     }
}

SceneOptionsCallForwarding.prototype.gotoNext = function(direction)
{
    alert("SceneOptionsCallForwarding.gotoNext() ");
    alert("Direction: " + direction);
    var curObj = this.path[this.curPos][this.idxObj];
    if(this.isNavigatable) 
    {
        this.curPos = this.path[this.curPos][direction][this.next]; 
        curObj = this.path[this.curPos][this.idxObj];
        this.highlight(curObj);
    }
    return curObj;
}

SceneOptionsCallForwarding.prototype.gotoPrev = function(direction)
{
    alert("SceneOptionsCallForwarding.gotoPrev() ");
    alert("Direction: " + direction);
    var curObj = this.path[this.curPos][this.idxObj];
    if(this.isNavigatable) 
    {
        this.curPos = this.path[this.curPos][direction][this.prev]; 
        curObj = this.path[this.curPos][this.idxObj];
        this.highlight(curObj);
    }
    return curObj;
}

SceneOptionsCallForwarding.prototype.processBlueKey = function()
{
    alert("SceneOptionsCallForwarding.processBlueKey() ");
    //this.preSave();
	var currentHighlight = this.OptionsCallForwardingView.getCurrentHighlight();
	if(OptionsMgr.flagChange == true && currentHighlight.objType == "NUMBERINPUTBOX")
	{
		currentHighlight.blur();
	}
	
    OptionsMgr.SaveOptions();
}

/**
 * Checks the skypeout capability and if it is disabled (not enough credit) 
 * and user make changes of call forwarding number or forwarding time settings the 
 * notification message box should be shown to user. After that the new settings should be saved.
 */
SceneOptionsCallForwarding.prototype.preSave = function()
{
    alert("SceneOptionsCallForwarding.preSave() ");
    this.setOptions();
	var scene = $.sfScene.get("OptionsCallForwarding");
    if(OptionsMgr.getSkypeOutState() === false)
        if(OptionsMgr.isChangedCallForwardNumbers() || OptionsMgr.isChangedCallForwardTimer())
            WndMgr.StartOptionsSkypeOutDisabledMsg(this.sceneId, scene.saveOptions);
}

SceneOptionsCallForwarding.prototype.saveOptions = function()
{
    alert("SceneOptionsCallForwarding.saveOptions()");
	var scene = $.sfScene.get("OptionsCallForwarding");

    var saveResult = OptionsMgr.saveCallForwarding(); 
    alert("Save result: " + saveResult);
    switch(saveResult)
    {
        case OptionsMgr.SAVE_NUMBER_MISSFORMAT:
            alert("Options forwarding numbers are misformatted");
            WndMgr.StartOptionsCommitNumberMisformatMsg(scene.sceneId);
            break;

        case OptionsMgr.SAVE_SERVER:
            alert("Wait for event from server");
            WndMgr.StartOptionsCommittingMsg(scene.sceneId);
            break;

        case OptionsMgr.SAVE_LOCAL:
            alert("Options committed");
            WndMgr.StartOptionsCommitedMsg(scene.sceneId); 
            break;

        default:
            alert("Not registered save result");
            break;
    }
}

/**
 * Initializes the value of options presented to user.
 */
SceneOptionsCallForwarding.prototype.initOptions = function()
{
    alert("SceneOptionsCallForwarding.initOptions");

    this.curPos = 0;

    var callForward = OptionsMgr.getCallForwardState();
    this.CallBtn.SetText(callForward);
    this.TimeBtn.SetText(OptionsMgr.getCallForwardTimer());
    
    for(var i = 0; i < this.maxPhones; i++)
    {
        var image = this.getFlagImageName(OptionsMgr.callForwardCountryCode[i] );
        alert("Image file name: " + image);

        this.countryCodeBtn[i].SetFgImage(image);
        this.countryCodeBtn[i].countryCode = OptionsMgr.callForwardCountryCode[i] ;
		this.CurCountryCode[i] = OptionsMgr.callForwardCountryCode[i] ;

        this.phoneNumber[i].SetText(OptionsMgr.callForwardLocalCode[i] );
    }

    if(callForward === SID_OFF)
        this.disable();
    else 
        this.enable();
       
       
     if(OptionsMgr.flagChange == true)
    {
        this.changeToSaveHelpBar();
    }
    else
    {
        this.changeToDefaultHelpBar();
    }
        
         this.isInit= false;
}

SceneOptionsCallForwarding.prototype.showCountryList = function(currentObject)
{
    alert("SceneOptionsCallForwarding.showCountryList");
	
	var sceneCountry = $.sfScene.get("CountryFlagList");
    var scene = $.sfScene.get("OptionsCallForwarding");
	var CountryCode;
    
	switch(currentObject)
    {
        case this.countryCodeBtn[0]:
            alert("Country code button 0");
			CountryCode = scene.CurCountryCode[0];
            sceneCountry.Init(FLAG_LIST_TYPE.OPTIONS_CALL_FORWARD_FIRST, 'OptionsCallForwarding', scene.setCountryFirst, null);
            break;

        case this.countryCodeBtn[1]:
            alert("Country code button 1");
			CountryCode = scene.CurCountryCode[1];
            sceneCountry.Init(FLAG_LIST_TYPE.OPTIONS_CALL_FORWARD_SECOND, 'OptionsCallForwarding', scene.setCountrySecond, null);
            break;

        case this.countryCodeBtn[2]:
            alert("Country code button 2");
			CountryCode = scene.CurCountryCode[2];
            sceneCountry.Init(FLAG_LIST_TYPE.OPTIONS_CALL_FORWARD_THIRD, 'OptionsCallForwarding', scene.setCountryThird, null);
            break;
    }
	
	var Index = g_Data.GetCountryIndexWithCode(CountryCode);
	
	sceneCountry.SetCurIndex(Index);				
	$.sfScene.show('CountryFlagList');
	setTimeout("CloseTimerCF()", 0);
	CloseTimerCF = function(){$.sfScene.focus('CountryFlagList');}	
	
	this.flagShownPrefixList = true;
}

SceneOptionsCallForwarding.prototype.setCountry = function(index)
{
    alert("SceneOptionsCallForwarding.setCountry");
    alert("Index: " + index);
	var Scene = $.sfScene.get("CountryFlagList");	
	var FlagImage = Scene.GetCountryFlag();
	var Prefix = Scene.GetPrefix();
    var CountryCode = Scene.GetCountryCode();
    alert("FlagImage: " + FlagImage);
    alert("Prefix: " + Prefix);
    alert("CountryCode: " + CountryCode);

    if(index < this.countryCodeBtn.length)
    {
        this.countryCodeBtn[index].SetFgImage(FlagImage);
        OptionsMgr.setCallForwardCountryCode(index, CountryCode);
		this.CurCountryCode[index] = CountryCode;
    }
}

SceneOptionsCallForwarding.prototype.setCountryFirst = function()
{
    alert("SceneOptionsCallForwarding.setCountryFirst");
    var scene = $.sfScene.get("OptionsCallForwarding");
    scene.setCountry(0);
}

SceneOptionsCallForwarding.prototype.setCountrySecond = function()
{
    alert("SceneOptionsCallForwarding.setCountrySecond");
    var scene = $.sfScene.get("OptionsCallForwarding");
    scene.setCountry(1);
}

SceneOptionsCallForwarding.prototype.setCountryThird = function()
{
    alert("SceneOptionsCallForwarding.setCountryThird");
    var scene = $.sfScene.get("OptionsCallForwarding");
    scene.setCountry(2);
}

SceneOptionsCallForwarding.prototype.enable = function()
{
    alert("SceneOptionsCallForwarding.enable");
    this.isNavigatable = true;
    for(var i = 0; i < this.maxPhones; i++)
    {
        this.countryCodeBtn[i].SetFlagDim(false);
        this.phoneNumber[i].SetFlagDim(false);
		this.countryCodeArrowLabel[i].SetBgImage(g_Image.OPTIONS_ARROW_DOWN);
    }
    this.TimeBtn.SetFlagDim(false);
}

SceneOptionsCallForwarding.prototype.disable = function()
{
    alert("SceneOptionsCallForwarding.disable");
    this.isNavigatable = false;
    for(var i = 0; i < this.maxPhones; i++)
    {
        this.countryCodeBtn[i].SetFlagDim(true);
        this.phoneNumber[i].SetFlagDim(true);
		this.countryCodeArrowLabel[i].SetBgImage(g_Image.OPTIONS_ARROW_DOWN_DIM);
    }
    this.TimeBtn.SetFlagDim(true);
}

SceneOptionsCallForwarding.prototype.processClickEvent = function(obj){
	alert("SceneOptionsCallForwarding.processClickEvent() ");
	OptionsMgr.resetTimer();
	
	for(var i = 0; i < this.btnList.length; i++)
	{
        if(this.btnList[i] == obj)
        {
        	this.curPos = i;
        	break;
        }
	}
	
	var currentHighlight =  this.OptionsCallForwardingView.getCurrentHighlight();
    if(currentHighlight != obj)
    {
    	this.highlight(obj);
    }
    
    if($.sfScene.get('Options').flag_Focus==true)
	{   
		$.sfScene.get('Options').moveToSub();
	}
	
	//if(currentHighlight != obj && obj.objType == "NUMBERINPUTBOX")
	if(obj.objType == "NUMBERINPUTBOX")
	{
		return;
	}

    this.processEnterKey();
}

SceneOptionsCallForwarding.prototype.startKeypad = function(){
    alert("SceneOptionsCallForwarding.startKeypad() ");
    
    var currentHighlight =  this.OptionsCallForwardingView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
		case this.phoneNumber[0]:
		case this.phoneNumber[1]:
		case this.phoneNumber[2]:
		case this.TimeBtn:
		
		if(OptionsMgr.CloseTimer ==true)
		{
			OptionsMgr.stopTimer();
		}
        
        var stopCF = function(){OptionsMgr.startTimer();};
        
        WndMgr.StartKeypad(currentHighlight, "OptionsCallForwarding", stopCF);
        break;            
    }    
}

SceneOptionsCallForwarding.prototype.inputPlus = function(){
    alert("SceneOptionsCallForwarding.inputPlus() ");
    
    var currentHighlight =  this.OptionsCallForwardingView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
		case this.phoneNumber[0]:
		case this.phoneNumber[1]:
		case this.phoneNumber[2]:
		
		if(OptionsMgr.CloseTimer ==true)
		{
			OptionsMgr.resetTimer();
		}	
		
		var keycode =35; //plus100
		if(ProcMgr.isTTXMIX == false)
		{
			keycode = 650 ; // TTXMIX
		}
        
        currentHighlight.processNumberKey(keycode);
        break;            
    }    
}

SceneOptionsCallForwarding.prototype.inputDelete = function(){
    alert("SceneOptionsCallForwarding.inputDelete() ");
    
    var currentHighlight =  this.OptionsCallForwardingView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
		case this.phoneNumber[0]:
		case this.phoneNumber[1]:
		case this.phoneNumber[2]:
		case this.TimeBtn:
		
		if(OptionsMgr.CloseTimer ==true)
		{
			OptionsMgr.resetTimer();
		}	
				        
        currentHighlight.processPreChKey();
        break;            
    }    
}

