/**
 * @author Samsung
 */

function SceneOptionsGeneralSettings(options)
{
    this.options = options;
    this.sceneId = "OptionsGeneralSettings";
    this.OptionsGeneralSettingsView = null;
    this.OptionsAutoStartLabel = null;
	this.OptionsAutoStartBtn = null;
    //this.OptionsAllowCallList = null;
    this.OptionsDisplayNotyLabel = null;
	this.OptionsDisplayNotyBtn = null;
    
    this.DefaultHelpBar = null;
    this.SaveHelpBar = null;
    
    this.flagCreate = false;
    this.isInit = true;
	this.flagEnable = true;	
	this.flagSubList = false; 
    
}

SceneOptionsGeneralSettings.prototype.initialize = function ()
{
	alert("SceneOptionsGeneralSettings.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
   this.create();
}

SceneOptionsGeneralSettings.prototype.handleShow = function ()
{
	alert("SceneOptionsGeneralSettings.handleShow()");
	// this function will be called when the scene manager show this scene 
	
    if(this.isInit == true)
    {
      this.initOptions();
    }
	
}

SceneOptionsGeneralSettings.prototype.handleHide = function ()
{
	alert("SceneOptionsGeneralSettings.handleHide()");
	// this function will be called when the scene manager hide this scene  

	if(this.flagSubList){
		WndMgr.StopOptionSelector();
		this.flagSubList = false;
	}
}

SceneOptionsGeneralSettings.prototype.handleFocus = function ()
{
	alert("SceneOptionsGeneralSettings.handleFocus()");
	// this function will be called when the scene manager focus this scene
	
	var currentHighlight =  this.OptionsGeneralSettingsView.getCurrentHighlight();
	if(currentHighlight==null)
	{
		if(this.flagEnable== true)
		{
			this.highlight(this.OptionsAutoStartBtn);
		}
		else
		{
			this.highlight(this.OptionsDisplayNotyBtn);
		}
	}
	else
	{
		this.highlight(currentHighlight);
	}

	this.flagSubList = false;
}

SceneOptionsGeneralSettings.prototype.handleBlur = function ()
{
	alert("SceneOptionsGeneralSettings.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
     var currentHighlight =  this.OptionsGeneralSettingsView.getCurrentHighlight();
     currentHighlight.blur();
}

SceneOptionsGeneralSettings.prototype.handleKeyDown = function (keyCode)
{
	alert("SceneOptionsGeneralSettings.handleKeyDown(" + keyCode + ")");
    // TODO : write an key event handler when this scene get focued
    PluginAPIMgr.PlayAudio(keyCode);
    switch (keyCode) {
        case $.sfKey.LEFT:
			OptionsMgr.resetTimer();
            this.processLeftKey();
            break;

        case $.sfKey.RIGHT:
            //this.processRightKey();
            break;

        case $.sfKey.UP:
        case $.sfKey.DOWN:
			OptionsMgr.resetTimer();
            this.processUpDownKey();
            break;

        case $.sfKey.ENTER:
			OptionsMgr.resetTimer();
            this.processEnterKey();
            break;

        case $.sfKey.BLUE:
            this.processBlueKey();
            break;

        case $.sfKey.RETURN:
			OptionsMgr.resetTimer();
            this.processReturnKey();
            $.sfKey.block(event);
            break;
          case $.sfKey.EXIT:
          	this.processExitKey();
			$.sfKey.block(event);
			break;
		
        case 147:  //infolink
        case 261:  //contents
        case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
    }
}

/////////////////////////////////////////////////////////////////////////////
SceneOptionsGeneralSettings.prototype.create = function()
{
    alert("SceneOptionsGeneralSettings.create()");

    this.OptionsGeneralSettingsView = new View(this.sceneId);

    this.OptionsAutoStartLabel = new Label(null, "options_auto_start_label");
    this.OptionsAutoStartLabel.SetTextStyle("options_auto_start_label_style");
    //this.OptionsAutoStartLabel.SetReverseDisable(true);
    
	var CurLangID = ResMgr.GetCurLanguage();
    
 	if(CurLangID == ENUM_TV_LANGUAGE.ZUL || CurLangID == ENUM_TV_LANGUAGE.SWA || CurLangID == ENUM_TV_LANGUAGE.XHO)
 	{
    	this.OptionsAutoStartLabel.SetText(IDWS_MOIP_SKYPE_SIGN_ME_IN_WHEN_TV_STARTS+":");    
   	}
   	else 
   	{
   		if(ResMgr.isReverseLanguage())
   		{
   			this.OptionsAutoStartLabel.SetText(IDWS_MOIP_SKYPE_SIGN_ME_IN_WHEN_TV_STARTS); 
   		}
   		else
   		{
   			this.OptionsAutoStartLabel.SetText(IDWS_MOIP_SKYPE_SIGN_ME_IN_WHEN_TV_STARTS+" :"); 
   		}		   
   	}
        
    
    var this_ = $.sfScene.get("OptionsGeneralSettings");
	var clickCF =  function(obj){this_.processClickEvent(obj);};

    this.OptionsAutoStartBtn = new Button();
    this.OptionsAutoStartBtn.SetImageObjId("options_auto_start_btn");
    this.OptionsAutoStartBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.OPTIONS_AUTO_START);
    this.OptionsAutoStartBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.OPTIONS_AUTO_START_HIGHLIGHT);
    this.OptionsAutoStartBtn.SetBgImage(BtnImgIndex.BTN_DIM_IMG, g_Image.OPTIONS_AUTO_START_DIM);
	this.OptionsAutoStartBtn.SetTextObjId("options_auto_start_txt");

 	if(CurLangID == ENUM_TV_LANGUAGE.ARA)
 	{
	    this.OptionsAutoStartBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "options_label_style_16");
		this.OptionsAutoStartBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "options_label_style_16");
		this.OptionsAutoStartBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE, "options_label_style_dim_16"); 
   	}
   	else 
   	{
	    this.OptionsAutoStartBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "options_label_style_17");
		this.OptionsAutoStartBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "options_label_style_17");
		this.OptionsAutoStartBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE, "options_label_style_dim_17");   
   	} 	
		
	this.OptionsAutoStartBtn.AppendFgImage("options_auto_start_icon", "113px", "21px", "13px", "8px");
	this.OptionsAutoStartBtn.SetFgImage(g_Image.OPTIONS_ARROW_DOWN);
	this.OptionsAutoStartBtn.SetOnClickCallbackFunc(clickCF);
	
	this.OptionsDisplayNotyLabel = new Label(null, "options_display_noty_label");
    this.OptionsDisplayNotyLabel.SetTextStyle("options_auto_start_label_style");
    //this.OptionsDisplayNotyLabel.SetReverseDisable(true);

 	if(CurLangID == ENUM_TV_LANGUAGE.ZUL || CurLangID == ENUM_TV_LANGUAGE.SWA || CurLangID == ENUM_TV_LANGUAGE.XHO)
 	{
    	this.OptionsDisplayNotyLabel.SetText(TV_SID_DISPLAY_NOTIFICATION_ONLINE_MSG+":");    
   	}
   	else 
   	{
   		if(ResMgr.isReverseLanguage())
   		{
   			this.OptionsDisplayNotyLabel.SetText(TV_SID_DISPLAY_NOTIFICATION_ONLINE_MSG); 
   		}
   		else
		{
			this.OptionsDisplayNotyLabel.SetText(TV_SID_DISPLAY_NOTIFICATION_ONLINE_MSG+" :");
		}
		   
   	}   

    this.OptionsDisplayNotyBtn = new Button();
    this.OptionsDisplayNotyBtn.SetImageObjId("options_display_noty_btn");
    this.OptionsDisplayNotyBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.OPTIONS_AUTO_START);
    this.OptionsDisplayNotyBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.OPTIONS_AUTO_START_HIGHLIGHT);
    this.OptionsDisplayNotyBtn.SetBgImage(BtnImgIndex.BTN_DIM_IMG, g_Image.OPTIONS_AUTO_START_DIM);
	this.OptionsDisplayNotyBtn.SetTextObjId("options_display_noty_txt");

 	if(CurLangID == ENUM_TV_LANGUAGE.ARA)
 	{
	    this.OptionsDisplayNotyBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "options_label_style_16");
		this.OptionsDisplayNotyBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "options_label_style_16");
		this.OptionsDisplayNotyBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE, "options_label_style_dim_16"); 
   	}
   	else 
   	{
	    this.OptionsDisplayNotyBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "options_label_style_17");
		this.OptionsDisplayNotyBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "options_label_style_17");
		this.OptionsDisplayNotyBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE, "options_label_style_dim_17");   
   	} 	
		
	this.OptionsDisplayNotyBtn.AppendFgImage("options_display_noty_icon", "113px", "21px", "13px", "8px");
	this.OptionsDisplayNotyBtn.SetFgImage(g_Image.OPTIONS_ARROW_DOWN);
	this.OptionsDisplayNotyBtn.SetOnClickCallbackFunc(clickCF);
 
	this.DefaultHelpBar = new HelpBar(HelpBarIndex.OPTIONS_GENERAL_SETTINGS,"Options");
    this.DefaultHelpBar.SetOnClickCallbackFunc(1, function(){this_.processReturnKey();});
     
    this.SaveHelpBar = new HelpBar(HelpBarIndex.OPTIONS_GENERAL_SETTINGS_SAVE,"Options");
    this.SaveHelpBar.SetOnClickCallbackFunc(1, function(){this_.processBlueKey();});
    this.SaveHelpBar.SetOnClickCallbackFunc(2, function(){this_.processReturnKey();});
    
	this.OptionsAutoStartBtn.registHelpBar(this.DefaultHelpBar);
	this.OptionsDisplayNotyBtn.registHelpBar(this.DefaultHelpBar);

    this.flagCreate = true;
}


SceneOptionsGeneralSettings.prototype.setInitFlag = function(initFlag)
{
    this.isInit = initFlag;
}

SceneOptionsGeneralSettings.prototype.changeToDefaultHelpBar= function()
{
     if(this.flagCreate == false)
    {
        return;
    }
    alert("SceneOptionsGeneralSettings.changeToDefaultHelpBar()");
	this.OptionsAutoStartBtn.changeHelpBar(this.DefaultHelpBar);
	this.OptionsDisplayNotyBtn.changeHelpBar(this.DefaultHelpBar);
}

SceneOptionsGeneralSettings.prototype.changeToSaveHelpBar= function()
{
	
     if(this.flagCreate == false)
    {
        return;
    }
    
	alert("SceneOptionsGeneralSettings.changeToSaveHelpBar()");
    this.OptionsAutoStartBtn.changeHelpBar(this.SaveHelpBar);
	this.OptionsDisplayNotyBtn.changeHelpBar(this.SaveHelpBar);
}


SceneOptionsGeneralSettings.prototype.highlight = function(obj)
{
    alert("SceneOptionsGeneralSettings.highlight()");
    this.OptionsGeneralSettingsView.setCurrenHighlight(obj);
}

SceneOptionsGeneralSettings.prototype.processBlueKey = function()
{
    alert("SceneOptionsGeneralSettings.processBlueKey() ");
 
    OptionsMgr.SaveOptions();
}

SceneOptionsGeneralSettings.prototype.processUpDownKey = function()
{
    alert("SceneOptionsGeneralSettings.processUpDownKey()");
    var currentHighlight = this.OptionsGeneralSettingsView.getCurrentHighlight();
	
	switch(currentHighlight)
	{
		case this.OptionsAutoStartBtn:
			this.highlight(this.OptionsDisplayNotyBtn);
			break;
		
		case this.OptionsDisplayNotyBtn:
			if(this.flagEnable==true)
			{
				this.highlight(this.OptionsAutoStartBtn);	
			}			
			break;
	} 
}

SceneOptionsGeneralSettings.prototype.processRightKey = function()
{
    alert("SceneOptionsGeneralSettings.processRightKey()");
    this.startSelector();
}

SceneOptionsGeneralSettings.prototype.processEnterKey = function()
{
    alert("SceneOptionsGeneralSettings.processEnterKey()");
    this.startSelector();	
}

SceneOptionsGeneralSettings.prototype.startSelector = function()
{
    alert("SceneOptionsGeneralSettings.startSelector()");
    var scene = $.sfScene.get("OptionsGeneralSettings");
	var currentHighlight = this.OptionsGeneralSettingsView.getCurrentHighlight();
	switch(currentHighlight)
	{
		case this.OptionsAutoStartBtn:
			WndMgr.StartSelectorOnOff(this.OptionsAutoStartBtn, this.sceneId, scene.setAutoStart, this.OptionsAutoStartBtn.GetText());
			this.flagSubList = true;
			break;
		
		case this.OptionsDisplayNotyBtn:
			WndMgr.StartSelectorOnOff(this.OptionsDisplayNotyBtn, this.sceneId, scene.setDisplayNoty, this.OptionsDisplayNotyBtn.GetText());
			this.flagSubList = true;
			break;
	} 
}

SceneOptionsGeneralSettings.prototype.setAutoStart = function(value)
{
    alert("SceneOptionsGeneralSettings.setAutoStart(): " + value);
    OptionsMgr.setAutoStart(value);
}

SceneOptionsGeneralSettings.prototype.setDisplayNoty= function(value)
{
    alert("SceneOptionsGeneralSettings.setDisplayNoty(): " + value);
    OptionsMgr.setDisplayNoty(value);
}

SceneOptionsGeneralSettings.prototype.exit = function()
{
    alert("SceneOptionsGeneralSettings.exit()");
    WndMgr.ReturnOptionsSubToMain();
    this.highlight(null);
}

SceneOptionsGeneralSettings.prototype.processReturnKey = function()
{
    alert("SceneOptionsGeneralSettings.processReturnKey()");
    this.exit();
}

SceneOptionsGeneralSettings.prototype.processExitKey = function()
{
    alert("SceneOptionsGeneralSettings.processExitKey()");
        
     if(OptionsMgr.flagChange == true)
    {
        WndMgr.StartOptionsSaveReturnStep();
     }
     else
     {
        StateMgr.Stop_Options_State(true); 
     }
}

SceneOptionsGeneralSettings.prototype.processLeftKey = function()
{
    alert("SceneOptionsGeneralSettings.processLeftKey()");
    this.exit();
}

/**
 * Initializes the value of options presented to user.
 */
SceneOptionsGeneralSettings.prototype.initOptions = function()
{
    alert("SceneOptionsGeneralSettings.initOptions");
    this.OptionsAutoStartBtn.SetText(OptionsMgr.getAutoStart());
	
	 if(PluginAPIMgr.IsDefaultAccountAvailable() ==1) // auto login
	 {
	 	this.OptionsAutoStartBtn.SetFlagDim(false);
		this.OptionsAutoStartBtn.SetFgImage(g_Image.OPTIONS_ARROW_DOWN);
		this.flagEnable = true;
	 }
	 else
	 {
	 	this.OptionsAutoStartBtn.SetFlagDim(true);
		this.OptionsAutoStartBtn.SetFgImage(g_Image.OPTIONS_ARROW_DOWN_DIM);
		this.flagEnable = false;
	 }
	 
	 this.OptionsDisplayNotyBtn.SetText(OptionsMgr.getDisplayNoty());
    
    if(OptionsMgr.flagChange == true)
    {
        this.changeToSaveHelpBar();
    }
    else
    {
        this.changeToDefaultHelpBar();
    }
    
	this.highlight(null);
    this.isInit = false;
}

SceneOptionsGeneralSettings.prototype.processClickEvent = function(obj){
	alert("SceneOptionsGeneralSettings.processClickEvent() ");
	OptionsMgr.resetTimer();
	
	var currentHighlight =  this.OptionsGeneralSettingsView.getCurrentHighlight();
    if(currentHighlight != obj)
    {
    	this.highlight(obj);
    }
    
    if($.sfScene.get('Options').flag_Focus==true)
	{   
		$.sfScene.get('Options').moveToSub();
	}

    this.processEnterKey();
}
