/**
 * @author Samsung
 */

function SceneOptionsPrivacySettings(options)
{
    this.options = options;

    this.OptionsPrivacySettingsView = null;
	
    this.AllowCallLabel = null;
	this.AllowCallBtn = null;
	
	//this.AllowChatLabel = null;
	//this.AllowChatBtn = null;
    
    this.sceneId = "OptionsPrivacySettings";
    this.content = null;
    this.callAllowPolicy = null;
    this.isOptionsRead = true;
    
    this.DefaultHelpBar = null;
    this.SaveHelpBar = null;
    
    this.flagCreate = false;
	this.flagSubList = false;
    this.isInit = true;
}

SceneOptionsPrivacySettings.prototype.initialize = function ()
{
	alert("SceneOptionsPrivacySettings.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
   this.create();
}

SceneOptionsPrivacySettings.prototype.handleShow = function ()
{
	alert("SceneOptionsPrivacySettings.handleShow()");
    if(this.isInit == true)
    {
        this.initOptions();
   }
	// this function will be called when the scene manager show this scene 
}

SceneOptionsPrivacySettings.prototype.handleHide = function ()
{
	alert("SceneOptionsPrivacySettings.handleHide()");
	// this function will be called when the scene manager hide this scene  

	if(this.flagSubList){
		WndMgr.StopOptionSelector();
		this.flagSubList = false;
	}

}

SceneOptionsPrivacySettings.prototype.handleFocus = function ()
{
	alert("SceneOptionsPrivacySettings.handleFocus()");
	// this function will be called when the scene manager focus this scene
	var currentHighlight =  this.OptionsPrivacySettingsView.getCurrentHighlight();
	if(currentHighlight==null)
	{
		this.highlight(this.AllowCallBtn);
	}
	else
	{
		this.highlight(currentHighlight);
	}
    
	this.flagSubList = false;
}

SceneOptionsPrivacySettings.prototype.handleBlur = function ()
{
	alert("SceneOptionsPrivacySettings.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
     var currentHighlight =  this.OptionsPrivacySettingsView.getCurrentHighlight();
     currentHighlight.blur();
}

SceneOptionsPrivacySettings.prototype.handleKeyDown = function (keyCode)
{
	alert("SceneOptionsPrivacySettings.handleKeyDown(" + keyCode + ")");
    // TODO : write an key event handler when this scene get focued
    PluginAPIMgr.PlayAudio(keyCode);
    switch (keyCode) {
        case $.sfKey.LEFT:
			OptionsMgr.resetTimer();
            this.processLeftKey();
            break;

        case $.sfKey.RIGHT:
            //this.processRightKey();
            break;

        case $.sfKey.UP:
        case $.sfKey.DOWN:
			OptionsMgr.resetTimer();
            //this.processUpDownKey();
            break;

        case $.sfKey.BLUE:
            this.processBlueKey();
            break;

        case $.sfKey.ENTER:
			OptionsMgr.resetTimer();
            this.processEnterKey();
            break;

        case $.sfKey.RETURN:
			OptionsMgr.resetTimer();
            this.processReturnKey();
            $.sfKey.block(event);
            break;
        case $.sfKey.EXIT:
        	this.processExitKey();
			$.sfKey.block(event);
			break;
		
        case 147:  //infolink
        case 261:  //contents
        case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
    }
}

/////////////////////////////////////////////////////////////////////////////
SceneOptionsPrivacySettings.prototype.create = function()
{
    alert("SceneOptionsPrivacySettings.create()");

    this.OptionsPrivacySettingsView = new View(this.sceneId);
    
    this.AllowCallLabel = new Label(null, "options_allow_call_label");
    this.AllowCallLabel.SetTextStyle("options_allow_call_label_style");
    this.AllowCallLabel.SetText(IDWS_MOIP_SETUP_CALL_OPTIONS+" :");
    
    var this_ = $.sfScene.get("OptionsPrivacySettings");
	var clickCF =  function(obj){this_.processClickEvent(obj);};

    this.AllowCallBtn = new Button();
    this.AllowCallBtn.SetImageObjId("options_allow_call_btn");
    this.AllowCallBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.OPTIONS_ALLOW_CALL);
    this.AllowCallBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.OPTIONS_ALLOW_CALL_HIGHLIGHT);
    this.AllowCallBtn.SetTextObjId("options_allow_call_txt");
    this.AllowCallBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "options_label_style_17");
	this.AllowCallBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "options_label_style_17");
	this.AllowCallBtn.AppendFgImage("options_allow_call_icon", "423px", "21px", "13px", "8px");
	this.AllowCallBtn.SetFgImage(g_Image.OPTIONS_ARROW_DOWN);
	this.AllowCallBtn.SetOnClickCallbackFunc(clickCF);
	
	/*this.AllowChatLabel = new Label(null, "options_allow_chat_label");
    this.AllowChatLabel.SetTextStyle("options_allow_call_label_style");
    this.AllowChatLabel.SetText(TV_SID_ALLOW_IMS_FROM+" :");

    this.AllowChatBtn = new Button();
    this.AllowChatBtn.SetImageObjId("options_allow_chat_btn");
    this.AllowChatBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.OPTIONS_ALLOW_CALL);
    this.AllowChatBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.OPTIONS_ALLOW_CALL_HIGHLIGHT);
    this.AllowChatBtn.SetTextObjId("options_allow_chat_txt");
    this.AllowChatBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "options_label_style_17");
	this.AllowChatBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "options_label_style_17");
	this.AllowChatBtn.AppendFgImage("options_allow_chat_icon", "423px", "21px", "13px", "8px");
	this.AllowChatBtn.SetFgImage(g_Image.OPTIONS_ARROW_DOWN);
	this.AllowChatBtn.SetOnClickCallbackFunc(clickCF);*/

    this.DefaultHelpBar = new HelpBar(HelpBarIndex.OPTIONS_PRIVACY_SETTINGS,"Options");
    this.DefaultHelpBar.SetOnClickCallbackFunc(1, function(){this_.processReturnKey();});
    
    this.SaveHelpBar = new HelpBar(HelpBarIndex.OPTIONS_PRIVACY_SETTINGS_SAVE,"Options");
    this.SaveHelpBar.SetOnClickCallbackFunc(1, function(){this_.processBlueKey();});
    this.SaveHelpBar.SetOnClickCallbackFunc(2, function(){this_.processReturnKey();});
    
	this.AllowCallBtn.registHelpBar(this.DefaultHelpBar);
	//this.AllowChatBtn.registHelpBar(this.DefaultHelpBar);

    //this.initOptions();

    this.content = [IDWS_MOIP_SETTING_ANYONE, TV_SID_PEOPLE_IN_MY_CONTACT_LIST_ONLY];
    
    this.flagCreate = true;
}

SceneOptionsPrivacySettings.prototype.setInitFlag = function(initFlag)
{
    this.isInit = initFlag;
}

SceneOptionsPrivacySettings.prototype.changeToDefaultHelpBar= function()
{
     if(this.flagCreate == false)
    {
        return;
    }
    
	this.AllowCallBtn.changeHelpBar(this.DefaultHelpBar);
	//this.AllowChatBtn.changeHelpBar(this.DefaultHelpBar);
}

SceneOptionsPrivacySettings.prototype.changeToSaveHelpBar= function()
{
    if(this.flagCreate == false)
    {
        return;
    }
    
    this.AllowCallBtn.changeHelpBar(this.SaveHelpBar);
	//this.AllowChatBtn.changeHelpBar(this.SaveHelpBar);
}

SceneOptionsPrivacySettings.prototype.highlight=function(obj)
{
    alert("SceneOptionsPrivacySettings.highlight()");
    this.OptionsPrivacySettingsView.setCurrenHighlight(obj);
}
/*
SceneOptionsPrivacySettings.prototype.processUpDownKey = function()
{
    alert("SceneOptionsPrivacySettings.processUpDownKey() ");	
	var currentHighlight = this.OptionsPrivacySettingsView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.AllowCallBtn:
            this.highlight(this.AllowChatBtn);
            break;
            
        case this.AllowChatBtn:
            this.highlight(this.AllowCallBtn);
            break;
    }
}
*/

SceneOptionsPrivacySettings.prototype.processEnterKey = function()
{
    alert("SceneOptionsPrivacySettings.processEnterKey()");
    this.startSelector();    
}

SceneOptionsPrivacySettings.prototype.exit = function()
{
    alert("SceneOptionsPrivacySettings.exit() ");
    WndMgr.ReturnOptionsSubToMain();
    this.highlight(null);
}

SceneOptionsPrivacySettings.prototype.processReturnKey = function()
{
    alert("SceneOptionsPrivacySettings.processReturnKey()");
    this.exit();
}

SceneOptionsPrivacySettings.prototype.processExitKey = function()
{
    alert("SceneOptionsPrivacySettings.processExitKey()");
        
     if(OptionsMgr.flagChange == true)
    {
        WndMgr.StartOptionsSaveReturnStep();
     }
     else
     {
        StateMgr.Stop_Options_State(true); 
     }
}

SceneOptionsPrivacySettings.prototype.processLeftKey = function()
{
    alert("SceneOptionsPrivacySettings.processLeftKey()");
    this.exit();
}

SceneOptionsPrivacySettings.prototype.startSelector = function()
{
    alert("SceneOptionsPrivacySettings.startSelector()");
	var currentHighlight = this.OptionsPrivacySettingsView.getCurrentHighlight();
	switch(currentHighlight)
    {
	   	case this.AllowCallBtn:
            WndMgr.StartSelectorAllowCall(this.content, this.AllowCallBtn, this.sceneId, this.setAllowCall, this.AllowCallBtn.GetText());
            this.flagSubList = true;	
			break;
            
        /*case this.AllowChatBtn:
             WndMgr.StartSelectorAllowCall(this.content, this.AllowChatBtn, this.sceneId, this.setAllowChat, this.AllowChatBtn.GetText());
  			 this.flagSubList = true;
			 break;*/
  	}
}

SceneOptionsPrivacySettings.prototype.setAllowCall = function(value)
{
    alert("SceneOptionsPrivacySettings.saveAllowCall():" + value);
    OptionsMgr.setCallAllowPolicy(value);
}
/*
SceneOptionsPrivacySettings.prototype.setAllowChat = function(value)
{
    alert("SceneOptionsPrivacySettings.setAllowChat():" + value);
    OptionsMgr.setChatAllowPolicy(value);
}*/

SceneOptionsPrivacySettings.prototype.processBlueKey = function()
{
    alert("SceneOptionsPrivacySettings.processBlueKey()");
    //this.saveOptions();
    OptionsMgr.SaveOptions();
}
/*
SceneOptionsPrivacySettings.prototype.saveOptions = function()
{
    alert("SceneOptionsPrivacySettings.saveOptions()");
	if(OptionsMgr.savePrivacySettings())
		WndMgr.StartOptionsCommittingMsg(this.sceneId);
}
*/
/**
 * Initializes the value of options presented to user.
 */
SceneOptionsPrivacySettings.prototype.initOptions = function()
{
    alert("SceneOptionsPrivacySettings.initOptions");
    this.AllowCallBtn.SetText(OptionsMgr.getCallAllowPolicy());
	//this.AllowChatBtn.SetText(OptionsMgr.getChatAllowPolicy());
    
     if(OptionsMgr.flagChange == true)
    {
        this.changeToSaveHelpBar();
    }
    else
    {
        this.changeToDefaultHelpBar();
    }
	
    this.highlight(null);
    this.isInit = false;
}

SceneOptionsPrivacySettings.prototype.processClickEvent = function(obj){
	alert("SceneOptionsPrivacySettings.processClickEvent() ");
	OptionsMgr.resetTimer();
	
	var currentHighlight =  this.OptionsPrivacySettingsView.getCurrentHighlight();
    if(currentHighlight != obj)
    {
    	this.highlight(obj);
    }
    
    if($.sfScene.get('Options').flag_Focus==true)
	{   
		$.sfScene.get('Options').moveToSub();
	}

    this.processEnterKey();
}
