function SceneOptionsSelectorAllowCall(options)
{
	this.options = options;	
    // Position of the selector
    this.posTop = 0;
    this.posLeft = 0;
    // Selector list created within the caller scene
    this.Selector = null;
    // Array with the content for selector list
    this.content = null;
    // Caller object which should be provided with the result
    this.callerObj = null;
    //The current scene id
    this.sceneId = "OptionsSelectorAllowCall";
    this.curValue = null;
    this.cbFunc = null;
	
	this.Helpbar = null;
}

SceneOptionsSelectorAllowCall.prototype.initialize = function ()
{
	alert("SceneOptionsSelectorAllowCall.initialize()");	
	this.create();
}

SceneOptionsSelectorAllowCall.prototype.handleShow = function ()
{
	alert("SceneOptionsSelectorAllowCall.handleShow()");

	$("#"+ this.Selector.GetBGLayer().Obj).css('top', this.posTop);	
	$("#"+ this.Selector.GetBGLayer().Obj).css('left', this.posLeft);	
	
    this.initSelector();
	this.Selector.Show();
}

SceneOptionsSelectorAllowCall.prototype.handleHide = function ()
{
	alert("SceneOptionsSelectorAllowCall.handleHide()");
    this.Selector.Hide();
}

SceneOptionsSelectorAllowCall.prototype.handleFocus = function ()
{
	alert("SceneOptionsSelectorAllowCall.handleFocus()");
    this.Selector.SetHighlightForDataIndex(this.getIndex(this.curValue));
	this.Helpbar.visibleObj();
}

SceneOptionsSelectorAllowCall.prototype.handleBlur = function ()
{
	alert("SceneOptionsSelectorAllowCall.handleBlur()");
	this.Selector.blur();
	this.Helpbar.hiddenObj();
}

SceneOptionsSelectorAllowCall.prototype.handleKeyDown = function (keyCode)
{
	alert("SceneOptionsSelectorAllowCall.handleKeyDown(" + keyCode + ")");
	PluginAPIMgr.PlayAudio(keyCode);
    switch(keyCode){
        case $.sfKey.ENTER:
			OptionsMgr.resetTimer();
            this.ProcessKeyEnter();			
            break;			

        case $.sfKey.RETURN:
            alert("KEY_RETURN");
			OptionsMgr.resetTimer();
            this.ProcessKeyReturn();
            $.sfKey.block(event);			
            break;
            
          case $.sfKey.EXIT:
			$.sfKey.block(event);
			break;
		
        case 147:  //infolink
        case 261:  //contents
        case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;

        default :
			if(keyCode == $.sfKey.DOWN || keyCode==$.sfKey.UP)
			{
				OptionsMgr.resetTimer();
			}
			
            this.Selector.KeyProcess(keyCode);	
            break;	
    }
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////
SceneOptionsSelectorAllowCall.prototype.create = function()
{
    alert("SceneOptionsSelectorAllowCall.create() ");

	this.Selector = new List();
	this.Selector.CreateBG("OptionsSelectorAllowCall");
	this.Selector.SetBGImage(g_Image.SELECTOR_ALLOW_CALL_BG);	
	this.Selector.SetNumOfVisibleItem(2);
    this.Selector.SetStartDataIndex(0);
	this.Selector.SetItemBgImage(ITEM_STATE.NORMAL," ");
	this.Selector.SetItemBgImage(ITEM_STATE.HIGHLIGHT, g_Image.SELECTOR_ALLOW_CALL_ITEM_HIGHLIGHT);
	this.Selector.SetItemDefualtTextStyle(ITEM_STATE.NORMAL,"cOptionsSelectorItem_Text_Normal");
	this.Selector.SetItemDefualtTextStyle(ITEM_STATE.HIGHLIGHT,"cOptionsSelectorItem_Text_Highlight");
	this.Selector.SetDataType(ITEM_DATA_TYPE.TEXT_ONLY);
	
	this.Selector.SetEventOnReturnFunc(this.ProcessKeyReturn);
	this.Selector.SetItemPressedEventCallback(this.ProcessKeyEnter);
	
	var this_ = $.sfScene.get("OptionsSelectorAllowCall");
	this.Helpbar = new HelpBar(HelpBarIndex.OPTIONS_SELECTOR_ALLOW_CALL,"OptionsSelectorAllowCallList");
	this.Helpbar.SetOnClickCallbackFunc(1, function(){this_.ProcessKeyReturn();});
}

SceneOptionsSelectorAllowCall.prototype.start = function(content, callerObj, cbFunc, curValue)
{
    alert("SceneOptionsSelectorAllowCall.start()");
	var scene = $.sfScene.get("OptionsSelectorAllowCall");
    scene.callerObj = callerObj;
    this.posTop = (parseInt($("#"+ callerObj.GetBGLayer().Obj).css('top').replace("px", "")) + 45) + "px";	
    this.posLeft = (parseInt($("#"+ callerObj.GetBGLayer().Obj).css('left')) + 4+270) + "px";	
    this.content = content; 
    this.curValue = curValue;
    this.cbFunc = cbFunc;
}

SceneOptionsSelectorAllowCall.prototype.getIndex = function(value)
{
	alert("SceneOptionsSelectorAllowCall.getIndex()");
    for(var i = 0; i < this.content.length; i++)
        if(value === this.content[i])
            return i;
    return 0;
}

SceneOptionsSelectorAllowCall.prototype.ProcessKeyReturn = function()
{
	alert("SceneOptionsSelectorAllowCall.ProcessKeyReturn()");
    WndMgr.StopSelectorAllowCall();
}

SceneOptionsSelectorAllowCall.prototype.ProcessKeyEnter = function()
{
	alert("SceneOptionsSelectorAllowCall.ProcessKeyEnter()");
	var scene = $.sfScene.get("OptionsSelectorAllowCall");
	var index = scene.Selector.GetCurrentItem();
    scene.callerObj.SetText(scene.content[index]);
    if(scene.cbFunc)
    {
        scene.cbFunc(scene.content[index]);
        alert("Call callback function");
    }
    WndMgr.StopSelectorAllowCall();
}

SceneOptionsSelectorAllowCall.prototype.initSelector = function()
{
	alert("SceneOptionsSelectorAllowCall.initSelector()");
    for(var i = 0; i < this.content.length; i++)
    {
    	this.Selector.AddData([this.content[i], null]);
    }

	this.Selector.SetOnClickCallbackFunc(0,this.onClickEventFunc1);
	this.Selector.SetOnClickCallbackFunc(1,this.onClickEventFunc2);
	this.Selector.SetClickEventAvailable(WndMgr.MouseClickEnable);
    
    this.Selector.ShowItem();
}

SceneOptionsSelectorAllowCall.prototype.onClickEventFunc1 = function(){
	
	var This_ = $.sfScene.get("OptionsSelectorAllowCall");	
	This_.ProcessCallback(0);
}

SceneOptionsSelectorAllowCall.prototype.onClickEventFunc2 = function(){

	var This_ = $.sfScene.get("OptionsSelectorAllowCall");	
	This_.ProcessCallback(1);
}

SceneOptionsSelectorAllowCall.prototype.ProcessCallback = function(Index)
{
	alert("SceneOptionsSelectorAllowCall.ProcessCallback()");
	
    this.callerObj.SetText(this.content[Index]);
    
    if(this.cbFunc)
    {
        this.cbFunc(this.content[Index]);
    }
    
    WndMgr.StopSelectorAllowCall();
}


