function SceneOptionsSelectorOnOff(options)
{
	this.options = options;	
    // Position of the selector
    this.posTop;
    this.posLeft;
    // Selector list created within the caller scene
    this.Selector = null;
    // Array with the content for selector list
    // todo describe the allowed content of the array
    this.content = null;
    // Caller object which should be provided with the result
    this.callerObj = null;
    //The current scene id
    this.sceneId = "OptionsSelectorOnOff";
    this.cbFunc = null;
    this.curValue = null;
	
	this.Helpbar = null;
}

SceneOptionsSelectorOnOff.prototype.initialize = function ()
{
	alert("SceneOptionsSelectorOnOff.initialize()");	
	this.create();
}

SceneOptionsSelectorOnOff.prototype.handleShow = function ()
{
	alert("SceneOptionsSelectorOnOff.handleShow()");

	$("#"+ this.Selector.GetBGLayer().Obj).css('top', this.posTop);	
	$("#"+ this.Selector.GetBGLayer().Obj).css('left', this.posLeft);	
	this.Selector.Show();
}

SceneOptionsSelectorOnOff.prototype.handleHide = function ()
{
	alert("SceneOptionsSelectorOnOff.handleHide()");
    this.Selector.Hide();
}

SceneOptionsSelectorOnOff.prototype.handleFocus = function ()
{
	alert("SceneOptionsSelectorOnOff.handleFocus()");
    this.Selector.SetHighlightForDataIndex(this.getIndex(this.curValue));
	this.Helpbar.visibleObj();
}

SceneOptionsSelectorOnOff.prototype.handleBlur = function ()
{
	alert("SceneOptionsSelectorOnOff.handleBlur()");
	this.Selector.blur();
	this.Helpbar.hiddenObj();
}

SceneOptionsSelectorOnOff.prototype.handleKeyDown = function (keyCode)
{
	alert("SceneOptionsSelectorOnOff.handleKeyDown(" + keyCode + ")");
	PluginAPIMgr.PlayAudio(keyCode);
    switch(keyCode){
        case $.sfKey.ENTER:
			OptionsMgr.resetTimer();
            this.ProcessKeyEnter();			
            break;			

        case $.sfKey.RETURN:
            alert("KEY_RETURN");
			OptionsMgr.resetTimer();
            this.ProcessKeyReturn();
            $.sfKey.block(event);			
            break;
            
        case $.sfKey.EXIT:
			$.sfKey.block(event);
			break;
		
        case 147:  //infolink
        case 261:  //contents
        case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;

        default :
			if(keyCode == $.sfKey.DOWN || keyCode==$.sfKey.UP)
			{
				OptionsMgr.resetTimer();
			}
			
            this.Selector.KeyProcess(keyCode);	
            break;	
    }
    
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////
SceneOptionsSelectorOnOff.prototype.create = function()
{
    alert("SceneOptionsSelectorOnOff.create() ");

	this.Selector = new List();
	this.Selector.CreateBG("OptionsSelectorOnOff");
	this.Selector.SetBGImage(g_Image.SELECTOR_BG);	
	this.Selector.SetNumOfVisibleItem(2);
    this.Selector.SetStartDataIndex(0);
	this.Selector.SetItemBgImage(ITEM_STATE.NORMAL," ");
	this.Selector.SetItemBgImage(ITEM_STATE.HIGHLIGHT, g_Image.SELECTOR_ITEM_HIGHLIGHT);	
	this.Selector.SetItemDefualtTextStyle(ITEM_STATE.NORMAL,"cOptionsSelectorItem_Text_Normal");
	this.Selector.SetItemDefualtTextStyle(ITEM_STATE.HIGHLIGHT,"cOptionsSelectorItem_Text_Highlight");
	this.Selector.SetDataType(ITEM_DATA_TYPE.TEXT_ONLY);
	this.Selector.SetEventOnReturnFunc(this.ProcessKeyReturn);
	this.Selector.SetItemPressedEventCallback(this.ProcessKeyEnter);
    this.initSelector();

	var this_ = $.sfScene.get("OptionsSelectorOnOff");
    this.Helpbar = new HelpBar(HelpBarIndex.OPTIONS_SELECTOR_ON_OFF,"OptionsSelectorList");
    this.Helpbar.SetOnClickCallbackFunc(1, function(){this_.ProcessKeyReturn();});
    
}

SceneOptionsSelectorOnOff.prototype.start = function(callerObj, cbFunc, curValue)
{
    alert("SceneOptionsSelectorOnOff.start()");
	var scene = $.sfScene.get("OptionsSelectorOnOff");
    scene.callerObj = callerObj;
    this.posTop = $("#"+ callerObj.GetBGLayer().Obj).css('top');	
    this.posLeft = $("#"+ callerObj.GetBGLayer().Obj).css('left');	
    //Adjust position
    this.posTop = (parseInt(this.posTop.replace("px","")) + 45) + "px";
    this.posLeft = (parseInt(this.posLeft.replace("px","")) + 6+270) + "px";
    this.content = [SID_OFF, SID_ON];
    this.cbFunc = cbFunc;
    this.curValue = curValue;
}

SceneOptionsSelectorOnOff.prototype.getIndex = function(value)
{
	alert("SceneOptionsSelectorOnOff.getIndex()");
    for(var i = 0; i < this.content.length; i++)
        if(value === this.content[i])
            return i;
    return 0;
}

SceneOptionsSelectorOnOff.prototype.ProcessKeyReturn = function()
{
	alert("SceneOptionsSelectorOnOff.ProcessKeyReturn()");
    WndMgr.StopSelectorOnOff();
}

SceneOptionsSelectorOnOff.prototype.ProcessKeyEnter = function()
{
	alert("SceneOptionsSelectorOnOff.ProcessKeyEnter()");
	var scene = $.sfScene.get("OptionsSelectorOnOff");
	var index = scene.Selector.GetCurrentItem();
    scene.callerObj.SetText(scene.content[index]);
    if(scene.cbFunc)
    {
        scene.cbFunc(scene.content[index]);
        alert("Call callback function");
    }
    WndMgr.StopSelectorOnOff();
}

SceneOptionsSelectorOnOff.prototype.initSelector = function()
{
	alert("SceneOptionsSelectorOnOff.initSelector()");
    
    for(var i = 0; i < this.content.length; i++)
    {
    	this.Selector.AddData([this.content[i], null]);
    }
       
    //check
	this.Selector.SetOnClickCallbackFunc(0,this.onClickEventFunc1);
	this.Selector.SetOnClickCallbackFunc(1,this.onClickEventFunc2);
	this.Selector.SetClickEventAvailable(WndMgr.MouseClickEnable);
        
    this.Selector.ShowItem();
}

SceneOptionsSelectorOnOff.prototype.onClickEventFunc1 = function(){
	
	var This_ = $.sfScene.get("OptionsSelectorOnOff");	
	This_.ProcessCallback(0);
}

SceneOptionsSelectorOnOff.prototype.onClickEventFunc2 = function(){

	var This_ = $.sfScene.get("OptionsSelectorOnOff");	
	This_.ProcessCallback(1);
}

SceneOptionsSelectorOnOff.prototype.ProcessCallback = function(Index)
{
	alert("SceneOptionsSelectorOnOff.ProcessKeyEnter()");
	
	var scene = $.sfScene.get("OptionsSelectorOnOff");
    scene.callerObj.SetText(scene.content[Index]);
    
    if(scene.cbFunc)
    {
        scene.cbFunc(scene.content[Index]);
    }
    
    WndMgr.StopSelectorOnOff();
}
