function SceneOptionsSelectorVideoShow(options)
{
	this.options = options;	
    // Position of the selector
    this.posTop;
    this.posLeft;
    // Selector list created within the caller scene
    this.Selector = null;
    // Array with the content for selector list
    // todo describe the allowed content of the array
    this.content = null;
    // Caller object which should be provided with the result
    this.callerObj = null;
    //The current scene id
    this.sceneId = "OptionsSelectorVideoShow";
    this.curValue = null;
    this.cbFunc = null;
	
	this.Helpbar = null;
}

SceneOptionsSelectorVideoShow.prototype.initialize = function ()
{
	alert("SceneOptionsSelectorVideoShow.initialize()");	
	this.create();
}

SceneOptionsSelectorVideoShow.prototype.handleShow = function ()
{
	alert("SceneOptionsSelectorVideoShow.handleShow()");

	$("#"+ this.Selector.GetBGLayer().Obj).css('top', this.posTop);	
	$("#"+ this.Selector.GetBGLayer().Obj).css('left', this.posLeft);	
	this.initSelector() 
	this.Selector.Show();
}

SceneOptionsSelectorVideoShow.prototype.handleHide = function ()
{
	alert("SceneOptionsSelectorVideoShow.handleHide()");
    this.Selector.Hide();
}

SceneOptionsSelectorVideoShow.prototype.handleFocus = function ()
{
	alert("SceneOptionsSelectorVideoShow.handleFocus()");
    this.Selector.SetHighlightForDataIndex(this.getIndex(this.curValue));
	this.Helpbar.visibleObj();
}

SceneOptionsSelectorVideoShow.prototype.handleBlur = function ()
{
	alert("SceneOptionsSelectorVideoShow.handleBlur()");
	this.Selector.blur();
	this.Helpbar.hiddenObj();	
}

SceneOptionsSelectorVideoShow.prototype.handleKeyDown = function (keyCode)
{
	alert("SceneOptionsSelectorVideoShow.handleKeyDown(" + keyCode + ")");
	PluginAPIMgr.PlayAudio(keyCode);
    switch(keyCode)
    {
        case $.sfKey.ENTER:
			OptionsMgr.resetTimer();
            this.ProcessKeyEnter();			
            break;			

        case $.sfKey.RETURN:
            alert("KEY_RETURN");
			OptionsMgr.resetTimer();
            this.ProcessKeyReturn();
            $.sfKey.block(event);			
            break;
            
          case $.sfKey.EXIT:
			$.sfKey.block(event);
			break;
		
        case 147:  //infolink
        case 261:  //contents
        case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;

        default :
			if(keyCode == $.sfKey.DOWN || keyCode==$.sfKey.UP)
			{
				OptionsMgr.resetTimer();
			}
            this.Selector.KeyProcess(keyCode);	
            break;	
    }
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////
SceneOptionsSelectorVideoShow.prototype.create = function()
{
    alert("SceneOptionsSelectorVideoShow.create() ");

	this.Selector = new List();
	this.Selector.CreateBG("OptionsSelectorVideoShow");
	this.Selector.SetBGImage(g_Image.SELECTOR_VIDEO_SHOW_BG);	
	this.Selector.SetNumOfVisibleItem(2);
    this.Selector.SetStartDataIndex(0);
	this.Selector.SetItemBgImage(ITEM_STATE.NORMAL," ");
	this.Selector.SetItemBgImage(ITEM_STATE.HIGHLIGHT, g_Image.SELECTOR_VIDEO_ITEM_HIGHLIGHT);
	this.Selector.SetItemDefualtTextStyle(ITEM_STATE.NORMAL,"cOptionsSelectorItem_Text_Normal");
	this.Selector.SetItemDefualtTextStyle(ITEM_STATE.HIGHLIGHT,"cOptionsSelectorItem_Text_Highlight");
	this.Selector.SetDataType(ITEM_DATA_TYPE.TEXT_ONLY);
	
	this.Selector.SetEventOnReturnFunc(this.ProcessKeyReturn);
	this.Selector.SetItemPressedEventCallback(this.ProcessKeyEnter);
	
	var this_ = $.sfScene.get("OptionsSelectorVideoShow");
	this.Helpbar = new HelpBar(HelpBarIndex.OPTIONS_SELECTOR_VIDEO_SHOW,"OptionsSelectorVideoShowList");
	this.Helpbar.SetOnClickCallbackFunc(1, function(){this_.ProcessKeyReturn();});
}

SceneOptionsSelectorVideoShow.prototype.start = function(content, callerObj, cbFunc, curValue)
{
    alert("SceneOptionsSelectorVideoShow.start()");
	var scene = $.sfScene.get("OptionsSelectorVideoShow");
    scene.callerObj = callerObj;
    this.posTop = (parseInt($("#"+ callerObj.GetBGLayer().Obj).css('top').replace("px", "")) + 45) + "px";	
    this.posLeft = (parseInt($("#"+ callerObj.GetBGLayer().Obj).css('left')) + 4+270) + "px";	
    this.content = content;
    this.curValue = curValue;
    this.cbFunc = cbFunc;
}

SceneOptionsSelectorVideoShow.prototype.getIndex = function(value)
{
	alert("SceneOptionsSelectorVideoShow.getIndex(" + value + ")");
    for(var i = 0; i < this.content.length; i++)
        if(value === this.content[i])
            return i;
    return 0;
}

SceneOptionsSelectorVideoShow.prototype.ProcessKeyReturn = function()
{
	alert("SceneOptionsSelectorVideoShow.ProcessKeyReturn() ");
    WndMgr.StopSelectorVideoShow();
}

SceneOptionsSelectorVideoShow.prototype.ProcessKeyEnter = function()
{
	alert("SceneOptionsSelectorVideoShow.ProcessKeyEnter() ");
	var scene = $.sfScene.get("OptionsSelectorVideoShow");
	var index = scene.Selector.GetCurrentItem();
    scene.callerObj.SetText(scene.content[index]);
    if(scene.cbFunc)
        scene.cbFunc(scene.content[index]);
    WndMgr.StopSelectorVideoShow();
}

SceneOptionsSelectorVideoShow.prototype.initSelector = function()
{
	alert("SceneOptionsSelectorVideoShow.initSelector()");
   
	this.Selector.DeleteDataAll();
    
    for(var i = 0; i < this.content.length; i++)
    {
    	this.Selector.AddData([this.content[i], null]);
    }
        
 	this.Selector.SetOnClickCallbackFunc(0,this.onClickEventFunc1);
	this.Selector.SetOnClickCallbackFunc(1,this.onClickEventFunc2);
	this.Selector.SetOnClickCallbackFunc(2,this.onClickEventFunc3);	
	this.Selector.SetClickEventAvailable(WndMgr.MouseClickEnable);          
        
        
    this.Selector.ShowItem();
}


SceneOptionsSelectorVideoShow.prototype.onClickEventFunc1 = function(){
	
	var This_ = $.sfScene.get("OptionsSelectorVideoShow");	
	This_.ProcessCallback(0);
}

SceneOptionsSelectorVideoShow.prototype.onClickEventFunc2 = function(){

	var This_ = $.sfScene.get("OptionsSelectorVideoShow");	
	This_.ProcessCallback(1);
}

SceneOptionsSelectorVideoShow.prototype.onClickEventFunc3 = function(){

	var This_ = $.sfScene.get("OptionsSelectorVideoShow");	
	This_.ProcessCallback(2);
}

SceneOptionsSelectorVideoShow.prototype.ProcessCallback = function(Index)
{
	alert("SceneOptionsSelectorVideo.ProcessCallback()");
	
    this.callerObj.SetText(this.content[Index]);
    
    if(this.cbFunc)
    {
        this.cbFunc(this.content[Index]);
    }
    
    WndMgr.StopSelectorVideoShow();
    
}
