/**
 * @author Samsung
 */
function SceneOptionsVideoSettings(options)
{
    this.options = options;

    this.OptionsVideoSettingsView = null;
	
	this.VideoFromLabel = null;
	this.VideoToLabel = null;
	this.AutoFocusLabel = null;
	this.VideoReceiveBtn = null;
	this.VideoAdvertBtn = null;
	this.AutoFocusBtn = null;
	
    this.contentReceive = null;
    this.contentAdvert = null;
  //  this.btnList = null;
   // this.curPos = 0;
    this.sceneId = "OptionsVideoSettings";
    this.videoAdvert = null; 
    
    this.DefaultHelpBar = null;
    this.SaveHelpBar = null;
    
    this.flagCreate = false;
	this.flagSubList = false;
    this.isInit = true;
}

SceneOptionsVideoSettings.prototype.initialize = function ()
{
	alert("SceneOptionsVideoSettings.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
    this.create();
}

SceneOptionsVideoSettings.prototype.handleShow = function ()
{
	// this function will be called when the scene manager show this scene 
	alert("SceneOptionsVideoSettings.handleShow()");
    //this.curPos = 0;
    if(this.isInit ==true)
    {
        this.initOptions();
    }
}

SceneOptionsVideoSettings.prototype.handleHide = function ()
{
	// this function will be called when the scene manager hide this scene  
	alert("SceneOptionsVideoSettings.handleHide()");
	if(this.flagSubList){
		WndMgr.StopOptionSelector();
		this.flagSubList = false;
	}	
}

SceneOptionsVideoSettings.prototype.handleFocus = function ()
{
	// this function will be called when the scene manager focus this scene
	alert("SceneOptionsVideoSettings.handleFocus()");
    //this.highlight(this.btnList[this.curPos]);
	var currentHighlight =  this.OptionsVideoSettingsView.getCurrentHighlight();
	if(currentHighlight==null)
	{
		this.highlight(this.VideoReceiveBtn);
	}
	else
	{
		this.highlight(currentHighlight);
	}
	
	this.flagSubList = false;
}

SceneOptionsVideoSettings.prototype.handleBlur = function ()
{
    // this function will be called when the scene manager move focus to another scene from this scene
    alert("SceneOptionsVideoSettings.handleBlur()");
    var currentHighlight =  this.OptionsVideoSettingsView.getCurrentHighlight();
    currentHighlight.blur();
}

SceneOptionsVideoSettings.prototype.handleKeyDown = function (keyCode)
{
	alert("SceneOptionsVideoSettings.handleKeyDown(" + keyCode + ")");
    // TODO : write an key event handler when this scene get focued
    PluginAPIMgr.PlayAudio(keyCode);
    switch (keyCode) {
        case $.sfKey.LEFT:
			OptionsMgr.resetTimer();
            this.processLeftKey();
            break;

        case $.sfKey.RIGHT:

            break;

        case $.sfKey.UP:
			OptionsMgr.resetTimer();
            this.processUpKey();
            break;

        case $.sfKey.DOWN:
			OptionsMgr.resetTimer();
            this.processDownKey();
            break;

        case $.sfKey.BLUE:
            this.processBlueKey();
            break;
            
        case $.sfKey.ENTER:
			OptionsMgr.resetTimer();
            this.processEnterKey();
            break;

        case $.sfKey.RETURN:
			OptionsMgr.resetTimer();
            this.processReturnKey();
            $.sfKey.block(event);
            break;
       case $.sfKey.EXIT:
       		this.processExitKey();
			$.sfKey.block(event);
			break;
		
        case 147:  //infolink
        case 261:  //contents
        case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
    }
}

/////////////////////////////////////////////////////////////////////////////
SceneOptionsVideoSettings.prototype.create = function()
{
    alert("SceneOptionsVideoSettings.create()");

    this.OptionsVideoSettingsView = new View(this.sceneId);
    
    this.VideoFromLabel = new Label(null, "options_video_from_settings_label");
    this.VideoFromLabel.SetTextStyle("options_video_settings_label_style");
    this.VideoFromLabel.SetText(TV_SID_AUTOMATICALLY_RECEIVE_VIDEO_FROM+" :");
    
    var this_ = $.sfScene.get("OptionsVideoSettings");
	var clickCF =  function(obj){this_.processClickEvent(obj);};

    this.VideoReceiveBtn = new Button();
    this.VideoReceiveBtn.SetImageObjId("options_video_from_settings_btn");
    this.VideoReceiveBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.OPTIONS_VIDEO_FROM);
    this.VideoReceiveBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.OPTIONS_VIDEO_FROM_HIGHLIGHT);
    //this.VideoReceiveBtn.SetBgImage(BtnImgIndex.BTN_FOCUS_IMG, g_Image.OPTIONS_AUTO_START_HIGHLIGHT);
    this.VideoReceiveBtn.SetTextObjId("options_video_from_settings_txt");
    this.VideoReceiveBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "options_label_style_17");
	this.VideoReceiveBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "options_label_style_17");
	this.VideoReceiveBtn.AppendFgImage("options_video_from_settings_icon", "423px", "21px", "13px", "8px");
	this.VideoReceiveBtn.SetFgImage(g_Image.OPTIONS_ARROW_DOWN);
	this.VideoReceiveBtn.SetOnClickCallbackFunc(clickCF);

    this.VideoToLabel = new Label(null, "options_video_to_settings_label");
    this.VideoToLabel.SetTextStyle("options_video_settings_label_style");
    this.VideoToLabel.SetText(IDWS_MOIP_SETTING_SHOW_VIDEO+" :");

    this.VideoAdvertBtn = new Button();
    this.VideoAdvertBtn.SetImageObjId("options_video_to_settings_btn");
    this.VideoAdvertBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.OPTIONS_VIDEO_FROM);
    this.VideoAdvertBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.OPTIONS_VIDEO_FROM_HIGHLIGHT);
    this.VideoAdvertBtn.SetTextObjId("options_video_to_settings_txt");
    this.VideoAdvertBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "options_label_style_17");
	this.VideoAdvertBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "options_label_style_17");
	this.VideoAdvertBtn.AppendFgImage("options_video_to_settings_icon", "423px", "21px", "13px", "8px");
	this.VideoAdvertBtn.SetFgImage(g_Image.OPTIONS_ARROW_DOWN);
	this.VideoAdvertBtn.SetOnClickCallbackFunc(clickCF);
	
	this.AutoFocusLabel = new Label(null, "options_auto_focus_label");
    this.AutoFocusLabel.SetTextStyle("options_auto_focus_label_style");
    //this.AutoFocusLabel.SetReverseDisable(true);
    if(ResMgr.isReverseLanguage())
    {
    	this.AutoFocusLabel.SetText(TV_SID_CAMERA_AUTO_FOCUS);
    }
    else
    {
    	this.AutoFocusLabel.SetText(TV_SID_CAMERA_AUTO_FOCUS+" :");
    }
    

    this.AutoFocusBtn = new Button();
    this.AutoFocusBtn.SetImageObjId("options_auto_focus_btn");
    this.AutoFocusBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.OPTIONS_AUTO_START);
    this.AutoFocusBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.OPTIONS_AUTO_START_HIGHLIGHT);
	this.AutoFocusBtn.SetTextObjId("options_auto_focus_txt");

	var CurLangID = ResMgr.GetCurLanguage();
 	if(CurLangID == ENUM_TV_LANGUAGE.ARA)
 	{
    	this.AutoFocusBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "options_label_style_16");
		this.AutoFocusBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "options_label_style_16");
   	}
   	else 
   	{
    	this.AutoFocusBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "options_label_style_17");
		this.AutoFocusBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "options_label_style_17"); 
   	} 
   	
	this.AutoFocusBtn.AppendFgImage("options_auto_focus_icon", "113px", "21px", "13px", "8px");
	this.AutoFocusBtn.SetFgImage(g_Image.OPTIONS_ARROW_DOWN);
	this.AutoFocusBtn.SetOnClickCallbackFunc(clickCF);

    this.DefaultHelpBar = new HelpBar(HelpBarIndex.OPTIONS_VIDEO_SETTINGS,"Options");
    this.DefaultHelpBar.SetOnClickCallbackFunc(1, function(){this_.processReturnKey();});
    
    this.SaveHelpBar = new HelpBar(HelpBarIndex.OPTIONS_VIDEO_SETTINGS_SAVE,"Options");
    this.SaveHelpBar.SetOnClickCallbackFunc(1, function(){this_.processBlueKey();});
    this.SaveHelpBar.SetOnClickCallbackFunc(2, function(){this_.processReturnKey();});
     
	this.VideoReceiveBtn.registHelpBar(this.DefaultHelpBar);
	this.VideoAdvertBtn.registHelpBar(this.DefaultHelpBar);
	this.AutoFocusBtn.registHelpBar(this.DefaultHelpBar);

   // this.initOptions();
    this.contentReceive = [IDWS_MOIP_SETTING_ANYONE, TV_SID_PEOPLE_IN_MY_CONTACT_LIST_ONLY, IDWS_MOIP_SETTING_NONE];
    this.contentAdvert = [TV_SID_PEOPLE_IN_MY_CONTACT_LIST_ONLY, IDWS_MOIP_SETTING_NONE]; 

    //alert(this.contentReceive); 
    //alert(this.contentAdvert); 

   /* this.btnList = new Array(3);
    this.btnList[0] = this.VideoReceiveBtn;
    this.btnList[1] = this.VideoAdvertBtn;
	this.btnList[2] = this.AutoFocusBtn;*/
    
    this.flagCreate = true;
}

SceneOptionsVideoSettings.prototype.setInitFlag = function(initFlag)
{
    this.isInit = initFlag;
}

SceneOptionsVideoSettings.prototype.changeToDefaultHelpBar= function()
{
     if(this.flagCreate == false)
    {
        return;
    }
    
	this.VideoReceiveBtn.changeHelpBar(this.DefaultHelpBar);
    this.VideoAdvertBtn.changeHelpBar(this.DefaultHelpBar);
	this.AutoFocusBtn.changeHelpBar(this.DefaultHelpBar);
}

SceneOptionsVideoSettings.prototype.changeToSaveHelpBar= function()
{
     if(this.flagCreate == false)
    {
        return;
    }
    
    this.VideoReceiveBtn.changeHelpBar(this.SaveHelpBar);
    this.VideoAdvertBtn.changeHelpBar(this.SaveHelpBar);
	this.AutoFocusBtn.changeHelpBar(this.SaveHelpBar);
}

SceneOptionsVideoSettings.prototype.highlight=function(obj)
{
    this.OptionsVideoSettingsView.setCurrenHighlight(obj);
}

SceneOptionsVideoSettings.prototype.processDownKey = function()
{
    alert("SceneOptionsVideoSettings.processDownKey() ");
    //this.gotoNext();
   	var currentHighlight = this.OptionsVideoSettingsView.getCurrentHighlight();   	
	
	switch(currentHighlight)
	{
		case this.VideoReceiveBtn:
			this.highlight(this.VideoAdvertBtn);
			break;
		
		case this.VideoAdvertBtn:
			if(OptionsMgr.isAutoFocusEnable==false)
			{
				this.highlight(this.VideoReceiveBtn);
			}
			else
			{
				this.highlight(this.AutoFocusBtn);
			}
				
			break;
			
		case this.AutoFocusBtn:
			this.highlight(this.VideoReceiveBtn);			
			break;
	} 
}

SceneOptionsVideoSettings.prototype.processUpKey = function()
{
    alert("SceneOptionsVideoSettings.processUpKey() ");
    
	//this.gotoPrev();
	var currentHighlight = this.OptionsVideoSettingsView.getCurrentHighlight();   	
	
	switch(currentHighlight)
	{
		case this.VideoReceiveBtn:
			if(OptionsMgr.isAutoFocusEnable==false)
			{
				this.highlight(this.VideoAdvertBtn);
			}
			else
			{
				this.highlight(this.AutoFocusBtn);
			}
			
			break;
		
		case this.VideoAdvertBtn:
			this.highlight(this.VideoReceiveBtn);	
			break;
			
		case this.AutoFocusBtn:
			this.highlight(this.VideoAdvertBtn);			
			break;
	}
}

SceneOptionsVideoSettings.prototype.processLeftKey = function()
{
    alert("SceneOptionsVideoSettings.processLeftKey() ");
    this.exit();
}
/*
SceneOptionsVideoSettings.prototype.processRightKey = function()
{
    alert("SceneOptionsVideoSettings.processRightKey() ");
    this.gotoNext();
}*/

SceneOptionsVideoSettings.prototype.processEnterKey = function()
{
    alert("SceneOptionsVideoSettings.processEnterKey() ");
    
    var currentHighlight =  this.OptionsVideoSettingsView.getCurrentHighlight();
    switch(currentHighlight)
    {
        case this.VideoReceiveBtn:
            WndMgr.StartSelectorVideo(this.contentReceive, this.VideoReceiveBtn, this.sceneId, this.setVideoReceive, this.VideoReceiveBtn.GetText());
            this.flagSubList = true;
			break;
            
        case this.VideoAdvertBtn:
            WndMgr.StartSelectorVideoShow(this.contentAdvert, this.VideoAdvertBtn, this.sceneId, this.setVideoAdvert, this.VideoAdvertBtn.GetText());
            this.flagSubList = true;
			break;
			
		case this.AutoFocusBtn:
			this.startSelector();
		 	break;
    }	
}

SceneOptionsVideoSettings.prototype.exit = function()
{
    alert("SceneOptionsVideoSettings.exit()");
    WndMgr.ReturnOptionsSubToMain();
    this.highlight(null);
}

SceneOptionsVideoSettings.prototype.processReturnKey = function(){
    alert("SceneOptionsVideoSettings.processReturnKey() ");
    this.exit();
}

SceneOptionsVideoSettings.prototype.processExitKey = function()
{
    alert("SceneOptionsVideoSettings.processExitKey()");
        
     if(OptionsMgr.flagChange == true)
    {
        WndMgr.StartOptionsSaveReturnStep();
     }
     else
     {
        StateMgr.Stop_Options_State(true); 
     }
}
/*
SceneOptionsVideoSettings.prototype.gotoNext = function()
{
    alert("SceneOptionsVideoSettings.gotoNext() ");
    this.curPos = (this.curPos + 1) % this.btnList.length;
    this.highlight(this.btnList[this.curPos]);
}

SceneOptionsVideoSettings.prototype.gotoPrev = function()
{
    alert("SceneOptionsVideoSettings.gotoPrev() ");
    this.curPos = (this.curPos - 1 + this.btnList.length) % this.btnList.length;
    this.highlight(this.btnList[this.curPos]);
}*/

SceneOptionsVideoSettings.prototype.processBlueKey = function()
{
    alert("SceneOptionsVideoSettings.processBlueKey() ");
    //this.saveOptions();
    OptionsMgr.SaveOptions();
}

SceneOptionsVideoSettings.prototype.saveOptions = function()
{
    alert("SceneOptionsVideoSettings.saveOptions()");

    if(OptionsMgr.saveVideoSettings())
        WndMgr.StartOptionsCommitedMsg("OptionsVideoSettings");
}

SceneOptionsVideoSettings.prototype.setVideoReceive = function(value)
{
    alert("SceneOptionsVideoSettings.setVideoReceive(): " + value);
    OptionsMgr.setVideoReceive(value);
}

SceneOptionsVideoSettings.prototype.setVideoAdvert = function(value)
{
    alert("SceneOptionsVideoSettings.setVideoAdvert(): " + value);
    OptionsMgr.setVideoAdvert(value);
}

SceneOptionsVideoSettings.prototype.startSelector = function()
{
    alert("SceneOptionsVideoSettings.startSelector()");
    var scene = $.sfScene.get("OptionsVideoSettings");
    WndMgr.StartSelectorOnOff(this.AutoFocusBtn, this.sceneId, scene.setAutoFocus, this.AutoFocusBtn.GetText());
	this.flagSubList = true;
}

SceneOptionsVideoSettings.prototype.setAutoFocus = function(value)
{
    alert("SceneOptionsVideoSettings.setAutoFocus(): " + value);
    OptionsMgr.setAutoFocus(value);
}


/**
 * Initializes the value of options presented to user.
 */
SceneOptionsVideoSettings.prototype.initOptions = function()
{
    alert("SceneOptionsVideoSettings.initOptions");
    this.VideoReceiveBtn.SetText(OptionsMgr.getVideoReceive());
    this.VideoAdvertBtn.SetText(OptionsMgr.getVideoAdvert());
	this.AutoFocusBtn.SetText(OptionsMgr.getAutoFocus()); 
    
     if(OptionsMgr.flagChange == true)
    {
        this.changeToSaveHelpBar();
    }
    else
    {
        this.changeToDefaultHelpBar();
    }
    
    if(OptionsMgr.isAutoFocusEnable==false)
    {
    	this.AutoFocusLabel.hiddenObj();
    	this.AutoFocusBtn.hiddenObj();
    	
    	$("#options_video_to_settings_label").css('top', "250px" );
    	$("#options_video_to_settings_btn").css('top', "275px" );
    }
    else
    {
    	this.AutoFocusLabel.visibleObj();
    	this.AutoFocusBtn.visibleObj();
    	
    	$("#options_video_to_settings_label").css('top', "195px" );
    	$("#options_video_to_settings_btn").css('top', "220px" );
    }
    
    this.isInit = false;
}

SceneOptionsVideoSettings.prototype.processClickEvent = function(obj){
	alert("SceneOptionsVideoSettings.processClickEvent() ");
	OptionsMgr.resetTimer();
	
	var currentHighlight =  this.OptionsVideoSettingsView.getCurrentHighlight();
    if(currentHighlight != obj)
    {
    	this.highlight(obj);
    }
    
    if($.sfScene.get('Options').flag_Focus==true)
	{   
		$.sfScene.get('Options').moveToSub();
	}

    this.processEnterKey();
}
