/**
 * @author Samsung
 */

function SceneOptionsVoiceMail(options)
{
    this.options = options;

    this.OptionsVoiceMailView = null;
    this.ForwardBtn = null;
    this.RejectBtn = null;
    this.BusyBtn = null;
    this.ForwardTimerBox = null;
    this.OfflineLabel = null;
    this.SettingsLabel = null;
    this.RespondLabel = null;
    this.RejectLable = null;
    this.BusyLabel = null;
    this.AttentionLabel = null;
	this.SecondsLabel=null;
	
    this.btnList = null;
    this.curPos = 0;
    this.sceneId = "OptionsVoiceMail";
    this.isNavigatable = false;
    //Flag shows wheather voice mail is enabled for the user account.
    this.voicemailCapability = false;
    this.TIME_MAX_LENGTH = 3;
    
    this.VoiceMailEnablePage = null;
    this.VoiceMailDisablePage = null;
	
	this.MsgVoiceMail = null;
	this.AboutVoiceMail = null;
	this.HowtoVoiceMail =null;
    
    this.DefaultHelpBar = null;
    this.SaveHelpBar = null;
    this.NumberInputHelpBar = null;
    this.NumberInputSaveHelpBar = null;
    
    this.flagCreate = false;
	this.flagSubList = false;
    this.isInit = true;
}

SceneOptionsVoiceMail.prototype.initialize = function ()
{
	alert("SceneOptionsVoiceMail.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
   this.create();
}

SceneOptionsVoiceMail.prototype.handleShow = function ()
{
	// this function will be called when the scene manager show this scene 
	alert("SceneOptionsVoiceMail.handleShow()");
    this.curPos = 0;
    if(this.isInit == true)
    {
        this.initOptions();
    }
}

SceneOptionsVoiceMail.prototype.handleHide = function ()
{
	// this function will be called when the scene manager hide this scene  
	alert("SceneOptionsVoiceMail.handleHide()");
	if(this.flagSubList){
		WndMgr.StopOptionSelector();
	}	
}

SceneOptionsVoiceMail.prototype.handleFocus = function ()
{
	// this function will be called when the scene manager focus this scene
	alert("SceneOptionsVoiceMail.handleFocus()");
    if (this.voicemailCapability) {
		this.highlight(this.btnList[this.curPos]);
	}
	
	this.flagSubList = false;
}

SceneOptionsVoiceMail.prototype.handleBlur = function ()
{
	// this function will be called when the scene manager move focus to another scene from this scene
	alert("SceneOptionsVoiceMail.handleBlur()");
    if(this.voicemailCapability == true)
    {
        var currentHighlight =  this.OptionsVoiceMailView.getCurrentHighlight();
		if(currentHighlight != null)
		{
			currentHighlight.blur();
		}
        
    }
}

SceneOptionsVoiceMail.prototype.handleKeyDown = function (keyCode)
{
	alert("SceneOptionsVoiceMail.handleKeyDown(" + keyCode + ")");
    // TODO : write an key event handler when this scene get focued
    PluginAPIMgr.PlayAudio(keyCode);
    switch (keyCode) {
        case $.sfKey.LEFT:
			OptionsMgr.resetTimer();
            this.processLeftKey();
            break;

        case $.sfKey.RIGHT:
            //this.processRightKey();
            break;

        case $.sfKey.UP:
            if(this.voicemailCapability)
			{
				OptionsMgr.resetTimer();
				this.processUpKey();
			}
                
            break;

        case $.sfKey.DOWN:
            if(this.voicemailCapability)
			{
				OptionsMgr.resetTimer();
				this.processDownKey();
			}                
            break;

        case $.sfKey.BLUE:
            if(this.voicemailCapability)
                this.processBlueKey();
            break;

        case $.sfKey.ENTER:
            if(this.voicemailCapability)
			{
				OptionsMgr.resetTimer();
				this.processEnterKey();
			}
                
            break;

        case $.sfKey.RETURN:
			OptionsMgr.resetTimer();
            this.processReturnKey();
            $.sfKey.block(event);
            break;
       case $.sfKey.EXIT:
       		this.processExitKey();
			$.sfKey.block(event);
			break;
		
        case 147:  //infolink
        case 261:  //contents
        case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
    }
}

/////////////////////////////////////////////////////////////////////////////
SceneOptionsVoiceMail.prototype.createEnabled = function()
{
    alert("SceneOptionsVoiceMail.createEnabled");

    this.OfflineLabel = new Label(null, "options_voice_mail_offline_label");
    this.OfflineLabel.SetTextStyle("options_enable_label_style");
    this.OfflineLabel.SetText(TV_SID_TAKE_VOICEMAIL_MESSAGE_OFFLINE_MSG);

    this.SettingLabel = new Label(null, "options_voice_mail_setting_label");
    this.SettingLabel.SetTextStyle("options_enable_label_style");
    //this.SettingLabel.SetReverseDisable(true);
    this.SettingLabel.SetText(TV_SID_VOICE_MAIL_SETTING + " :");

    this.RespondLabel = new Label(null, "options_voice_mail_respond_label");
    this.RespondLabel.SetTextStyle("options_enable_label_style");
    this.RespondLabel.SetText(TV_SID_NO_RESPONSE);
	
	this.SecondsLabel = new Label(null, "options_voice_mail_seconds_label");
    this.SecondsLabel.SetTextStyle("options_label_style_17");
    this.SecondsLabel.SetText(SID_SEC);

    this.RejectLabel = new Label(null, "options_voice_mail_reject_label");
    this.RejectLabel.SetTextStyle("options_enable_label_style");
    this.RejectLabel.SetText(TV_SID_REJECT_INCOMING_CALL);

    this.BusyLabel = new Label(null, "options_voice_mail_busy_label");
    this.BusyLabel.SetTextStyle("options_enable_label_style");
    this.BusyLabel.SetText(IDWS_MOIP_SKYPE_BUSY);

    this.AttentionLabel = new Label("options_voice_mail_attention_bg", "options_voice_mail_attention_label");
    this.AttentionLabel.SetTextStyle("options_enable_label_style");
    this.AttentionLabel.SetText(TV_SID_INCOMING_CALL_FORWARDED_FIRST_MSG);
    this.AttentionLabel.AppendFgImage("options_info_icon_voice_mail", "0px", "0px", "28px", "28px");
    this.AttentionLabel.SetFgImage(g_Image.FORWARDING_INFO_ICON);
	
    var this_ = $.sfScene.get("OptionsVoiceMail");
	var clickCF =  function(obj){this_.processClickEvent(obj);};

    var CurLangID = ResMgr.GetCurLanguage();
	
    this.ForwardBtn = new Button();
    this.ForwardBtn.SetImageObjId("options_voice_mail_offline_btn");
    this.ForwardBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.OPTIONS_SELECTOR_ONOFF);
    this.ForwardBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.OPTIONS_SELECTOR_ONOFF_HIGHLIGHT);
    this.ForwardBtn.SetTextObjId("options_voice_mail_offline_txt");       
 	if(CurLangID == ENUM_TV_LANGUAGE.ARA)
 	{
	    this.ForwardBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "options_label_style_16");
		this.ForwardBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "options_label_style_16");
		this.ForwardBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE, "options_label_style_dim_16");
   	}
   	else 
   	{
	    this.ForwardBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "options_label_style_17");
		this.ForwardBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "options_label_style_17");
		this.ForwardBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE, "options_label_style_dim_17");	
   	}            
    this.ForwardBtn.AppendFgImage("options_voice_mail_offline", "113px", "21px", "13px", "8px");
    this.ForwardBtn.SetFgImage(g_Image.OPTIONS_ARROW_DOWN);
    this.ForwardBtn.SetOnClickCallbackFunc(clickCF);


    this.RejectBtn = new Button();
    this.RejectBtn.SetImageObjId("options_voice_mail_reject_btn");
    this.RejectBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.OPTIONS_SELECTOR_ONOFF);
    this.RejectBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.OPTIONS_SELECTOR_ONOFF_HIGHLIGHT);
    this.RejectBtn.SetBgImage(BtnImgIndex.BTN_DIM_IMG, g_Image.OPTIONS_SELECTOR_ONOFF_DIM);
    this.RejectBtn.SetTextObjId("options_voice_mail_reject_txt");
 	if(CurLangID == ENUM_TV_LANGUAGE.ARA)
 	{
	    this.RejectBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "options_label_style_16");
		this.RejectBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "options_label_style_16");
    	this.RejectBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE, "options_label_style_dim_16");		
   	}
   	else 
   	{
	    this.RejectBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "options_label_style_17");
		this.RejectBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "options_label_style_17");
    	this.RejectBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE, "options_label_style_dim_17");		
   	} 

    this.RejectBtn.AppendFgImage("options_voice_mail_reject", "113px", "21px", "13px", "8px");
    this.RejectBtn.SetFgImage(g_Image.OPTIONS_ARROW_DOWN);
    this.RejectBtn.SetOnClickCallbackFunc(clickCF);

    this.BusyBtn = new Button();
    this.BusyBtn.SetImageObjId("options_voice_mail_busy_btn");
    this.BusyBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.OPTIONS_SELECTOR_ONOFF);
    this.BusyBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.OPTIONS_SELECTOR_ONOFF_HIGHLIGHT);
    this.BusyBtn.SetBgImage(BtnImgIndex.BTN_DIM_IMG, g_Image.OPTIONS_SELECTOR_ONOFF_DIM);
    this.BusyBtn.SetTextObjId("options_voice_mail_busy_txt");
 	if(CurLangID == ENUM_TV_LANGUAGE.ARA)
 	{
	    this.BusyBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "options_label_style_16");
		this.BusyBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "options_label_style_16");
		this.BusyBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE, "options_label_style_dim_16");
   	}
   	else 
   	{
	    this.BusyBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "options_label_style_17");
		this.BusyBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "options_label_style_17");
		this.BusyBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE, "options_label_style_dim_17");	
   	}
    this.BusyBtn.AppendFgImage("options_voice_mail_busy", "113px", "21px", "13px", "8px");
    this.BusyBtn.SetFgImage(g_Image.OPTIONS_ARROW_DOWN);
    this.BusyBtn.SetOnClickCallbackFunc(clickCF);

    var scene = $.sfScene.get("OptionsVoiceMail");
    this.ForwardTimerBox = new NumberInputBox();
    this.ForwardTimerBox.SetButtonObjId("options_voice_mail_respond_box");
    this.ForwardTimerBox.SetButtonTextObjId("options_voice_mail_respond_text");
    this.ForwardTimerBox.SetInputBoxObjId("options_voice_mail_respond_text_editor");
    this.ForwardTimerBox.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.RESPOND_INPUTBOX);
    this.ForwardTimerBox.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.RESPOND_INPUTBOX_FOCUS);
    this.ForwardTimerBox.SetBgImage(BtnImgIndex.BTN_DIM_IMG, g_Image.RESPOND_INPUTBOX_DIM);
    this.ForwardTimerBox.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE, "options_label_style_17");
    this.ForwardTimerBox.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE, "options_label_style_17");
    this.ForwardTimerBox.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE, "options_label_style_dim_17");
	this.ForwardTimerBox.setPrevEventOnLeftFunc(function(){scene.processLeftKey(); OptionsMgr.resetTimer();});
    this.ForwardTimerBox.setPrevEventOnDownFunc(function(){scene.moveDown(); OptionsMgr.resetTimer();});
	this.ForwardTimerBox.setEnterFunc(function(){scene.processEnterKey(); OptionsMgr.resetTimer();});
    this.ForwardTimerBox.setPrevEventOnUpFunc(function(){scene.moveUp(); OptionsMgr.resetTimer();});
    this.ForwardTimerBox.setPrevEventOnBlueFunc(function(){scene.processBlueKey()});
    this.ForwardTimerBox.setPrevEventOnReturnFunc(function(){$.sfKey.block(event); scene.processReturnKey(); OptionsMgr.resetTimer();});
    this.ForwardTimerBox.setPrevEventOnExitFunc(function(){$.sfKey.block(event); scene.processExitKey(); });
	this.ForwardTimerBox.setPrevEventOnInfolinkFunc(function(){$.sfKey.block(event); });	
	this.ForwardTimerBox.setAnyKeyFunc(function(keyCode){scene.callbackNumberInput(); OptionsMgr.resetTimer();});
    this.ForwardTimerBox.setMaxLength(this.TIME_MAX_LENGTH);
    this.ForwardTimerBox.setFlagPhoneNumber(false);
    this.ForwardTimerBox.SetOnClickCallbackFunc(clickCF);

	this.AdjustLanguage();

    this.btnList = new Array(4);
    for(var i = 0; i < this.btnList.length; i++);
        this.btnList[i] = new  Object();

    this.btnList[0] = this.ForwardBtn;
    this.btnList[1] = this.ForwardTimerBox;
    this.btnList[2] = this.RejectBtn; 
    this.btnList[3] = this.BusyBtn;
    
    this.DefaultHelpBar  = new HelpBar(HelpBarIndex.OPTIONS_VOICE_MAIL,"Options");
    this.DefaultHelpBar.SetOnClickCallbackFunc(1, function(){this_.processReturnKey();});
    
    this.SaveHelpBar = new HelpBar(HelpBarIndex.OPTIONS_VOICE_MAIL_SAVE,"Options");
    this.SaveHelpBar.SetOnClickCallbackFunc(1, function(){this_.processBlueKey();});
    this.SaveHelpBar.SetOnClickCallbackFunc(2, function(){this_.processReturnKey();});
    
    this.NumberInputHelpBar = new HelpBar(HelpBarIndex.OPTIONS_VOICE_MAIL_NUMBER_INPUT,"Options");
    this.NumberInputHelpBar.SetOnClickCallbackFunc(1, function(){this_.startKeypad();});
    this.NumberInputHelpBar.SetOnClickCallbackFunc(2, function(){this_.inputDelete();});
    this.NumberInputHelpBar.SetOnClickCallbackFunc(3, function(){this_.processReturnKey();});
    
    this.NumberInputSaveHelpBar = new HelpBar(HelpBarIndex.OPTIONS_VOICE_MAIL_NUMBER_INPUT_SAVE,"Options");
    this.NumberInputSaveHelpBar.SetOnClickCallbackFunc(1, function(){this_.startKeypad();});
    this.NumberInputSaveHelpBar.SetOnClickCallbackFunc(2, function(){this_.inputDelete();});
    this.NumberInputSaveHelpBar.SetOnClickCallbackFunc(3, function(){this_.processBlueKey();});
    this.NumberInputSaveHelpBar.SetOnClickCallbackFunc(4, function(){this_.processReturnKey();});
    
    this.ForwardBtn.registHelpBar(this.DefaultHelpBar);
	this.RejectBtn.registHelpBar(this.DefaultHelpBar);
	this.BusyBtn.registHelpBar(this.DefaultHelpBar);
	this.ForwardTimerBox.registHelpBar(this.NumberInputHelpBar);

}

SceneOptionsVoiceMail.prototype.setInitFlag = function(initFlag)
{
    this.isInit = initFlag;
}

SceneOptionsVoiceMail.prototype.changeToDefaultHelpBar= function()
{
    if(this.flagCreate == false)
    {
        return;
    }
    
    this.ForwardBtn.changeHelpBar(this.DefaultHelpBar);
	this.RejectBtn.changeHelpBar(this.DefaultHelpBar);
	this.BusyBtn.changeHelpBar(this.DefaultHelpBar);
	this.ForwardTimerBox.changeHelpBar(this.NumberInputHelpBar);
}

SceneOptionsVoiceMail.prototype.changeToSaveHelpBar= function()
{
     if(this.flagCreate == false)
    {
        return;
    }
    
    this.ForwardBtn.changeHelpBar(this.SaveHelpBar);
	this.RejectBtn.changeHelpBar(this.SaveHelpBar);
	this.BusyBtn.changeHelpBar(this.SaveHelpBar);
	this.ForwardTimerBox.changeHelpBar(this.NumberInputSaveHelpBar);
}


SceneOptionsVoiceMail.prototype.createDisabled = function()
{
    alert("SceneOptionsVoiceMail.createDisabled");
	
	this.MsgVoiceMail = new Label(null, "options_voice_mail_msg_label");
    this.MsgVoiceMail.SetTextStyle("options_disable_label_style");
    this.MsgVoiceMail.SetText(TV_SID_NEVER_MISS_ANOTHER_CALL_WITH_VOICEMAIL);
	
    this.AboutVoiceMail = new Label(null, "options_voice_mail_about_label");
    this.AboutVoiceMail.SetTextStyle("options_disable_label_style");
    this.AboutVoiceMail.SetText(TV_SID_SKYPE_TAKE_MESSAGE_OFFLINE_MSG);

    this.HowtoVoiceMail = new Label(null, "options_voice_mail_howto_label");
    this.HowtoVoiceMail.SetTextStyle("options_disable_label_style");
    this.HowtoVoiceMail.SetText(TV_SID_GET_VOICEMAIL_AT_WWW_SKYPE_COM);
}

SceneOptionsVoiceMail.prototype.create = function()
{
    alert("SceneOptionsVoiceMail.create()");
    this.OptionsVoiceMailView = new View(this.sceneId);
    
     this.VoiceMailEnablePage = new View("options_voice_mail_enable_page");   
     this.VoiceMailDisablePage = new View("options_voice_mail_disable_page");

     this.createEnabled();
     this.createDisabled();
     
     this.flagCreate = true;
}

SceneOptionsVoiceMail.prototype.callbackPhoneNumberInput = function(keyCode)
{
    alert("SceneOptionsVoiceMail.callbackPhoneNumberInput() ");
}

SceneOptionsVoiceMail.prototype.callbackNumberInput = function()
{
    alert("SceneOptionsVoiceMail.callbackNumberInput() ");

       OptionsMgr.setVoiceMailForwardTimer(this.ForwardTimerBox.GetText());
}

SceneOptionsVoiceMail.prototype.highlight = function(obj)
{
	var preHighlight =  this.OptionsVoiceMailView.getCurrentHighlight();
	
    this.OptionsVoiceMailView.setCurrenHighlight(obj);
    
    if(obj != null && preHighlight!=null)
    {
    	if(preHighlight.objType == "NUMBERINPUTBOX" && obj.objType != "NUMBERINPUTBOX")
    	{
    		this.leaveInputBox();
    	}        
    }
}

SceneOptionsVoiceMail.prototype.processDownKey = function()
{
    alert("SceneOptionsVoiceMail.processDownKey() ");
     
    this.gotoNext(); 
}

SceneOptionsVoiceMail.prototype.processUpKey = function()
{
    alert("SceneOptionsVoiceMail.processUpKey() ");
    this.gotoPrev(); 
}

SceneOptionsVoiceMail.prototype.processEnterKey = function(){
    alert("SceneOptionsVoiceMail.processEnterKey() ");
    
    var currentHighlight =  this.OptionsVoiceMailView.getCurrentHighlight();
     var scene = $.sfScene.get("OptionsVoiceMail");
   
    switch(currentHighlight)
    {
        case this.ForwardBtn:
            WndMgr.StartSelectorOnOff(currentHighlight, this.sceneId, scene.callBack, this.ForwardBtn.GetText());
            break;
        case this.RejectBtn :
            WndMgr.StartSelectorOnOff(currentHighlight, this.sceneId, scene.callBackReject, this.RejectBtn.GetText());
            break;
        case this.BusyBtn:
            WndMgr.StartSelectorOnOff(currentHighlight, this.sceneId, scene.callBackBusy, this.BusyBtn.GetText());
            break;
        case this.ForwardTimerBox:
        	this.moveDown();
        	break;
    }
	
	this.flagSubList = true;
}

SceneOptionsVoiceMail.prototype.exit = function()
{
    alert("SceneOptionsVoiceMail.exit()");
	this.highlight(null);
    WndMgr.ReturnOptionsSubToMain();    
}

SceneOptionsVoiceMail.prototype.processReturnKey = function()
{
    alert("SceneOptionsVoiceMail.processReturnKey() ");
    this.exit();
}

SceneOptionsVoiceMail.prototype.processExitKey = function()
{
    alert("SceneOptionsVoiceMail.processExitKey()");
        
     if(OptionsMgr.flagChange == true)
    {
        WndMgr.StartOptionsSaveReturnStep();
     }
     else
     {
        StateMgr.Stop_Options_State(true); 
     }
}

SceneOptionsVoiceMail.prototype.processLeftKey = function()
{
    alert("SceneOptionsVoiceMail.processLeftKey() ");
    this.exit();
}

SceneOptionsVoiceMail.prototype.moveLeft = function()
{
    alert("SceneOptionsVoiceMail.moveLeft() ");
    
    var curObj = this.gotoPrev();
    /*if(curObj.objType != "NUMBERINPUTBOX")
        this.leaveInputBox();*/
}

SceneOptionsVoiceMail.prototype.moveRight = function()
{
    alert("SceneOptionsVoiceMail.moveRight() ");
    
    var curObj = this.gotoNext();
    /*if(curObj.objType != "NUMBERINPUTBOX")
        this.leaveInputBox();*/
}

SceneOptionsVoiceMail.prototype.moveUp = function()
{
    alert("SceneOptionsVoiceMail.moveUp()");
    var curObj = this.gotoPrev();
    /*if(curObj.objType != "NUMBERINPUTBOX")
        this.leaveInputBox();*/
}

SceneOptionsVoiceMail.prototype.moveDown = function()
{
    alert("SceneOptionsVoiceMail.moveDown()");
    var curObj = this.gotoNext();
    /*if(curObj.objType != "NUMBERINPUTBOX")
        this.leaveInputBox();*/
}

SceneOptionsVoiceMail.prototype.leaveInputBox = function()
{
    alert("SceneOptionsVoiceMail.leaveInputBox() ");
    $.sfScene.focus(this.sceneId);
	$.sf.returnFocus();
}

SceneOptionsVoiceMail.prototype.gotoNext = function()
{
    alert("SceneOptionsVoiceMail.gotoNext() ");
    if(this.isNavigatable)
    {
        this.curPos = (this.curPos + 1) % (this.btnList.length - 1);
        this.highlight(this.btnList[this.curPos]);
    }
    return this.btnList[this.curPos];
}

SceneOptionsVoiceMail.prototype.gotoPrev = function()
{
    alert("SceneOptionsVoiceMail.gotoPrev() ");
    if(this.isNavigatable)
    {
        this.curPos = (this.curPos - 1 + (this.btnList.length - 1)) % (this.btnList.length - 1);
        this.highlight(this.btnList[this.curPos]);
    }
    return this.btnList[this.curPos];
}

SceneOptionsVoiceMail.prototype.processBlueKey = function()
{
    alert("SceneOptionsVoiceMail.processBlueKey() ");
    var currentHighlight = this.OptionsVoiceMailView.getCurrentHighlight();
	if(OptionsMgr.flagChange == true && currentHighlight.objType == "NUMBERINPUTBOX")
	{
		currentHighlight.blur();
	}
	
    OptionsMgr.SaveOptions();
}

/**
 * Initializes the value of options presented to user.
 */
SceneOptionsVoiceMail.prototype.initOptions = function()
{
    alert("SceneOptionsVoiceMail.initOptions");
    this.voicemailCapability = OptionsMgr.getVoiceMailState();
    alert("Voice mail capability: " + this.voicemailCapability);
    if(this.voicemailCapability)
    {
        this.VoiceMailEnablePage.visibleObj();
        this.VoiceMailDisablePage.hiddenObj();
    }
   else
   {
        this.VoiceMailDisablePage.visibleObj();
        this.VoiceMailEnablePage.hiddenObj();
   }
       
    if(this.voicemailCapability)
    {
        var forward = OptionsMgr.getVoiceMailForwardState();
        this.ForwardBtn.SetText(forward);
        this.RejectBtn.SetText(OptionsMgr.getVoiceMailReject());
        this.BusyBtn.SetText(OptionsMgr.getVoiceMailBusy());
        this.ForwardTimerBox.SetText(OptionsMgr.getVoiceMailForwardTimer());

        if(forward === SID_OFF)
            this.disableNavigation();    
        else 
            this.enableNavigation();
            
         if(OptionsMgr.flagChange == true)
        {
            this.changeToSaveHelpBar();
        }
        else
        {
            this.changeToDefaultHelpBar();
        }
    }
    
    this.isInit = false;
}

SceneOptionsVoiceMail.prototype.setOptions = function()
{
    alert("SceneOptionsVoiceMail.setOptions()");
    OptionsMgr.setVoiceMailForwardState(this.ForwardBtn.GetText());
    if(this.isNavigatable)
    {
        OptionsMgr.setVoiceMailReject(this.RejectBtn.GetText());
        OptionsMgr.setVoiceMailBusy(this.BusyBtn.GetText());
        OptionsMgr.setVoiceMailForwardTimer(this.ForwardTimerBox.GetText());
    }
}

SceneOptionsVoiceMail.prototype.saveOptions = function()
{
    alert("SceneOptionsVoiceMail.saveOptions()");
    this.setOptions();

    if(OptionsMgr.saveVoiceMail())
        WndMgr.StartOptionsCommitedMsg(this.sceneId);
}

/**
 * Resets visible options to it's initial state.
 * @remarks It is necessary in the case when user changed some settings and without saving pressed return button.
 */
SceneOptionsVoiceMail.prototype.resetOptions = function()
{
    alert("SceneOptionsVoiceMail.resetOptions");
    this.initOptions();
}

SceneOptionsVoiceMail.prototype.callBack = function(result)
{
    alert("SceneOptionsVoiceMail.callBack"); 
    var scene = $.sfScene.get("OptionsVoiceMail");
    OptionsMgr.setVoiceMailForwardState(scene.ForwardBtn.GetText());    
    
    if(result === SID_OFF)
        scene.disableNavigation();    
    else 
        scene.enableNavigation();
}

SceneOptionsVoiceMail.prototype.callBackReject = function(result)
{
     alert("SceneOptionsVoiceMail.callBackReject"); 
     var scene = $.sfScene.get("OptionsVoiceMail");
     OptionsMgr.setVoiceMailReject(scene.RejectBtn.GetText());
}

SceneOptionsVoiceMail.prototype.callBackBusy = function(result)
{
     alert("SceneOptionsVoiceMail.callBackBusy"); 
     var scene = $.sfScene.get("OptionsVoiceMail");
     OptionsMgr.setVoiceMailBusy(scene.BusyBtn.GetText());
}

SceneOptionsVoiceMail.prototype.enableNavigation = function()
{
    alert("SceneOptionsVoiceMail.enableNavigation");
    this.isNavigatable = true;
    this.RejectBtn.SetFlagDim(false);
    this.BusyBtn.SetFlagDim(false); 
    this.ForwardTimerBox.SetFlagDim(false);
	
	this.RejectBtn.SetFgImage(g_Image.OPTIONS_ARROW_DOWN);
	this.BusyBtn.SetFgImage(g_Image.OPTIONS_ARROW_DOWN);
}

SceneOptionsVoiceMail.prototype.disableNavigation = function()
{
    alert("SceneOptionsVoiceMail.disableNavigation");
    this.isNavigatable = false;
    this.RejectBtn.SetFlagDim(true);
    this.BusyBtn.SetFlagDim(true); 
    this.ForwardTimerBox.SetFlagDim(true);
	
	this.RejectBtn.SetFgImage(g_Image.OPTIONS_ARROW_DOWN_DIM);
	this.BusyBtn.SetFgImage(g_Image.OPTIONS_ARROW_DOWN_DIM);
}

SceneOptionsVoiceMail.prototype.AdjustLanguage = function()
{
	var CurLangID = ResMgr.GetCurLanguage();

 	if(CurLangID == ENUM_TV_LANGUAGE.HAU || CurLangID == ENUM_TV_LANGUAGE.XHO || CurLangID == ENUM_TV_LANGUAGE.IGB || CurLangID == ENUM_TV_LANGUAGE.URD)
 	{
		$("#options_voice_mail_respond_box").css('left', "315px" );	 		
		$("#options_voice_mail_seconds_label").css('left', "420px");
	
		$("#options_voice_mail_reject_btn").css('left', "315px");
		$("#options_voice_mail_busy_btn").css('left', "315px" );
   	}
}

SceneOptionsVoiceMail.prototype.processClickEvent = function(obj){
	alert("SceneOptionsVoiceMail.processClickEvent() ");
	OptionsMgr.resetTimer();
	
	for(var i = 0; i < this.btnList.length; i++)
	{
        if(this.btnList[i] == obj)
        {
        	this.curPos = i;
        	break;
        }
	}
	
	var currentHighlight =  this.OptionsVoiceMailView.getCurrentHighlight();
    if(currentHighlight != obj)
    {
    	this.highlight(obj);
    }
    
    if($.sfScene.get('Options').flag_Focus==true)
	{   
		$.sfScene.get('Options').moveToSub();
	}
	
	//if(currentHighlight != obj && obj.objType == "NUMBERINPUTBOX")
	if(obj.objType == "NUMBERINPUTBOX")
	{
		return;
	}

    this.processEnterKey();
}

SceneOptionsVoiceMail.prototype.startKeypad = function(){
    alert("SceneOptionsVoiceMail.startKeypad() ");
    
    var currentHighlight =  this.OptionsVoiceMailView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
		case this.ForwardTimerBox:
		
		if(OptionsMgr.CloseTimer ==true)
		{
			OptionsMgr.stopTimer();
		}
        
        var stopCF = function(){OptionsMgr.startTimer();};
        
        WndMgr.StartKeypad(currentHighlight, "OptionsVoiceMail", stopCF);
        break;            
    }    
}


SceneOptionsVoiceMail.prototype.inputDelete = function(){
    alert("SceneOptionsVoiceMail.inputDelete() ");
    
    var currentHighlight =  this.OptionsVoiceMailView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
		case this.ForwardTimerBox:
		
		if(OptionsMgr.CloseTimer ==true)
		{
			OptionsMgr.resetTimer();
		}	
				        
        currentHighlight.processPreChKey();
        break;            
    }    
}


