

var REMOVE_TYPE = {      

    CONTACT		:   0,
    HISTORY		:   1,
}


function SceneRemove(options) {
	
	this.options = options;
	
	this.Type			= null;
	this.TargetDisplay	= null;				//to display name
	this.TargetIdentity = null;				//to use pluginApi to remove contact
	this.TargetIndex	= null;				//to use pluginApi to remove history
			
	this.RemoveView = null;	
	this.RemoveDim	= null;
	
	this.BodyMsg	= null;
	this.OkBtn		= null;
	this.CancelBtn	= null;

	//flag
//	this.InProgressMode = false;

	//timer
    this.CloseTimer = false;	 
}

SceneRemove.prototype.initialize = function () {
	alert("SceneRemove.initialize()");
	this.create();

}

SceneRemove.prototype.handleShow = function () {
	alert("SceneRemove.handleShow()");
			
	//this.NameLabel.SetText(this.TargetDisplay);
	this.RemoveDim.show();
	this.ResetPopup();    

    this.startTimer();
}

SceneRemove.prototype.handleHide = function () {
	alert("SceneRemove.handleHide()");
	this.RemoveDim.hide();
	
	if(this.InProgressMode){		
//		this.OkBtn.blur();
//		this.CancelBtn.blur();
		this.InProgressMode = false;
	}
	else{
		this.highlight(null);	
	}

    if (this.CloseTimer ==true)
    {
        this.stopTimer();
    }
	
}

SceneRemove.prototype.handleFocus = function () {
	alert("SceneRemove.handleFocus()");
	
    var currentHighlight =  this.RemoveView.getCurrentHighlight();

    if(currentHighlight ==null)
    {
        this.highlight(this.CancelBtn);
    }
    else
    {
         this.highlight(currentHighlight);
    }
	
}

SceneRemove.prototype.handleBlur = function () {
	alert("SceneRemove.handleBlur()");
	
}

SceneRemove.prototype.handleKeyDown = function (keyCode) {
	alert("SceneRemove.handleKeyDown(" + keyCode + ")");
	PluginAPIMgr.PlayAudio(keyCode);
	
	switch (keyCode) {
		case $.sfKey.LEFT:
		case $.sfKey.RIGHT:
			this.resetTimer();
			this.processLEFTKey();
			break;
					
		case $.sfKey.ENTER:
			this.processEnterKey();
			break;
		
		case $.sfKey.RETURN:
		case $.sfKey.EXIT:
			this.processReturnKey();
			$.sfKey.block(event);
			break;

        case 147:  //infolink
        case 261:  //contents
         case 115:  //wiselink
            $.sfKey.block(event);
			break;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneRemove.prototype.create = function(){
    alert("SceneRemove.create()");
	
    this.RemoveView = new View("Remove");
    this.RemoveView.SetBgImage(g_Image.IMAGE_LIST_MAIN_REMOVE_CONTACT_BG);  
	
	this.RemoveDim = new DimBg("RemoveDim", "Remove");  

	//this.NameLabel	= new Label(null,"RemoveName");
    this.BodyMsg 	= new Label(null,"RemoveMassage");	

    this.OkBtn = new ButtonBase();
    this.OkBtn.Create("Remove_OkButton",BUTTON_BASE_TYPE.BG_TEXT);
    this.OkBtn.SetBgImage(BUTTON_BASE_STATE.NORMAL, g_Image.IMAGE_LIST_MAIN_BLOCK_CONTACT_BTN_NORMAL_BG);
    this.OkBtn.SetBgImage(BUTTON_BASE_STATE.HIGHLIGHT, g_Image.IMAGE_LIST_MAIN_BLOCK_CONTACT_BTN_HIGHLIGHT_BG);	
	this.OkBtn.SetTextStyle(BUTTON_BASE_STATE.NORMAL,"cButton_Text_Blur_Style");
	//this.OkBtn.SetTextStyle(BUTTON_BASE_STATE.HIGHLIGHT,"cButton_Text_Highlight_Style"); 
    this.OkBtn.SetText(SID_OK_KR_YES);
    this.OkBtn.SetOnClickCallbackFunc(this.ClickOkBtn);
 
	this.CancelBtn = new ButtonBase();
    this.CancelBtn.Create("Remove_CancelButton",BUTTON_BASE_TYPE.BG_TEXT);
    this.CancelBtn.SetBgImage(BUTTON_BASE_STATE.NORMAL, g_Image.IMAGE_LIST_MAIN_BLOCK_CONTACT_BTN_NORMAL_BG);
    this.CancelBtn.SetBgImage(BUTTON_BASE_STATE.HIGHLIGHT, g_Image.IMAGE_LIST_MAIN_BLOCK_CONTACT_BTN_HIGHLIGHT_BG);	
	this.CancelBtn.SetTextStyle(BUTTON_BASE_STATE.NORMAL,"cButton_Text_Blur_Style");
	//this.CancelBtn.SetTextStyle(BUTTON_BASE_STATE.HIGHLIGHT,"cButton_Text_Highlight_Style");
    this.CancelBtn.SetText(SID_CANCEL);
    this.CancelBtn.SetOnClickCallbackFunc(this.ClickCancelBtn);

}

SceneRemove.prototype.highlight=function(obj)
{
	alert("SceneRemove.highlight()");
	
    this.RemoveView.setCurrenHighlight(obj);
	
}

SceneRemove.prototype.Init = function(Type_,Identity,Display,Index){
    alert("SceneRemove.Init() ");


	this.Type			= Type_;
	this.TargetDisplay	= Display;
	this.TargetIdentity = Identity;
	this.TargetIndex	= Index;

}

SceneRemove.prototype.ResetPopup = function(){
	alert("SceneRemove.ResetPopup() ");

	if(this.Type == REMOVE_TYPE.HISTORY){
		
		this.BodyMsg.SetText(TV_SID_REMOVE_THE_SELECTED_ITEM_FROM_HISTORY);	
	}
	else{
		alert("-- Error Remove Type");
	}

}

	
SceneRemove.prototype.processEnterKey = function(){
    alert("SceneRemove.processEnterKey() ");

    var currentHighlight =  this.RemoveView.getCurrentHighlight();
    
	
	if(currentHighlight == this.OkBtn){
	
		this.highlight(null);
//		this.OkBtn.dim();
//		this.CancelBtn.dim();
		this.InProgressMode = true;
		
		ProcMgr.RemoveItem(this.TargetIndex,this.Type);
	}
	else{
	
		this.processReturnKey();	
	}
	
}



SceneRemove.prototype.processReturnKey = function(){
    alert("SceneRemove.processReturnKey() ");

	StateMgr.Stop_Remove_State(true);

	//TEMPCODE: for only hisorty..   because no event
	var Scene = $.sfScene.get(WndMgr.GetMainSubSceneID());	
	Scene.Activation();

}

SceneRemove.prototype.processLEFTKey = function(){
    alert("SceneRemove.processLEFTKey() ");

    var currentHighlight =  this.RemoveView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.OkBtn:
            this.highlight(this.CancelBtn);
            break;
            
        case this.CancelBtn:
            this.highlight(this.OkBtn);
            break;
    }
    
}

SceneRemove.prototype.startTimer = function()
{
    alert("SceneRemove.startTimer() ");
	
	this.CloseTimer = true;
	PluginAPIMgr.StartOSDTimer("30000" , function() { $.sfScene.get('Remove').popupTimerCallback();}, ENUM_TIMER_TYPE.TWO_BUTTON);
}

SceneRemove.prototype.resetTimer = function()
{
    alert("SceneRemove.resetTimer() ");
	
	if(this.CloseTimer == true)
	{
		PluginAPIMgr.RestartOSDTimer("30000" ,ENUM_TIMER_TYPE.TWO_BUTTON);
	}
}

SceneRemove.prototype.stopTimer = function()
{
    alert("SceneRemove.stopTimer() ");

	this.CloseTimer = false;
	PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.TWO_BUTTON); 
}

SceneRemove.prototype.popupTimerCallback = function()
{
    alert("SceneRemove.popupTimerCallback() ");
	
	if (this.CloseTimer == false)
	{
		return;
	}
	this.CloseTimer = false;	
		
	this.processReturnKey();
}

SceneRemove.prototype.ClickOkBtn = function(){

	var This_ = $.sfScene.get('Remove');
	
	This_.highlight(null);
	This_.InProgressMode = true;	
	
	ProcMgr.RemoveItem(This_.TargetIndex,This_.Type);
}

SceneRemove.prototype.ClickCancelBtn = function(){

	var This_ = $.sfScene.get('Remove');
	This_.processReturnKey();
}

