

function SceneRemoveContact(options) {
	
	this.options = options;
	
	this.RemoveIdentityName = null;
	this.RemoveDisplayName = null;

			
	this.RemoveContactView = null;
	this.RemoveContactDim=null;
	
	this.BodyMsg	= null;
	
	this.OkBtn 		= null;
	this.CancelBtn = null;
	
	//timer
    this.CloseTimer = false;

}

SceneRemoveContact.prototype.initialize = function () {
	alert("SceneRemoveContact.initialize()");
	this.create();

}

SceneRemoveContact.prototype.handleShow = function () {
	alert("SceneRemoveContact.handleShow()");
	this.RemoveContactDim.show();			
	this.ResetPopup();

    this.startTimer();    
}

SceneRemoveContact.prototype.handleHide = function () {
	alert("SceneRemoveContact.handleHide()");
	this.RemoveContactDim.hide();
	this.highlight(null);
	
    if (this.CloseTimer ==true)
    {
        this.stopTimer();
    }	
}

SceneRemoveContact.prototype.handleFocus = function () {
	alert("SceneRemoveContact.handleFocus()");
	
    var currentHighlight =  this.RemoveContactView.getCurrentHighlight();

    if(currentHighlight ==null)
    {
        this.highlight(this.CancelBtn);
    }
    else
    {
         this.highlight(currentHighlight);
    }
	
}

SceneRemoveContact.prototype.handleBlur = function () {
	alert("SceneRemoveContact.handleBlur()");
	
}

SceneRemoveContact.prototype.handleKeyDown = function (keyCode) {
	alert("SceneRemoveContact.handleKeyDown(" + keyCode + ")");
	PluginAPIMgr.PlayAudio(keyCode);
	
	switch (keyCode) {
		case $.sfKey.LEFT:
		case $.sfKey.RIGHT:
			this.resetTimer();
			this.processLEFTKey();
			break;
					
		case $.sfKey.ENTER:
			this.processEnterKey();
			break;
		
		case $.sfKey.RETURN:
		case $.sfKey.EXIT:
			$.sfKey.block(event);
			StateMgr.Stop_Remove_Contact_State(true);
			break;

        case 147:  //infolink
        case 261:  //contents
         case 115:  //wiselink
            $.sfKey.block(event);
			break;
						
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneRemoveContact.prototype.create = function(){
    alert("SceneRemoveContact.create()");
	
    this.RemoveContactView = new View("RemoveContact");
    this.RemoveContactView.SetBgImage(g_Image.IMAGE_LIST_MAIN_REMOVE_CONTACT_BG);
	
	this.RemoveContactDim = new DimBg("RemoveContactDim", "RemoveContact");      

    this.BodyMsg = new Label(null,"RemoveContact_Msg");
    this.BodyMsg.SetIsPlainText(true);		
	//this.BodyMsg.SetText(Text);

    this.OkBtn = new ButtonBase();
    this.OkBtn.Create("RemoveContact_OkButton",BUTTON_BASE_TYPE.BG_TEXT);
    this.OkBtn.SetBgImage(BUTTON_BASE_STATE.NORMAL, g_Image.IMAGE_LIST_MAIN_BLOCK_CONTACT_BTN_NORMAL_BG);
    this.OkBtn.SetBgImage(BUTTON_BASE_STATE.HIGHLIGHT, g_Image.IMAGE_LIST_MAIN_BLOCK_CONTACT_BTN_HIGHLIGHT_BG);	
 	this.OkBtn.SetTextStyle(BUTTON_BASE_STATE.NORMAL,"cButton_Text_Blur_Style");
//	this.OkBtn.SetTextStyle(BUTTON_BASE_STATE.HIGHLIGHT,"cButton_Text_Highlight_Style");
    this.OkBtn.SetText(SID_OK_KR_YES);
    this.OkBtn.SetOnClickCallbackFunc(this.ClickOkBtn);    
 
	this.CancelBtn = new ButtonBase();
    this.CancelBtn.Create("RemoveContact_CancelButton",BUTTON_BASE_TYPE.BG_TEXT);
    this.CancelBtn.SetBgImage(BUTTON_BASE_STATE.NORMAL, g_Image.IMAGE_LIST_MAIN_BLOCK_CONTACT_BTN_NORMAL_BG);
    this.CancelBtn.SetBgImage(BUTTON_BASE_STATE.HIGHLIGHT, g_Image.IMAGE_LIST_MAIN_BLOCK_CONTACT_BTN_HIGHLIGHT_BG);	
	this.CancelBtn.SetTextStyle(BUTTON_BASE_STATE.NORMAL,"cButton_Text_Blur_Style");
//	this.CancelBtn.SetTextStyle(BUTTON_BASE_STATE.HIGHLIGHT,"cButton_Text_Highlight_Style");
    this.CancelBtn.SetText(SID_CANCEL);
	this.CancelBtn.SetOnClickCallbackFunc(this.ClickCancelBtn);
 
}

SceneRemoveContact.prototype.highlight=function(obj)
{
	alert("SceneRemoveContact.highlight()");
	
    this.RemoveContactView.setCurrenHighlight(obj);
	
}

SceneRemoveContact.prototype.ResetPopup = function(){
	alert("SceneRemoveContact.ResetPopup() ");
	
	//TEMPCODE
	var finalName;
	
//	var tempName = 'WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW';
//	finalName = tempName.slice(0,9) + '...';	
	
	if(this.RemoveDisplayName.length > 28){
		
		finalName = this.RemoveDisplayName.slice(0,27) + '...';
	}
	else{
		finalName = this.RemoveDisplayName;
	}
	
	var BodyText = g_Data.CombinateStrings(TV_SID_MIX_REMOVE_FROM_CONTACTS,finalName);
		
	this.BodyMsg.SetText(BodyText);	
	
}


SceneRemoveContact.prototype.processEnterKey = function(){
    alert("SceneRemoveContact.processEnterKey() ");

    var currentHighlight =  this.RemoveContactView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.OkBtn:
			this.ClickOkBtn();
            break;
            
        case this.CancelBtn:
			this.ClickCancelBtn();
            break;		
    }

}


SceneRemoveContact.prototype.processReturnKey = function(){
    alert("SceneRemoveContact.processReturnKey() ");
	
	StateMgr.Stop_Remove_Contact_State(true);
  
}

SceneRemoveContact.prototype.processLEFTKey = function(){
    alert("SceneRemoveContact.processLEFTKey() ");

    var currentHighlight =  this.RemoveContactView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.OkBtn:
            this.highlight(this.CancelBtn);
            break;
            
        case this.CancelBtn:
            this.highlight(this.OkBtn);
            break;
    }
    
}

SceneRemoveContact.prototype.Init = function(Identity,Display){
    
	this.RemoveIdentityName = Identity;
	this.RemoveDisplayName = Display;

}

/*
SceneRemoveContact.prototype.startTimer = function()
{
    alert("SceneRemoveContact.startTimer() ");
    
    this.CloseTimer = setTimeout("CloseTimerCF()", POPUP_WINDOW_CLOSE_TIME);
    
    CloseTimerCF = function() { $.sfScene.get('RemoveContact').processReturnKey();}
}

SceneRemoveContact.prototype.stopTimer = function()
{
    alert("SceneRemoveContact.stopTimer() ");
    
    clearTimeout( this.CloseTimer);
    this.CloseTimer = null;
}*/

SceneRemoveContact.prototype.startTimer = function()
{
    alert("SceneRemoveContact.startTimer() ");
	
	this.CloseTimer = true;
	PluginAPIMgr.StartOSDTimer("30000" , function() { $.sfScene.get('RemoveContact').popupTimerCallback();}, ENUM_TIMER_TYPE.TWO_BUTTON);
}

SceneRemoveContact.prototype.resetTimer = function()
{
    alert("SceneRemoveContact.resetTimer() ");
	
	if(this.CloseTimer == true)
	{
		PluginAPIMgr.RestartOSDTimer("30000" ,ENUM_TIMER_TYPE.TWO_BUTTON);
	}
}

SceneRemoveContact.prototype.stopTimer = function()
{
    alert("SceneRemoveContact.stopTimer() ");

	this.CloseTimer = false;
	PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.TWO_BUTTON); 
}

SceneRemoveContact.prototype.popupTimerCallback = function()
{
    alert("SceneRemoveContact.popupTimerCallback() ");
	
	if (this.CloseTimer == false)
	{
		return;
	}
	this.CloseTimer = false;	
		
	this.processReturnKey();
}

SceneRemoveContact.prototype.ClickOkBtn = function(){

	WndMgr.NextStepRemoveContact();	
	PluginAPIMgr.RemoveContact(this.RemoveIdentityName);
}

SceneRemoveContact.prototype.ClickCancelBtn = function(){

	StateMgr.Stop_Remove_Contact_State(true);
}
