

function SceneSignout(options) {
	this.options = options;
    
    this.SignoutView=null;
	this.SignoutDim=null;
    
    this.PopupMsg = null;
    this.YesBtn = null;
    this.NoBtn = null;
    
    this.flagWaiting = false;
	
	this.CloseTimer = false;
   
}

SceneSignout.prototype.initialize = function () {
	alert("SceneSignout.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
    
   this.create();
}

SceneSignout.prototype.handleShow = function () {
	alert("SceneSignout.handleShow()");
	// this function will be called when the scene manager show this scene 
	this.SignoutDim.show();
    this.highlight(this.NoBtn);
	
	this.startTimer();
}

SceneSignout.prototype.handleHide = function () {
	alert("SceneSignout.handleHide()");
	// this function will be called when the scene manager hide this scene 
	this.SignoutDim.hide(); 
	
	if (this.CloseTimer == true)
    {
        this.stopTimer();
    }
}

SceneSignout.prototype.handleFocus = function () {
	alert("SceneSignout.handleFocus()");
	// this function will be called when the scene manager focus this scene

}

SceneSignout.prototype.handleBlur = function () {
	alert("SceneSignout.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
    this.enableButton();
}

SceneSignout.prototype.handleKeyDown = function (keyCode) {
	alert("SceneSignout.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	PluginAPIMgr.PlayAudio(keyCode);
	switch (keyCode) {
		case $.sfKey.LEFT:
		case $.sfKey.RIGHT:
		this.resetTimer();
        this.processLeftRightKey();
			break;
		case $.sfKey.UP:

			break;
		case $.sfKey.DOWN:

			break;

		case $.sfKey.ENTER:
             this.processEnterKey();
			break;
            
        case $.sfKey.RETURN:
        case $.sfKey.EXIT:
            this.processReturnKey();
            $.sfKey.block(event);
			break;

         case 147:  //infolink
         case 261:  //contents
         case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneSignout.prototype.create = function(){
    alert("SceneSignout.create()");
    this.SignoutView = new View("Signout");
    this.SignoutView.SetBgImage(WndMgr.Bg_Popup.src); 
	
	this.SignoutDim = new DimBg("SignoutDim", "Signout");    
    
    this.PopupMsg = new Label(null,"signout_message");
    this.PopupMsg.SetTextStyle("signout_message_style");
    this.PopupMsg.SetText(TV_SID_DO_YOU_WANT_TO_SIGN_OUT);
    
    var this_ = $.sfScene.get("Signout");
    var clickCF =  function(obj){this_.processClickEvent(obj);};

    this.YesBtn = new Button();
    this.YesBtn.SetImageObjId("signout_yes_btn");
    this.YesBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_LOADING_BTN_NORMAL);
    this.YesBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_LOADING_BTN_NORMALFOCUS);	
    this.YesBtn.SetBgImage(BtnImgIndex.BTN_DIM_IMG, g_Image.IMAGE_LOADING_BTN_DIM);
    this.YesBtn.SetTextObjId("signout_yes_btn_text");
    this.YesBtn.SetText(SID_OK_KR_YES);
    this.YesBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"common_btn_text_f19_normal_style");
    this.YesBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE,"common_btn_text_f19_dim_style");
    this.YesBtn.SetOnClickCallbackFunc(clickCF);
    
    this.NoBtn = new Button();
    this.NoBtn.SetImageObjId("signout_no_btn");
    this.NoBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_LOADING_BTN_NORMAL);
    this.NoBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_LOADING_BTN_NORMALFOCUS);
	this.NoBtn.SetBgImage(BtnImgIndex.BTN_DIM_IMG, g_Image.IMAGE_LOADING_BTN_DIM);
    this.NoBtn.SetTextObjId("signout_no_btn_text");
    this.NoBtn.SetText(SID_CANCEL);
    this.NoBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"common_btn_text_f19_normal_style");
    this.NoBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE,"common_btn_text_f19_dim_style");
	this.NoBtn.SetOnClickCallbackFunc(clickCF);
}

SceneSignout.prototype.highlight=function(obj)
{
    this.SignoutView.setCurrenHighlight(obj);

}

SceneSignout.prototype.requestSignout = function()
{
    alert("SceneSignout.requestSignout() ");
    
    this.disableButton();
    ProcMgr.Signout(false);     
}

SceneSignout.prototype.startTimer = function()
{
    alert("SceneSignout.startTimer() ");
	
	this.CloseTimer = true;
	PluginAPIMgr.StartOSDTimer("30000" , function() { $.sfScene.get('Signout').popupTimerCallback();}, ENUM_TIMER_TYPE.TWO_BUTTON);
}

SceneSignout.prototype.resetTimer = function()
{
    alert("SceneSignout.resetTimer() ");
	
	if(this.CloseTimer == true)
	{
		PluginAPIMgr.RestartOSDTimer("30000" ,ENUM_TIMER_TYPE.TWO_BUTTON);
	}
}

SceneSignout.prototype.stopTimer = function()
{
    alert("SceneSignout.stopTimer() ");

	this.CloseTimer = false;
	PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.TWO_BUTTON); 
}

SceneSignout.prototype.popupTimerCallback = function()
{
    alert("SceneSignout.popupTimerCallback() ");
	
	if (this.CloseTimer == false)
	{
		return;
	}
	this.CloseTimer = false;	
		
	StateMgr.Stop_Signout_State(true);
}


SceneSignout.prototype.processLeftRightKey = function(){
    alert("SceneSignout.processLeftRightKey() ");
    
    if(this.flagWaiting ==true)
    {
        return;
    }
    
    var currentHighlight =  this.SignoutView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.YesBtn:
           this.highlight(this.NoBtn);
            break;
            
        case this.NoBtn:
           this.highlight(this.YesBtn);
            break;
    }
}

SceneSignout.prototype.processEnterKey = function(){
    alert("SceneSignout.processEnterKey() ");
    
     if(this.flagWaiting ==true)
    {
        return;
    }
    
    var currentHighlight =  this.SignoutView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.YesBtn:
            this.requestSignout();
            break;
            
        case this.NoBtn:
           StateMgr.Stop_Signout_State(true);
            break;
    }
}

SceneSignout.prototype.enableButton = function(){
    alert("SceneSignout.enableButton() ");
    
    this.PopupMsg.SetText(TV_SID_DO_YOU_WANT_TO_SIGN_OUT);
    this.YesBtn.SetFlagDim(false);
    this.NoBtn.SetFlagDim(false);
    
     this.flagWaiting = false;
}

SceneSignout.prototype.disableButton = function(){
    alert("SceneSignout.disableButton() ");
	if(this.CloseTimer == true)
	{
		this.stopTimer();
	}
	
     this.flagWaiting = true;
     this.PopupMsg.SetText(TV_SID_WAITING_DOT);
     
    this.YesBtn.blur();
    
    this.YesBtn.SetFlagDim(true);
    this.NoBtn.SetFlagDim(true);
    
}


SceneSignout.prototype.processReturnKey = function(){
    alert("SceneSignout.processReturnKey() ");
    
     if(this.flagWaiting ==true)
    {
        return;
    }
    
    StateMgr.Stop_Signout_State(true);
}

///////// Processing Click evnet  //////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*
SceneSignout.prototype.processYesBtnClick = function(){
    alert("SceneSignout.processYesBtnClick() ");
    var currentHighlight =  this.SignoutView.getCurrentHighlight();
    if(currentHighlight != this.YesBtn)
    {
    	this.highlight(this.YesBtn);
    }
    
    this.requestSignout();
}

SceneSignout.prototype.processNoBtnClick = function(){
    alert("SceneSignout.processNoBtnClick() ");
    var currentHighlight =  this.SignoutView.getCurrentHighlight();
    if(currentHighlight != this.NoBtn)
    {
    	this.highlight(this.NoBtn);
    }
    
    StateMgr.Stop_Signout_State(true);
}*/

SceneSignout.prototype.processClickEvent = function(obj){
	alert("SceneSignout.processClickEvent() ");
	
	var currentHighlight =  this.SignoutView.getCurrentHighlight();
    if(currentHighlight != obj)
    {
    	this.highlight(obj);
    }
	
	this.processEnterKey();
}



