

var CountryListStyle = [
		"CountryList_Init_position",
		"CountryList_Signup_position",
		"CountryList_Edit_Profile_position",			
	];

function SceneSignupCountryList(options) {

	this.options			= options;	
	this.CountryList		= null;
	this.UpArrow			= null;
	this.DownArrow			= null;
	this.CountryNameArray	= null;
	
	this.ListType	= COUNTRY_LIST_TYPE.INIT; 
	this.NeedToInit	= false;
	
	this.CurCountryIndex = -1;
	
	this.CallerScene = null;
	this.EnterCallbackFunc = null;
	this.ReturnCallbackFunc = null;				

	this.WheelOperation = false;
}

SceneSignupCountryList.prototype.initialize = function () {
	alert("SceneSignupCountryList.initialize()");	
	this.create();
}

SceneSignupCountryList.prototype.handleShow = function () {
	alert("SceneSignupCountryList.handleShow()");
	
	if(this.NeedToInit){
		alert("CountryList Init.......");
		
		var BgLayer = this.CountryList.GetBGLayer();
		BgLayer.SetStyle(CountryListStyle[this.ListType]);	

		this.NeedToInit = false;
				
	}	
		
	this.CountryList.Show();
	
}

SceneSignupCountryList.prototype.handleHide = function () {
	alert("SceneSignupCountryList.handleHide()");
	this.CountryList.Hide();

}

SceneSignupCountryList.prototype.handleFocus = function () {
	alert("SceneSignupCountryList.handleFocus()");
	
	if(this.CountryList.GetCurrentDataIndex() != this.CurCountryIndex){
		this.CountryList.SetHighlightForDataIndex(this.CurCountryIndex);	
	}	
	else {		
		this.CountryList.highlight();
	}
}

SceneSignupCountryList.prototype.handleBlur = function () {
	alert("SceneSignupCountryList.handleBlur()");

	this.CountryList.blur();

}

SceneSignupCountryList.prototype.handleKeyDown = function (keyCode) {
	
	alert("SceneSignupCountryList.handleKeyDown(" + keyCode + ")");
	PluginAPIMgr.PlayAudio(keyCode);
	
	switch(keyCode){
    
		case $.sfKey.ENTER:
			this.ResetCallerSceneTimer();
			this.ProcessKeyEnter();			
			break;			
                   
		case $.sfKey.RETURN:
			alert("KEY_RETURN");
			this.ResetCallerSceneTimer();
			this.ProcessKeyReturn();
			$.sfKey.block(event);			
			break;
			
		case $.sfKey.EXIT:
			$.sfKey.block(event);
			break;	
      
       case 147:  //infolink
       case 261:  //contents
       case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
			
		default :
			if(keyCode == $.sfKey.DOWN || keyCode == $.sfKey.UP)
			{
				this.ResetCallerSceneTimer();	
			}
			
			this.CountryList.KeyProcess(keyCode);	
			break;				                   
    }	

}

///////////////////////////////////////////////////////////////////////////////////////////////////////////


SceneSignupCountryList.prototype.create = function(){
    alert("SceneSignupCountryList.create() ");

	this.CountryList = new ScrollList();
	this.CountryList.CreateBG("CountryList");
	this.CountryList.SetBGImage(g_Image.IMAGE_SIGNUP_COUNTRY_LIST_L_BG);	
	this.CountryList.SetNumOfVisibleItem(5);
	this.CountryList.SetItemBgImage(ITEM_STATE.NORMAL," ");
	this.CountryList.SetItemBgImage(ITEM_STATE.HIGHLIGHT,g_Image.IMAGE_SIGNUP_COUNTRY_LIST_ITEM_HIGHLIGHT);
	this.CountryList.SetItemDefualtTextStyle(ITEM_STATE.NORMAL,"cCountryListItem_Text_Normal");
	this.CountryList.SetItemDefualtTextStyle(ITEM_STATE.HIGHLIGHT,"cCountryListItem_Text_Highlight");
	this.CountryList.SetDataType(ITEM_DATA_TYPE.IMAGE_TEXT);
	this.CountryList.CreateScrBar("CountryListScrollBar");
	this.CountryList.SetScrBarImage(g_Image.IMAGE_SIGNUP_COUNTRY_LIST_SCROLLBAR_BG,
		g_Image.IMAGE_BLOCK_SCROLLBAR_TOP,
		g_Image.IMAGE_BLOCK_SCROLLBAR_CENTER,
		g_Image.IMAGE_BLOCK_SCROLLBAR_BOTTOM);		
	
	this.InitData();

    var This_ = $.sfScene.get("SignupCountryList");
    var list_ = This_.CountryList;

	this.UpArrow = new CompBase(); 
	this.UpArrow.CreateBG("CountryListUpArrow");
	this.UpArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_UP_NOR);
	this.UpArrow.SetOnClickCallbackFunc(function(){list_.PreviousPage();});	
	this.UpArrow.SetOnMouseOverCallbackFunc(function(){This_.ChangeArrow(ARROW_TYPE.UP_SEL);});
	this.UpArrow.SetOnMouseOutCallbackFunc(function(){This_.ChangeArrow(ARROW_TYPE.UP_NOR);});	

	this.DownArrow = new CompBase(); 
	this.DownArrow.CreateBG("CountryListDownArrow");
	this.DownArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_DOWN_NOR);
	this.DownArrow.SetOnClickCallbackFunc(function(){list_.NextPage();});	
	this.DownArrow.SetOnMouseOverCallbackFunc(function(){This_.ChangeArrow(ARROW_TYPE.DOWN_SEL);});
	this.DownArrow.SetOnMouseOutCallbackFunc(function(){This_.ChangeArrow(ARROW_TYPE.DOWN_NOR);});		

    this.TempDiv = document.getElementById("SignupCountryList");
   	this.TempDiv.onmousewheel = function()
   	{
   		if(This_.WheelOperation == false)
   		{
   			alert("SignupCountryList.onmousewheel");
	   		This_.WheelOperation = true;
	   		PluginAPIMgr.StartOSDTimer("700" , function() { This_.wheelTimerCallback();}, ENUM_TIMER_TYPE.NO_BUTTON);
	   		
			if(event.wheelDelta > 0)
			{
				//alert("Up Up");
				list_.PreviousPage();
			}
			else
			{
				//alert("Down Down");
				list_.NextPage();
			}
	    }		
    };	
		
}

SceneSignupCountryList.prototype.Init = function(nType,CallerScene_,EnterCallbackFunc,Index){
	
	this.NeedToInit	= true;
	this.ListType	= nType; 
	
	this.CallerScene = CallerScene_;
	this.EnterCallbackFunc = EnterCallbackFunc;
	
	if(Index < 0){		
		this.CurCountryIndex = g_Data.GetMyCountryIndex();		
	}
	else{
		this.CurCountryIndex = Index;		
	}
	
	alert("SceneSignupCountryList.Init  >>> Index = " + this.CurCountryIndex);
		
}

SceneSignupCountryList.prototype.ProcessKeyReturn = function(){

	$.sfScene.focus(this.CallerScene);
	$.sfScene.hide('SignupCountryList');

}

SceneSignupCountryList.prototype.ProcessKeyEnter = function(){
		
	if(this.EnterCallbackFunc){
		this.EnterCallbackFunc();
	}
	
	$.sfScene.focus(this.CallerScene);
	$.sfScene.hide('SignupCountryList');		
	
	
}

SceneSignupCountryList.prototype.InitData = function(){

	var NumOfCountryList = g_Data.GetNumOfCountry();
	var tempData = new Array(NumOfCountryList);  
		
	for (var i=0; i < NumOfCountryList; i++) {
				
		tempData[i] = [ g_Data.DATA_COUNTRY_NAME_ARRAY[i] , g_Image.base_flag_image_path + g_Data.DATA_COUNTRY_CODE_ARRAY[i].toUpperCase() + ".png" ];				
		this.CountryList.AddData(tempData[i]);					
	}		


	this.CountryList.SetOnClickCallbackFunc(0,this.onClickEventFunc1);
	this.CountryList.SetOnClickCallbackFunc(1,this.onClickEventFunc2);
	this.CountryList.SetOnClickCallbackFunc(2,this.onClickEventFunc3);
	this.CountryList.SetOnClickCallbackFunc(3,this.onClickEventFunc4);
	this.CountryList.SetOnClickCallbackFunc(4,this.onClickEventFunc5);
	this.CountryList.SetClickEventAvailable(WndMgr.MouseClickEnable);
				
	this.CountryList.ShowItem();
	this.CountryList.SetScrBarPosition(210,0,5);
	
}

SceneSignupCountryList.prototype.GetCountryFlag = function(){
	
	var Index = this.CountryList.GetCurrentDataIndex();
	return g_Image.base_flag_image_path + g_Data.DATA_COUNTRY_CODE_ARRAY[Index].toUpperCase() + ".png"
}


SceneSignupCountryList.prototype.GetCountryName = function(){

	var Index = this.CountryList.GetCurrentDataIndex();	
	return g_Data.DATA_COUNTRY_NAME_ARRAY[Index];

}

SceneSignupCountryList.prototype.GetPrefix = function(){
	
	var Index = this.CountryList.GetCurrentDataIndex();	
	return g_Data.DATA_COUNTRY_PREFIX_ARRAY[Index];

}

SceneSignupCountryList.prototype.GetCountryCode= function(){
	
	var Index = this.CountryList.GetCurrentDataIndex();	
	return g_Data.DATA_COUNTRY_CODE_ARRAY[Index];

}

SceneSignupCountryList.prototype.ResetCallerSceneTimer = function(){
	switch(this.ListType)
	{
		case COUNTRY_LIST_TYPE.EDIT_PROFILE:
			$.sfScene.get("EditProfile").resetTimer();
		break;

	}
}

SceneSignupCountryList.prototype.ProcessClick = function(ItemIndex)
{
	alert("SceneSignupCountryList.ProcessClick() -- " + ItemIndex);		

	this.CountryList.MoveItem(ItemIndex);

	if(this.EnterCallbackFunc){
		this.EnterCallbackFunc();
	}
	
	$.sfScene.focus(this.CallerScene);
	$.sfScene.hide('SignupCountryList');		

}

SceneSignupCountryList.prototype.onClickEventFunc1 = function()
{
	var This_ = $.sfScene.get("SignupCountryList");	
	This_.ProcessClick(0);	
}

SceneSignupCountryList.prototype.onClickEventFunc2 = function()
{
	var This_ = $.sfScene.get("SignupCountryList");	
	This_.ProcessClick(1);	
}

SceneSignupCountryList.prototype.onClickEventFunc3 = function()
{
	var This_ = $.sfScene.get("SignupCountryList");	
	This_.ProcessClick(2);	
}

SceneSignupCountryList.prototype.onClickEventFunc4 = function()
{
	var This_ = $.sfScene.get("SignupCountryList");	
	This_.ProcessClick(3);	
}

SceneSignupCountryList.prototype.onClickEventFunc5 = function()
{
	var This_ = $.sfScene.get("SignupCountryList");	
	This_.ProcessClick(4);	
}

SceneSignupCountryList.prototype.ChangeArrow = function(Type)
{
	alert("SceneSignupCountryList.ChangeArrow");

	switch(Type)
	{
		case ARROW_TYPE.UP_NOR:
			this.UpArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_UP_NOR);
			break;
			
		case ARROW_TYPE.UP_SEL:
			this.UpArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_UP_SEL);
			break;

		case ARROW_TYPE.DOWN_NOR:
			this.DownArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_DOWN_NOR);
			break;
			
		case ARROW_TYPE.DOWN_SEL:
			this.DownArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_DOWN_SEL);
			break;		
	}
}

SceneSignupCountryList.prototype.wheelTimerCallback=function()
{
	this.WheelOperation = false;
}
