function SceneTextEditor(options) {
	this.options = options;
   // this.Bg_Image =null;
    this.TitleBar = null;    
    this.MsgLabel = null;
    this.MsgLengthLabel = null;
	
    this.TextEditorView=null;
	this.TextEditorDim=null;
    
    this.TextInputBox = null;
    
    this.flagPWD = false;
    this.initText ="";
    this.maxStringLenght = 50;
    this.callerObj = null;
    this.flagBlockSpace = false;
    
    this.flagCreate = false;
    
    this.flagPwdShow = false;
	
	this.TextInputTimer = false;

}

SceneTextEditor.prototype.initialize = function () {
	alert("SceneTextEditor.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
    
   this.create();
}

SceneTextEditor.prototype.handleShow = function () {
	alert("SceneTextEditor.handleShow()");
	// this function will be called when the scene manager show this scene 
    this.TextEditorDim.show();
	
	this.TextInputBox.initKeySet();		
    this.TextInputBox.initInputBox( this.flagPWD, this.initText, this.maxStringLenght,  this.callerObj );
 
    if(this.flagPWD == false )
    {
        this.TextInputBox.setBlockSpace(this.flagBlockSpace);
    }
	
	this.startTimer(); 
}

SceneTextEditor.prototype.handleHide = function () {
	alert("SceneTextEditor.handleHide()");
	// this function will be called when the scene manager hide this scene  
	this.TextEditorDim.hide();
    var obj = this.TextEditorView.getCurrentHighlight();
    if(obj!=null)
	{
		obj.imeHide();
	}
	
    this.flagPwdShow = false; //init
    
	this.MsgLengthLabel.SetText("");
	
	if(this.TextInputTimer == true)
	{
		this.stopTimer();
	}
}

SceneTextEditor.prototype.handleFocus = function () {
	alert("SceneTextEditor.handleFocus()");
	// this function will be called when the scene manager focus this scene   
    this.initTextEditor();
    this.highlight(this.TextInputBox);	
}

SceneTextEditor.prototype.handleBlur = function () {
	alert("SceneTextEditor.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
}

SceneTextEditor.prototype.handleKeyDown = function (keyCode) {
	alert("SceneTextEditor.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	PluginAPIMgr.PlayAudio(keyCode);
	switch (keyCode) {
		case $.sfKey.LEFT:
		case $.sfKey.RIGHT:
             this.processLeftRightKey();
			break;
		case $.sfKey.UP:

			break;
		case $.sfKey.DOWN:

			break;

		case $.sfKey.ENTER:
             //this.processEnterKey();
			break;
            
        case $.sfKey.RETURN:
            //this.processReturnKey();
            $.sfKey.block(event);
			break;
            
         case $.sfKey.EXIT:
            //this.processExitKey();
            $.sfKey.block(event);
			break;
            
         case 147:  //infolink
           $.sfKey.block(event);
			break;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneTextEditor.prototype.create = function(){
    if(this.flagCreate== true)
    {
        return;
    }
    
    alert("SceneTextEditor.create()");
    
    this.TextEditorView = new View("TextEditor");
    this.TextEditorView.SetBgImage(WndMgr.Bg_TextEditor.src );
	
	this.TextEditorDim = new DimBg("TextEditorDim", "TextEditor"); 
    
    this.TitleBar = new Label(null,"text_editor_title");
    this.TitleBar.SetTextStyle("text_editor_title_style");
    this.TitleBar.SetText("TextEditor");
   
    this.MsgLabel = new Label(null,"text_editor_msg");
    this.MsgLabel.SetTextStyle("text_editor_msg_style");
    this.MsgLabel.SetText("Help");
    
    this.TextInputBox= new InputBox();
	this.TextInputBox.SetButtonObjId("text_editor_input_box");
    this.TextInputBox.SetButtonTextObjId("text_editor_input_box_text");
	this.TextInputBox.SetInputBoxObjId("text_editor_input_box_editor");
	this.TextInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_INPUT_BOX_NORMAL);
	this.TextInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_INPUT_BOX_NORMALFOCUS);	
	this.TextInputBox.setKeypadPos(675,100);
    this.TextInputBox.setWordBoxPos(236,50);
    
	this.MsgLengthLabel = new Label(null,"text_editor_msg_length");
    this.MsgLengthLabel.SetTextStyle("text_editor_msg_length_style");
    this.MsgLengthLabel.SetText("");
	

    this.flagCreate = true;    
}

SceneTextEditor.prototype.initTextEditor= function()
{
    alert("SceneTextEditor.initTextEditor()");
    
    this.TitleBar.SetText(this.callerObj.GetTextEditorTitle());
    this.MsgLabel.SetText(this.callerObj.GetTextEditorMsg());
	this.TextInputBox.SetText("");
     
}

SceneTextEditor.prototype.update = function()
{  
 alert("SceneTextEditor.update() ");
  var obj = this.TextEditorView.getCurrentHighlight();
    
   var scene = $.sfScene.get("TextEditor");
   
   var ime = new IMEShell(obj.IMEObjInfo.id, scene.imeReady, 'en' /*, 'en' ,  "2_35_259"*/);

}

SceneTextEditor.prototype.highlight=function(obj)
{
	alert("SceneTextEditor.highlight() ");
    this.TextEditorView.setCurrenHighlight(obj);
	
	if(obj == null)
   {
   	 this.TextInputBox.imeHide();
   }
}

SceneTextEditor.prototype.processReturnKey = function(){
    alert("SceneTextEditor.processReturnKey() ");
	
	this.highlight(null);
	WndMgr.CancelTextEditor();
	$.sfKey.block(event);
}

SceneTextEditor.prototype.processEnterKey = function(){
    alert("SceneTextEditor.processEnterKey() ");

	this.highlight(null);
    WndMgr.StopTextEditor();

}


SceneTextEditor.prototype.initInputBox = function(callerObj)
{
    alert("SceneTextEditor.initInputBox()");

    this.flagPWD = callerObj.GetFlagPwd();
	this.initText =  callerObj.GetText();    
	this.flagBlockSpace = callerObj.GetFlagBlockSpace();
    this.maxStringLenght = callerObj.GetMaxStringLength();
    this.callerObj = callerObj;
    
    this.flagPwdShow = false;    
}

SceneTextEditor.prototype.imeReady = function(imeObject){
    alert("SceneTextEditor.imeReady() ");

	var scene = $.sfScene.get("TextEditor");
	var obj = scene.TextEditorView.getCurrentHighlight();

	obj.imeShow(imeObject);
    
    obj.setKeyFunc(88,  function(keyCode){ scene.processReturnKey(); $.sfKey.block(event); return false;}); // return key
    obj.setKeyFunc(45,  function(keyCode){ scene.processReturnKey(); $.sfKey.block(event); return false;}); // exit key
	obj.setKeyFunc(108, function(keyCode){scene.DeleteAllText();  return false;}); // red key
    obj.setKeyFunc(222, function(keyCode){$.sfKey.block(event);  return false;}); // source

	obj.setKeyFunc(147, function(keyCode){$.sfKey.block(event);  return false;}); // infolink
	obj.setKeyFunc(261, function(keyCode){$.sfKey.block(event);  return false;}); // contents
	obj.setKeyFunc(115, function(keyCode){$.sfKey.block(event);  return false;}); // wiselink
	
	obj.setOnCompleteFunc(function(keyCode){scene.updateMsgLength(); scene.resetTimer();  return false;});
	obj.setAnyKeyFunc(function(keyCode){scene.resetTimer();  return false;});
    obj.setEnterFunc( function(keyCode){scene.processEnterKey(); return false;});
            
    obj.setKeySetFunc("qwerty");
    
    scene.updateHelpBar(); //when input mode is pwd, display show or hide pwd string on help bar
    
	obj.setReady();
	
	scene.updateMsgLength();	
}

SceneTextEditor.prototype.updateMsgLength = function()
{
	alert("SceneTextEditor.updateMsgLength() ");
	
    var obj = this.TextEditorView.getCurrentHighlight();
    var input_string = obj.getString();
	
	if(input_string.length>0)
	{
		obj.SetText(input_string);
	}
	else
	{
		obj.SetText("");
	}
	
	this.MsgLengthLabel.SetText(String(input_string.length) +"/" +String(this.maxStringLenght)); 	
}

SceneTextEditor.prototype.updateHelpBar = function()
{
	var scene = $.sfScene.get("TextEditor");
	var obj = scene.TextEditorView.getCurrentHighlight();
	
	if(scene.flagPWD == true) 
	{
 		if(scene.flagPwdShow == true)
		{
			alert("SceneTextEditor.updateHelpBar() : mode 1 (hide)");
			obj.setShowHideString(SID_HIDE_PASSWORD);
		}
		else
		{
			alert("SceneTextEditor.updateHelpBar() : mode 2 (show)");
			obj.setShowHideString(SID_SHOW_PASSWORD);
		}
	} 
	else
	{
		alert("SceneTextEditor.updateHelpBar() : mode 3 (null)");
		obj.setShowHideString(null);
	}
}

SceneTextEditor.prototype.GetInputText = function()
{
    //var TextInputBox = this.TextEditorView.getCurrentHighlight();
   // return this.TextInputBox.getString();
   return this.TextInputBox.GetText();
}

SceneTextEditor.prototype.DeleteAllText = function()
{
	this.resetTimer();
	
    if(this.flagPWD == true)
    {
        this.TogglePWDShowMode();
    }
    else
    {
        var obj = this.TextEditorView.getCurrentHighlight();
        obj.setString("");
		this.updateMsgLength();
    }
}

SceneTextEditor.prototype.TogglePWDShowMode = function()
{
    alert("SceneTextEditor.TogglePWDShowMode() ");
    
	var obj = this.TextEditorView.getCurrentHighlight();
	var curr_string = obj.GetText();
    obj.setEngOnly(true);
    
    this.TextInputBox.updateInputBox( this.flagPwdShow, curr_string, this.maxStringLenght,  this.callerObj );
    if( $.sfScene.get('TextEditor').flagPwdShow == false)
    {
        obj.setBlockSpace(true);
    }
    
    if(this.flagPwdShow == false)
    {
        this.flagPwdShow = true;
        
    }
    else
    {
        this.flagPwdShow = false;
        
    }  
    
    this.update();
    //this.updateMsgLength();

}

SceneTextEditor.prototype.startTimer = function()
{
    alert("SceneTextEditor.startTimer() ");
	
	this.TextInputTimer = true;
	PluginAPIMgr.StartOSDTimer("60000" , function() { $.sfScene.get('TextEditor').popupTimerCallback();}, ENUM_TIMER_TYPE.TEXT_INPUT);
}

SceneTextEditor.prototype.resetTimer = function()
{
    alert("SceneTextEditor.resetTimer() ");

	if(this.TextInputTimer == true)
	{
		PluginAPIMgr.RestartOSDTimer("60000" ,ENUM_TIMER_TYPE.TEXT_INPUT);
	}
}

SceneTextEditor.prototype.stopTimer = function()
{
    alert("SceneTextEditor.stopTimer() ");
	
	this.TextInputTimer = false;
	PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.TEXT_INPUT);
}

SceneTextEditor.prototype.popupTimerCallback = function()
{
	alert("SceneTextEditor.popupTimerCallback() ");
	if(this.TextInputTimer == false)
	{
		return;
	}	
	
	this.TextInputTimer = false;
   	this.highlight(null);
	WndMgr.CancelTextEditor();
}



