var VIDEO_SNAPSHOT_COUNTER = { 
 
 	INIT		: 0,
 	NOTHING		: 1,
 	ONE			: 2,
	TWO			: 3, 	
	THREE		: 4,
	
}

var VIDEO_SNAPSHOT_MODE = { 

	RECORD		: 1,
	SAVE		: 2,
}

function SceneVideoSnapshot(options) {
	this.options = options;
    
    this.VideoSnapshotView	= null;

    this.Title		 		= null;
	this.FirstCountButton	= null;
	this.SecondCountButton	= null;
	this.ThirdCountButton	= null;	
    this.ShootBtn			= null;
	this.SaveBtn			= null;
	this.RetryBtn			= null;
		       
    this.VideoSnapshotHelpBar 		= null;

	this.timer		= null;
	this.Counter	= VIDEO_SNAPSHOT_COUNTER.INIT;
	
	this.magnification = 0;
	
	//flag
	this.IsKeyBlock	= false;
	this.Is1366x768Panel = false;
	this.Mode = VIDEO_SNAPSHOT_MODE.RECORD;
}

SceneVideoSnapshot.prototype.initialize = function () {
	alert("SceneVideoSnapshot.initialize()");
	
	this.create();
}

SceneVideoSnapshot.prototype.handleShow = function () {
	alert("SceneVideoSnapshot.handleShow()");

	if(this.Is1366x768Panel)
	{
		PluginAPIMgr.StartPreview(43,24,1280,720);
	}
	else{
		PluginAPIMgr.StartPreview(320,174,1280,720);
	}

	this.magnification = 0;
	
}

SceneVideoSnapshot.prototype.handleHide = function () {
	alert("SceneVideoSnapshot.handleHide()");

    this.ResetState();
	this.highlight(null);
	
	if(ProcMgr.GetIsInCall() == false)
	{
		PluginAPIMgr.StopPreview();	
	}	
	
}

SceneVideoSnapshot.prototype.handleFocus = function () {
	alert("SceneVideoSnapshot.handleFocus()");

    var currentHighlight =  this.VideoSnapshotView.getCurrentHighlight();
	
	if(currentHighlight == null){
		
		if(this.Mode == VIDEO_SNAPSHOT_MODE.SAVE){
			
			this.highlight(this.SaveBtn);
		}
		else{
			this.highlight(this.ShootBtn);
		}
		
	}
	else{

		this.highlight(currentHighlight);
	}
	
}

SceneVideoSnapshot.prototype.handleBlur = function () {
	alert("SceneVideoSnapshot.handleBlur()");	
	
	var currentHighlight =  this.VideoSnapshotView.getCurrentHighlight();
	
	if(currentHighlight != null){
	
		currentHighlight.blur();
	}

}

SceneVideoSnapshot.prototype.handleKeyDown = function (keyCode) {
	alert("SceneVideoSnapshot.handleKeyDown(" + keyCode + ")");
	PluginAPIMgr.PlayAudio(keyCode);
	
	if(this.IsKeyBlock == false){

		switch (keyCode) {
	
			case $.sfKey.ENTER:
				this.processEnterKey();
				break;
	            
	        case $.sfKey.RETURN:
	        case $.sfKey.EXIT:
	            this.processReturnKey();
	            $.sfKey.block(event);
				break;

	        case $.sfKey.LEFT:
	        case $.sfKey.RIGHT:
				this.processLeftRightKey();
	            break;
										                
            case 147:  //infolink
            case 261:  //contents
            case 115:  //wiselink
            	PluginAPIMgr.StopPreview(); 
            	ProcMgr.processInfolinkKey(); 
			break;
			
			default:
            	ProcMgr.processBlockKey(keyCode);
            break;
							
		}		
	}
	else{		
		if(keyCode == $.sfKey.RETURN && this.Counter > VIDEO_SNAPSHOT_COUNTER.INIT){
			this.ResetState();
			this.highlight(this.ShootBtn);
			$.sfKey.block(event);	
		}
		else{
			$.sfKey.block(event);	
		}		
	}


}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneVideoSnapshot.prototype.create = function(){
    alert("SceneViewProfileProfile.create()");

	//PluginAPIMgr.GetResolution();

		
    this.VideoSnapshotView = new View("VideoSnapshot");

	if(WndMgr.Is1366x768Panel())
	{
		alert("**************** this panel is 1366 x 768");
		this.Is1366x768Panel = true;
		this.VideoSnapshotView.SetBgImage(g_Image.VIDEO_SNAPSHOT_SMALL);
	}
	else{
		this.VideoSnapshotView.SetBgImage(g_Image.VIDEO_SNAPSHOT);
	}
    
    this.Title = new Label(null,"VideoSnapshot_title");
    this.Title.SetText(IDWS_MOIP_SKYPE_TAKE_VIDEO_SNAPSHOT);	 

	this.FirstCountLabel = new Label("VideoSnapshot_Count1",null);
	this.FirstCountLabel.SetBgImage(g_Image.IMAGE_CALLING_ANIMATION_NORMAL);
	
    this.FirstCountButton= new ButtonBase();
    this.FirstCountButton.Create("VideoSnapshot_Count1",BUTTON_BASE_TYPE.ONLY_BG);
    this.FirstCountButton.SetBgImage(BUTTON_BASE_STATE.NORMAL, g_Image.IMAGE_LIST_MAIN_SETTING_SNAPSHOT_COUNT1_NORMAL_BG);
    this.FirstCountButton.SetBgImage(BUTTON_BASE_STATE.HIGHLIGHT, g_Image.IMAGE_LIST_MAIN_SETTING_SNAPSHOT_COUNT1_HIGHLIGHT_BG);

    this.SecondCountButton= new ButtonBase();
    this.SecondCountButton.Create("VideoSnapshot_Count2",BUTTON_BASE_TYPE.ONLY_BG);
    this.SecondCountButton.SetBgImage(BUTTON_BASE_STATE.NORMAL, g_Image.IMAGE_LIST_MAIN_SETTING_SNAPSHOT_COUNT2_NORMAL_BG);
    this.SecondCountButton.SetBgImage(BUTTON_BASE_STATE.HIGHLIGHT, g_Image.IMAGE_LIST_MAIN_SETTING_SNAPSHOT_COUNT2_HIGHLIGHT_BG);

    this.ThirdCountButton= new ButtonBase();
    this.ThirdCountButton.Create("VideoSnapshot_Count3",BUTTON_BASE_TYPE.ONLY_BG);
    this.ThirdCountButton.SetBgImage(BUTTON_BASE_STATE.NORMAL, g_Image.IMAGE_LIST_MAIN_SETTING_SNAPSHOT_COUNT3_NORMAL_BG);
    this.ThirdCountButton.SetBgImage(BUTTON_BASE_STATE.HIGHLIGHT, g_Image.IMAGE_LIST_MAIN_SETTING_SNAPSHOT_COUNT3_HIGHLIGHT_BG);

 	this.ShootBtn = new ButtonBase();
    this.ShootBtn.Create("VideoSnapshot_ShootButton",BUTTON_BASE_TYPE.BG_TEXT);
    this.ShootBtn.SetBgImage(BUTTON_BASE_STATE.NORMAL, g_Image.IMAGE_SNAPSHOT_SHOOT_BTN_NORMAL);	
    this.ShootBtn.SetBgImage(BUTTON_BASE_STATE.HIGHLIGHT, g_Image.IMAGE_SNAPSHOT_SHOOT_NORMALFOCUS);
	this.ShootBtn.SetBgImage(BUTTON_BASE_STATE.DIM, g_Image.IMAGE_SNAPSHOT_SHOOT_DIM);	
 	this.ShootBtn.SetTextStyle(BUTTON_BASE_STATE.NORMAL,"cButton_Text_Blur_Style");
 	this.ShootBtn.SetTextStyle(BUTTON_BASE_STATE.DIM,"cButton_Text_Dim_Style");	
	this.ShootBtn.SetText(TV_SID_TAKE_A_SNAPSHOT);
	this.ShootBtn.SetOnClickCallbackFunc(this.ClickShootBtn);

 	this.SaveBtn = new ButtonBase();
    this.SaveBtn.Create("VideoSnapshot_SaveButton",BUTTON_BASE_TYPE.BG_TEXT);
    this.SaveBtn.SetBgImage(BUTTON_BASE_STATE.NORMAL, g_Image.IMAGE_SNAPSHOT_SHOOT_BTN_NORMAL);	
    this.SaveBtn.SetBgImage(BUTTON_BASE_STATE.HIGHLIGHT, g_Image.IMAGE_SNAPSHOT_SHOOT_NORMALFOCUS);
 	this.SaveBtn.SetTextStyle(BUTTON_BASE_STATE.NORMAL,"cButton_Text_Blur_Style");
	this.SaveBtn.SetText(SID_SAVE);
	this.SaveBtn.SetOnClickCallbackFunc(this.ClickSaveBtn);

 	this.RetryBtn = new ButtonBase();
    this.RetryBtn.Create("VideoSnapshot_RetryButton",BUTTON_BASE_TYPE.BG_TEXT);
    this.RetryBtn.SetBgImage(BUTTON_BASE_STATE.NORMAL, g_Image.IMAGE_SNAPSHOT_SHOOT_BTN_NORMAL);	
    this.RetryBtn.SetBgImage(BUTTON_BASE_STATE.HIGHLIGHT, g_Image.IMAGE_SNAPSHOT_SHOOT_NORMALFOCUS);
 	this.RetryBtn.SetTextStyle(BUTTON_BASE_STATE.NORMAL,"cButton_Text_Blur_Style");
	this.RetryBtn.SetText(SID_RETRY_KR_RETRY);
	this.RetryBtn.SetOnClickCallbackFunc(this.ClickRetryBtn);
				
    this.VideoSnapshotHelpBar = new HelpBar(HelpBarIndex.VIDEO_SNAPSHOT, "VideoSnapshot");

	this.ShootBtn.Show();

	var scene = $.sfScene.get("VideoSnapshot");	
	this.VideoSnapshotHelpBar.SetOnClickCallbackFunc(1, function(){scene.processReturnKey();	});    

    this.VideoSnapshotView.registHelpBar( this.VideoSnapshotHelpBar);

}

SceneVideoSnapshot.prototype.highlight=function(obj){
	
	this.VideoSnapshotView.setCurrenHighlight(obj);
}

SceneVideoSnapshot.prototype.processReturnKey = function(){
    alert("SceneVideoSnapshot.processReturnKey() ");
	
	if(this.Mode == VIDEO_SNAPSHOT_MODE.RECORD){
		
		StateMgr.Start_Main_State();
		StateMgr.Start_Change_Picture_State();		
	}
	else if(this.Mode == VIDEO_SNAPSHOT_MODE.SAVE){

		StateMgr.Start_Main_State();
		StateMgr.Start_Change_Picture_State();
	}
	else
	{
		alert("Mode Error!!!!");
	}
	
}


SceneVideoSnapshot.prototype.processLeftRightKey = function(){
    alert("SceneVideoSnapshot.processLeftRightKey() ");

	var currentHighlight =  this.VideoSnapshotView.getCurrentHighlight();
	
	if(currentHighlight == this.RetryBtn){
		
		this.highlight(this.SaveBtn);
	}
	else if(currentHighlight == this.SaveBtn){
		
		this.highlight(this.RetryBtn);
	}
	
}

SceneVideoSnapshot.prototype.processEnterKey = function(){
    alert("SceneVideoSnapshot.processEnterKey() ");
	
	var currentHighlight =  this.VideoSnapshotView.getCurrentHighlight();
	
	switch(currentHighlight) {
		
		case this.RetryBtn:
			this.IsKeyBlock = true;
			PluginAPIMgr.StopPreview();			
			PluginAPIMgr.StartPreview(320,174,1280,720);	
			this.SetMode(VIDEO_SNAPSHOT_MODE.RECORD);
			this.IsKeyBlock = false;			
			break;			
			
		case this.ShootBtn:		
			this.ProcessSootBtn();		
			break;
			
		case this.SaveBtn:
			$.sfScene.get("ChangePicture").ResetLastIndex();		
			this.ProcessSaveBtn();
			break;
	}
}


SceneVideoSnapshot.prototype.ProcessSootBtn = function(){

	if(PluginAPIMgr.GetNumOfSnapShot() < TOTAL_NUM_OF_SNAPSHOT){

		this.IsKeyBlock = true;
		this.highlight(null);	
		this.ShootBtn.dim();		
		this.StartSnapshot();
				
	}
	else {

		StateMgr.Start_Main_State();
		WndMgr.StartOneBottonPopup(OneBtnPopupIndex.NO_MORE_PHOTO_AVAILABLE_IN_VIDEO_SNAPSHOT);		
							
	}
}


SceneVideoSnapshot.prototype.ProcessSaveBtn = function(){

	this.IsKeyBlock = true;
	//Sync function !!! Do not process event from engine. 
	PluginAPIMgr.SaveSnapShot();
	PluginAPIMgr.StopPreview();			

	StateMgr.Start_Main_State();
	StateMgr.Start_Change_Picture_State();	
	
}

SceneVideoSnapshot.prototype.SetMode = function(nMode){
	alert("SceneVideoSnapshot.SetMode() ");

	if(nMode == this.Mode){
		
		if(nMode == VIDEO_SNAPSHOT_MODE.SAVE){
			
			this.highlight(this.SaveBtn);
		}
		else{
			
			this.highlight(this.ShootBtn);
		}
	}
	else{
		
		this.Mode = nMode;
		
		if(nMode == VIDEO_SNAPSHOT_MODE.SAVE){
			
			this.ShootBtn.Hide();

			this.SaveBtn.Show();
			this.RetryBtn.Show();
			
			this.highlight(this.SaveBtn);
		}
		else if(nMode == VIDEO_SNAPSHOT_MODE.RECORD){
			
			this.SaveBtn.Hide();
			this.RetryBtn.Hide();	

			this.ShootBtn.blur();			
			this.ShootBtn.Show();
	
			this.highlight(this.ShootBtn);
		}
	}
}


SceneVideoSnapshot.prototype.SetCounterImage = function(count){

	alert("SceneVideoSnapshot.SetCounterImage(" + count + ")");
	
	switch(count){

		case VIDEO_SNAPSHOT_COUNTER.INIT: 
			this.FirstCountButton.Hide();
			this.SecondCountButton.Hide();
			this.ThirdCountButton.Hide();
			this.FirstCountButton.blur();				
			this.SecondCountButton.blur();			
			this.ThirdCountButton.blur();			
			break;
		case VIDEO_SNAPSHOT_COUNTER.NOTHING: 
			this.FirstCountButton.Show();
			this.SecondCountButton.Show();
			this.ThirdCountButton.Show();			
			break;
		case VIDEO_SNAPSHOT_COUNTER.ONE: 		
			this.FirstCountButton.highlight();
			break;
		case VIDEO_SNAPSHOT_COUNTER.TWO: 
			this.FirstCountButton.blur();		
			this.SecondCountButton.highlight();
			break;
		case VIDEO_SNAPSHOT_COUNTER.THREE: 
			this.SecondCountButton.blur();		
			this.ThirdCountButton.highlight();
			break;			
	}

}


SceneVideoSnapshot.prototype.StartSnapshot = function(){

	alert("SceneVideoSnapshot.StartSnapshot()");
	
	var this_ = $.sfScene.get('VideoSnapshot');
	
	this_.Counter++;
	if(this_.Counter == VIDEO_SNAPSHOT_COUNTER.THREE){
						
		this_.SetCounterImage(this_.Counter);
		this_.timer = setTimeout("Callbackfunction()", 300);
		Callbackfunction = function() { this_.StartSnapshot();}	
	}
	else if(this_.Counter > VIDEO_SNAPSHOT_COUNTER.THREE){

		//this_.IsKeyBlock = true;
		this_.Counter = VIDEO_SNAPSHOT_COUNTER.INIT;
		this_.SetCounterImage(this_.Counter);
		PluginAPIMgr.TakeSnapShot();	
					
		this_.SetMode(VIDEO_SNAPSHOT_MODE.SAVE);
				
	}
	else{
		
		this_.SetCounterImage(this_.Counter);
		this_.timer = setTimeout("Callbackfunction()", 1000);
		Callbackfunction = function() { this_.StartSnapshot();}		
		
	}	
}

SceneVideoSnapshot.prototype.stopSnapshot = function()
{
    alert("SceneVideoSnapshot.stopSnapshot() ");
    
    clearTimeout( this.timer);
    this.timer=null;
}

SceneVideoSnapshot.prototype.RemovedCamera = function(){

    alert("SceneVideoSnapshot.RemovedCamera() ");
	this.processReturnKey();

}

SceneVideoSnapshot.prototype.ResetState = function(){

    alert("SceneVideoSnapshot.ResetState() ");

	//reset countering 
    clearTimeout( this.timer);
    this.timer		= null;
	this.IsKeyBlock	= false;	
	this.Counter	= VIDEO_SNAPSHOT_COUNTER.INIT;
	this.SetCounterImage(VIDEO_SNAPSHOT_COUNTER.INIT);
	
	//reset button mode
	this.Mode = VIDEO_SNAPSHOT_MODE.RECORD;    
	
	this.SaveBtn.Hide();
	this.RetryBtn.Hide();
	
	this.ShootBtn.blur();	
	this.ShootBtn.Show();

}

SceneVideoSnapshot.prototype.TrunOffKeyBlock = function()
{
	alert("SceneVideoSnapshot.TrunOffKeyBlock() ");
	this.IsKeyBlock = false;
}


SceneVideoSnapshot.prototype.ClickRetryBtn = function(){
	alert("SceneVideoSnapshot.ClickRetryBtn");	

	var This_ = $.sfScene.get('VideoSnapshot');

	This_.IsKeyBlock = true;
	PluginAPIMgr.StopPreview();			
	PluginAPIMgr.StartPreview(320,174,1280,720);	
	This_.SetMode(VIDEO_SNAPSHOT_MODE.RECORD);
	This_.IsKeyBlock = false;
}

SceneVideoSnapshot.prototype.ClickShootBtn = function(){

	var This_ = $.sfScene.get('VideoSnapshot');
	This_.ProcessSootBtn();
}

SceneVideoSnapshot.prototype.ClickSaveBtn = function(){

	var This_ = $.sfScene.get('VideoSnapshot');

	$.sfScene.get("ChangePicture").ResetLastIndex();		
	This_.ProcessSaveBtn();
}

