function SceneVoiceMail(options) {
	this.options = options;
    
    this.VoiceMailView=null;
	this.VoiceMailDim=null;

    this.CallMemberThumbnailLabel = null;
    this.CallMembertNameLabel = null;

    this.VoiceMailMessageLabel = null;
    this.VoiceMailTimeDurationLabel = null;
    
	this.CancelBtn = null;
    this.UploadBtn = null;
    this.EndCallBtn = null;
	
    this.current_volume_value = 0;
}

SceneVoiceMail.prototype.initialize = function () {
	alert("SceneVoiceMail.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
    
   this.create();
}

SceneVoiceMail.prototype.handleShow = function () {
	alert("SceneVoiceMail.handleShow()");
	// this function will be called when the scene manager show this scene 
	this.VoiceMailDim.show();
	this.update();
}

SceneVoiceMail.prototype.handleHide = function () {
	alert("SceneVoiceMail.handleHide()");
	// this function will be called when the scene manager hide this scene  
	this.VoiceMailDim.hide();
}

SceneVoiceMail.prototype.handleFocus = function () {
	alert("SceneVoiceMail.handleFocus()");
	// this function will be called when the scene manager focus this scene
	this.highlight(this.CancelBtn);
}

SceneVoiceMail.prototype.handleBlur = function () {
	alert("SceneVoiceMail.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
}

SceneVoiceMail.prototype.handleKeyDown = function (keyCode) {
	alert("SceneVoiceMail.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	PluginAPIMgr.PlayAudio(keyCode);
	switch (keyCode) {
		
		case $.sfKey.VOL_DOWN:
        case $.sfKey.PANEL_VOL_DOWN:

           this.processVolumeDownKey();
			break;
		case $.sfKey.VOL_UP:
        case $.sfKey.PANEL_VOL_UP:

             this.processVolumeUpKey();
			break;
			
		case $.sfKey.LEFT:
		case $.sfKey.RIGHT:
             this.processLeftRightKey();
			break;
			
		case $.sfKey.UP:
			break;
		case $.sfKey.DOWN:
			break;
			
		case $.sfKey.ENTER:
             this.processEnterKey();
			break;
            
        case $.sfKey.RETURN:
		case $.sfKey.EXIT:
            $.sfKey.block(event);
			break;
            
        case 147:  //infolink
         case 261:  //contents
         case 115:  //wiselink
            $.sfKey.block(event);
			break;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneVoiceMail.prototype.create = function(){
    alert("SceneVoiceMail.create()");
    this.VoiceMailView = new View("VoiceMail");
    this.VoiceMailView.SetBgImage(WndMgr.Bg_Calling.src);
	
	this.VoiceMailDim = new DimBg("VoiceMailDim", "VoiceMail"); 
    
    this.CallMembertNameLabel = new Label(null,"voice_mail_member_name");
    this.CallMembertNameLabel.SetTextStyle("voice_mail_member_name_style");
    this.CallMembertNameLabel.SetReverseDisable(true);
    this.CallMembertNameLabel.SetIsPlainText(true);

    this.CallMemberThumbnailLabel= new Label("voice_mail_member_thumbnail", null);
    this.CallMemberThumbnailLabel.SetBgImage(g_Image.IMAGE_CALLING_CALL_MEMBER_THUMBNAIL);
    this.CallMemberThumbnailLabel.AppendFgImage("voice_mail_member_thumbnail_avata","3px","2px","69px","69px");
    
    this.VoiceMailMessageLabel= new Label("voice_mail_message", "voice_mail_message_text");
    this.VoiceMailMessageLabel.SetBgImage(g_Image.IMAGE_CALLING_CALL_FAIL_MSG_BG);
    this.VoiceMailMessageLabel.SetTextStyle("voice_mail_message_text_style");
   
    this.VoiceMailTimeDurationLabel= new Label(null, "voice_mail_time_duration_text");
    this.VoiceMailTimeDurationLabel.SetTextStyle("voice_mail_message_text_style");
    
    var this_ = $.sfScene.get("VoiceMail");
    var clickCF =  function(obj){this_.processClickEvent(obj);};
	
	this.CancelBtn = new Button();
    this.CancelBtn.SetImageObjId("voice_mail_cancel_btn");
    this.CancelBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_CALLING_BTN_NORMAL);
    this.CancelBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_CALLING_BTN_NORMALFOCUS);
	this.CancelBtn.SetBgImage(BtnImgIndex.BTN_DIM_IMG, g_Image.IMAGE_CALLING_BTN_DIM);		
    this.CancelBtn.SetTextObjId("voice_mail_cancel_btn_text");
    this.CancelBtn.SetText(SID_CANCEL);
    this.CancelBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"common_btn_text_f17_normal_style");
	this.CancelBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE,"common_btn_text_f17_dim_style");
	this.CancelBtn.SetOnClickCallbackFunc(clickCF);
	this.CancelBtn.visibleObj();

    this.UploadBtn = new Button();
    this.UploadBtn.SetImageObjId("voice_mail_upload_btn");
    this.UploadBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_VOICE_CALL_END_BTN_NORMAL);
    this.UploadBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_VOICE_CALL_END_BTN_NORMALFOCUS);	
    this.UploadBtn.SetBgImage(BtnImgIndex.BTN_DIM_IMG, g_Image.IMAGE_VOICE_CALL_TO_VIDEO_CALL_BTN_DIM);
	this.UploadBtn.SetTextObjId("voice_mail_upload_btn_text");
    this.UploadBtn.SetText(TV_SID_END_CALL);
    this.UploadBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"common_btn_text_f17_normal_style");
	this.UploadBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE,"common_btn_text_f17_dim_style");
	this.UploadBtn.SetOnClickCallbackFunc(clickCF);
	this.UploadBtn.hiddenObj();
    
    this.EndCallBtn = new Button();
    this.EndCallBtn.SetImageObjId("voice_mail_end_call_btn");
    this.EndCallBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_VOICE_CALL_BTN_NORMAL);
    this.EndCallBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_VOICE_CALL_BTN_NORMALFOCUS);
	this.EndCallBtn.SetBgImage(BtnImgIndex.BTN_DIM_IMG, g_Image.IMAGE_VOICE_CALL_BTN_DIM);
	this.EndCallBtn.SetTextObjId("voice_mail_end_call_btn_text");
    this.EndCallBtn.SetText(SID_CANCEL);
    this.EndCallBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"common_btn_text_f17_normal_style");
	this.EndCallBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE,"common_btn_text_f17_dim_style");
	this.EndCallBtn.SetOnClickCallbackFunc(clickCF);
	this.EndCallBtn.hiddenObj();

}

SceneVoiceMail.prototype.highlight=function(obj)
{
    this.VoiceMailView.setCurrenHighlight(obj);

}

SceneVoiceMail.prototype.update = function()
{
    
    this.CallMembertNameLabel.SetText( g_Data.DATA_VOICE_MAIL_INPUT_INFO.callee_name); 
    this.CallMemberThumbnailLabel.SetFgImage(PluginAPIMgr.GetContactAvataImage( g_Data.DATA_VOICE_MAIL_INPUT_INFO.callee_name));

    this.VoiceMailMessageLabel.SetText(IDWS_MOIP_SKYPE_RINGING);
	
	this.BtnEnable();
	
	this.CancelBtn.visibleObj();
	this.UploadBtn.hiddenObj();
	this.EndCallBtn.hiddenObj();
	
    this.VoiceMailTimeDurationLabel.SetText("");
    this.VoiceMailTimeDurationLabel.hiddenObj();
}

SceneVoiceMail.prototype.updateCallDuration = function(time)
{
     this.VoiceMailTimeDurationLabel.SetText(time);
}

SceneVoiceMail.prototype.updateVoiceMailMessage = function(call_status)
{
    if(call_status == ENUM_CALL_STATUS.VM_RECORDING)
    {
		 this.VoiceMailTimeDurationLabel.SetText("00:00:01");
		 this.UploadBtn.SetFlagDim(false);
         this.highlight(this.UploadBtn);
    }
    else
    {
	    if (call_status == ENUM_CALL_STATUS.VM_PLAYING_GREETING) 
		{
			this.CancelBtn.hiddenObj();

			this.UploadBtn.SetFlagDim(true);
			this.highlight(this.EndCallBtn);
			
			this.EndCallBtn.visibleObj();
			this.UploadBtn.visibleObj();
			
			this.VoiceMailTimeDurationLabel.SetText("");
			this.VoiceMailTimeDurationLabel.visibleObj(); // for playing greeting msg
		}
		else
		{
			this.VoiceMailTimeDurationLabel.SetText("");
			this.VoiceMailTimeDurationLabel.hiddenObj();
		}
		
        
    }
    
    this.VoiceMailMessageLabel.SetText(this.GetCallStatusString(call_status));
}

	

SceneVoiceMail.prototype.GetCallStatusString = function(call_status)
{
	switch(call_status)
	{
		case ENUM_CALL_STATUS.VM_BUFFERING_GREETING :
			return IDWS_MOIP_BUFFERING_VOICEMAIL_GREETING;

		case ENUM_CALL_STATUS.VM_PLAYING_GREETING :
			return IDWS_MOIP_PLAYING_VOICEMAIL_GREETING;

		case ENUM_CALL_STATUS.VM_RECORDING :
			return IDWS_MOIP_VOICEMAIL_RECORDING;

		case ENUM_CALL_STATUS.VM_UPLOADING : 
			return IDWS_MOIP_VOICEMAIL_UPLOADING;

		case ENUM_CALL_STATUS.VM_SENT : 
			return IDWS_MOIP_VOICEMAIL_SENT;

		case ENUM_CALL_STATUS.VM_CANCELLED : 
			return IDWS_MOIP_VOICEMAIL_CANCELLED;

		case ENUM_CALL_STATUS.VM_FAILED : 
			return IDWS_MOIP_VOICEMAIL_FAILED;
			
		case ENUM_CALL_STATUS.TRANSFERRING : 
			return TRANSFERRING;
			
		case ENUM_CALL_STATUS.TRANSFERRED : 
			return TRANSFERRED;
		
		case ENUM_CALL_STATUS. VM_SEND_FAILED:
			return IDWS_MOIP_VOICEMAIL_FAILED;
    }
}

SceneVoiceMail.prototype.processLeftRightKey = function(){
    alert("SceneVoiceMail.processLeftRightKey() ");
    
    var currentHighlight =  this.VoiceMailView.getCurrentHighlight();
    
    switch(currentHighlight)
    {           
        case this.UploadBtn:
            this.highlight(this.EndCallBtn);
            break;
            
        case this.EndCallBtn:
			if(this.UploadBtn.GetFlagDim()==false)
			{
				this.highlight(this.UploadBtn);
			}
            
            break;
    }
}

SceneVoiceMail.prototype.processEnterKey = function(){
    alert("SceneVoiceMail.processEnterKey() ");
    
    var currentHighlight =  this.VoiceMailView.getCurrentHighlight();
    
    switch(currentHighlight)
    {       
	    case this.CancelBtn:
			this.BtnDisable();
			ProcMgr.CancelVoiceMail();
            break;
			    
        case this.UploadBtn:
			this.BtnDisable();
			ProcMgr.UploadVoiceMail();
            break;
            
        case this.EndCallBtn:
			this.BtnDisable();
			ProcMgr.CancelVoiceMail();
            break;

    }
	//TEMPCODE
	var scene = $.sfScene.get("ListMainContact");
	scene.Activation();	
}

SceneVoiceMail.prototype.BtnDisable = function()
{
	this.highlight(null);
	this.CancelBtn.SetFlagDim(true);
	this.UploadBtn.SetFlagDim(true);
	this.EndCallBtn.SetFlagDim(true);
	
}

SceneVoiceMail.prototype.BtnEnable = function()
{
	this.CancelBtn.SetFlagDim(false);
	this.UploadBtn.SetFlagDim(false);
	this.EndCallBtn.SetFlagDim(false);
	
}

SceneVoiceMail.prototype.processClickEvent = function(obj){
	alert("SceneVoiceMail.processClickEvent() ");
	
	var currentHighlight =  this.VoiceMailView.getCurrentHighlight();
    if(currentHighlight != obj)
    {
    	this.highlight(obj);
    }
	
	this.processEnterKey();
}

SceneVoiceMail.prototype.processVolumeDownKey = function(){
    alert("SceneVoiceMail.processVolumeDownKey() ");
   this.current_volume_value = PluginAPIMgr.GetSpeakerVolume();
   
    var min_volume =0;
    this.current_volume_value --;
    
    if(this.current_volume_value < min_volume)
    {
        this.current_volume_value = min_volume;
    }
    
    PluginAPIMgr.SetSpeakerVolume(this.current_volume_value );  
}

SceneVoiceMail.prototype.processVolumeUpKey = function(){
    alert("SceneVoiceMail.processVolumeUpKey() ");
    this.current_volume_value = PluginAPIMgr.GetSpeakerVolume();
   
    var max_volume =100;
    this.current_volume_value ++;
    
    if(this.current_volume_value >  max_volume)
    {
        this.current_volume_value = max_volume;
    }
    
    PluginAPIMgr.SetSpeakerVolume(this.current_volume_value );  
}




