
function SceneWelcome(options) {
	this.options = options;
	
    this.destroyFlag = true;
    
    this.MainView=null;
    
    this.TitleLabel = null;
	this.ImageLabel = null;
	this.MsgLabel = null; 
    
    this.SigninBtn = null;
    this.CreateAccountBtn = null;
    this.MSABtn = null;
    this.NeedHelpBtn = null;
	
    this.DefaultHelpBar =null;
 
}

SceneWelcome.prototype.initialize = function () {
	alert("SceneWelcome.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
   
    this.create();
    
}

SceneWelcome.prototype.handleShow = function () {
	alert("SceneWelcome.handleShow()");
	// this function will be called when the scene manager show this scene 
	
	if(this.destroyFlag==true)
	{
		this.highlight(null);
        this.destroyFlag= false;	
	}    
}

SceneWelcome.prototype.handleHide = function () {
	alert("SceneWelcome.handleHide()");
	// this function will be called when the scene manager hide this scene  
    

}

SceneWelcome.prototype.handleFocus = function () {
	alert("SceneWelcome.handleFocus()");
	// this function will be called when the scene manager focus this scene
    var currentHighlight =  this.MainView.getCurrentHighlight();
    if(currentHighlight ==null)
    {
        this.highlight(this.SigninBtn);
    }
    else
    {
         this.highlight(currentHighlight);
    }
}

SceneWelcome.prototype.handleBlur = function () {
	alert("SceneWelcome.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
    
    var currentHighlight =  this.MainView.getCurrentHighlight();
    currentHighlight.blur();

}
 
SceneWelcome.prototype.handleKeyDown = function (keyCode) {
	alert("SceneWelcome.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	PluginAPIMgr.PlayAudio(keyCode);
	switch (keyCode) {
		case $.sfKey.LEFT:
		case $.sfKey.RIGHT:
            this.processLeftRightKey(keyCode);
			break;
		case $.sfKey.UP:
		case $.sfKey.DOWN:
           this.processUpDownKey(keyCode);
			break;

		case $.sfKey.ENTER:
            this.processEnterKey();
			break;
        
		case $.sfKey.TOOLS:
            
			break; 
            
        case $.sfKey.RETURN:
            this.processReturnKey();
            $.sfKey.block(event);
			break;
            
        case $.sfKey.EXIT:
            this.processExitKey();
            $.sfKey.block(event);
			break;
		
        case 147:  //infolink
        case 261:  //contents
        case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
			
		default:
            ProcMgr.processBlockKey(keyCode);
            break;

	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneWelcome.prototype.create = function(){
    alert("SceneWelcome.create()");
    this.MainView = new View("Welcome");
    this.MainView.SetBgImage(g_Image.IMAGE_WELCOME_BG);
    
    this.TitleLabel = new Label(null,"welcome_title");
    this.TitleLabel.SetTextStyle("welcome_title_style");
    this.TitleLabel.SetText(IDWS_MOIP_WELCOM_TO_SKYPE);    
	
	this.ImageLabel= new Label("welcome_image", null);
    this.ImageLabel.SetBgImage(g_Image.IMAGE_WELCOME_IMAGE);
    
    this.MsgLabel = new Label(null,"welcome_msg");
    this.MsgLabel.SetTextStyle("welcome_msg_style");
    this.MsgLabel.SetText(TV_ENJOY_FREE_VIDEO_CALLS_MSG);  
  
  	var this_ = $.sfScene.get("Welcome");
  	var clickCF =  function(obj){this_.processClickEvent(obj);};
  	
    this.SigninBtn= new Button();
    this.SigninBtn.SetImageObjId("welcome_signin_btn");
    this.SigninBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_WELCOME_BTN_NORMAL);
    this.SigninBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_WELCOME_BTN_NORMALFOCUS);
    this.SigninBtn.SetTextObjId("welcome_signin_btn_text");
    this.SigninBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"welcome_btn_normal_style");
	this.SigninBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"welcome_btn_select_style");
    this.SigninBtn.SetText(IDWS_MOIP_SKYPE_SIGNIN);
    this.SigninBtn.SetOnClickCallbackFunc(clickCF);

    this.CreateAccountBtn= new Button();
    this.CreateAccountBtn.SetImageObjId("welcome_create_account_btn");
    this.CreateAccountBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_WELCOME_BTN_NORMAL);
    this.CreateAccountBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_WELCOME_BTN_NORMALFOCUS);
    this.CreateAccountBtn.SetTextObjId("welcome_create_account_btn_text");
    this.CreateAccountBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"welcome_btn_normal_style");
	this.CreateAccountBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"welcome_btn_select_style");
    this.CreateAccountBtn.SetText(SID_CREATE_ACCOUNT);
    this.CreateAccountBtn.SetOnClickCallbackFunc(clickCF);
    
    
    this.MSABtn = new Button();
    this.MSABtn.SetImageObjId("welcome_microsoft_account_btn");
    this.MSABtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_WELCOME_MSA_BTN_NORMAL);
    this.MSABtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_WELCOME_MSA_BTN_NORMALFOCUS);
    this.MSABtn.SetTextObjId("welcome_microsoft_account_btn_text");
    this.MSABtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"welcome_btn_normal_style");
	this.MSABtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"welcome_btn_select_style");
    this.MSABtn.SetText(TV_SID_USE_MY_MICROSOFT_ACCOUNT);
    this.MSABtn.SetOnClickCallbackFunc(clickCF);
    
    this.NeedHelpBtn = new Button();
    this.NeedHelpBtn.SetImageObjId("welcome_need_help_btn");
    this.NeedHelpBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_WELCOME_NEED_HELP_BTN_NORMAL);
    this.NeedHelpBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_WELCOME_NEED_HELP_BTN_NORMALFOCUS);
    this.NeedHelpBtn.SetTextObjId("welcome_need_help_btn_text");
    this.NeedHelpBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"welcome_btn_normal_style");
	this.NeedHelpBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"welcome_btn_select_style");
    this.NeedHelpBtn.SetText("?");
    this.NeedHelpBtn.SetOnClickCallbackFunc(clickCF);
    
    this.makeToolTip();
    this.hideTooltip();

    this.DefaultHelpBar = new HelpBar(HelpBarIndex.WELCOME,"Welcome");
    this.DefaultHelpBar.SetOnClickCallbackFunc(1, function(){this_.processReturnKey();});
    
	this.MainView.registHelpBar(this.DefaultHelpBar);

}


SceneWelcome.prototype.setDestroyFlag= function(destroy_flag){
     this.destroyFlag = destroy_flag;
}

SceneWelcome.prototype.highlight=function(obj)
{
	alert("SceneWelcome.highlight()");
	var currentHighlight =  this.MainView.getCurrentHighlight();
	if(obj==this.NeedHelpBtn){
		this.showTooltip();
	}else if(currentHighlight==this.NeedHelpBtn){
		this.hideTooltip();
	}
	
    this.MainView.setCurrenHighlight(obj);
	
}

SceneWelcome.prototype.processUpDownKey = function(keyCode){
    alert("SceneWelcome.processUpDownKey() ");
    switch(keyCode){
    	case $.sfKey.UP:
    		this.highlight(this.SigninBtn);
    		break;
		case $.sfKey.DOWN:
			this.highlight(this.MSABtn);
			break;
    }
    
    
}
SceneWelcome.prototype.processLeftRightKey = function(keyCode){
    alert("SceneWelcome.processLeftRightKey() ");
    var currentHighlight =  this.MainView.getCurrentHighlight();
    
    switch(keyCode)
    {       
    	case $.sfKey.LEFT:
    		if(currentHighlight==this.CreateAccountBtn){
    			this.highlight(this.SigninBtn);
    		}else if(currentHighlight==this.NeedHelpBtn){
    			this.highlight(this.CreateAccountBtn);
    		}
    		break;
    	case $.sfKey.RIGHT:
	    	if(currentHighlight==this.SigninBtn){
	    		this.highlight(this.CreateAccountBtn);
	    	}else if(currentHighlight==this.CreateAccountBtn){
	    		this.highlight(this.NeedHelpBtn);
	    	}
    		break;
    	
    }
}

SceneWelcome.prototype.processEnterKey = function(){
    alert("SceneWelcome.processEnterKey() ");
    
    var currentHighlight =  this.MainView.getCurrentHighlight();

    switch(currentHighlight)
    {
        case this.SigninBtn:
	        if(PluginAPIMgr.RecognitionPluginAvailable==true)
	        {
	        	if(PluginAPIMgr.GetLoginMode()==0)
	        	{
	        		StateMgr.Start_Signin_State();
	        	}
	        	else
	        	{
	        		ProcMgr.StartFaceRecogSignin();
	        	}
	        }
	        else
	        {
	        	StateMgr.Start_Signin_State();
	        }
			
            break;
            
        case this.CreateAccountBtn:
			//StateMgr.Start_Create_Account_State();
			StateMgr.Start_Guide_Page_State(GUIDEPAGE_TYPE.CREATE_NEW_ACCOUNT);
            break;
        case this.MSABtn:
        	StateMgr.Start_Guide_Page_State(GUIDEPAGE_TYPE.SIGNIN_WITH_MSA);
        	break;
        case this.NeedHelpBtn:
        	StateMgr.Start_Guide_Page_State(GUIDEPAGE_TYPE.NEED_HELP);
        	break;
    }
}

SceneWelcome.prototype.processReturnKey = function(){
    alert("SceneWelcome.processReturnKey() ");
   
   ProcMgr.CloseWithSignIn();
}

SceneWelcome.prototype.processExitKey = function(){
    alert("SceneWelcome.processExitKey() ");
   
   ProcMgr.ExitWithSignIn();
}
SceneWelcome.prototype.showTooltip = function(){
	alert("SceneWelcome.showTooltip() ");
	$("#welcome_help_ball").show();
}
SceneWelcome.prototype.hideTooltip = function(){
	alert("SceneWelcome.hideTooltip() ");
	$("#welcome_help_ball").hide();
}

SceneWelcome.prototype.makeToolTip = function(){
	alert("SceneWelcome.makeToolTip() ");
	var text_width = this.CheckMarquee(TV_SID_NEED_HELP);
	var div_left = 702-(20+(text_width/2));
	var div_width = text_width+40;
	
	alert("text width : "+text_width);
	alert("div_left : "+div_left);
	alert("div_width : "+div_width);
	
	
	$("#welcome_help_ball").css({
		"left":div_left+"px",
		"width":div_width+"px"
	});
	var tooltip_width = div_width-40;
	$(".welcome_tooltip_center").css("width", tooltip_width+"px");
	$(".welcome_tooltip_arrow").css("left",(tooltip_width/2+8)+"px");
	$(".welcome_tooltip_right").css("left",(20+tooltip_width)+"px");
	
	$(".welcome_tooltip_left").css("background-image", 'url('+g_Image.IMAGE_WELCOME_TOOLTIP_LEFT+')');
	$(".welcome_tooltip_center").css("background-image", 'url('+g_Image.IMAGE_WELCOME_TOOLTIP_CENTER+')');
	$(".welcome_tooltip_arrow").css("background-image", 'url('+g_Image.IMAGE_WELCOME_TOOLTIP_ARROW+')');
	$(".welcome_tooltip_right").css("background-image", 'url('+g_Image.IMAGE_WELCOME_TOOLTIP_RIGHT+')');
	
	$("#welcome_tooltip_text").text(TV_SID_NEED_HELP);
	
	
	
}
SceneWelcome.prototype.CheckMarquee = function(string) {
	var tempHTML = "<div id='checkmarquee' style='position:absolute'></div>";
	$("#Welcome").append(tempHTML);
	$("#checkmarquee").removeClass();
	$("#checkmarquee").html(string);
	var width = $("#checkmarquee").css('width');
	var len= width.indexOf("px");
	var curr_w_int = parseInt(width.substring(0,len));
	alert(string+" : " + width); 
	$("#checkmarquee").remove();
	return curr_w_int;
	
}

/*
SceneWelcome.prototype.processSigninBtnClick = function(){
    alert("SceneWelcome.processSigninBtnClick() ");
    var currentHighlight =  this.MainView.getCurrentHighlight();
    if(currentHighlight != this.SigninBtn)
    {
    	this.highlight(this.SigninBtn);
    }
    
    StateMgr.Start_Signin_State();
}

SceneWelcome.prototype.processCreateAccountClick = function(){
    alert("SceneWelcome.processCreateAccountClick() ");
    var currentHighlight =  this.MainView.getCurrentHighlight();
    if(currentHighlight != this.CreateAccountBtn)
    {
    	this.highlight(this.CreateAccountBtn);
    }
    
    StateMgr.Start_Create_Account_State();
}*/

///////// Processing Click evnet  //////////////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneWelcome.prototype.processClickEvent = function(obj){
	alert("SceneWelcome.processClickEvent() ");
	
	var currentHighlight =  this.MainView.getCurrentHighlight();
    if(currentHighlight != obj)
    {
    	this.highlight(obj);
    }
	
	this.processEnterKey();
}

